// Built 2011301358
/*  
taccgl(TM)    version 0.62 
see http://www.taccgl.org for Examples, Tutorial, Documentation

H.E.I. Informationssysteme GmbH
Wimpfener Strasse 23
68259 Mannheim
Germany
http://www.taccgl.org
email: contact@taccgl.org
Sales Tax ID: DE185233091
HRB Mannheim 7273
Geschaeftssfuehrer: Dr. Helmut Emmelmann
Phone: +49 - 621 - 79 51 41
Fax:   +49 - 621 - 79 51 61

Copyright (c) 2020 H.E.I.Informationssysteme GmbH (https://www.taccgl.org) and suppliers

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This is BETA Software and known to contain bugs. It is probably
not implemented completely and will probably not run on all
browsers and client computers. It will switch off itself on
certain client computers and browsers. In addition some client
computers might run animations slowly, animations may appear
choppy or jumpy, or even client computers might get overloaded or
even crash. */

"use strict"
var taccgl_epwarning=
/*    M E D I C A L     W A R N I N G   
      Note that taccgl allows you to add fast flashing and video game like animations to web pages. A small percentage of 
      the population may experience epileptic symptoms when exposed to such animations. You might want to, or you may even 
      be required to, add / show an epileptic warning message on your web site before showing such animations and you might 
      want to or you may even be required to avoid certain types of animations on your web site. Please protect yourself 
      when programming animations and protect the users of your web site and take the following warning message seriously:  
*/
"     EPILEPSY WARNING, READ BEFORE VIEWING THE FOLLOWING ANIMATIONS,                                                       "+
"     BEFORE USING A VIDEO GAME SYSTEM, BEFORE PROGRAMMING, WATCHING AND PUTTING ANIMATIONS ONLINE                          "+
"                                                                                                                           "+ 
"     MEDICAL RESEARCH INDICATES A SMALL PERCENTAGE OF THE POPULATION MAY EXPERIENCE EPILEPTIC SEIZURES OR SEIZURE-LIKE     "+
"     SYMPTOMS  EXPOSED TO CERTAIN STIMULI, INCLUDING, WITHOUT LIMITATION, LIGHT PATTERNS, FLASHING LIGHTS OR CERTAIN       "+
"     PATTERNS OF BACKGROUND ON A TELEVISION SCREEN, OR VIDEO MONITOR. EXPOSURE TO THESE STIMULI WHILE PLAYING VIDEO GAMES  "+
"     OR WATCHING ANIMATIONS MAY INDUCE AN EPILEPTIC SEIZURE OR SEIZURE LIKE SYMPTOMS IN THESE INDIVIDUALS. CERTAIN         "+
"     CONDITIONS MAY INDUCE EPILEPTIC SYMPTOMS EVEN IN PERSONS WHO HAVE NO PRIOR HISTORY OF SEIZURES OF EPILEPSY. IF YOU    "+
"     EXPERIENCE ANY OF THE FOLLOWING SYMPTOMS WHILE PLAYING A VIDEO GAME OR WATCH ANIMATIONS --- DIZZINESS, ALTERED VISION,"+
"     EYE OR MUSCLE TWITCHES, LOSS OF AWARENESS, DISORIENTATION, AND INVOLUNTARY MOVEMENT OR CONVULSIONS ---                "+
"     IMMEDIATELY DISCONTINUE USE AND CONSULT YOUR PHYSICAN BEFORE PLAY OR WATCHING ANIMATIONS.                             ";
 
// var taccgl_texCanWidth=1200; 
// var taccgl_texCanHeight=2048;
// var taccgl_texCanWidth=512;
// var taccgl_texCanHeight=512; 
var taccgl_3d, taccgl_2d,  taccgl_maxQ, taccgl_frontfacing, taccgl_advCompileTimeChrome, taccgl_advCompileTime,
   taccgl_failIfMajorPerformanceCaveat, taccgl_perVertex, taccgl_noSpecular, taccgl_qmix,  taccgl_singleTex, taccgl_mipmap,
   taccgl_immediateStop, taccgl_texCanWidth, taccgl_texCanHeight, taccgl_shadowFactor;
if (window.taccgl_3d!=false) taccgl_3d=true;            // normally true, false for testing 2D mode
if (window.taccgl_2d!=false) taccgl_2d=true;            // normally true, false for testing deactivation on non canvas browsers
if (!window.taccgl_maxQ)     taccgl_maxQ=5;             // normally 4, 3, 2 or 1 for testing these quality levels
if (window.taccgl_frontfacing!=false)  taccgl_frontfacing=true;   // if false does not even try to make a shader with frontfacing 
if (!window.taccgl_advCompileTimeChrome)  taccgl_advCompileTimeChrome=300;  // if compiling the fast shader takes longer, we do not even try compiling the advanced shader
if (!window.taccgl_advCompileTime)   taccgl_advCompileTime=600;  
if (!window.taccgl_failIfMajorPerformanceCaveat) taccgl_failIfMajorPerformanceCaveat=false;
if (!window.taccgl_perVertex) taccgl_perVertex=false;   // so shading per vertex (fast but lower quality) or by fragment
if (!window.taccgl_noSpecular) taccgl_noSpecular=false; // disables specular lighting 
if (window.taccgl_qmix!=false) taccgl_qmix=true;        // quick mix of textures, incorrect but fast and often looks ok
if (!window.taccgl_singleTex) taccgl_singleTex=false;   // just use one texture (fast for simple examples)
// var taccgl_immediateStop=-1;
// var taccgl_debug=true;     // taccgl_debug can be enabled here or after including the lib
if (!window.taccgl_debugButtons) var taccgl_debugButtons=false;
if (!window.taccgl_showShader)   var taccgl_showShader=false;
if (!window.taccgl_use_disjoint_timer_query!=false) var taccgl_use_disjoint_timer_query=true;
if (!window.taccgl_errAlert)   var taccgl_errAlert=false;
if (window.taccgl_drawerrcheck!=false)   var taccgl_drawerrcheck=true;   // perform gl error checking before rendering each frame
if (window.taccgl_setuperrcheck!=false)  var taccgl_setuperrcheck=true;  // perform gl error checking after setting up animation
if (!window.taccgl_tfr30) var taccgl_tfr30 = [0,30,30,30,30,30];
if (!window.taccgl_tfr60) var taccgl_tfr60 = [0,60,60,60,60,60];
if (!window.taccgl_tfr) var taccgl_tfr = taccgl_tfr30;

if(!window.taccgl_looperrcheck){var taccgl_looperrcheck=false}if(!window.taccgl_adjusterrcheck){var taccgl_adjusterrcheck=taccgl_looperrcheck}if(!window.taccgl_debug){var taccgl_debug=false}var taccgl_debug_vertex=false;function taccgl_onscroll(){taccgl.detectScroll();taccgl.detectPr();if(taccgl.tpr<2&&taccgl.pr>taccgl.tpr){taccgl_onresize();if(taccgl.resizeTimer){return}}taccgl.parallaxAdjust();taccgl.doHook(taccgl.onScroll,taccgl.o_sl,taccgl.o_st);if(taccgl.ddmode&&taccgl.draw_running){taccgl.resizeBody()}taccgl.draw_meaIgnore=3;if(taccgl.dddmode&&taccgl.draw_running){var a=window.performance.now()-taccgl.meaA[(taccgl.draw_meaFrames)%taccgl.meaAS];var b=false;if(b){taccgl.cancelDraw();if(a>60){if(taccgl.resumeAfterScrollTimer==null){taccgl.resumeAfterScrollTimer=setTimeout(function(){taccgl.resumeAfterScrollTimer=null;taccgl.pendingResizeBody=true;taccgl_draw3d()},90)}}else{taccgl.pendingResizeBody=true;taccgl_draw3d()}}else{if(a>60){if(taccgl.resumeAfterScrollTimer==null){taccgl.cancelDraw();taccgl.resumeAfterScrollTimer=setTimeout(function(){taccgl.resumeAfterScrollTimer=null;taccgl.resizeBody();taccgl_draw3d()},150)}}else{taccgl.pendingResizeBody=true}}}}function taccgl_onresize(){if(taccgl.winInnerWidth==window.innerWidth&&taccgl.winDpr==window.devicePixelRatio){return}taccgl.winOuterWidth=window.outerWidth;taccgl.winOuterHeight=window.outerHeight;taccgl.winInnerWidth=window.innerWidth;taccgl.winDpr=window.devicePixelRatio;if(taccgl.resizeTimer){clearTimeout(taccgl.resizeTimer)}taccgl.resizeTimer=setTimeout(function(){taccgl.resizeTimer=null;taccgl.tonresize()},taccgl.resizeTime)}function taccgl_onmousemove(a){taccgl.mouseX=a.clientX;taccgl.mouseY=a.clientY;if(taccgl.controller&&taccgl.controller.bodyOnMouseMove){taccgl.controller.bodyOnMouseMove(a)}}function taccgl_onmousewheel(c){if(!c){c=window.event}var b=20;var a=1;if(taccgl.scrollTimer){taccgl.scrollSpeed+=2}else{taccgl.scrollSpeed=25}clearTimeout(taccgl.scrollTimer);if(c.wheelDelta>0){a=-1}function d(){var e=a*taccgl.scrollSpeed;window.scrollBy(0,e);if(b<taccgl.scrollSpeed){taccgl.scrollSpeed=b-1}b--;if(b>0){taccgl.scrollTimer=setTimeout(d,18)}else{taccgl.scrollTimer=null}}d();c.preventDefault();return false}function taccgl_create(){var i;taccgl=this;this.foreground_zIndex=1000;this.background_zIndex="-1";this.draw_running=false;this.busy=false;this.showWarning=false;this.timeScale=1;this.endMode="hide";this.endStyle={transition:"opacity 0.25s, visibility 0.25s",opacity:"0",visibility:"hidden"};this.textureCanvasshanged=false;this.textureCanvasChanged2=false;this.texcanvas=null;this.texc=null;this.vBgControl=false;this.ddmode=this.dddmode=false;this.compatmode=true;this.initialized=false;this.webglerror=false;this.shddmode=this.shdddmode=null;this.onTerm=null;this.onBeforeDraw3D=null;taccgl.onImmediateTerm=null;taccgl.onAdjustQuality=null;this.onDebugKeyPress=[];this.drawConsoleTime=false;this.drawConsoleTimeStamp=false;this.delno=1;this.qualityCnt=Array(6);for(i=0;i<6;i++){this.qualityCnt[i]=0}this.heightExtension=0;this.resizeTime=200;this.meaAS=256;this.meaA=Array(this.meaAS);this.meaAA=Array(this.meaAS);this.errcode=0;this.winOuterWidth=window.outerWidth;this.winOuterHeight=window.outerHeight;this.winInnerWidth=window.innerWidth;this.winDpr=window.devicePixelRatio;this.shadowEna=null;this.glerr=0;this.mouseX=this.mouseY=0;var ua=navigator.userAgent;this.isOldiOS=false;this.curPaintJob=this.prevPaintJob=null;this.resumeAfterScrollTimer=null;this.pendingResizeBody=false;if(window.requestAnimationFrame){window.taccgl_requestAnimationFrame=requestAnimationFrame}else{if(window.webkitRequestAnimationFrame){window.taccgl_requestAnimationFrame=webkitRequestAnimationFrame}else{if(window.mozRequestAnimationFrame){window.taccgl_requestAnimationFrame=mozRequestAnimationFrame}else{if(window.msRequestAnimationFrame){window.taccgl_requestAnimationFrame=msRequestAnimationFrame}else{if(window.oRequestAnimationFrame){window.taccgl_requestAnimationFrame=oRequestAnimationFrame}}}}}if(window.cancelAnimationFrame){window.taccgl_cancelAnimationFrame=cancelAnimationFrame}else{if(window.webkitCancelAnimationFrame){window.taccgl_cancelAnimationFrame=webkitCancelAnimationFrame}else{if(window.mozCancelAnimationFrame){window.taccgl_cancelAnimationFrame=mozCancelAnimationFrame}else{if(window.msCancelAnimationFrame){window.taccgl_cancelAnimationFrame=msCancelAnimationFrame}else{if(window.oCancelAnimationFrame){window.taccgl_cancelAnimationFrame=oCancelAnimationFrame}}}}}this.clog=function(s){if(window.console){console.log(s)}};this.tlog=function(s,c){if(window.console){if(c+""!="undefined"){console.log(taccgl.perfnow().toFixed(1)+":  "+s,c)}else{console.log(taccgl.perfnow().toFixed(1)+":  "+s)}}};this.glAlert=function(msg){this.tlog("%c"+msg,"font-size:20px; color:red");if(taccgl_errAlert){alert(msg)}};this.glError=function(msg){this.glAlert(msg);this.webglerror=true};this.defaultLighting=function(){this.lightAmbient=0.7;this.lightDiffuse=0.3;this.lightSpecular=0.3;this.lightShininess=256};this.defaultLighting();this.defaultEye=function(){var se=this.stdEye;se.setDefault()};this.setStdEye=function(e){this.stdEye=e;if(this.stdsc){this.createShaders();this.adjustQuality()}};taccglEye.prototype=new taccglEyePrototype();this.createEye=function(e){return new taccglEye(e)};this.eyePositions=Array(0);this.setStdEye(this.createEye());this.defaultShadowZRange=function(){this.zBack=-4000;this.zFront=2000};this.defaultShadowZRange();this.setShadowZRange=function(front,back){this.zBack=back;this.zFront=front;this.adjustShcvp()};this.detectFRLast=0;this.detectFRCnt=0;this.detectFRmin=10000;this.maxFR=60;this.detectFR=function(){if(window.taccgl_requestAnimationFrame){taccgl.reqAnimFrameId=taccgl_requestAnimationFrame(taccgl.detectFRLoop)}};this.detectFRLoop=function(t){var d=(t-taccgl.detectFRLast);if(d<taccgl.detectFRmin){taccgl.detectFRmin=d}taccgl.detectFRLast=t;if(taccgl.detectFRCnt++<5){taccgl.reqAnimFrameId=taccgl_requestAnimationFrame(taccgl.detectFRLoop)}else{taccgl.detectFRFinish()}};this.detectFRFinish=function(){var fr=1000/this.detectFRmin;if(fr>60){fr=60}if(fr<35){fr=30}this.detectFRCnt=10000;this.maxFR=fr;if(fr>=60){taccgl_tfr=taccgl_tfr60}};this.detectFR();this.detectScroll=this.autoDetectScroll=function(){var detect=document.getElementById("taccgl_detect");var cr=detect.getClientRects();this.scrollTop=100-cr[0].top;this.scrollLeft=100-cr[0].left};this.initDetectScroll=function(){if(this.scrollLeft){return}var detect=document.getElementById("taccgl_detect");if(detect){return}document.body.insertAdjacentHTML("afterbegin",'<div id="taccgl_detect"  style="position:absolute; top:100px; left:100px; min-width:10px; min-height:10px; z-index:10000;"></div> ');taccgl.detectScroll()};this.detectPr=function(){if(window.devicePixelRatio){this.pr=window.devicePixelRatio}else{this.pr=1}this.prevDpr=this.pr;var vp=window.visualViewport,f,wiw=window.innerWidth;if(vp){wiw=vp.width}var ow=window.outerWidth;if(!ow){ow=window.screen.width}if(wiw>ow){f=10/Math.round(10*wiw/ow)}else{f=Math.round(10*ow/wiw)/10}if(vp&&vp.scale){var rpr;this.pr*=vp.scale;rpr=this.pr/f}else{if(typeof window.ontouchstart!="undefined"){if(f>0&&f<1000){this.pr*=f}if(this.pr>2*f){var prevpr=this.pr;this.pr=2*f}}}};this.detectTpr=function(){this.detectPr();this.tpr=this.pr;if(this.tpr>2){this.tpr=2}if(this.tpr<1){this.tpr=1}if(this.dddmode){var m=this.g.getParameter(this.g.MAX_TEXTURE_SIZE);var x=m/taccgl_texCanWidth;if(this.tpr>x){this.tpr=x}x=m/taccgl_texCanHeight;if(this.tpr>x){this.tpr=x}}};this.init1=function(){this.softFailQ=this.hardFailQ=taccgl_maxQ+1;this.softFailCnt=0;var cv=document.getElementById("taccgl_canvas3d");var initcreate=!cv;if(!cv){this.initDetectScroll();if(!window.taccgl_texCanWidth){taccgl_texCanWidth=1200}if(!window.taccgl_texCanHeight){taccgl_texCanHeight=1424}if(!window.taccgl_mipmap){taccgl_mipmap=false}if(!window.taccgl_immediateStop){taccgl_immediateStop=4}if(document.body.insertAdjacentHTML){document.body.insertAdjacentHTML("afterbegin",'<canvas id="taccgl_canvas3d" width="10" height="10" style="position:absolute; top:0px; left:0px; z-index:-1;display:none;visibility:visible " onmousemove="taccgl.canvasOnMouseMove(event)"></canvas>');cv=document.getElementById("taccgl_canvas3d")}}if(cv&&cv.getContext){var g=null;if(taccgl_3d){try{var opt={antialias:true,stencil:false,premultipliedAlpha:true,preserveDrawingBuffer:false,failIfMajorPerformanceCaveat:taccgl_failIfMajorPerformanceCaveat};g=cv.getContext("webgl",opt);if(!g){this.errcode=1;g=cv.getContext("experimental-webgl",opt)}if(!g){this.errcode=2;g=cv.getContext("webkit-3d",opt)}if(!g){this.errcode=3;opt={antialias:true,stencil:false,premultipliedAlpha:true,preserveDrawingBuffer:false,failIfMajorPerformanceCaveat:taccgl_failIfMajorPerformanceCaveat};g=cv.getContext("webgl",opt)}if(!g){this.errcode=10;g=cv.getContext("experimental-webgl",opt)}if(!g){this.errcode=11;g=cv.getContext("webkit-3d",opt)}if(!g){this.errcode=12;opt={stencil:false,premultipliedAlpha:true,preserveDrawingBuffer:false,failIfMajorPerformanceCaveat:taccgl_failIfMajorPerformanceCaveat};g=cv.getContext("webgl",opt)}if(!g){this.errcode=13;g=cv.getContext("experimental-webgl",opt)}if(!g){this.errcode=14;g=cv.getContext("webkit-3d",opt)}if(!g){this.errcode=15;opt={premultipliedAlpha:true,preserveDrawingBuffer:false,failIfMajorPerformanceCaveat:taccgl_failIfMajorPerformanceCaveat};g=cv.getContext("webgl",opt)}if(!g){this.errcode=16;g=cv.getContext("experimental-webgl",opt)}if(!g){this.errcode=17;g=cv.getContext("webkit-3d",opt)}if(!g){this.errcode=18;opt={preserveDrawingBuffer:false,failIfMajorPerformanceCaveat:taccgl_failIfMajorPerformanceCaveat};g=cv.getContext("webgl",opt)}if(!g){this.errcode=50;g=cv.getContext("experimental-webgl",opt)}if(!g){this.errcode=51;g=cv.getContext("webkit-3d",opt)}if(!g){this.errcode=3;opt={failIfMajorPerformanceCaveat:taccgl_failIfMajorPerformanceCaveat};g=cv.getContext("webgl",opt)}if(!g){this.errcode=5;g=cv.getContext("experimental-webgl",opt)}if(!g){this.errcode=6;g=cv.getContext("webkit-3d",opt)}if(!g){this.errcode=7}}catch(e){g=null;this.errcode=8}finally{}}if(g&&taccgl_3d){this.g=g;this.cv=cv;this.dddmode=true;this.ddmode=false;this.compatmode=false}else{g=cv.getContext("2d");if(g&&taccgl_2d){this.g=g;this.cv=cv;this.dddmode=false;this.ddmode=true;this.compatmode=false}else{this.dddmode=this.ddmode=false}this.compatmode=true}}else{this.errcode=9}if(initcreate){if(document.body.insertAdjacentHTML){this.detectTpr();var wpr=Math.round(taccgl_texCanWidth*this.tpr),hpr=Math.round(taccgl_texCanHeight*this.tpr);document.body.insertAdjacentHTML("afterbegin",'<canvas id="taccgl_textureCanvas" width="'+wpr+'" height="'+hpr+'" style="display:none;position:absolute;top:0px;left:0px;z-index:9999;background-color:silver;width:'+taccgl_texCanWidth+"px;height:"+taccgl_texCanHeight+'px" crossorigin onclick="taccgl.HideTexCanvas(1)"></canvas><canvas id="taccgl_textureCanvas2" width="'+wpr+'" height="'+hpr+'" style="display:none;position:absolute;top:0px;left:0px;z-index:9999;background-color:silver;width:'+taccgl_texCanWidth+"px;height:"+taccgl_texCanHeight+'px" crossorigin onclick="taccgl.HideTexCanvas(2)"></canvas><canvas id="taccgl_scratchCanvas" width=1 height=1 style="display:none;position:absolute;top:0px;left:0px;z-index:1000;background-color:cyan; width:3; height:3" ></canvas>');this.scratchcanvas=document.getElementById("taccgl_scratchCanvas");if(this.scratchcanvas){this.scratchc=this.scratchcanvas.getContext("2d")}this.texTo(2);if(this.texc){taccgl.texTransform(1,0,0,1,0,0)}this.texTo(1);if(this.texc){taccgl.texTransform(1,0,0,1,0,0)}var ta=this.texAtlas=this.textureAtlas();ta.addBin(1,taccgl_texCanWidth,taccgl_texCanHeight);ta.addBin(2,taccgl_texCanWidth,taccgl_texCanHeight);this.allocPaintErrorTexture()}}this.dddCanvas=new this.createDDDCanvas();this.controller=new this.createForwardingController();this.controller.attach();this.stdLight=this.lightSource();this.initialized=true;this.quality=3;this.TM=this.m44I();this.TM_1=this.m33I()};this.texCanInit=function(){taccgl_texCanWidth=10;taccgl_texCanHeight=10;this.initDetectScroll()};this.bb=function(el){this.autoDetectScroll();if(typeof(el)=="string"){el=document.getElementById(el)}if(!el){return null}var bcr=el.getBoundingClientRect(el);bcr={y:bcr.top,x:bcr.left,b:bcr.bottom,r:bcr.right,h:bcr.height,w:bcr.width};bcr.y+=this.scrollTop;bcr.b+=this.scrollTop;bcr.x+=this.scrollLeft;bcr.r+=this.scrollLeft;return bcr};this.texCanEl=function(el,opt,ox,oy){if(typeof(el)=="string"){el=document.getElementById(el)}var cr=el.getClientRects();var i;for(i=0;i<cr.length;i++){var x=cr[i].left,y=cr[i].top,w=cr[i].width,h=cr[i].height;if(ox){x+=ox}if(oy){y+=oy}x+=this.scrollLeft;y+=this.scrollTop;if(opt){if(opt.match(/r/)){if(x+w+1>taccgl_texCanWidth){taccgl_texCanWidth=x+w+1}}if(opt.match(/b/)){if(y+h+1>taccgl_texCanHeight){taccgl_texCanHeight=y+h+1}}if(opt.match(/l/)){if(x+1>taccgl_texCanWidth){taccgl_texCanWidth=x+1}}if(opt.match(/t/)){if(y+1>taccgl_texCanHeight){taccgl_texCanHeight=y+1}}}else{if(x+w+1>taccgl_texCanWidth){taccgl_texCanWidth=x+w+1}if(y+h+1>taccgl_texCanHeight){taccgl_texCanHeight=y+h+1}}}taccgl_texCanWidth=Math.round(taccgl_texCanWidth+0.49999);taccgl_texCanHeight=Math.round(taccgl_texCanHeight+0.49999)};this.perfnow=function(){if(window.performance&&window.performance.now){return window.performance.now()}else{return new Date().getTime()}};this.epWarningText=function(){return'<form action="javascript:void()"><h2>'+taccgl_epwarning.replace(/ONLINE/,"ONLINE</h2>")+'<p><ul> <li> <button name="Disable" type="button" onclick="taccgl.epDisable()">Disable</button>Animations on this page <li> <button name="Acknowlege Warning" type="button" onclick="taccgl.epEnable()"/>Acknowledge Warning</button> and enable animation on your own risk </ul></form>'};this.epWarningStyle=function(){if(window.screen&&window.screen.width&&window.screen.width<800){return"position:fixed; top:0px; left:0px; z-index:10000;display:none;background-color:white; font-size:12px;padding:20px; border: ridge 3px silver; width:"+(window.screen.width-60)+"px"}else{return"position:fixed; width:700px; top:20px; left:20px; z-index:10000;display:none;background-color:white; font-size:16px;padding:20px; border: ridge 3px silver"}};this.epWarning=function(){if(document.body.insertAdjacentHTML){var w=document.getElementById("taccgl_epwarning");if(!w){document.body.insertAdjacentHTML("afterbegin",'<div id="taccgl_epwarning" style="'+this.epWarningStyle()+'">'+this.epWarningText()+"</div>")}}};this.disabledWarningStyle=function(){return"position:fixed; width:120px; font-size:12px; top:0px; left:0px; z-index:10000;display:none;background-color:white;padding:2px; border-right: ridge 1px silver; border-bottom: ridge 1px silver; vertical-align:middle;"};this.disabledWarningText=function(){var x='Animations&nbsp;<a href="javascript:taccgl.epUnset();" title="click to enable">disabled</a>';return x};this.disabledWarning=function(){if(document.body.insertAdjacentHTML){var w=document.getElementById("taccgl_disabledWarning");if(!w){document.body.insertAdjacentHTML("afterbegin",'<div id="taccgl_disabledWarning" style="'+this.disabledWarningStyle()+'">'+this.disabledWarningText()+"</div>")}}};this.showEpWarning=function(){var w=document.getElementById("taccgl_epwarning");w.style.display="";this.busy=true;this.showWarning=true};this.showDisabledWarning=function(){this.disabledWarning();var w=document.getElementById("taccgl_disabledWarning");w.style.display="";this.busy=false};this.epcheck=function(){if(this.epack){return true}if(this.epack==false){this.showDisabledWarning();return false}this.epWarning();this.cancelDraw();this.showEpWarning();return"wait"};this.hideEpWarning=function(){var w=document.getElementById("taccgl_epwarning");w.style.display="none";this.showWarning=false};this.hidedisabledWarning=function(){var w=document.getElementById("taccgl_disabledWarning");w.style.display="none"};this.epEnable=function(){this.epack=true;this.hideEpWarning();if(this.draw_running){this.continueDraw();this.beginIgnoreDrop();this.endIgnoreDrop(true)}this.start()};this.epDisable=function(){this.showDisabledWarning();this.epack=false;this.hideEpWarning();this.start()};this.epUnset=function(){this.epack=null;this.hidedisabledWarning()};this.canvasOnMouseMove=function(e){if(!e){e=window.event}this.mouseX=e.clientX;this.mouseY=e.clientY};this.ddFallBack=function(){if(this.dddmode||this.ddmode){return}var cv=document.getElementById("taccgl_canvas3d");if(!cv){return}if(!cv.getContext){return}if(this.webglerror){document.body.removeChild(cv);if(document.body.insertAdjacentHTML){document.body.insertAdjacentHTML("afterbegin",'<canvas id="taccgl_canvas3d" width="10" height="10" style="position:absolute; top:0px; left:0px; z-index:-1"></canvas>')}cv=document.getElementById("taccgl_canvas3d");this.controller.attach()}var g=cv.getContext("2d");if(g&&taccgl_2d){this.g=g;this.cv=cv;this.dddmode=false;this.ddmode=true;this.compatmode=false;this.resizeBody()}else{this.dddmode=this.ddmode=false;this.compatmode=true}};this.escapeRegExp=/[[\\\]+?*(){}|.^$]/g;this.addClass=function(el,cl){var cn=el.className;var cle=cl.replace(this.escapeRegExp,"$&");if(cn.match(new RegExp("\\b"+cle+"\\b"))){return}el.className=cn+" "+cl};this.removeClass=function(el,cl){var cle=cl.replace(this.escapeRegExp,"$&");el.className=el.className.replace(new RegExp("\\b"+cle+"\\b"),"")};this.removeClassRe=function(el,cl){el.className=el.className.replace(new RegExp("\\b<"+cl+"\\b"),"")};this.addClass(document.documentElement,"taccgl");this.showHideComments=function(){var e;if(this.ddmode==this.shddmode&&this.dddmode==this.shdddmode){return}this.removeClassRe(document.documentElement,"(no-)?taccgl-.d");this.addClass(document.documentElement,(this.dddmode?"":"no-")+"taccgl-3d");this.addClass(document.documentElement,(this.ddmode?"":"no-")+"taccgl-2d");this.shddmode=this.ddmode;this.shdddmode=this.dddmode;if(e=document.getElementById("taccgl_CommentImage")){var errurl="",src,srcset;if(this.errcode){errurl+="&errcode="+this.errcode;if(this.g&&this.g.getError){errurl+="&webglerr="+this.g.getError()}}if(this.glerr){errurl+="&glerr="+this.glerr}if(this.glmsg){errurl+="&msg="+this.glmsg.replace(/ /g,"+")}if(this.ddmode){src=taccgl_Com_ddmode;if(window.taccgl_Com_ddmode_set){srcset=taccgl_Com_ddmode_set}}if(this.dddmode){src=taccgl_Com_dddmode;if(window.taccgl_Com_dddmode_set){srcset=taccgl_Com_dddmode_set}}if(!(this.dddmode||this.ddmode)){src=taccgl_Com_off;if(window.taccgl_Com_off_set){srcset=taccgl_Com_off_set}}if(errurl){if(!src.match(/\?/)){src+="?"}src+=errurl;if(srcset){srcset=srcset.replace(/([^ ?]+)([?])?([^ ]+)? +([^ ]+)/g,"$1?$3"+errurl+" $4")}}e.src=src;if(srcset){e.srcset=srcset}}if(document.getElementsByClassName){var s=document.getElementsByClassName("taccgl_cl_ddmode");for(i=0;i<s.length;i++){s[i].style.display=this.ddmode?"inherit":"none"}s=document.getElementsByClassName("taccgl_cl_dddmode");for(i=0;i<s.length;i++){s[i].style.display=this.dddmode?"inherit":"none"}s=document.getElementsByClassName("taccgl_cl_active");for(i=0;i<s.length;i++){s[i].style.display=(this.ddmode||this.dddmode)?"inherit":"none"}s=document.getElementsByClassName("taccgl_cl_inactive");for(i=0;i<s.length;i++){s[i].style.display=(!(this.ddmode||this.dddmode))?"inherit":"none"}s=document.getElementsByClassName("taccgl_cl_can3derror");for(i=0;i<s.length;i++){s[i].style.display=(this.can3derror)?"inherit":"none"}}else{var i,all,el;if(document.all){all=document.all}else{all=document.getElementsByTagName("*")}for(i=0;i<all.length;i++){el=all[i];if(el.className){if(el.className.match(/taccgl_cl_inactive/)){el.style.display="block"}}}}};this.tonresize=function(){this.doHook(this.onResize)};this.resizeBody=function(){this.adjustQuality();return};this.adjustEye=function(x,y,z){this.stdEye.setPos(x,y,z)};this.parallaxEye=function(fx,fy,x,y,z){this.stdEye.parallax(fx,fy,x,y,z)};this.parallaxAdjust=function(){var b=document.body,de=document.documentElement;var st=b.scrollTop;if(de.scrollTop){st=de.scrollTop}if(window.pageYOffset){st=window.pageYOffset}var sl=b.scrollLeft;if(de.scrollLeft){st=de.scrollLeft}if(window.pageXOffset){sl=window.pageXOffset}this.o_sl=sl;this.o_st=st;var i;for(i=0;i<this.eyePositions.length;i++){var e=this.eyePositions[i];if(e){e.parallaxAdjust()}}var l=taccgl.stdLight;if(l.plxfx&&l.plxfy){l.setPosI(l.plxx+l.plxfx*sl,l.plxy+st*l.plxfy,l.plxz)}var i;for(i=0;i<taccgl.doParallax.length;i++){var t=taccgl.doParallax[i];if(t.cssAdjustFun){t.cssAdjustFun()}}};this.adjustCanvasRaw=function(x,y,w,h,pr){if(!this.cv){return}if(this.dddmode){if(taccgl_adjusterrcheck){if((taccgl.glerr=this.g.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on begin of adjustCanvasRaw")}}}if(window.taccgl_maxCanHeight){if(h>taccgl_maxCanHeight){h=taccgl_maxCanHeight}}if(window.taccgl_maxCanWidth){if(w>taccgl_maxCanWidth){w=taccgl_maxCanWidth}}if(x==this.canvasX&&y==this.canvasY&&w==this.canvasW&&h==this.canvasH&&this.canvasPr==pr){return}var wpr=Math.round(w*pr),hpr=Math.round(h*pr);if(this.canvasW!=w||this.canvasH!=h||this.canvasPr!=pr){this.cv.width=wpr;this.cv.style.width=w+"px";this.cv.height=hpr;this.cv.style.height=h+"px"}this.cv.style.top=y+"px";this.cv.style.left=x+"px";this.canvasX=x;this.canvasY=y;this.canvasW=w;this.canvasH=h;this.canvasPr=pr;if(this.dddmode){if(taccgl_adjusterrcheck){if((taccgl.glerr=this.g.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" before viewport")}}this.g.viewport(0,0,this.g.drawingBufferWidth,this.g.drawingBufferHeight);if(taccgl_adjusterrcheck){if((taccgl.glerr=this.g.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" after viewport "+w+","+h)}}}this.setCanvasDim(x,y,w,h)};this.adjustCanvas=function(x,y,w,h,pr){var b=document.body,st=b.scrollTop,sl=b.scrollLeft,de=document.documentElement;if(de.scrollTop){st=de.scrollTop}if(de.scrollLeft){sl=de.scrollLeft}if(window.pageXOffset){sl=window.pageXOffset}if(window.pageYOffset){st=window.pageYOffset}var wiw=window.innerWidth,wih=window.innerHeight,vp=window.visualViewport;if(vp){wiw=vp.width;wih=vp.height;sl=vp.pageLeft;st=vp.pageTop}if(this.isOldiOS){wiw=window.screen.width;wih=window.screen.height}if(x<sl){x=sl}if(y<st){y=st}var x1=x+w,y1=y+h;if(x1>wiw+sl){x1=wiw+sl;x=x1-w}if(y1>wih+st){y1=wih+st;y=y1-h}if(x<sl){x=sl}if(y<st){y=st}this.adjustCanvasRaw(x,y,x1-x,y1-y,pr)};this.adjustLowQuality=function(){var hpr=this.pr/2;if(this.isOldiOS){hpr=this.pr}if(this.lqc_w){this.adjustCanvas(this.lqc_x,this.lqc_y,this.lqc_w,this.lqc_h,hpr)}else{var x=0,y=0,b=document.body;var st=b.scrollTop,sl=b.scrollLeft,de=document.documentElement;if(de.scrollTop){st=de.scrollTop}if(de.scrollLeft){sl=de.scrollLeft}if(window.pageXOffset){sl=window.pageXOffset}if(window.pageYOffset){st=window.pageYOffset}var wiw=window.innerWidth,wih=window.innerHeight,vp=window.visualViewport;if(vp){wiw=vp.width;wih=vp.height;sl=vp.pageLeft;st=vp.pageTop}var h=wih,w=wiw;x=sl;y=st;var mw=512,mh=512;if(wiw>mw){x=sl+Math.floor((wiw-mw)/2);w=mw}if(wih>mh){y=st+Math.floor((wih-mh)/2);h=mh}this.adjustCanvas(x,y,w,h,hpr)}};this.documentWidth=function(){var w=document.body.clientWidth,e=document.documentElement;if(e&&e.clientWidth&&e.clientWidth>w){w=e.clientWidth}return w};this.documentHeight=function(){var h=document.body.clientHeight,e=document.documentElement;if(e&&e.clientHeight&&e.clientHeight>h){h=e.clientHeight}return h};this.adjustNormalQuality=function(pr){if(this.nqc_w){this.adjustCanvas(this.nqc_x,this.nqc_y,this.nqc_w,this.nqc_h,pr)}else{var x=0,y=0,w=this.documentWidth(),h=this.documentHeight();var mw=1024;if(w>mw){x=Math.floor((w-mw)/2);w=mw}this.adjustCanvas(x,y,w,h,pr)}};this.adjustHighQuality=function(){this.adjustCanvas(0,0,this.documentWidth(),this.documentHeight()+this.heightExtension,this.pr)};this.adjustQuality=function(){if(this.quality>=taccgl.hardFailQ){this.quality=taccgl.hardFailQ-1}if(this.quality==1){this.adjustLowQuality()}if(this.quality==2&&!this.isOldiOS){this.adjustNormalQuality(this.pr/2)}if(this.quality==3||(this.quality==2&&this.isOldiOS)){this.adjustNormalQuality(this.pr)}if(this.quality==4){this.adjustNormalQuality(this.pr)}if(this.quality==5){this.adjustHighQuality()}if(taccgl.draw_running){this.measureQuality()}this.doHook(taccgl.onAdjustQuality)};this.reduceQuality=function(){if(this.qualitylock){return}if(this.draw_meaFrames<60){if(this.quality<this.softFailQ){this.softFailQ=this.quality;this.softFailCnt=0}if(this.softFailQ==this.quality){this.softFailCnt++}if(this.softFailCnt>2){this.hardFailQ=this.softFailQ}}this.quality--;this.adjustQuality();this.draw_meaFrames=-3;this.draw_meaAdjust=0;this.draw_meaIgnore=0;taccgl.resetGPUTimers()};this.onDprChange=function(){var pr=this.pr;this.detectPr();if(pr!=this.pr){taccgl_onresize();return true}else{return false}};this.LQCanvas=function(x,y,w,h){this.lqc_x=x;this.lqc_y=y;this.lqc_w=w;this.lqc_h=h;if(this.quality==1){this.adjustQuality()}};this.NQCanvas=function(x,y,w,h){this.nqc_x=x;this.nqc_y=y;this.nqc_w=w;this.nqc_h=h;if(this.quality>=2&&this.quality<=4){this.adjustQuality()}};this.beginIgnoreDrop=function(){this.startTimeIGD=this.perfnow()};this.endIgnoreDrop=function(pause){if(!this.startTimeIGD){return}var now=this.perfnow();if(pause){var d=now-(this.currenttime*this.draw_duration+this.draw_startTime);this.draw_startTime+=d}else{}this.draw_meaIgnore=3};this.setHandlers=function(){var vp=window.visualViewport;if(vp){vp.addEventListener("scroll",taccgl_onscroll);window.onscroll=taccgl_onscroll}else{window.onscroll=taccgl_onscroll}window.onresize=taccgl_onresize;document.body.onresize=taccgl_onresize;document.body.onmousemove=taccgl_onmousemove;window.addEventListener("mousewheel",taccgl_onmousewheel,{passive:false})};this.init=function(){this.init1();this.setHandlers();this.createShaders();this.ddFallBack()};this.createVertexShader=function(t){var g=this.g;if(!t.match(/\n/)){var el=document.getElementById(t);if(el){t=el.innerText;if(!t){t=el.text}}}var vs=g.createShader(g.VERTEX_SHADER);g.shaderSource(vs,t);g.compileShader(vs);if(!g.getShaderParameter(vs,g.COMPILE_STATUS)){this.webglerror=true}return vs};this.logNumberedText=function(t){var a=t.split("\n");var i=0,r="";while(i<a.length){r+=(i+1)+"\t"+a[i]+"\n";i++}taccgl.clog(r)};this.createFragmentShader=function(t){if(!this.dddmode){return null}if(!t.match(/\n/)){var el=document.getElementById(t);if(el){t=el.innerText;if(!t){t=el.text}}}var fs=this.g.createShader(this.g.FRAGMENT_SHADER);this.g.shaderSource(fs,t);this.g.compileShader(fs);if(!this.g.getShaderParameter(fs,this.g.COMPILE_STATUS)){this.webglerror=true}return fs};this.bindProgramAttributes=function(p){var g=this.g;g.bindAttribLocation(p,0,"pos");g.bindAttribLocation(p,1,"origin");g.bindAttribLocation(p,2,"texpos");g.bindAttribLocation(p,3,"rotP");g.bindAttribLocation(p,4,"rotA");g.bindAttribLocation(p,5,"color");g.bindAttribLocation(p,6,"texmix");g.bindAttribLocation(p,7,"accel");g.bindAttribLocation(p,8,"normal")};this.createShaderProgram=function(vs,fs){var g=this.g,p=g.createProgram();g.attachShader(p,vs);g.attachShader(p,fs);this.bindProgramAttributes(p);g.linkProgram(p);if(!g.isProgram(p)||!g.getProgramParameter(p,g.LINK_STATUS)){console.timeEnd("createShaderProgram");this.webglerror=true;g.detachShader(p,vs);g.detachShader(p,fs);g.deleteProgram(p);return null}g.validateProgram(p);if(!g.isProgram(p)||!g.getProgramParameter(p,g.LINK_STATUS)||!g.getProgramParameter(p,g.VALIDATE_STATUS)){this.webglerror=true;g.detachShader(p,vs);g.detachShader(p,fs);g.deleteProgram(p);return null}return p};this.newShaderConfigPrototype=function(){if(this.shaderConfigPrototype){return}var pt=this.shaderConfigPrototype=new taccglShaderConfigPrototype();pt.initShader();taccglShaderConfigEmpty.prototype=pt};this.createShaderConfig=function(){this.newShaderConfigPrototype();return new taccglShaderConfigEmpty()};this.createStdShaderConfig=this.ssc=function(n){if(!this.initialized){this.begin()}this.newShaderConfigPrototype();var sc=new taccglShaderConfigEmpty();if(n){sc.extendShader(n)}return sc};this.cvxmin=function(z){return((this.stdEye.eyeX-this.cvpx)*z+this.cvpx*this.stdEye.eyeZ)/this.stdEye.eyeZ};this.cvxmax=function(z){return -((this.cvpw-this.stdEye.eyeX+this.cvpx)*z-this.stdEye.eyeZ*this.cvpw-this.cvpx*this.stdEye.eyeZ)/this.stdEye.eyeZ};this.cvymin=function(z){return((this.stdEye.eyeY-this.cvpy)*z+this.cvpy*this.stdEye.eyeZ)/this.stdEye.eyeZ};this.cvymax=function(z){return -((this.cvph-this.stdEye.eyeY+this.cvpy)*z-this.stdEye.eyeZ*this.cvph-this.cvpy*this.stdEye.eyeZ)/this.stdEye.eyeZ};this.adjustShcvp=function(){var zfront=this.zFront,zback=this.zBack;var xmin=this.cvxmin(zfront),xmax=this.cvxmax(zfront);this.shcvpw=(this.stdLight.z*xmin-this.stdLight.z*xmax)/(zfront-this.stdLight.z);this.shcvpx=(this.stdLight.x*zfront-this.stdLight.z*xmin)/(zfront-this.stdLight.z);xmin=this.cvxmin(zback);xmax=this.cvxmax(zback);var cx=(this.stdLight.x*zback-this.stdLight.z*xmin)/(zback-this.stdLight.z);if(cx<this.shcvpx){this.shcvpw+=this.shcvpx-cx;this.shcvpx=cx}var cw=(this.stdLight.z*xmin-this.stdLight.z*xmax)/(zback-this.stdLight.z);if(cx+cw>this.shcvpx+this.shcvpw){this.shcvpw=cx+cw-this.shcvpx}var ymin=this.cvymin(zfront),ymax=this.cvymax(zfront);this.shcvph=(this.stdLight.z*ymin-this.stdLight.z*ymax)/(zfront-this.stdLight.z);this.shcvpy=(this.stdLight.y*zfront-this.stdLight.z*ymin)/(zfront-this.stdLight.z);ymin=this.cvymin(zback);ymax=this.cvymax(zback);var cy=(this.stdLight.y*zback-this.stdLight.z*ymin)/(zback-this.stdLight.z);if(cy<this.shcvpy){this.shcvph+=this.shcvpy-cy;this.shcvpy=cy}var ch=(this.stdLight.z*ymin-this.stdLight.z*ymax)/(zback-this.stdLight.z);if(cy+ch>this.shcvpy+this.shcvph){this.shcvph=cy+ch-this.shcvpy}};this.setCanvasDim=function(cpx,cpy,w,h){this.cvpx=cpx;this.cvpy=cpy;this.cvpw=w;this.cvph=h;this.adjustShcvp()};this.createShaders=function(){if(this.stdsc){this.stdsc.freeCompiled()}else{this.stdsc=this.createStdShaderConfig("taccgl_Shaders")}this.stdsc.compile();this.p=this.stdsc.p;if(!this.p){this.dddmode=false}if(this.stdsc.advProg){this.shadowEna=true}else{this.shadowEna=false}};this.replaceShaderVariables=function(t){t=t.replace(/\$\$EYEX/g,Math.floor(this.stdEye.eyeX)+".0");t=t.replace(/\$\$EYEY/g,Math.floor(this.stdEye.eyeY)+".0");t=t.replace(/\$\$EYEZ/g,Math.floor(this.stdEye.eyeZ)+".0");t=t.replace(/\$\$TEXTURECANVASWIDTH/g,taccgl_texCanWidth+".0");t=t.replace(/\$\$TEXTURECANVASHEIGHT/g,taccgl_texCanHeight+".0");return t};this.setupTextures=function(){if(!this.dddmode){return}var timestr;var g=taccgl.g;var e;var tcv=document.getElementById("taccgl_textureCanvas"),tcv2=document.getElementById("taccgl_textureCanvas2");if(tcv.getContext){if(!this.draw_texturecanvas){this.draw_texturecanvas=g.createTexture();this.textureCanvasChanged=true}if(!this.draw_texturecanvas2){this.draw_texturecanvas2=g.createTexture();this.textureCanvasChanged2=true}if(this.textureCanvasChanged){var tex=this.draw_texturecanvas;g.activeTexture(g.TEXTURE0);g.bindTexture(g.TEXTURE_2D,tex);var t=tcv.getContext("2d");g.pixelStorei(g.UNPACK_PREMULTIPLY_ALPHA_WEBGL,true);g.texImage2D(g.TEXTURE_2D,0,g.RGBA,g.RGBA,g.UNSIGNED_BYTE,tcv);if(taccgl_mipmap){g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MAG_FILTER,g.LINEAR);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MIN_FILTER,g.LINEAR_MIPMAP_NEAREST);g.generateMipmap(g.TEXTURE_2D)}else{g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MAG_FILTER,g.LINEAR);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MIN_FILTER,g.LINEAR);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_WRAP_S,g.CLAMP_TO_EDGE);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_WRAP_T,g.CLAMP_TO_EDGE)}this.textureCanvasChanged=false}if(this.textureCanvasChanged2){tex=this.draw_texturecanvas2;g.activeTexture(g.TEXTURE1);g.bindTexture(g.TEXTURE_2D,tex);t=tcv2.getContext("2d");g.pixelStorei(g.UNPACK_PREMULTIPLY_ALPHA_WEBGL,true);g.texImage2D(g.TEXTURE_2D,0,g.RGBA,g.RGBA,g.UNSIGNED_BYTE,tcv2);if(taccgl_mipmap){g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MAG_FILTER,g.LINEAR);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MIN_FILTER,g.LINEAR_MIPMAP_NEAREST);g.generateMipmap(g.TEXTURE_2D)}else{g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MAG_FILTER,g.LINEAR);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MIN_FILTER,g.LINEAR);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_WRAP_S,g.CLAMP_TO_EDGE);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_WRAP_T,g.CLAMP_TO_EDGE)}this.textureCanvasChanged2=false}}this.draw_meaIgnore=3};this.cvert=function(r,g,b,o){};this.nvertAcceleration=function(x,y,z){this.vertAcceleration[4*this.vertI-4]=x;this.vertAcceleration[4*this.vertI-3]=y;this.vertAcceleration[4*this.vertI-2]=z};this.nvertTexMove=function(s,t){this.vertTexPos[4*this.vertI-2]=s/taccgl_texCanWidth;this.vertTexPos[4*this.vertI-1]=t/taccgl_texCanHeight};this.nvertTexMove4=function(s0,t0,s1,t1){this.vertTexPos[4*this.vertI-4]=s0/taccgl_texCanWidth;this.vertTexPos[4*this.vertI-3]=t0/taccgl_texCanHeight;this.vertTexPos[4*this.vertI-2]=s1/taccgl_texCanWidth;this.vertTexPos[4*this.vertI-1]=t1/taccgl_texCanHeight};this.nvertRot=function(px,py,pz,ax,ay,az,from,to,acc){if(!acc){acc=0}if(from!=0&&to==0){var breakhere=55}if(az<0){to=-to;from=-from;ax=-ax;ay=-ay}this.vertRotP[4*this.vertI-4]=px;this.vertRotP[4*this.vertI-3]=py;this.vertRotP[4*this.vertI-2]=pz;this.vertRotP[4*this.vertI-1]=from;this.vertRotA[4*this.vertI-4]=ax;this.vertRotA[4*this.vertI-3]=ay;this.vertRotA[4*this.vertI-2]=acc;this.vertRotA[4*this.vertI-1]=to};this.nvertN1=function(nx1,ny1,nz1){var nx0=this.vertNormal[4*this.vertI-4],ny0=this.vertNormal[4*this.vertI-3],nz0=this.vertNormal[4*this.vertI-2],nl0=Math.sqrt(nx0*nx0+ny0*ny0+nz0*nz0),nl1=Math.sqrt(nx1*nx1+ny1*ny1+nz1*nz1),ax=-ny0*nz1+nz0*ny1,ay=-nz0*nx1+nx0*nz1,az=-nx0*ny1+ny0*nx1,al=Math.sqrt(ax*ax+ay*ay+az*az),w=Math.PI*2-Math.acos(Math.max(-1,Math.min((nx0*nx1+ny0*ny1+nz0*nz1)/nl0/nl1,1))),w0=Math.PI*2;if(Math.abs(w-w0)<0.0001){w=w0=0}else{az*=1}ax/=al;ay/=al;az/=al;this.vertRotP[4*this.vertI-4]=this.vertPos[4*this.vertI-4];this.vertRotP[4*this.vertI-3]=this.vertPos[4*this.vertI-3];this.vertRotP[4*this.vertI-2]=this.vertPos[4*this.vertI-2];this.vertRotP[4*this.vertI-1]=w0;this.vertRotA[4*this.vertI-4]=ax;this.vertRotA[4*this.vertI-3]=ay;this.vertRotA[4*this.vertI-2]=az;this.vertRotA[4*this.vertI-1]=w};this.nvertTime=function(basetime,duration,flags){this.vertOrigin[4*this.vertI+3]=basetime;this.vertPos[4*this.vertI+3]=(flags&65535)+(flags>>16)*0.25;this.vertAcceleration[4*this.vertI+3]=duration;this.vertI+=1};this.nvertMove=function(x0,y0,z0,x,y,z,nx,ny,nz,spec,s,t,flags,basetime,duration){if(16*this.vertI>=this.vertBufferSize){this.ResizeVertexBuffers(2*this.vertBufferSize)}this.vertOrigin[4*this.vertI]=x0;this.vertOrigin[4*this.vertI+1]=y0;this.vertOrigin[4*this.vertI+2]=z0;this.vertOrigin[4*this.vertI+3]=basetime;this.vertPos[4*this.vertI]=x;this.vertPos[4*this.vertI+1]=y;this.vertPos[4*this.vertI+2]=z;this.vertPos[4*this.vertI+3]=(flags&65535)+(flags>>16)*0.25;this.vertTexPos[4*this.vertI]=s/taccgl_texCanWidth;this.vertTexPos[4*this.vertI+1]=t/taccgl_texCanHeight;this.vertTexPos[4*this.vertI+2]=s/taccgl_texCanWidth;this.vertTexPos[4*this.vertI+3]=t/taccgl_texCanHeight;this.vertRotA[4*this.vertI+3]=0;this.vertRotP[4*this.vertI+3]=0;this.vertAcceleration[4*this.vertI]=0;this.vertAcceleration[4*this.vertI+1]=0;this.vertAcceleration[4*this.vertI+2]=0;this.vertAcceleration[4*this.vertI+3]=duration;this.vertNormal[4*this.vertI+0]=nx;this.vertNormal[4*this.vertI+1]=ny;this.vertNormal[4*this.vertI+2]=nz;this.vertNormal[4*this.vertI+3]=spec;this.vertI+=1};this.nvertColor=function(c0s,c0t,c1s,c1t,m0,m1,mm0,mm1){var i=4*this.vertI,vc=this.vertColor,tm=this.vertTexmix;vc[i-4]=c0s;vc[i-3]=c0t;vc[i-2]=c1s;vc[i-1]=c1t;tm[i-4]=m0;tm[i-3]=mm0;tm[i-2]=m1;tm[i-1]=mm1};this.nvertColor3=function(c0s,c0t,c1s,c1t,m0,m1,mm0,mm1){var i=4*this.vertI,vc=this.vertColor,tm=this.vertTexmix;vc[i-4]=c0s;vc[i-3]=c0t;vc[i-2]=c1s;vc[i-1]=c1t;tm[i-4]=m0;tm[i-3]=mm0;tm[i-2]=m1;tm[i-1]=mm1;vc[i-8]=c0s;vc[i-7]=c0t;vc[i-6]=c1s;vc[i-5]=c1t;tm[i-8]=m0;tm[i-7]=mm0;tm[i-6]=m1;tm[i-5]=mm1;vc[i-12]=c0s;vc[i-11]=c0t;vc[i-10]=c1s;vc[i-9]=c1t;tm[i-12]=m0;tm[i-11]=mm0;tm[i-10]=m1;tm[i-9]=mm1};this.nvertColor6=function(c0s,c0t,c1s,c1t,m0,m1,mm0,mm1){var i=4*this.vertI,vc=this.vertColor,tm=this.vertTexmix;vc[i-4]=c0s;vc[i-3]=c0t;vc[i-2]=c1s;vc[i-1]=c1t;tm[i-4]=m0;tm[i-3]=mm0;tm[i-2]=m1;tm[i-1]=mm1;vc[i-8]=c0s;vc[i-7]=c0t;vc[i-6]=c1s;vc[i-5]=c1t;tm[i-8]=m0;tm[i-7]=mm0;tm[i-6]=m1;tm[i-5]=mm1;vc[i-12]=c0s;vc[i-11]=c0t;vc[i-10]=c1s;vc[i-9]=c1t;tm[i-12]=m0;tm[i-11]=mm0;tm[i-10]=m1;tm[i-9]=mm1;vc[i-16]=c0s;vc[i-15]=c0t;vc[i-14]=c1s;vc[i-13]=c1t;tm[i-16]=m0;tm[i-15]=mm0;tm[i-14]=m1;tm[i-13]=mm1;vc[i-20]=c0s;vc[i-19]=c0t;vc[i-18]=c1s;vc[i-17]=c1t;tm[i-20]=m0;tm[i-19]=mm0;tm[i-18]=m1;tm[i-17]=mm1;vc[i-24]=c0s;vc[i-23]=c0t;vc[i-22]=c1s;vc[i-21]=c1t;tm[i-24]=m0;tm[i-23]=mm0;tm[i-22]=m1;tm[i-21]=mm1};this.nvertNormal=function(nx,ny,nz,spec){this.vertNormal[4*this.vertI-4]=nx;this.vertNormal[4*this.vertI-3]=ny;this.vertNormal[4*this.vertI-2]=nz;this.vertNormal[4*this.vertI-1]=spec};this.nvertNormal3=function(nx,ny,nz){this.vertNormal[4*this.vertI-4]=nx;this.vertNormal[4*this.vertI-3]=ny;this.vertNormal[4*this.vertI-2]=nz};this.nvertOffset=function(i){this.vertI+=i};this.AllocateVertexBuffers=function(size){size=Math.ceil(size/16)*16;var vertPosBuffer=new ArrayBuffer(size);this.vertPos=new Float32Array(vertPosBuffer);var vertOriginBuffer=new ArrayBuffer(size);this.vertOrigin=new Float32Array(vertOriginBuffer);var vertTexPosBuffer=new ArrayBuffer(size);this.vertTexPos=new Float32Array(vertTexPosBuffer);var vertRotPBuffer=new ArrayBuffer(size);this.vertRotP=new Float32Array(vertRotPBuffer);var vertRotABuffer=new ArrayBuffer(size);this.vertRotA=new Float32Array(vertRotABuffer);var vertcolorBuffer=new ArrayBuffer(size);this.vertColor=new Float32Array(vertcolorBuffer);var verttexmixBuffer=new ArrayBuffer(size);this.vertTexmix=new Float32Array(verttexmixBuffer);var vertAccelerationBuffer=new ArrayBuffer(size);this.vertAcceleration=new Float32Array(vertAccelerationBuffer);var vertnormalBuffer=new ArrayBuffer(size);this.vertNormal=new Float32Array(vertnormalBuffer);this.vertBufferSize=size};this.ResizeVertexBuffers=function(size){var vertPos=this.vertPos;var vertOrigin=this.vertOrigin;var vertTexPos=this.vertTexPos;var vertRotP=this.vertRotP;var vertRotA=this.vertRotA;var vertColor=this.vertColor;var vertTexmix=this.vertTexmix;var vertAcceleration=this.vertAcceleration;var vertNormal=this.vertNormal;this.AllocateVertexBuffers(size);var cs=size;if(this.vertBufferSize<cs){cs=this.vertBufferSize}this.vertPos.set(vertPos);this.vertOrigin.set(vertOrigin);this.vertTexPos.set(vertTexPos);this.vertRotP.set(vertRotP);this.vertRotA.set(vertRotA);this.vertColor.set(vertColor);this.vertTexmix.set(vertTexmix);this.vertAcceleration.set(vertAcceleration);this.vertNormal.set(vertNormal);this.vertBufferSize=size};this.StartRender=function(){if(!this.initialized){this.init()}this.delno++;if(this.dddmode){if(!this.vertPos){var size;if(window.taccgl_vertexMem){size=taccgl_vertexMem}else{size=10000}this.AllocateVertexBuffers(size)}this.vertI=0;this.shprog=Array(0);this.shprogfrom=Array(0);this.shprog.push(this.stdsc);this.shprogfrom.push(0)}if(this.ddmode){this.AA=Array(0);this.AAstartedLength=0}this.duration=0;this.foregroundCnt=0;this.currenttime=0;this.doat=Array(0);this.showAfterAnimation=Array(0);this.doParallax=Array(0);this.renderingStarted=true;this.adjustQuality();this.lqc_w=null};this.BgControl=function(b){this.vBgControl=b};this.setEndMode=function(m){this.endMode=m};this.setEndStyle=function(st){if(st){this.endStyle=st}else{this.endStyle={transition:"opacity 0.25s, visibility 0.25s",opacity:"0",visibility:"hidden"}}};this.begin=function(){if(!this.initialized){this.init();this.StartRender()}};this.adjustForeground=function(){if(this.foregroundCnt>0){this.cv.style.zIndex=this.foreground_zIndex}else{this.cv.style.zIndex=this.background_zIndex}};this.incForeground=function(){this.foregroundCnt++;if(this.foregroundCnt==1){this.adjustForeground()}};this.decForeground=function(){this.foregroundCnt--;if(this.foregroundCnt==0){this.adjustForeground()}if(this.foregroundCnt==-1){taccgl.glAlert("decForeground called more often that incForeground")}};this.bindDraw=function(g,p){g.clearColor(0,0,0,0);g.enable(g.DEPTH_TEST);g.depthFunc(g.LEQUAL);g.blendFunc(g.ONE,g.ONE_MINUS_SRC_ALPHA);g.enable(g.BLEND);this.draw_locpos=g.getAttribLocation(p,"pos");this.draw_locOrigin=g.getAttribLocation(p,"origin");this.draw_loctexpos=g.getAttribLocation(p,"texpos");this.draw_locrotp=g.getAttribLocation(p,"rotP");this.draw_locrota=g.getAttribLocation(p,"rotA");this.draw_loccolor=g.getAttribLocation(p,"color");this.draw_loctexmix=g.getAttribLocation(p,"texmix");this.draw_locnormal=g.getAttribLocation(p,"normal");this.draw_locacceleration=g.getAttribLocation(p,"accel");this.draw_locuTexture=g.getUniformLocation(p,"uTexture");this.draw_locuTexture2=g.getUniformLocation(p,"uTexture2");this.createAndUploadVertexBuffers();this.cv.style.transition="";this.cv.style.display="";this.cv.style.opacity=1;this.cv.style.visibility="visible";this.setupShprog();this.setVertAttrib();g.activeTexture(g.TEXTURE0);g.bindTexture(g.TEXTURE_2D,this.draw_texturecanvas);g.activeTexture(g.TEXTURE1);g.bindTexture(g.TEXTURE_2D,this.draw_texturecanvas2)};this.createAndUploadVertexBuffers=function(){var g=this.g;var drawpar=g.DYNAMIC_DRAW;this.uploadedVertBufferSize=this.vertBufferSize;this.draw_vertexPosBufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_locpos);g.bindBuffer(g.ARRAY_BUFFER,this.draw_vertexPosBufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertPos,drawpar);this.draw_originBufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_locOrigin);g.bindBuffer(g.ARRAY_BUFFER,this.draw_originBufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertOrigin,drawpar);this.draw_vertexTexPosBufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_loctexpos);g.bindBuffer(g.ARRAY_BUFFER,this.draw_vertexTexPosBufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertTexPos,drawpar);if(this.draw_locrotp>=0){this.draw_rotPBufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_locrotp);g.bindBuffer(g.ARRAY_BUFFER,this.draw_rotPBufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertRotP,drawpar)}this.draw_accelerationBufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_locacceleration);g.bindBuffer(g.ARRAY_BUFFER,this.draw_accelerationBufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertAcceleration,drawpar);if(this.draw_locrota>=0){this.draw_rotABufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_locrota);g.bindBuffer(g.ARRAY_BUFFER,this.draw_rotABufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertRotA,drawpar)}if(this.draw_loccolor>=0){this.draw_colorBufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_loccolor);g.bindBuffer(g.ARRAY_BUFFER,this.draw_colorBufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertColor,drawpar)}if(this.draw_loctexmix>=0){this.draw_texmixBufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_loctexmix);g.bindBuffer(g.ARRAY_BUFFER,this.draw_texmixBufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertTexmix,drawpar)}if(this.draw_locnormal>=0){this.draw_normalBufferObjekt=g.createBuffer();g.enableVertexAttribArray(this.draw_locnormal);g.bindBuffer(g.ARRAY_BUFFER,this.draw_normalBufferObjekt);g.bufferData(g.ARRAY_BUFFER,this.vertNormal,drawpar)}};this.setVertAttrib=function(){var jaccobj=taccgl;var g=this.g;g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_vertexPosBufferObjekt);g.vertexAttribPointer(jaccobj.draw_locpos,4,g.FLOAT,false,0,0);g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_originBufferObjekt);g.vertexAttribPointer(jaccobj.draw_locOrigin,4,g.FLOAT,false,0,0);g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_vertexTexPosBufferObjekt);g.vertexAttribPointer(jaccobj.draw_loctexpos,4,g.FLOAT,false,0,0);if(jaccobj.draw_locrotp>=0){g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_rotPBufferObjekt);g.vertexAttribPointer(jaccobj.draw_locrotp,4,g.FLOAT,false,0,0)}if(jaccobj.draw_locrota>=0){g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_rotABufferObjekt);g.vertexAttribPointer(jaccobj.draw_locrota,4,g.FLOAT,false,0,0)}if(jaccobj.draw_loccolor>=0){g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_colorBufferObjekt);g.vertexAttribPointer(jaccobj.draw_loccolor,4,g.FLOAT,false,0,0)}if(jaccobj.draw_loctexmix>=0){g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_texmixBufferObjekt);g.vertexAttribPointer(jaccobj.draw_loctexmix,4,g.FLOAT,false,0,0)}if(jaccobj.draw_locnormal>=0){g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_normalBufferObjekt);g.vertexAttribPointer(jaccobj.draw_locnormal,4,g.FLOAT,false,0,0)}g.bindBuffer(g.ARRAY_BUFFER,jaccobj.draw_accelerationBufferObjekt);g.vertexAttribPointer(jaccobj.draw_locacceleration,4,g.FLOAT,false,0,0)};this.setupShadow=function(){var g=this.g;var h=this.shadowH=2048;var w=this.shadowW=2048;this.shadowfb=g.createFramebuffer();g.bindFramebuffer(g.FRAMEBUFFER,this.shadowfb);this.shadowdb=g.createRenderbuffer();g.bindRenderbuffer(g.RENDERBUFFER,this.shadowdb);g.renderbufferStorage(g.RENDERBUFFER,g.DEPTH_COMPONENT16,w,h);g.framebufferRenderbuffer(g.FRAMEBUFFER,g.DEPTH_ATTACHMENT,g.RENDERBUFFER,this.shadowdb);this.shadowtex=g.createTexture();g.activeTexture(g.TEXTURE2);g.bindTexture(g.TEXTURE_2D,this.shadowtex);g.activeTexture(g.TEXTURE2);g.texImage2D(g.TEXTURE_2D,0,g.RGBA,w,h,0,g.RGBA,g.UNSIGNED_BYTE,null);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MAG_FILTER,g.LINEAR);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_MIN_FILTER,g.LINEAR);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_WRAP_S,g.CLAMP_TO_EDGE);g.texParameteri(g.TEXTURE_2D,g.TEXTURE_WRAP_T,g.CLAMP_TO_EDGE);g.framebufferTexture2D(g.FRAMEBUFFER,g.COLOR_ATTACHMENT0,g.TEXTURE_2D,this.shadowtex,0)};this.setupShprog=function(){this.draw_vertexnumber=this.vertI;this.shprogRun=this.shprog.slice();this.shprogfromRun=this.shprogfrom.slice();if(this.vertI==this.shprogfrom[this.shprogfrom.length-1]){this.shprogRun.pop();this.shprogfromRun.pop()}this.draw_shprognumber=this.shprogRun.length};this.startDraw=function(g,p){this.detectPr();taccgl.parallaxAdjust();this.adjustQuality();g=this.g;p=this.p;if(!this.vBgControl){this.incForeground()}else{this.adjustForeground()}this.draw_lastSwitchTime=-10;this.draw_duration=1000;this.doatI=0;this.pendingResizeBody=false;if(!this.extTimer){var ua=navigator.userAgent;this.isAndroid=ua.match(/Android/)!=null;var force=location.href.match(/exttimer/)!=null;if(!this.isAndroid||force){this.extTimer=g.getExtension("EXT_disjoint_timer_query")}else{this.extTimer=null}}this.resetGPUTimers();this.draw_frames=this.draw_meaFrames=0;this.slowStartupTime=0;this.slowStartupFrames=0;this.bindDraw(g,p);if(this.webglerror){return}this.draw_startTime=this.draw_meaTime=this.meaA[0]=this.perfnow();this.draw_meaAdjust=0;this.draw_meaIgnore=0;this.loadTest=false;this.loadTestl=0;this.rAFdeviation=0;this.rAFcnt=0;if(this.shadow){this.setupShadow()}if(this.webglerror){return}var plug=new taccglAnimPlug();plug.attime=this.duration;this.newDoat(plug);this.draw_running=true;this.busy=true;this.removeClassRe(document.documentElement,"(no-)?taccgl-run");this.addClass(document.documentElement,"taccgl-run");taccgl_draw3d()};this.updateDraw=function(){var g=this.g,e;var drawpar=g.DYNAMIC_DRAW;this.createAndUploadVertexBuffers();this.setVertAttrib();this.doat[this.doat.length-1].attime=this.duration;this.setupShprog();taccgl.draw_meaIgnore=3};this.updateDrawDD=function(){this.doat[this.doat.length-1].attime=this.duration;this.AAstartedLength=this.AA.length};this.measureQuality=function(){this.qualityCnt[this.quality]++;var s=this.qualityCnt[1]+this.qualityCnt[2]+this.qualityCnt[3]+this.qualityCnt[4]+this.qualityCnt[5],me=document.getElementById("taccgl_ImmediateMeasureImage");if(me){me.src=taccgl_ImmediateMeasureImage+this.quality+".png";var q=this.quality;if(q==0){me.title="Slow taccGL Animations Disabled."}if(q==1){me.title="For performance reasons taccGL Animations run on a small portion of the window only. Shadows are disabled."}if(q==2){me.title="For performance reasons taccGL Animations are simplified and running with low resolution."}if(q==3){me.title="For performance reasons taccGL Animations are simplified, use per Vertex shading, and do not run full window but still on a big portion of the window. Shadows are disabled."}if(q==4){me.title="For performance reasons taccGL Animations are simplified and do not run full window but still on a big portion of the window. Shadows are disabled."}if(q==5){me.title="taccGL Animations run full speed in full window mode "+(this.shadowEna?"with":"without")+" shadows."}}if(s==10){var p=this.qualityCnt[1]+this.qualityCnt[2]*2+this.qualityCnt[3]*3+this.qualityCnt[4]*4+this.qualityCnt[5]*5;var q=Math.round(p/s);me=document.getElementById("taccgl_MeasureImage");if(me){me.src=taccgl_MeasureImage+q+".png"}}};this.applyObjStyle=function(el,st){var n;for(n in st){el.style[n]=st[n]}};this.NonDisplay3DCanvas=function(){if(taccgl.endMode=="background"){this.foregroundCnt=0;this.adjustForeground()}else{if(taccgl.endMode=="foreground"){this.incForeground()}else{this.applyObjStyle(this.cv,this.endStyle);if(taccgl.controller&&taccgl.controller.invisibleCanvas){taccgl.controller.invisibleCanvas()}}}this.foregroundCnt=0};this.drawTerminated=function(){this.NonDisplay3DCanvas();this.g.deleteBuffer(this.draw_vertexPosBufferObjekt);this.g.deleteBuffer(this.draw_originBufferObjekt);this.g.deleteBuffer(this.draw_vertexTexPosBufferObjekt);this.g.deleteBuffer(this.draw_rotPBufferObjekt);this.g.deleteBuffer(this.draw_rotABufferObjekt);this.g.deleteBuffer(this.draw_colorBufferObjekt);this.g.deleteBuffer(this.draw_texmixBufferObjekt);this.g.deleteBuffer(this.draw_normalBufferObjekt);this.g.deleteBuffer(this.draw_accelerationBufferObjekt);this.g.deleteTexture(this.draw_texturecanvas);this.draw_texturecanvas=null;this.g.deleteTexture(this.draw_texturecanvas2);this.draw_texturecanvas2=null;this.draw_running=false;this.busy=false;var vel=document.getElementById("taccglVertexNumber");if(vel){vel.innerHTML=this.draw_vertexnumber+"/"+this.draw_frames+"/"+this.draw_meaFrames/(this.perfnow()-this.draw_meaTime)*1000}for(i=0;i<this.showAfterAnimation.length;i++){var pv=this.showAfterAnimation[i].el.taccgl.postVisibility;var ov=this.showAfterAnimation[i].el.taccgl.postOpacity;if(pv||pv==""){this.showAfterAnimation[i].el.style.visibility=pv}if(ov||ov==""){this.showAfterAnimation[i].el.style.opacity=ov}}this.measureQuality();var uTime=(this.perfnow()-taccgl.draw_meaTime)/taccgl.draw_duration,frate=taccgl.draw_meaFrames/uTime;if(frate>50&&taccgl.quality<5){taccgl.quality++}this.showHideComments();this.removeClassRe(document.documentElement,"(no-)?taccgl-run");this.addClass(document.documentElement,"no-taccgl-run");this.StartRender()};this.drawImmediateTerm=function(errcode){this.errcode=errcode;if(this.reqAnimFrameId){window.taccgl_cancelAnimationFrame(this.reqAnimFrameId)}clearInterval(this.interval);this.cv.style.display="none";if(taccgl.controller&&taccgl.controller.invisibleCanvas){taccgl.controller.invisibleCanvas()}this.foregroundCnt=0;this.draw_running=false;this.busy=false;this.dddmode=false;this.compatmode=true;this.quality=0;this.ddFallBack();this.nullDraw();this.removeClassRe(document.documentElement,"(no-)?taccgl-run");this.addClass(document.documentElement,"no-taccgl-run");this.showHideComments();this.measureQuality();this.doHook(taccgl.onImmediateTerm)};this.resetGPUTimers=function(){taccgl.etGPUTime=1000;taccgl.etGPUTimeLag=10000000000;taccgl.etGA=Array(this.meaAS);taccgl.etGAS=128;taccgl.etGi=-1;if(this.extTimer){if(!this.eTimerAll){this.eTimerAll=this.extTimer.createQueryEXT()}this.extTimerRunning=false}};this.evaluateGPUTimer=function(){var et=taccgl.extTimer;if(!taccgl.extTimerRunning){return true}if(et.getQueryObjectEXT(taccgl.eTimerAll,et.QUERY_RESULT_AVAILABLE_EXT)){var t=et.getQueryObjectEXT(taccgl.eTimerAll,et.QUERY_RESULT_EXT)/1000;taccgl.etGPUTimeLag=1;taccgl.etGi++;taccgl.etGA[taccgl.etGi%taccgl.etGAS]=t;var n=taccgl.etGi+1;if(n>5){n=5}var s=0,max=0;for(var i=0;i<n;i++){var v=taccgl.etGA[(taccgl.etGi-i)%taccgl.etGAS];if(v>max){max=v}s+=v}if(n>1){s-=max;n--}taccgl.etGPUTime=s/n;return true}else{taccgl.etGPUTimeLag++;return false}};this.doHook=function(h,a,b,c,d,e,f,g){if(typeof(h)=="function"){return h(a,b,c,d,e,f,g)}else{if(typeof(h)=="string"){return eval(h)}else{if(h&&typeof(h)=="object"){if(h.length||h.length==0){var i,r;for(i=0;i<h.length;i++){r=this.doHook(h[i],a,b,c,d,e,f,g)}return r}else{return h.todo(a,b,c,d,e,f,g)}}}}};this.hookDeclined=Array(0);this.doFirstHook=function(h,a,b,c,d,e,f,g){if(typeof(h)=="function"){return h(a,b,c,d,e,f,g)}else{if(typeof(h)=="string"){return eval(h)}else{if(h&&typeof(h)=="object"){if(h.length||h.length==0){var i,r=taccgl.hookDeclined;for(i=0;i<h.length;i++){r=this.doHook(h[i],a,b,c,d,e,f,g)}}else{return h.todo(a,b,c,d,e,f,g)}}}}return taccgl.hookDeclined};this.doat=new Array(0);this.newDoat=function(a){var i=this.doat.length-1;while(i>=0&&this.doat[i].attime>a.attime){this.doat[i+1]=this.doat[i];i--}this.doat[i+1]=a};this.adjustDoat=function(i,t){this.doat[i].attime=t;while(this.doat[i+1].attime<t){var x=this.doat[i+1];this.doat[i+1]=this.doat[i];this.doat[i]=x;i++}};this.findInDoat=function(a){var f=0,t=this.doat.length-1;var v=a.attime;if(!v&&v!=0){return null}if(t<0){return null}while(true){var m=Math.floor((f+t)/2);if(this.doat[m].attime<v){f=m}else{if(this.doat[m].attime>v){t=m}else{var i=m;while(this.doat[i]!=a&&this.doat[i-1].attime==v){i--}if(this.doat[i]==a){return i}i=m+1;while(this.doat[i]!=a&&this.doat[i+1].attime==v){i++}if(this.doat[i]==a){return i}return null}}}};this.deleteFromDoat=function(a){var i=this.findInDoat(a);if(i!=null){if(this.doatI>i){this.doatI--}this.doat.splice(i,1)}};this.checkDoat=function(){var i;if(this.draw_running){if(!this.doat[this.doat.length-1].isPlug){taccgl.glAlert("missing plug")}}for(i=0;i<this.doat.length-1;i++){if(this.doat[i].isPlug){taccgl.glAlert("plug not at end")}if(!this.doat[i].attime&&this.doat[i].attime!=0){taccgl.glAlert("doat null")}if(!(this.doat[i].attime<=this.doat[i+1].attime)){taccgl.glAlert("doat sort error ")}}};this.setDuration=function(d){this.duration=d};this.setShader=function(p){if(this.shprogfrom[this.shprogfrom.length-1]>this.vertI){return}else{if(this.shprogfrom[this.shprogfrom.length-1]==this.vertI){if(this.shprogfrom.length>1&&this.shprog[this.shprogfrom.length-2]==p){this.shprog.pop();this.shprogfrom.pop()}else{this.shprog[this.shprogfrom.length-1]=p}}else{if(this.shprog[this.shprogfrom.length-1]!=p){this.shprog.push(p);this.shprogfrom.push(this.vertI)}}}};this.startDD=function(){if(!this.vBgControl){this.incForeground()}this.draw_duration=1000;this.doatI=0;taccgl.parallaxAdjust();this.adjustQuality();if(!this.vBgControl){this.incForeground()}else{this.adjustForeground()}var plug=new taccglAnimPlug();plug.attime=this.duration;this.newDoat(plug);this.draw_running=true;this.busy=true;this.cv.style.transition="";this.cv.style.display=this.epack!=false?"":"none";this.cv.style.opacity=1;this.cv.style.visibility="visible";this.draw_frames=this.draw_meaFrames=0;this.slowStartupTime=0;this.slowStartupFrames=0;this.draw_startTime=this.draw_meaTime=this.perfnow();this.draw_meaAdjust=0;this.draw_meaIgnore=0;this.loadTest=false;this.loadTestl=0;this.AAstartedLength=this.AA.length;this.removeClassRe(document.documentElement,"(no-)?taccgl-run");this.addClass(document.documentElement,"taccgl-run");if(!window.taccgl_requestAnimationFrame){this.interval=setInterval(taccgl_draw2d,16)}taccgl_draw2d()};this.drawTerminatedDD=function(){clearInterval(this.interval);this.NonDisplay3DCanvas();if(taccgl.controller&&taccgl.controller.invisibleCanvas){taccgl.controller.invisibleCanvas()}this.foregroundCnt=0;this.draw_running=false;this.busy=false;for(i=0;i<this.showAfterAnimation.length;i++){var pv=this.showAfterAnimation[i].el.taccgl.postVisibility;var ov=this.showAfterAnimation[i].el.taccgl.postOpacity;if(pv||pv==""){this.showAfterAnimation[i].el.style.visibility=pv}if(ov||ov==""||ov==0){this.showAfterAnimation[i].el.style.opacity=ov}}var vel=document.getElementById("taccglVertexNumber");if(vel){vel.innerHTML=this.draw_meaFrames+" "+this.draw_meaFrames/(this.perfnow()-this.draw_meaTime-this.draw_meaAdjust)*1000}this.measureQuality();var uTime=(this.perfnow()-taccgl.draw_meaTime-this.draw_meaAdjust)/taccgl.draw_duration,frate=taccgl.draw_meaFrames/uTime;if(frate>50&&taccgl.quality<5){taccgl.quality++}this.removeClassRe(document.documentElement,"(no-)?taccgl-run");this.addClass(document.documentElement,"no-taccgl-run");this.showHideComments();this.StartRender()};this.drawImmediateTermDD=function(){clearInterval(this.interval);this.cv.style.display="none";if(taccgl.controller&&taccgl.controller.invisibleCanvas){taccgl.controller.invisibleCanvas()}this.foregroundCnt=0;this.draw_running=false;this.busy=false;this.ddmode=false;this.compatmode=true;this.quality=0;this.nullDraw();this.removeClassRe(document.documentElement,"(no-)?taccgl-run");this.addClass(document.documentElement,"no-taccgl-run");this.showHideComments();this.measureQuality();this.doHook(taccgl.onImmediateTerm)};this.doAllDoats=function(){var i;for(i=0;i<this.doat.length;i++){var t=this.doat[i];if(t.elshowatend){var pv=t.postVisibility;var ov=t.postOpacity;if(pv||pv==""){t.elshowatend.style.visibility=pv}if(ov||ov==""||ov==0){t.elshowatend.style.opacity=ov}}}};this.nullDraw=function(){var i;this.foregroundCnt=0;this.draw_running=false;this.busy=false;this.doAllDoats();for(i=0;i<this.showAfterAnimation.length;i++){var pv=this.showAfterAnimation[i].el.taccgl.postVisibility;var ov=this.showAfterAnimation[i].el.taccgl.postOpacity;if(pv||pv==""){this.showAfterAnimation[i].el.style.visibility=pv}if(ov||ov==""){this.showAfterAnimation[i].el.style.opacity=ov}}this.StartRender();this.doHook(this.onTerm);if(this.cv){this.cv.style.display="none"}};this.cancelDraw=function(){if(this.reqAnimFrameId){window.taccgl_cancelAnimationFrame(this.reqAnimFrameId)}clearInterval(this.interval)};this.continueDraw=function(){if(window.taccgl_requestAnimationFrame){taccgl.reqAnimFrameId=taccgl_requestAnimationFrame(taccgl.dddmode?taccgl_draw3d:taccgl_draw2d)}else{taccgl.interval=setInterval(taccgl.dddmode?taccgl_draw3d:taccgl_draw2d,16)}};this.stop=function(){this.cancelDraw();if(!taccgl.draw_running){return}this.doAllDoats();if(this.dddmode){this.drawTerminated()}else{if(this.ddmode){this.drawTerminatedDD()}}this.doHook(this.onStop)};this.start=function(s){if(s!="no epilepsy warning"||taccgl.epack==false||this.showWarning){if(this.ddmode||this.dddmode){var w=this.epcheck();if(w=="wait"){return}if(!w){if(this.draw_running){this.stop()}else{this.nullDraw()}this.cv.style.display="none";return}}}if(this.prevPaintJob){var job=this.newJob(function(){taccgl.start(s)});job.waitFor(this.prevPaintJob);this.prevPaintJob=null;return}this.showHideComments();if(this.ddmode&&taccgl.epack!=false){if(!taccgl.draw_running){this.startDD()}else{taccgl.updateDrawDD()}}else{if(this.dddmode&&taccgl.epack!=false){if(this.g.isContextLost()){this.glError("Context Lost on start")}if(!this.webglerror){this.setupTextures()}if(!this.webglerror){if(!taccgl.draw_running){taccgl.startDraw(taccgl.g,taccgl.p)}else{taccgl.updateDraw()}}if(taccgl_setuperrcheck&&this.dddmode){if((taccgl.glerr=this.g.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" after start/bindDraw")}}if(this.webglerror){this.drawImmediateTerm(20)}}else{this.nullDraw()}}};this.restart=function(){if(!taccgl.draw_running){this.start()}else{this.draw_startTime=this.perfnow()}};this.ShowTexCanvas=function(i,bg){var c;if(i==1){c=document.getElementById("taccgl_textureCanvas")}else{if(i==2){c=document.getElementById("taccgl_textureCanvas2")}}c.style.display="";c.style.backgroundColor=bg};this.Bg3DCanvas=function(bg){var c=document.getElementById("taccgl_canvas3d");c.style.backgroundColor=bg};this.Display3DCanvas=function(d){var c=document.getElementById("taccgl_canvas3d");c.style.display=d};this.ZIndex3DCanvas=function(d){var c=document.getElementById("taccgl_canvas3d");c.style.zIndex=d};this.HideTexCanvas=function(){document.getElementById("taccgl_textureCanvas").style.display="none";document.getElementById("taccgl_textureCanvas2").style.display="none"};this.texTo=function(i){this.texcanvasi=i;if(i==1){this.texcanvas=document.getElementById("taccgl_textureCanvas")}else{if(i==2){this.texcanvas=document.getElementById("taccgl_textureCanvas2")}}if(this.texcanvas&&this.texcanvas.getContext){this.texc=this.texcanvas.getContext("2d")}};this.texTransform=function(a,b,c,d,e,f){var p=this.tpr;this.texc.setTransform(p*a,p*b,p*c,p*d,p*e,p*f)};this.resetTransform=function(){taccgl.texTransform(1,0,0,1,0,0)};this.markCanvasChanged=function(){if(this.texcanvasi==1){this.textureCanvasChanged=true}else{if(this.texcanvasi==2){this.textureCanvasChanged2=true}}};this.texClear=function(i){var el;if(!this.initialized){this.begin()}if(i==1){el=document.getElementById("taccgl_textureCanvas");this.textureCanvasChanged=true}if(i==2){el=document.getElementById("taccgl_textureCanvas2");this.textureCanvasChanged2=true}if(el){var wpr=Math.round(taccgl_texCanWidth*this.tpr),hpr=Math.round(taccgl_texCanHeight*this.tpr);el.width=wpr;el.height=hpr}if(this.texcanvasi==i){if(this.texc){taccgl.texTransform(1,0,0,1,0,0)}}else{var x=this.texcanvas;this.texTo(i);if(this.texc){taccgl.texTransform(1,0,0,1,0,0)}this.texTo(x)}};this.texCanResize=function(i){var el;if(i==1){el=document.getElementById("taccgl_textureCanvas")}if(i==2){el=document.getElementById("taccgl_textureCanvas2")}var w=el.style.width,h=el.style.height;if(taccgl_texCanWidth+"px"==w&&taccgl_texCanHeight+"px"==h){return false}el.style.width=w+"px";el.style.height=h+"px";return true};this.texClearAll=this.texInit=function(){if(!this.initialized){this.begin();return}this.detectTpr();this.texClear(1);this.texClear(2);this.texTo(1);this.texAtlas.clear();this.allocPaintErrorTexture()};this.allocPaintErrorTexture=function(){this.texAtlas.alloc(null,3,3);this.texc.fillStyle="yellow";this.texc.fillRect(0,0,3,3);this.texc.fillStyle="red";this.texc.fillRect(1,1,1,1)};this.texIntResolution=function(tpr){this.tpr=tpr;this.texClearAll()};this.a=function(el,k){if(!this.initialized){this.begin()}if(!k){k=this.taccglAnim}if(typeof(k)=="object"){k.actorInit(el);return k}else{var a=new k(el);a.initSecond();return a}};this.actor=function(el,k,v,t){if(!this.initialized){this.begin()}if(!k){k=this.taccglAnim}if(!t){t=1}else{throw ("actor: parameter error")}var a;if(typeof(k)=="object"){k.actorInit(el);a=k;a.alloc()}else{a=new k(el);a.alloc();a.initSecond()}a.hideAtBegin();a.paint();if(v!=null){a.visatend(v)}else{taccgl.taccglAttach(a.el);if(!a.el.taccgl.preVisibility&&a.el.taccgl.preVisibility!=""){a.el.taccgl.preVisibility=a.el.style.visibility}a.visatend(a.el.taccgl.preVisibility)}if(a.defTexCan==2){a.blendInt(0,1)}return a};this.shadow=function(el,k){if(typeof(el)=="string"){var xel=document.getElementById(el);if(!xel){alert("No Element with id "+el);return}el=xel}if(!this.initialized){this.begin()}if(!k){k=this.taccglAnim}this.taccglAttach(el);if(el.taccgl.asShadow){return el.taccgl.asShadow}else{var r;if(typeof(k)=="object"){k.actorInit(el);r=k}else{r=new k(el);r.initSecond()}el.taccgl.asShadow=r;return r}};this.getShadow=function(el){if(typeof(el)=="string"){var xel=document.getElementById(el);if(!xel){alert("No Element with id "+el);return}el=xel}if(!el){return null}if(!el.taccgl){return null}var as;if(!(as=el.taccgl.asShadow)){return null}return as};this.taccglAnim=function(el){this.init(el)};var tap=new taccglAnimPrototype();tap.taccglAnimClone.prototype=tap;this.taccglAnim.prototype=tap;this.flexiBorder=function(el){this.init(el)};this.multiFace=function(el){this.init(el)};this.triangle=function(el){this.init(el)};this.dddBox=function(el){this.init(el)};this.mEmpty=function(){return new taccglMultiEmpty()};this.mSingle=function(a){return new taccglMultiElement(a)};this.ma=function(el,k){return new taccglMultiElement(this.a(el,k))};this.mac=function(el,k){if(typeof(el)=="string"){var xel=document.getElementById(el);if(!xel){return new taccglMultiEmpty()}}return new taccglMultiElement(this.a(el,k))};this.mClass=function(cl,k){return new taccglMultiSet(document.getElementsByClassName(cl),k)};this.mName=function(cl,k){return new taccglMultiSet(document.getElementsByName(cl),k)};this.mTagName=function(cl,k){return new taccglMultiSet(document.getElementsByTagName(cl),k)};this.paintTextNode=function(el){var r=document.createRange(),tcel=el.textContent;r.selectNode(el);var i=tcel.search(/\S+/);if(i>0){r.setStart(el,i)}var rects=r.getClientRects(),t=this.texc;if(rects.length>=1){var cs=null,font;if(!cs){if(el.parentElement){cs=getComputedStyle(el.parentElement)}else{cs=getComputedStyle(el.parentNode)}}if(cs.fontStyle){font=cs.fontStyle+" "+cs.fontVariant+" "+cs.fontWeight+" "+cs.fontSize+" "+cs.fontFamily}else{font=cs["font-style"]+" "+cs["font-variant"]+" "+cs["font-weight"]+" "+cs["font-size"]+" "+cs["font-family"]}t.lineWidth=1;font=font.replace(/Calibri/,"calibri");t.font=font;t.fillStyle=cs.color;var lh=parseInt(cs["line-height"]);if(typeof(lh)!="number"||isNaN(lh)){lh=parseInt(cs.lineHeight)}if(typeof(lh)!="number"||isNaN(lh)){lh=1.2*parseInt(cs["font-size"])}if(typeof(lh)!="number"||isNaN(lh)){lh=19}t.textBaseline="bottom"}if(rects.length==1&&cs.textAlign!="justify"){var x=rects[0].left,y=rects[0].bottom;x+=this.scrollLeft;y+=this.scrollTop;var tc=el.textContent;tc=r.toString();tc=tc.replace(/\s+/g," ");t.fillText(tc,x,y)}else{if(rects.length>=1){var regex=/[A-Za-z0-9]+|\s|\S/g,res,j=0;while((res=regex.exec(tcel))&&j<1000){r.setStart(el,res.index);r.setEnd(el,res.index+res[0].length);rects=r.getClientRects();if(rects.length>1){var breakhere=65}if(rects.length){var re=rects[0];if(rects.length>1&&re.width==0){re=rects[1]}var tc=r.toString(),x=re.left,y=re.bottom;x+=this.scrollLeft;y+=this.scrollTop;t.fillText(tc,x,y)}j++}}}};this.paintBackground=function(el){var t=this.texc,cs=getComputedStyle(el),c=cs.backgroundColor;if(c!="none"&&c!="rgba(0, 0, 0, 0)"&&c!="transparent"){t.fillStyle=c;var rect=el.getBoundingClientRect();var x=rect.left+this.scrollLeft,y=rect.top+this.scrollTop;var btlr=this.getPxProp(cs.borderTopLeftRadius,0),btrr=this.getPxProp(cs.borderTopRightRadius,0),bblr=this.getPxProp(cs.borderBottomLeftRadius,0),bbrr=this.getPxProp(cs.borderBottomRightRadius,0),ww=0.5;var wi=el.offsetWidth,he=el.offsetHeight;if(el.tagName=="TD"){var cr=el.getClientRects();wi=cr[0].width;he=cr[0].height;x=cr[0].left;y=cr[0].top;x+=this.scrollLeft;y+=this.scrollTop}if(btlr==0&&btrr==0&&bblr==0&&bbrr==0){t.fillRect(x,y,wi,he)}else{t.beginPath();var d=(1-Math.sqrt(0.5))*btlr;if(btlr>0){t.moveTo(x+d+ww,y+d+ww);t.arcTo(x+d+d+ww,y+ww,x+btlr+ww,y+ww,btlr)}else{t.moveTo(x+ww,y+ww)}t.lineTo(x+wi-btrr-ww,y+ww);d=(1-Math.sqrt(0.5))*btrr;if(btrr>0){t.arcTo(x+wi-d-d-ww,y+ww,x+wi-d-ww,y+ww+d,btrr)}else{t.lineTo(x+wi,y+ww)}d=(1-Math.sqrt(0.5))*btrr;if(btrr>0){t.arcTo(x+wi-ww,y+d+d+ww,x+wi-ww,y+btrr+ww,btrr)}t.lineTo(x+wi-ww,y+he-bbrr-ww);d=(1-Math.sqrt(0.5))*bbrr;if(bbrr>0){t.arcTo(x+wi-ww,y+he-d-d-ww,x+wi-d-ww,y+he-ww-d,bbrr)}d=(1-Math.sqrt(0.5))*bbrr;if(bbrr>0){t.arcTo(x+wi-d-d-ww,y+he-ww,x+wi-bbrr-ww,y+he-ww,bbrr)}t.lineTo(x+bblr+ww,y+he-ww);d=(1-Math.sqrt(0.5))*bblr;if(bblr>0){t.arcTo(x+d+d+ww,y+he-ww,x+d+ww,y+he-d-ww,bblr)}d=(1-Math.sqrt(0.5))*bblr;if(bblr>0){t.arcTo(x+ww,y+he-d-d-ww,x+ww,y+he-bblr,bblr)}t.lineTo(x+ww,y+btlr+ww);d=(1-Math.sqrt(0.5))*btlr;if(btlr>0){t.arcTo(x+ww,y+d+d+ww,x+ww+d,y+d+ww,btlr)}t.fill()}}var u=cs.backgroundImage,i;if((u&&u!="none")){var sImage=u.split(/\s*,\s*/),sAttachment=cs.backgroundAttachment.split(/\s*,\s*/),bbm=cs.backgroundBlendMode,sBlendMode;if(typeof(bbm)=="string"){sBlendMode=bbm.split(/\s*,\s*/)}else{sBlendMode=Array(sImage.length)}var sClip=cs.backgroundClip.split(/\s*,\s*/),sOrigin=cs.backgroundOrigin.split(/\s*,\s*/),sPosition=cs.backgroundPosition.split(/\s*,\s*/),sRepeat=cs.backgroundRepeat.split(/\s*,\s*/),sSize=cs.backgroundSize.split(/\s*,\s*/);for(i=sImage.length-1;i>=0;i--){var u=sImage[i];if(u!="none"){this.paintBackgroundSingle(el,cs,u,sAttachment[i],sBlendMode[i],sClip[i],sOrigin[i],sPosition[i],sRepeat[i],sSize[i])}}}};this.paintBackgroundSingle=function(el,cs,Image,Attachment,BlendMode,Clip,Origin,Position,Repeat,size){var url=Image.replace(/url\("([^)]*)"\)/,"$1");var img=this.imageTable[url];var rect=el.getBoundingClientRect();var x0=rect.left+this.scrollLeft,y0=rect.top+this.scrollTop,w=rect.width,h=rect.height,clpx=x0,clpy=y0,clpw=w,clph=h,btlr=0,btrr=0,bblr=0,bbrr=0;if(Origin=="content-box"){var b=this.getPxProp(cs.borderLeftWidth,0);x0+=b;w-=b;b=this.getPxProp(cs.borderRightWidth,0);w-=b;b=this.getPxProp(cs.borderTopWidth,0);y0+=b;h-=b;b=this.getPxProp(cs.borderBottomWidth,0);h-=b;var pl=this.getPxProp(cs.paddingLeft,0),pt=this.getPxProp(cs.paddingTop,0),pr=this.getPxProp(cs.paddingRight,0),pb=this.getPxProp(cs.paddingBottom,0);x0+=pl;w-=pl+pr;y0+=pt;h-=pt+pb}else{if(Origin=="border-box"){}else{var b=this.getPxProp(cs.borderLeftWidth,0);x0+=b;w-=b;b=this.getPxProp(cs.borderRightWidth,0);w-=b;b=this.getPxProp(cs.borderTopWidth,0);y0+=b;h-=b;b=this.getPxProp(cs.borderBottomWidth,0);h-=b}}if(Clip=="padding-box"||Clip=="content-box"){var b=this.getPxProp(cs.borderLeftWidth,0);clpx+=b;clpw-=b;b=this.getPxProp(cs.borderRightWidth,0);clpw-=b;b=this.getPxProp(cs.borderTopWidth,0);clpy+=b;clph-=b;b=this.getPxProp(cs.borderBottomWidth,0);clph-=b}if(Clip=="content-box"){var pl=this.getPxProp(cs.paddingLeft,0),pt=this.getPxProp(cs.paddingTop,0),pr=this.getPxProp(cs.paddingRight,0),pb=this.getPxProp(cs.paddingBottom,0);clpx+=pl;clpw-=pl+pr;clpy+=pt;clph-=pt+pb}if(Clip!="content-box"){var btlr=this.getPxProp(cs.borderTopLeftRadius,0),btrr=this.getPxProp(cs.borderTopRightRadius,0),bblr=this.getPxProp(cs.borderBottomLeftRadius,0),bbrr=this.getPxProp(cs.borderBottomRightRadius,0)}var drw=img.width,drh=img.height;if(size=="cover"){var scale=w/drw;if(h/drh>scale){scale=h/drh}drw*=scale;drh*=scale}else{if(size=="contain"){var scale=w/drw;if(h/drh<scale){scale=h/drh}drw*=scale;drh*=scale}else{if(typeof(size)=="string"){var sa=size.split(/\s+/),sizex,sizey;if(sa.length>=1){sizex=sa[0]}else{sizex=drw+"px"}if(sa.length==2){sizey=sa[1]}else{sizey="auto"}if(sizex=="auto"){if(sizey!="auto"){var sy=this.getPxProp(sizey);if(sizey.match(/[0-9.]*%/)){sy*=0.01*h}drw*=sy/drh;drh=sy}}else{var sx=this.getPxProp(sizex);if(sizex.match(/[0-9.]*%/)){sx*=0.01*w}if(sizey=="auto"){drh*=sx/drw;drw=sx}else{drw=sx;drh=this.getPxProp(sizey);if(sizey.match(/[0-9.]*%/)){drh*=0.01*h}}}}}}var xn=1,yn=1,xo=drw,yo=drh,i,j;if(typeof(Position)=="string"){var pa=Position.split(/\s+/),posx="0px",posy="0px";if(pa.length>=1){posx=pa[0]}if(pa.length==2){posy=pa[1]}var px=this.getPxProp(posx),py=this.getPxProp(posy);if(posx.match(/[0-9.]*%/)){x0+=px*0.01*(w-drw)}else{x0+=px}if(posx.match(/[0-9.]*%/)){y0+=py*0.01*(h-drh)}else{y0+=py}}xn=Math.ceil(w/drw);yn=Math.ceil(h/drh);if(typeof(Repeat)=="string"){var ra=Repeat.split(/\s+/),repx,repy;if(ra.length==0){repx="repeat"}if(ra.length>=1){repx=ra[0]}if(ra.length==2){repy=ra[1]}else{repy=repx}if(repx=="no-repeat"){xn=1}if(repy=="no-repeat"){yn=1}if(repx=="repeat-x"){yn=1}if(repx=="repeat-y"){xn=1}if(repx=="space"){if(w>=2*drw){xn=Math.floor(w/drw);var used=xn*drw,free=w-used,fp=free/(xn-1);xo=drw+fp}else{xn=1}}if(repy=="space"){if(h>=2*drh){yn=Math.floor(h/drh);var used=yn*drh,free=h-used,fp=free/(yn-1);yo=drh+fp}else{yn=1}}if(repx=="round"){if(w>=drw){xn=Math.floor(w/drw);drw=w/xn;xo=drw}else{xn=1}}if(repy=="round"){if(h>=drh){yn=Math.floor(h/drh);drh=h/yn;yo=drh}else{yn=1}}}var t=taccgl.texc,ww=0.5;t.save();t.beginPath();var d=(1-Math.sqrt(0.5))*btlr;if(btlr>0){t.moveTo(clpx+d+ww,clpy+d+ww);t.arcTo(clpx+d+d+ww,clpy+ww,clpx+btlr+ww,clpy+ww,btlr)}else{t.moveTo(clpx+ww,clpy+ww)}t.lineTo(clpx+clpw-btrr-ww,clpy+ww);d=(1-Math.sqrt(0.5))*btrr;if(btrr>0){t.arcTo(clpx+clpw-d-d-ww,clpy+ww,clpx+clpw-d-ww,clpy+ww+d,btrr)}else{t.lineTo(clpx+clpw,clpy+ww)}d=(1-Math.sqrt(0.5))*btrr;if(btrr>0){t.arcTo(clpx+clpw-ww,clpy+d+d+ww,clpx+clpw-ww,clpy+btrr+ww,btrr)}t.lineTo(clpx+clpw-ww,clpy+clph-bbrr-ww);d=(1-Math.sqrt(0.5))*bbrr;if(bbrr>0){t.arcTo(clpx+clpw-ww,clpy+clph-d-d-ww,clpx+clpw-d-ww,clpy+clph-ww-d,bbrr)}d=(1-Math.sqrt(0.5))*bbrr;if(bbrr>0){t.arcTo(clpx+clpw-d-d-ww,clpy+clph-ww,clpx+clpw-bbrr-ww,clpy+clph-ww,bbrr)}t.lineTo(clpx+bblr+ww,clpy+clph-ww);d=(1-Math.sqrt(0.5))*bblr;if(bblr>0){t.arcTo(clpx+d+d+ww,clpy+clph-ww,clpx+d+ww,clpy+clph-d-ww,bblr)}d=(1-Math.sqrt(0.5))*bblr;if(bblr>0){t.arcTo(clpx+ww,clpy+clph-d-d-ww,clpx+ww,clpy+clph-bblr,bblr)}t.lineTo(clpx+ww,clpy+btlr+ww);d=(1-Math.sqrt(0.5))*btlr;if(btlr>0){t.arcTo(clpx+ww,clpy+d+d+ww,clpx+ww+d,clpy+d+ww,btlr)}t.clip();if(xn>1&&yn>1){var i0=Math.floor((clpx-x0)/xo),i1=Math.ceil((clpx+clpw-x0-drw)/xo);var j0=Math.floor((clpy-y0)/yo),j1=Math.ceil((clpy+clph-y0-drh)/yo);for(i=i0;i<=i1;i++){for(j=j0;j<=j1;j++){taccgl.texc.drawImage(img,x0+xo*i,y0+yo*j,drw,drh)}}}else{if(xn==1&&yn==1){taccgl.texc.drawImage(img,x0,y0,drw,drh)}else{if(xn==1&&yn>1){var j0=Math.floor((clpy-y0)/yo),j1=Math.ceil((clpy+clph-y0-drh)/yo);for(j=j0;j<=j1;j++){taccgl.texc.drawImage(img,x0,y0+yo*j,drw,drh)}}else{if(yn==1&&xn>1){var i0=Math.floor((clpx-x0)/xo),i1=Math.ceil((clpx+clpw-x0-drw)/xo);for(i=i0;i<=i1;i++){taccgl.texc.drawImage(img,x0+xo*i,y0,drw,drh)}}}}}t.restore()};this.getPxProp=function(s,d){var r=parseInt(s);if(typeof(r)!="number"){return d}if(r<0){return d}return r};this.paintBorder=function(el){var t=this.texc,cs=getComputedStyle(el),c=cs.borderTopColor,cr;if(c!="none"||c!="rgba(0, 0, 0, 0)"||c!="transparent"){var btlr=this.getPxProp(cs.borderTopLeftRadius,0),btrr=this.getPxProp(cs.borderTopRightRadius,0);var w=this.getPxProp(cs.borderTopWidth,0);var ww=w*0.5;if(w>0){var wi=el.offsetWidth,he=el.offsetHeight,x,y;if(el.tagName=="TD"){cr=el.getClientRects();wi=cr[0].width;he=cr[0].height;x=cr[0].left;y=cr[0].top;x+=this.scrollLeft;y+=this.scrollTop}else{var rect=el.getBoundingClientRect();var x=rect.left+this.scrollLeft,y=rect.top+this.scrollTop}t.beginPath();t.strokeStyle=c;t.lineWidth=w;var d=(1-Math.sqrt(0.5))*btlr;if(btlr>0){t.moveTo(x+d+ww,y+d+ww);t.arcTo(x+d+d+ww,y+ww,x+btlr+ww,y+ww,btlr)}else{t.moveTo(x,y+ww)}t.lineTo(x+wi-btrr-ww,y+ww);d=(1-Math.sqrt(0.5))*btrr;if(btrr>0){t.arcTo(x+wi-d-d-ww,y+ww,x+wi-d-ww,y+ww+d,btrr)}else{t.lineTo(x+wi,y+ww)}t.stroke()}}c=cs.borderRightColor;if(c!="none"||c!="rgba(0, 0, 0, 0)"||c!="transparent"){btrr=this.getPxProp(cs.borderTopRightRadius,0);var bbrr=this.getPxProp(cs.borderBottomRightRadius,0);w=this.getPxProp(cs.borderRightWidth,0);ww=w*0.5;if(w>0){if(el.tagName=="TD"){cr=el.getClientRects();wi=cr[0].width;he=cr[0].height;x=cr[0].left;y=cr[0].top;x+=this.scrollLeft;y+=this.scrollTop}else{var rect=el.getBoundingClientRect();var x=rect.left+this.scrollLeft,y=rect.top+this.scrollTop,he=rect.height,wi=rect.width}x+=wi;t.beginPath();t.strokeStyle=c;t.lineWidth=w;d=(1-Math.sqrt(0.5))*btrr;if(btrr>0){t.moveTo(x-d-ww,y+d+ww);t.arcTo(x-ww,y+d+d+ww,x-ww,y+btrr+ww,btrr)}else{t.moveTo(x-ww,y)}t.lineTo(x-ww,y+he-bbrr-ww);d=(1-Math.sqrt(0.5))*bbrr;if(bbrr>0){t.arcTo(x-ww,y+he-d-d-ww,x-d-ww,y+he-ww-d,bbrr)}else{t.lineTo(x-ww,y+he)}t.stroke()}}c=cs.borderBottomColor;if(c!="none"||c!="rgba(0, 0, 0, 0)"||c!="transparent"){var bblr=this.getPxProp(cs.borderBottomLeftRadius,0);bbrr=this.getPxProp(cs.borderBottomRightRadius,0),w=this.getPxProp(cs.borderBottomWidth,0),ww=w*0.5;if(w>0){if(el.tagName=="TD"){cr=el.getClientRects();wi=cr[0].width;he=cr[0].height;x=cr[0].left;y=cr[0].top;x+=this.scrollLeft;y+=this.scrollTop}else{var rect=el.getBoundingClientRect();var x=rect.left+this.scrollLeft,y=rect.top+this.scrollTop,he=rect.height,wi=rect.width}t.beginPath();t.strokeStyle=c;t.lineWidth=w;y+=he;d=(1-Math.sqrt(0.5))*bblr;if(bblr>0){t.moveTo(x+d+ww,y-d-ww);t.arcTo(x+d+d+ww,y-ww,x+bblr+ww,y-ww,bblr)}else{t.moveTo(x,y-ww)}t.lineTo(x+wi-bbrr-ww,y-ww);d=(1-Math.sqrt(0.5))*bbrr;if(bbrr>0){t.arcTo(x+wi-d-d-ww,y-ww,x+wi-d-ww,y-ww-d,bbrr)}else{t.lineTo(x+wi,y-ww)}t.stroke()}}c=cs.borderLeftColor;if(c!="none"||c!="rgba(0, 0, 0, 0)"||c!="transparent"){btlr=this.getPxProp(cs.borderTopLeftRadius,0);bblr=this.getPxProp(cs.borderBottomLeftRadius,0);w=this.getPxProp(cs.borderLeftWidth,0),ww=w*0.5;if(w>0){if(el.tagName=="TD"){cr=el.getClientRects();wi=cr[0].width;he=cr[0].height;x=cr[0].left;y=cr[0].top;x+=this.scrollLeft;y+=this.scrollTop}else{var rect=el.getBoundingClientRect();var x=rect.left+this.scrollLeft,y=rect.top+this.scrollTop,he=rect.height,wi=rect.width}t.beginPath();t.strokeStyle=c;t.lineWidth=w;d=(1-Math.sqrt(0.5))*btlr;if(btlr>0){t.moveTo(x+d+ww,y+d+ww);t.arcTo(x+ww,y+d+d+ww,x+ww,y+btlr+ww,btlr)}else{t.moveTo(x+ww,y)}t.lineTo(x+ww,y+he-bblr-ww);d=(1-Math.sqrt(0.5))*bblr;if(bblr>0){t.arcTo(x+ww,y+he-d-d-ww,x+d+ww,y+he-ww-d,bblr)}else{t.lineTo(x+ww,y+he)}t.stroke()}}};this.paintImg=function(el){var cs=getComputedStyle(el),pl=this.getPxProp(cs.paddingLeft,0),pt=this.getPxProp(cs.paddingTop,0),pr=this.getPxProp(cs.paddingRight,0),pb=this.getPxProp(cs.paddingBottom,0);var rect=el.getBoundingClientRect();var x0=rect.left+this.scrollLeft,y0=rect.top+this.scrollTop;taccgl.texc.drawImage(el,x0+pl,y0+pt,rect.width-pl-pr,rect.height-pt-pb)};this.paintSVG=function(el){var cs=getComputedStyle(el),pl=this.getPxProp(cs.paddingLeft,0),pt=this.getPxProp(cs.paddingTop,0),pr=this.getPxProp(cs.paddingRight,0),pb=this.getPxProp(cs.paddingBottom,0);var rect=el.getBoundingClientRect();var x0=rect.left+this.scrollLeft,y0=rect.top+this.scrollTop;taccgl.texc.drawImage(el.taccgl.img,x0+pl,y0+pt,rect.width-pl-pr,rect.height-pt-pb)};this.paintElementInt=function(el,ignoreHidden,dofloat){var needsRestore=false;if(!(this.ddmode||this.dddmode)){return}this.markCanvasChanged();if(typeof(el)=="string"){el=document.getElementById(el)}if(el.nodeType==3){this.paintTextNode(el)}else{if(el.nodeType==1){var cs=getComputedStyle(el);if(el.style.visibility=="hidden"&&!ignoreHidden){return}if(cs.display=="none"){return}var fl=cs.getPropertyValue("float");if(fl!="none"&&fl+""!="undefined"&&!dofloat){this.elToPaint.push(el);return}if(el.style.visibility!="visible"&&!ignoreHidden){if(!this.hiddenClasses){this.calcHiddenClasses()}var cnstr=el.className;if(typeof cnstr=="string"){var cns=cnstr.split(" "),i;for(i=0;i<cns.length;i++){var c=cns[i];if(this.hiddenClasses["."+c]=="hidden"){return}if(this.hiddenClasses[(el.tagName.toUpperCase()+"."+c)]=="hidden"){return}if(this.hiddenClasses["#"+el.id]=="hidden"){return}}}}var t;if(((t=cs.webkitTransform)||(t=cs.mozTransform)||(t=cs.msTransform)||(t=cs.transform))&&(t!="none")){needsRestore=true;this.texc.save();var m;var savekind,to;if(t=cs.transform){m=taccgl.m32Parse(t);to=cs.transformOrigin;savekind="trans";el.style.transform="none"}else{if(t=cs.webkitTransform){m=taccgl.m32Parse(t);to=cs.webkitTransformOrigin;savekind="webkit";el.style.webkitTransform="none"}else{if(t=cs.mozTransform){m=taccgl.m32Parse(t);to=cs.mozTransformOrigin;savekind="moz";el.style.mozTransform="none"}else{if(t=cs.mstTransform){m=taccgl.m32Parse(t);to=cs.msTransformOrigin;savekind="ms";el.style.msTransform="none"}}}}var savetrans="matrix("+m[0].toFixed(20)+","+m[3].toFixed(20)+","+m[1].toFixed(20)+","+m[4].toFixed(20)+","+m[2].toFixed(20)+","+m[5].toFixed(20)+")";var toa=to.split(" ");var tox=parseFloat(toa[0]),toy=parseFloat(toa[1]);var cr=el.getClientRects();var x=cr[0].left,y=cr[0].top;x+=this.scrollLeft;y+=this.scrollTop;this.texc.translate(x+tox,y+toy);this.texc.transform(m[0],m[3],m[1],m[4],m[2],m[5]);this.texc.translate(-x-tox,-y-toy)}this.paintBackground(el);this.paintBorder(el);var n=el.tagName.toLowerCase();if(n=="img"){this.paintImg(el)}else{if(n=="svg"){this.paintSVG(el)}}}}c=el.firstChild;while(c){this.paintElementInt(c,false,false);c=c.nextSibling}if(needsRestore){this.texc.restore();if(savekind=="trans"){el.style.transform=savetrans}else{if(savekind=="webkit"){el.style.webkitTransform=savetrans}else{if(savekind=="moz"){el.style.mozTransform=savetrans}else{if(savekind=="ms"){el.style.msTransform=savetrans}}}}}};this.paintElement=function(el,ignoreHidden){this.autoDetectScroll();this.elToPaint=Array(0);this.paintElementInt(el,ignoreHidden);var i=0;while(i<this.elToPaint.length){var igh=false;if(this.elToPaint[i]==el){igh=ignoreHidden}this.paintElementInt(this.elToPaint[i],igh,true);i++}this.elToPaint=null};this.prepareBackground=function(el){var i,cs=getComputedStyle(el),sImage=cs.backgroundImage.split(/\s*,\s*/);for(i=0;i<sImage.length;i++){var u=sImage[i];if(u!="none"){var url=u.replace(/url\("([^)]*)"\)/,"$1"),img=this.newImageEntry(url)}}};this.prepareImg=function(el){if(!el.complete){this.createCurPaintJob();var job=this.curPaintJob;job.incWait();var ponload=el.onload;el.onload=function(){el.onload=ponload;job.decWait();taccgl.jobScheduleAll();if(ponload){ponload()}}}};this.prepareSVG=function(el){var t=el.outerHTML;t=t.replace(/svg/,'svg xmlns="http://www.w3.org/2000/svg"');t=t.replace(/width\s*=\s*"[0-9]+%"/,'width="'+el.clientWidth+'px"');t=t.replace(/height\s*=\s*"[0-9]+%"/,'height="'+el.clientHeight+'px"');var img=new Image(el.clientWidth,el.clientHeight);var blob=new Blob([t],{type:"image/svg+xml;charset=utf-8"});var texc=taccgl.texc;var u=(window.URL||window.webkitURL||window).createObjectURL(blob);img.src=u;this.createCurPaintJob();var job=this.curPaintJob;job.incWait();img.onload=function(){img.onload=null;job.decWait();taccgl.jobScheduleAll()};this.taccglAttach(el);el.taccgl.img=img};this.prepareElementInt=function(el,ignoreHidden,dofloat){if(!(this.ddmode||this.dddmode)){return}if(typeof(el)=="string"){el=document.getElementById(el)}if(el+""=="undefined"){var t=45}if(el.nodeType==3){}else{if(el.nodeType==1){var cs=getComputedStyle(el);if(el.style.visibility=="hidden"&&!ignoreHidden){return}if(cs.display=="none"){return}var fl=cs.getPropertyValue("float");if(fl!="none"&&fl+""!="undefined"&&!dofloat){this.elToPrepare.push(el);return}if(el.style.visibility!="visible"&&!ignoreHidden){if(!this.hiddenClasses){this.calcHiddenClasses()}var cnstr=el.className;if(typeof cnstr=="string"){var cns=cnstr.split(" "),i;for(i=0;i<cns.length;i++){var c=cns[i];if(this.hiddenClasses["."+c]=="hidden"){return}if(this.hiddenClasses[(el.tagName.toUpperCase()+"."+c)]=="hidden"){return}if(this.hiddenClasses["#"+el.id]=="hidden"){return}}}}this.prepareBackground(el);var n=el.tagName.toLowerCase();if(n=="img"){this.prepareImg(el)}else{if(n=="svg"){this.prepareSVG(el)}}}}c=el.firstChild;while(c){this.prepareElementInt(c,false,false);c=c.nextSibling}};this.createCurPaintJob=function(){if(!this.curPaintJob){this.curPaintJob=this.newJob(null)}};this.prepareElement=function(el,ignoreHidden){this.curPaintjob=null;if(taccgl.prevPaintJob){this.createCurPaintJob()}this.autoDetectScroll();this.elToPrepare=Array(0);this.prepareElementInt(el,ignoreHidden);var i=0;while(i<this.elToPrepare.length){this.prepareElementInt(this.elToPrepare[i],false,true);i++}this.elToPrepare=null};this.prePaintElement=function(el,ignoreHidden,canvas,pre,post){this.prepareElement(el,ignoreHidden);if(this.curPaintJob){this.curPaintJob.f=function(){taccgl.texTo(canvas);if(typeof(pre)=="function"){pre()}taccgl.paintElement(el,ignoreHidden);if(typeof(post)=="function"){post()}if(taccgl.prevPaintJob==this){taccgl.prevPaintJob=null}};if(this.prevPaintJob){this.curPaintJob.waitFor(this.prevPaintJob)}this.prevPaintJob=this.curPaintJob;this.curPaintJob=null}if(!this.prevPaintJob){taccgl.texTo(canvas);if(typeof(pre)=="function"){pre()}this.paintElement(el,ignoreHidden);if(typeof(post)=="function"){post()}}};this.hiddenClassesConstr=function(){};this.calcHiddenClasses=function(){this.hiddenClasses=new this.hiddenClassesConstr();var ss=window.document.styleSheets,i,s;for(i=0;i<ss.length;i++){s=ss[i];if(!s.disabled&&s.type=="text/css"){var j,r;for(j=0;j<s.cssRules.length;j++){r=s.cssRules[j];if(r.selectorText&&r.selectorText.match(/([^.:]*\.[^.:]+)|(#[^.:]+)/)){this.hiddenClasses[r.selectorText]=r.style.visibility}}}}};this.taccglAttachment=function(){this.delno=taccgl.delno};this.taccglAttach=function(el){if(el.taccgl&&el.taccgl.delno==this.delno){return}if(!el.taccgl){var t;t=new this.taccglAttachment();el.taccgl=t}el.taccgl.delno=taccgl.delno;el.taccgl.preVisibility=el.taccgl.postVisibility=el.taccgl.preOpacity=el.taccgl.postOpacity=null;el.taccgl.asShadow=null};this.createImageTable=function(){};this.imageTable=new this.createImageTable();this.newImageEntry=function(u){var t;if((t=this.imageTable[u])){if(t.complete){return t}this.createCurPaintJob();var job=this.curPaintJob;job.incWait();var ponload=t.onload;t.onload=function(){t.onload=ponload;job.decWait();taccgl.jobScheduleAll();if(ponload){ponload()}}}var img=new Image();img.src=u;this.createCurPaintJob();var job=this.curPaintJob;job.incWait();img.onload=function(){img.onload=null;job.decWait();taccgl.jobScheduleAll()};this.imageTable[u]=img};this.vAdd=this.mAdd=function(a,b){var r=a.slice();for(var i=0;i<a.length;i++){r[i]+=b[i]}return r};this.vSub=this.mSub=function(a,b){var r=a.slice();for(var i=0;i<a.length;i++){r[i]-=b[i]}return r};this.vNeg=this.mNeg=function(a){var r=a.slice();for(var i=0;i<a.length;i++){r[i]*=-1}return r};this.vMulS=this.mMulS=function(a,b){var r=a.slice();for(var i=0;i<a.length;i++){r[i]*=b}return r};this.viAdd=this.miAdd=function(a,b){for(var i=0;i<a.length;i++){a[i]+=b[i]}return a};this.viSub=this.miSub=function(a,b){for(var i=0;i<a.length;i++){a[i]-=b[i]}return a};this.viNeg=this.miNeg=function(a){for(var i=0;i<a.length;i++){a[i]*=-1}return a};this.viMulS=this.miMulS=function(a,b){for(var i=0;i<a.length;i++){a[i]*=b}return a};this.m32IConst=[1,0,0,0,1,0];this.m32I=function(){return this.m32IConst.slice(0)};this.mi32Add=function(a,b){a[0]+=b[0];a[1]+=b[1];a[2]+=b[2];a[3]+=b[3];a[4]+=b[4];a[5]+=b[5];return a};this.m32Add=function(a,b){return[a[0]+b[0],a[1]+b[1],a[2]+b[2],a[3]=b[3],a[4]+b[4],a[5]+=b[5]]};this.m32Mulx=function(m,v){var a=m;return a[0]*v[0]+a[1]*v[1]+a[2]};this.m32Muly=function(m,v){var a=m;return a[3]*v[0]+a[4]*v[1]+a[5]};this.m32Parse=function(t){var regex=/matrix\(([- 0-9.Ee]*),([- 0-9.Ee]*),([- 0-9.Ee]*),([- 0-9.Ee]*),([- 0-9.Ee]*),([- 0-9.Ee]*)\)/;var a=regex.exec(t);if(a&&a.length==7){return([parseFloat(a[1]),parseFloat(a[3]),parseFloat(a[5]),parseFloat(a[2]),parseFloat(a[4]),parseFloat(a[6])])}return null};this.m33IConst=[1,0,0,0,1,0,0,0,1];this.m33I=function(){return this.m33IConst.slice(0)};this.mi33Add=function(a,b){a[0]+=b[0];a[1]+=b[1];a[2]+=b[2];a[3]+=b[3];a[4]+=b[4];a[5]+=b[5];a[6]+=b[6];a[7]+=b[7];a[8]+=b[8];return a};this.m33Add=function(a,b){return[a[0]+b[0],a[1]+b[1],a[2]+b[2],a[3]+b[3],a[4]+b[4],a[5]+b[5],a[6]+b[6],a[7]+b[7],a[8]+b[8]]};this.mi33Mul=function(a,b){var x=a[0]*b[0]+a[1]*b[3]+a[2]*b[6];var y=a[0]*b[1]+a[1]*b[4]+a[2]*b[7];var z=a[0]*b[2]+a[1]*b[5]+a[2]*b[8];a[0]=x;a[1]=y;a[2]=z;x=a[3]*b[0]+a[4]*b[3]+a[5]*b[6];y=a[3]*b[1]+a[4]*b[4]+a[5]*b[7];z=a[3]*b[2]+a[4]*b[5]+a[5]*b[8];a[3]=x;a[4]=y;a[5]=z;x=a[6]*b[0]+a[7]*b[3]+a[8]*b[6];y=a[6]*b[1]+a[7]*b[4]+a[8]*b[7];z=a[6]*b[2]+a[7]*b[5]+a[8]*b[8];a[6]=x;a[7]=y;a[8]=z;return a};this.m33Mul=function(a,b){return[a[0]*b[0]+a[1]*b[3]+a[2]*b[6],a[0]*b[1]+a[1]*b[4]+a[2]*b[7],a[0]*b[2]+a[1]*b[5]+a[2]*b[8],a[3]*b[0]+a[4]*b[3]+a[5]*b[6],a[3]*b[1]+a[4]*b[4]+a[5]*b[7],a[3]*b[2]+a[4]*b[5]+a[5]*b[8],a[6]*b[0]+a[7]*b[3]+a[8]*b[6],a[6]*b[1]+a[7]*b[4]+a[8]*b[7],a[6]*b[2]+a[7]*b[5]+a[8]*b[8]]};this.mi33MulV=function(a,v){return[a[0]*v[0]+a[1]*v[1]+a[2]*v[2],a[3]*v[0]+a[4]*v[1]+a[5]*v[2],a[6]*v[0]+a[7]*v[1]+a[8]*v[2]]};this.mi33T=function(a){var x=a[3];a[3]=a[1];a[1]=x;x=a[2];a[2]=a[6];a[6]=x;x=a[5];a[5]=a[7];a[7]=x;return a};this.m33T=function(a){return[a[0],a[3],a[6],a[1],a[4],a[7],a[2],a[5],a[8]]};taccgl.m33Det=function(a){return a[0]*(a[4]*a[8]-a[5]*a[7])-a[1]*(a[3]*a[8]-a[5]*a[6])+a[2]*(a[3]*a[7]-a[4]*a[6])};this.m33Inverse=function(a){var d=a[0]*(a[4]*a[8]-a[5]*a[7])-a[1]*(a[3]*a[8]-a[5]*a[6])+a[2]*(a[3]*a[7]-a[4]*a[6]);var di=1/d;return[(a[4]*a[8]-a[5]*a[7])*di,(a[2]*a[7]-a[1]*a[8])*di,(a[1]*a[5]-a[2]*a[4])*di,(a[5]*a[6]-a[3]*a[8])*di,(a[0]*a[8]-a[2]*a[6])*di,(a[2]*a[3]-a[0]*a[5])*di,(a[3]*a[7]-a[4]*a[6])*di,(a[1]*a[6]-a[0]*a[7])*di,(a[0]*a[4]-a[1]*a[3])*di]};this.mi33Negate=function(a){a[0]=-a[0];a[1]=-a[1];a[2]=-a[2];a[3]=-a[3];a[4]=-a[4];a[5]=-a[5];a[6]=-a[6];a[7]=-a[7];a[8]=-a[8];return a};this.m33Negate=function(a){return[-a[0],-a[1],-a[2],-a[3],-a[4],-a[5],-a[6],-a[7],-a[8]]};this.m33Rotation=function(alpha,av){var s=Math.sin(alpha),c=Math.cos(alpha),mc=1-c,ax=av[0],ay=av[1],az=av[2];return[c+ax*ax*mc,ax*ay*mc-az*s,ax*az*mc+ay*s,ax*ay*mc+az*s,c+ay*ay*mc,ay*az*mc-ax*s,az*ax*mc-ay*s,az*ay*mc+ax*s,c+az*az*mc]};this.m33ToString=function(a){return"["+a[0]+",\t"+a[1]+",\t"+a[2]+",\n"+a[3]+",\t"+a[4]+",\t"+a[5]+",\n"+a[6]+",\t"+a[7]+",\t"+a[8]+"]"};this.m44IConst=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1];this.m44I=function(){return this.m44IConst.slice(0)};this.mi44Add=function(a,b){a[0]+=b[0];a[1]+=b[1];a[2]+=b[2];a[3]+=b[3];a[4]+=b[4];a[5]+=b[5];a[6]+=b[6];a[7]+=b[7];a[8]+=b[8];a[9]+=b[9];a[10]+=b[10];a[11]+=b[11];a[12]+=b[12];a[13]+=b[13];a[14]+=b[14];a[15]+=b[15];return a};this.m44Add=function(a,b){return[a[0]+b[0],a[1]+b[1],a[2]+b[2],a[3]+b[3],a[4]+b[4],a[5]+b[5],a[6]+b[6],a[7]+b[7],a[8]+b[8],a[9]+b[9],a[10]+b[10],a[11]+b[11],a[12]+b[12],a[13]+b[13],a[14]+b[14],a[15]+b[15]]};this.mi44Mul=function(a,b){var x=a[0]*b[0]+a[1]*b[4]+a[2]*b[8]+a[3]*b[12];var y=a[0]*b[1]+a[1]*b[5]+a[2]*b[9]+a[3]*b[13];var z=a[0]*b[2]+a[1]*b[6]+a[2]*b[10]+a[3]*b[14];var w=a[0]*b[3]+a[1]*b[7]+a[2]*b[11]+a[3]*b[15];a[0]=x;a[1]=y;a[2]=z;a[3]=w;x=a[4]*b[0]+a[5]*b[4]+a[6]*b[8]+a[7]*b[12];y=a[4]*b[1]+a[5]*b[5]+a[6]*b[9]+a[7]*b[13];z=a[4]*b[2]+a[5]*b[6]+a[6]*b[10]+a[7]*b[14];w=a[4]*b[3]+a[5]*b[7]+a[6]*b[11]+a[7]*b[15];a[4]=x;a[5]=y;a[6]=z;a[7]=w;x=a[8]*b[0]+a[9]*b[4]+a[10]*b[8]+a[11]*b[12];y=a[8]*b[1]+a[9]*b[5]+a[10]*b[9]+a[11]*b[13];z=a[8]*b[2]+a[9]*b[6]+a[10]*b[10]+a[11]*b[14];w=a[8]*b[3]+a[9]*b[7]+a[10]*b[11]+a[11]*b[15];a[8]=x;a[9]=y;a[10]=z;a[11]=w;x=a[12]*b[0]+a[13]*b[4]+a[14]*b[8]+a[15]*b[12];y=a[12]*b[1]+a[13]*b[5]+a[14]*b[9]+a[15]*b[13];z=a[12]*b[2]+a[13]*b[6]+a[14]*b[10]+a[15]*b[14];w=a[12]*b[3]+a[13]*b[7]+a[14]*b[11]+a[15]*b[15];a[12]=x;a[13]=y;a[14]=z;a[15]=w;return a};this.m44Mul=function(a,b){return[a[0]*b[0]+a[1]*b[4]+a[2]*b[8]+a[3]*b[12],a[0]*b[1]+a[1]*b[5]+a[2]*b[9]+a[3]*b[13],a[0]*b[2]+a[1]*b[6]+a[2]*b[10]+a[3]*b[14],a[0]*b[3]+a[1]*b[7]+a[2]*b[11]+a[3]*b[15],a[4]*b[0]+a[5]*b[4]+a[6]*b[8]+a[7]*b[12],a[4]*b[1]+a[5]*b[5]+a[6]*b[9]+a[7]*b[13],a[4]*b[2]+a[5]*b[6]+a[6]*b[10]+a[7]*b[14],a[4]*b[3]+a[5]*b[7]+a[6]*b[11]+a[7]*b[15],a[8]*b[0]+a[9]*b[4]+a[10]*b[8]+a[11]*b[12],a[8]*b[1]+a[9]*b[5]+a[10]*b[9]+a[11]*b[13],a[8]*b[2]+a[9]*b[6]+a[10]*b[10]+a[11]*b[14],a[8]*b[3]+a[9]*b[7]+a[10]*b[11]+a[11]*b[15],a[12]*b[0]+a[13]*b[4]+a[14]*b[8]+a[15]*b[12],a[12]*b[1]+a[13]*b[5]+a[14]*b[9]+a[15]*b[13],a[12]*b[2]+a[13]*b[6]+a[14]*b[10]+a[15]*b[14],a[12]*b[3]+a[13]*b[7]+a[14]*b[11]+a[15]*b[15]]};this.mi44MulV=function(a,v){return[a[0]*v[0]+a[1]*v[1]+a[2]*v[2]+a[3]*v[3],a[4]*v[0]+a[5]*v[1]+a[6]*v[2]+a[7]*v[3],a[8]*v[0]+a[9]*v[1]+a[10]*v[2]+a[11]*v[3],a[12]*v[0]+a[13]*v[1]+a[14]*v[2]+a[15]*v[3]]};this.m33FromM44=function(a){return[a[0],a[1],a[2],a[4],a[5],a[6],a[8],a[9],a[10]]};this.mi33FromM44=function(r,a){r[0]=a[0];r[1]=a[1];r[2]=a[2];r[3]=a[4];r[4]=a[5];r[5]=a[6];r[6]=a[8];r[7]=a[9];r[8]=a[10];return r};this.mi33FromM44T=function(r,a){r[0]=a[0];r[1]=a[4];r[2]=a[8];r[3]=a[1];r[4]=a[5];r[5]=a[9];r[6]=a[2];r[7]=a[6];r[8]=a[10];return r};this.m44FromM33=function(a,v){return[a[0],a[1],a[2],v[0],a[3],a[4],a[5],v[1],a[6],a[7],a[8],v[2],0,0,0,1]};this.m44FromM33C=function(a,c,t){var v=taccgl.mi33MulV(a,c);if(t){return[a[0],a[1],a[2],c[0]-v[0]+t[0],a[3],a[4],a[5],c[1]-v[1]+t[1],a[6],a[7],a[8],c[2]-v[2]+t[2],0,0,0,1]}else{return[a[0],a[1],a[2],c[0]-v[0],a[3],a[4],a[5],c[1]-v[1],a[6],a[7],a[8],c[2]-v[2],0,0,0,1]}};taccgl.mi44Scale=function(m,s){m[0]*=s;m[1]*=s;m[2]*=s;m[4]*=s;m[5]*=s;m[6]*=s;m[8]*=s;m[9]*=s;m[10]*=s;return m};taccgl.m44Scale=function(m,s){return[m[0]*s,m[1]*s,m[2]*s,m[4]*s,m[5]*s,m[6]*s,m[8]*s,m[9]*s,m[10]*s]};this.m44Translation=function(x,y,z){return[1,0,0,x,0,1,0,y,0,0,1,z,0,0,0,1]};this.mi44T=function(a){var x=a[1];a[1]=a[4];a[4]=x;x=a[2];a[2]=a[8];a[8]=x;x=a[3];a[3]=a[12];a[12]=x;x=a[6];a[6]=a[9];a[9]=x;x=a[7];a[7]=a[13];a[13]=x;x=a[11];a[11]=a[14];a[14]=x;return a};this.m44T=function(a){return[a[0],a[4],a[8],a[12],a[1],a[5],a[9],a[13],a[2],a[6],a[10],a[14],a[3],a[7],a[11],a[15]]};taccgl.mAffInverse=function(a){var R=taccgl.m33FromM44(a);var S=taccgl.m33Inverse(R);var t=taccgl.viNeg(taccgl.mi33MulV(S,taccgl.m44TransV(a)));return taccgl.m44FromM33(S,t)};this.m44TransV=function(a){return[a[3],a[7],a[11]]};this.clamp=function(v,mi,ma){return Math.max(mi,Math.min(v,ma))};taccgl.m33ToEulerAngles=function(m){var d=taccgl.m33Det(m);var scale=Math.pow(d,1/3);var e=1/scale;var a={yaw:Math.atan2(-m[2]*e,m[8]*e),pitch:-Math.asin(-m[5]*e),roll:Math.atan2(m[3]*e,m[4]*e),scale:scale,};return a};this.m33FromEulerAngles=function(a){var f=this.m33Rotation(a.roll,[0,0,1]);var m=this.m33Rotation(-a.pitch,[1,0,0]);var im=this.m33Rotation(-a.yaw,[0,1,0]);this.mi33Mul(im,m);this.mi33Mul(im,f);taccgl.miMulS(im,a.scale);return im};this.m44ToString=function(a){return"["+a[0]+",\t"+a[1]+",\t"+a[2]+",\t"+a[3]+",\n"+a[4]+",\t"+a[5]+",\t"+a[6]+",\t"+a[7]+",\n"+a[8]+",\t"+a[9]+",\t"+a[10]+",\t"+a[11]+",\n"+a[12]+",\t"+a[13]+",\t"+a[14]+",\t"+a[15]+"]"};this.vToString=function(v){var s="["+v[0];for(var i=1;i<v.length;i++){s+=",\t "+v[i]}return s+"]"};this.setTMorth=function(tm){this.TM=tm;this.mi33FromM44T(this.TM_1,this.TM)};this.setTM=function(tm){this.TM=tm;this.TM_1=this.m33Inverse(this.m33FromM44(this.TM))};this.applyTM=function(m){taccgl.setTM(taccgl.m44Mul(m,taccgl.TM))};this.projectionMatrix=function(){return[1,0,this.stdEye.eyeX/this.stdEye.eyeZ,0,0,1,this.stdEye.eyeY/this.stdEye.eyeZ,0,0,0,1,0,0,0,1/this.stdEye.eyeZ,1]};this.projectX=function(x,y,z){var w=-z*(1/this.stdEye.eyeZ)+1;return(x-z*(this.stdEye.eyeX/this.stdEye.eyeZ))/w};this.projectY=function(x,y,z){var w=-z*(1/this.stdEye.eyeZ)+1;return(y-z*(this.stdEye.eyeY/this.stdEye.eyeZ))/w};if(window.taccgl_ext){this.doHook(taccgl_ext)}}var taccgl=new taccgl_create();function taccglAnimPlug(){this.isPlug=true;this.doPreDraw=function(){taccgl.doatI++;return true}}function taccglAnimPrototype(a){this.init=function(c){if(typeof(c)=="string"){var e=document.getElementById(c);if(!e){alert("No Element with id "+c);return}c=e}var b=c;this.curface=this;this.el=c;taccgl.autoDetectScroll();var d=c.getBoundingClientRect();this.x1=this.x0=d.left+taccgl.scrollLeft;this.y1=this.y0=d.top+taccgl.scrollTop;this.z0=this.z1=0;this.w=this.wx0=this.wx1=c.offsetWidth;this.wy0=this.wz1=this.wz0=this.hx1=0;this.h=this.hy0=this.hy1=c.offsetHeight;this.hx0=this.hz1=this.wy1=this.hz0=0;this.dx0=this.dx1=this.dy0=this.dy1=this.dz0=this.dz1=0;this.x=this.x0;this.y=this.y0;this.s0=1;this.t0=1;this.ws0=1;this.wt0=0;this.ht0=1;this.hs0=0;this.rotation=false;this.flags=0;this.basetime=taccgl.currenttime;this.vduration=taccgl.timeScale;this.isforeground=false;this.elshowatend=false;this.elhideatbegin=false;this.p=taccgl.stdsc;this.lightSpecular=taccgl.lightSpecular;this.lightShininess=taccgl.lightShininess;this.defTexCan=1};this.initSecond=function(){};this.pclone=function(){if(typeof(this.attime)=="number"){return this.clone()}else{this.astepdelno=null;return this}};this.pnclone=function(){var b;if(typeof(this.attime)=="number"){b=this.clone()}else{b=this}if(this.vertEndIndex){b.vertindex=this.vertEndIndex}return b};this.appendBuffer=function(){this.astepdelno=null;return this};this.specLight=function(b,c){this.lightSpecular=b%1;this.lightShininess=Math.floor(c);return this};this.shadowOnly=function(c){if(c==false){this.flags&=~128}else{this.flags|=128}return this};this.opaqueShadow=function(c){if(c!=false){this.color("black")}this.shadowOnly(c);return this};this.castShadow=function(c){if(c){this.flags&=~256}else{this.flags|=256}return this};this.useTM=function(c){if(c==false){this.flags&=~8}else{this.flags|=8}return this};this.foreground=function(){if(taccgl.vBgControl){this.isforeground=true;this.special=true}return this};this.ddstop=function(){var c=taccgl;taccgl.AA.splice(this.ddindex,1);for(var b=this.ddindex;b<c.AA.length;b++){c.AA[b].ddindex=b}c.AAstartedLength--};this.dddstop=function(){var b=taccgl;var d=b.vertI;b.vertI=this.vertindex;var c=this.flags&=~2;while(b.vertI<this.vertEndIndex){b.nvertTime(-2,1,c)}b.vertI=d};this.stop=function(){if(this.astepdelno==taccgl.delno){if(taccgl.dddmode){this.dddstop()}else{this.ddstop()}}taccgl.deleteFromDoat(this);this.attime=null};this.cposClientRects=function(){taccgl.autoDetectScroll();var e=this.el.getClientRects();var b=e[0].left,f=e[0].top,c=e[0].width,d=e[0].height;b+=taccgl.scrollLeft;f+=taccgl.scrollTop;this.x=this.s0=this.x0=b;this.y=this.t0=this.y0=f;this.x1=this.x0;this.y1=this.y0;this.w=this.ws0=this.wx0=this.wx1=c;this.wt0=0;this.h=this.ht0=this.hy0=this.hy1=d;this.hs0=0};this.cposTransform=function(){var g=getComputedStyle(this.el);var j=this.x,i=this.y,k=this.w,f=this.h;var o,l,b=null;if(o=g.transform){b=taccgl.m32Parse(o);l=g.transformOrigin}else{if(o=g.webkitTransform){b=taccgl.m32Parse(o);l=g.webkitTransformOrigin}else{if(o=g.mozTransform){b=taccgl.m32Parse(o);l=g.mozTransformOrigin}else{if(o=g.mstTransform){b=taccgl.m32Parse(o);l=g.msTransformOrigin}}}}var e=l.split(" ");var d=parseFloat(e[0]),c=parseFloat(e[1]);if(b){var n=[j-j-d,i-i-c];j=taccgl.m32Mulx(b,n)+j+d;i=taccgl.m32Muly(b,n)+c+i;this.x=this.s0=this.x0=j;this.y=this.t0=this.y0=i;this.x1=this.x0;this.y1=this.y0;n=[k,0];this.wx1=this.wx0=this.ws0=taccgl.m32Mulx(b,n);this.wy1=this.wy0=this.wt0=taccgl.m32Muly(b,n);n=[0,f];this.hx1=this.hx0=this.hs0=taccgl.m32Mulx(b,n);this.hy1=this.hy0=this.ht0=taccgl.m32Muly(b,n);this.ws0=this.ht0=0;this.w=Math.sqrt(this.wx0*this.wx0+this.wy0*this.wy0);this.h=Math.sqrt(this.hx0*this.hx0+this.hy0*this.hy0)}};this.flyHome=function(){taccgl.autoDetectScroll();var b=this.el.getBoundingClientRect();this.x1=b.left+taccgl.scrollLeft;this.y1=b.top+taccgl.scrollTop;this.z1=0;return this};this.rotateHome=function(){this.wx1=this.el.offsetWidth;this.wz1=this.hx1=0;this.hy1=this.el.offsetHeight;this.hz1=this.wy1=0;return this};this.flyToElement=function(c){if(typeof(c)=="string"){c=document.getElementById(c)}var b=c;taccgl.autoDetectScroll();var d=c.getBoundingClientRect();this.x1=d.left+taccgl.scrollLeft;this.y1=d.top+taccgl.scrollTop;this.z1=0;this.wx1=c.offsetWidth;this.wz1=this.hx1=0;this.hy1=c.offsetHeight;this.hz1=this.wy1=0;return this};this.hvec=this.hV=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.hx0=this.hx1=b;this.hy0=this.hy1=d;this.hz0=this.hz1=c;return this};this.hVFrom=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.hx0=b;this.hy0=d;this.hz0=c;return this};this.hvec1=this.hVTo=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.hx1=b;this.hy1=d;this.hz1=c;return this};this.wvec=this.wV=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.wx0=this.wx1=b;this.wy0=this.wy1=d;this.wz0=this.wz1=c;return this};this.wVFrom=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.wx0=b;this.wy0=d;this.wz0=c;return this};this.wvec1=this.wVTo=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.wx1=b;this.wy1=d;this.wz1=c;return this};this.dvec=this.dV=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.dx0=this.dx1=b;this.dy0=this.dy1=d;this.dz0=this.dz1=c;return this};this.dVFrom=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.dx0=b;this.dy0=d;this.dz0=c;return this};this.dvec1=this.dVTo=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-this.x0;d=this.resy-this.y0;c=this.resz-this.z0}this.dx1=b;this.dy1=d;this.dz1=c;return this};this.line=function(b,i,h,e){b-=this.x0;i-=this.y0;h-=this.z0;this.wx0=this.wx1=b;this.wy0=this.wy1=i;this.wz0=this.wz1=h;if(Math.abs(b)>Math.abs(i)){this.hx0=-i/b;this.hy0=1}else{this.hy0=-b/i;this.hx0=1}var g=this.hx0*this.hx0+this.hy0*this.hy0;var f=e/Math.sqrt(g);this.hx1=(this.hx0*=f);this.hy1=(this.hy0*=f);this.x1=this.x0+=0.5-this.hx1*0.5;this.y1=this.y0+=0.5-this.hy1*0.5;this.z1=this.z0+=0-this.hz1*0.5;var c=Math.sqrt(this.wx0*this.wx0+this.wy0*this.wy0+this.wz0*this.wz0);f=(c+1)/c;this.wx1=this.wx0*=f;this.wy1=this.wy0*=f;this.wz1=this.wz0*=f;f=-0.5/(c+1);this.x1=this.x0+=f*this.wx1;this.y1=this.y0+=f*this.wy1;this.z1=this.z0+=f*this.wz1;return this};this.depth=function(f,e){if(typeof(f)=="number"){var c=Math.sqrt(this.dx0*this.dx0+this.dy0*this.dy0+this.dz0*this.dz0);if(typeof(e)!="number"){e=f}if(c<0.000001){this.dx0=0;this.dy0=0;this.dz0=f}else{this.dx0*=f/c;this.dy0*=f/c;this.dz0*=f/c}}if(typeof(e)=="number"){var b=Math.sqrt(this.dx1*this.dx1+this.dy1*this.dy1+this.dz1*this.dz1);if(b<0.000001){this.dx1=0;this.dy1=0;this.dz1=e}else{this.dx1*=e/b;this.dy1*=e/b;this.dz1*=e/b}}return this};this.LQCanvas=function(c,b,e,d){return this.SetQCanvas(c,b,e,d,taccgl.LQCanvas)};this.NQCanvas=function(c,b,e,d){return this.SetQCanvas(c,b,e,d,taccgl.NQCanvas)};this.SetQCanvas=function(d,c,n,l,g){if(!d){d=0}if(!c&&c!=0){c=d}if(!n&&n!=0){n=d}if(!l&&l!=0){l=n}var k=this.x-d,i=this.y-n,b=this.x+this.w+c,j=this.y+this.h+l;if(k<0){k=0}if(i<0){i=0}var m=b-k,e=j-i;g.call(taccgl,k,i,m,e);return this};this.shader=function(b){this.p=b};this.sc=function(b){if(!taccgl.dddmode){return this}if(!b.p){b.compile()}this.p=b;if(!b.p&&taccgl.webglerror){this.p=taccgl.stdsc;taccgl.webglerror=false;taccgl.dddmode=true}this.special=true;return this};this.doAtBegin=function(){if(this.elhideatbegin){if(this.opaqueLevelBegin||this.opaqueLevelBegin==0){this.elhideatbegin.style.opacity=this.opaqueLevelBegin}else{this.elhideatbegin.style.visibility="hidden"}}if(this.isforeground){taccgl.incForeground()}if(this.todoAtBegin){var b,c;for(b=0;b<this.todoAtBegin.length;b++){c=this.todoAtBegin[b];this.todo=c;this.todo()}}};this.doAtEnd=function(){if(this.elshowatend){var f=this.postVisibility;var e=this.postOpacity;if(f||f==""){this.elshowatend.style.visibility=f}if(e||e==""||e==0){this.elshowatend.style.opacity=e}var b;if(this.el.taccgl&&(b=this.el.taccgl.asShadow)&&f!="hidden"&&e!==0){if(!b.hbStarted||!b.inTime()){b.showafter();b.start();if(taccgl.dddmode){taccgl.updateDraw()}else{taccgl.updateDrawDD()}}}}if(this.isforeground){taccgl.decForeground()}if(this.todoAtEnd){var c,g;for(c=0;c<this.todoAtEnd.length;c++){g=this.todoAtEnd[c];if(typeof(g)=="function"){g.call(this)}else{g(this)}}}};this.registerBegin=this.onBegin=function(b){if(!this.todoAtBegin){this.todoAtBegin=Array(0)}this.todoAtBegin.push(b);this.special=true;return this};this.registerEnd=this.onEnd=function(b){if(!this.todoAtEnd){this.todoAtEnd=Array(0)}this.todoAtEnd.push(b);this.special=true;return this};this.doPreDraw=function(b){if(this.draw_running){this.doAtEndDone=true;this.doAtEnd();taccgl.doatI++}else{this.doAtBegin();this.draw_running=true;taccgl.adjustDoat(b,this.basetime+this.vduration)}};this.registerBeginEnd=function(){if(!this.attime&&this.attime!=0){var c=this.vduration+this.basetime;if(taccgl.duration<c&&((this.flags&1<<16)==0)){taccgl.setDuration(c)}var b=taccgl.doat[taccgl.doat.length-1];if(b&&b.isPlug&&b.attime<c){b.attime=c}this.attime=this.basetime;taccgl.newDoat(this)}};this.acceleration=function(e,j,i){if(typeof(j)!="number"){var g=(this.x1-this.x0),f=(this.y1-this.y0),c=(this.z1-this.z0);var h=e/Math.sqrt(g*g+c*c+f*f);e=g*h;j=f*h;i=c*h}else{if(typeof(i)!="number"){i=0}}var b=this.vduration*this.vduration;this.ax=e*b;this.ay=j*b;this.az=i*b;this.doacceleration=true;this.flags|=4;return this};this.scalarAcceleration=function(b){this.ax=(this.x1-this.x0)*b;this.ay=(this.y1-this.y0)*b;this.az=(this.z1-this.z0)*b;this.doacceleration=true;this.flags|=4;return this};this.vBegin=function(c,i,h){if(typeof(i)!="number"){var f=(this.x1-this.x0),e=(this.y1-this.y0),b=(this.z1-this.z0);var g=c/Math.sqrt(f*f+b*b+e*e);c=f*g;i=e*g;h=b*g}else{if(typeof(h)!="number"){h=0}}this.ax=(this.x1-this.x0)*2-2*this.vduration*c;this.ay=(this.y1-this.y0)*2-2*this.vduration*i;this.az=(this.z1-this.z0)*2-2*this.vduration*h;this.doacceleration=true;this.flags|=4;return this};this.vEnd=function(c,i,h){if(typeof(i)!="number"){var f=(this.x1-this.x0),e=(this.y1-this.y0),b=(this.z1-this.z0);var g=c/Math.sqrt(f*f+b*b+e*e);c=f*g;i=e*g;h=b*g}else{if(typeof(h)!="number"){h=0}}this.ax=-(this.x1-this.x0)*2+2*this.vduration*c;this.ay=-(this.y1-this.y0)*2+2*this.vduration*i;this.az=-(this.z1-this.z0)*2+2*this.vduration*h;this.doacceleration=true;this.flags|=4;return this};this.rotateNN=function(d,c,b,g,f,e){this.rotation=true;this.rotpx=d;this.rotpy=c;this.rotpz=b;this.rotax=g;this.rotay=f;this.rotaz=e;this.rotfrom=0;this.rotto=2*Math.PI;return this};this.rotate=function(d,c,b,g,f,e){if(typeof(d)=="object"){this.resolvePosition(d);e=g;f=b;g=c;d=this.resx;c=this.resy;b=this.resz}var h=1/Math.sqrt(g*g+f*f+e*e);this.rotateNN(d,c,b,g*h,f*h,e*h);return this};this.rotateMiddleNN=function(d,c,b){this.rotateNN(this.x1+this.wx1/2,this.y1+this.hy1/2,this.z1+this.dz1/2,d,c,b);return this};this.rotateMiddle=function(d,c,b){var e=1/Math.sqrt(d*d+c*c+b*b);this.rotateNN(this.x1+this.wx1/2,this.y1+this.hy1/2,this.z1+this.dz1/2,d*e,c*e,b*e);return this};this.rotVEnd=function(b){this.rotacc=(this.rotto-this.rotfrom)*2-2*this.vduration*b;return this};this.rotVBegin=function(b){this.rotacc=-(this.rotto-this.rotfrom)*2+2*this.vduration*b;return this};this.rotatePart=this.rotPart=function(d,c,b){this.rotfrom=d;this.rotto=c;if(!b){b=0}this.rotacc=b;return this};this.PWHRF=function(i,h,d,c,g,f){this.x0+=this.wx0*i+this.hx0*h;this.y0+=this.wy0*i+this.hy0*h;this.z0+=this.wz0*i+this.hz0*h;var j=this.wx0*g+this.hx0*f;var e=this.wy0*g+this.hy0*f;var b=this.wz0*g+this.hz0*f;this.wx0=this.wx0*d+this.hx0*c;this.wy0=this.wy0*d+this.hy0*c;this.wz0=this.wz0*d+this.hz0*c;this.hx0=j;this.hy0=e;this.hz0=b;return this};this.mapRFrom=function(k,j,e,d,i,h){if(!this.dotexmove){this.dotexmove=true;this.s1=this.s0;this.ws1=this.ws0;this.t1=this.t0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0}this.s0+=this.ws0*k+this.hs0*j;this.t0+=this.wt0*k+this.ht0*j;var f=this.ws0*i+this.hs0*h;var b=this.wt0*i+this.ht0*h;this.ws0=this.ws0*e+this.hs0*d;this.wt0=this.wt0*e+this.ht0*d;this.hs0=f;this.ht0=b;if(typeof(this.wp0)=="number"){this.p0+=this.wp0*k+this.hp0*j;this.q0+=this.wq0*k+this.hq0*j;var g=this.wp0*i+this.hp0*h;var c=this.wq0*i+this.hq0*h;this.wp0=this.wp0*e+this.hp0*d;this.wq0=this.wq0*e+this.hq0*d;this.hp0=g;this.hq0=c}return this};this.mapR=function(k,j,e,d,i,h){if(this.dotexmove){this.mapRFrom(k,j,e,d,i,h);this.mapRTo(k,j,e,d,i,h)}else{this.s0+=this.ws0*k+this.hs0*j;this.t0+=this.wt0*k+this.ht0*j;var f=this.ws0*i+this.hs0*h;var b=this.wt0*i+this.ht0*h;this.ws0=this.ws0*e+this.hs0*d;this.wt0=this.wt0*e+this.ht0*d;this.hs0=f;this.ht0=b;if(typeof(this.wp0)=="number"){this.p0+=this.wp0*k+this.hp0*j;this.q0+=this.wq0*k+this.hq0*j;var g=this.wp0*i+this.hp0*h;var c=this.wq0*i+this.hq0*h;this.wp0=this.wp0*e+this.hp0*d;this.wq0=this.wq0*e+this.hq0*d;this.hp0=g;this.hq0=c;this.wp1=this.wp0;this.wq1=this.wq0;this.hq1=this.hq0;this.hp1=this.hp0;this.p1=this.p0;this.q1=this.q0}}return this};this.clipRFrom=function(b,g,d,c,f,e){if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}this.mapRFrom(b,g,d,c,f,e);this.PWHRF(b,g,d,c,f,e);return this};this.PWHRT=function(j,i,e,c,g,f){this.x1+=this.wx1*j+this.hx1*i;this.y1+=this.wy1*j+this.hy1*i;this.z1+=this.wz1*j+this.hz1*i;var h=this.wx1*g+this.hx1*f;var d=this.wy1*g+this.hy1*f;var b=this.wz1*g+this.hz1*f;this.wx1=this.wx1*e+this.hx1*c;this.wy1=this.wy1*e+this.hy1*c;this.wz1=this.wz1*e+this.hz1*c;this.hx1=h;this.hy1=d;this.hz1=b;return this};this.mapRTo=function(k,j,e,d,i,h){if(!this.dotexmove){this.dotexmove=true;this.s1=this.s0;this.ws1=this.ws0;this.t1=this.t0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0}this.s1+=this.ws1*k+this.hs1*j;this.t1+=this.wt1*k+this.ht1*j;var f=this.ws1*i+this.hs1*h;var b=this.wt1*i+this.ht1*h;this.ws1=this.ws1*e+this.hs1*d;this.wt1=this.wt1*e+this.ht1*d;this.hs1=f;this.ht1=b;if(typeof(this.wp0)=="number"){this.p1+=this.wp1*k+this.hp1*j;this.q1+=this.wq1*k+this.hq1*j;var g=this.wp1*i+this.hp1*h;var c=this.wq1*i+this.hq1*h;this.wp1=this.wp1*e+this.hp1*d;this.wq1=this.wq1*e+this.hq1*d;this.hp1=g;this.hq1=c}return this};this.clipRTo=function(b,g,d,c,f,e){if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}this.mapRTo(b,g,d,c,f,e);this.PWHRT(b,g,d,c,f,e);return this};this.clipR=function(b,g,d,c,f,e){if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}this.PWHRT(b,g,d,c,f,e);this.PWHRF(b,g,d,c,f,e);this.mapR(b,g,d,c,f,e);return this};this.restrict=this.clip=function(f,g,b,c){if(typeof(f)=="object"){this.resolvePosition(f);c=b;b=g;f=this.resx;g=this.resy}if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-f;c=this.resy-g}if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}var e=this.hq0*this.wp0-this.hp0*this.wq0;this.clipR(((f-this.p0)*this.hq0+(this.q0-g)*this.hp0)/e,-((f-this.p0)*this.wq0+(this.q0-g)*this.wp0)/e,b*this.hq0/e,0,0,c*this.wp0/e);return this};this.clipFrom=function(f,g,b,c){if(typeof(f)=="object"){this.resolvePosition(f);c=b;b=g;f=this.resx;g=this.resy}if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-f;c=this.resy-g}if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}var e=this.ht0*this.ws0-this.hs0*this.wt0;this.clipRFrom(((f-this.p0)*this.ht0+(this.q0-g)*this.hs0)/e,-((f-this.p0)*this.wt0+(this.q0-g)*this.ws0)/e,b*this.ht0/e,0,0,c*this.ws0/e);return this};this.clipTo=function(f,g,b,c){if(typeof(f)=="object"){this.resolvePosition(f);c=b;b=g;f=this.resx;g=this.resy}if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-f;c=this.resy-g}if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}var e=this.ht0*this.ws0-this.hs0*this.wt0;this.clipRTo(((f-this.p0)*this.ht0+(this.q0-g)*this.hs0)/e,-((f-this.p0)*this.wt0+(this.q0-g)*this.ws0)/e,b*this.ht0/e,0,0,c*this.ws0/e);return this};this.clipT=function(h,g,c,b,f,e){if(typeof(h)=="object"){this.resolvePosition(h);e=f;f=b;b=c;c=g;h=this.resx;g=this.resy}if(typeof(c)=="object"){this.resolvePosition(c);e=f;f=b;c=this.resx-h;b=this.resy-g}if(typeof(f)=="object"){this.resolvePosition(f);f=this.resx-h;e=this.resy-g}if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}var i=this.ht0*this.ws0-this.hs0*this.wt0;this.clipR(((h-this.p0)*this.ht0+(this.q0-g)*this.hs0)/i,-((h-this.p0)*this.wt0+(this.q0-g)*this.ws0)/i,(c*this.ht0-b*this.hs0)/i,-(c*this.wt0-b*this.ws0)/i,(f*this.ht0-e*this.hs0)/i,-(f*this.wt0-e*this.ws0)/i);return this};this.clipTFrom=function(h,g,c,b,f,e){if(typeof(h)=="object"){this.resolvePosition(h);e=f;f=b;b=c;c=g;h=this.resx;g=this.resy}if(typeof(c)=="object"){this.resolvePosition(c);e=f;f=b;c=this.resx-h;b=this.resy-g}if(typeof(f)=="object"){this.resolvePosition(f);f=this.resx-h;e=this.resy-g}if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}var i=this.ht0*this.ws0-this.hs0*this.wt0;this.clipRFrom(((h-this.p0)*this.ht0+(this.q0-g)*this.hs0)/i,-((h-this.p0)*this.wt0+(this.q0-g)*this.ws0)/i,(c*this.ht0-b*this.hs0)/i,-(c*this.wt0-b*this.ws0)/i,(f*this.ht0-e*this.hs0)/i,-(f*this.wt0-e*this.ws0)/i);return this};this.clipTTo=function(h,g,c,b,f,e){if(typeof(h)=="object"){this.resolvePosition(h);e=f;f=b;b=c;c=g;h=this.resx;g=this.resy}if(typeof(c)=="object"){this.resolvePosition(c);e=f;f=b;c=this.resx-h;b=this.resy-g}if(typeof(f)=="object"){this.resolvePosition(f);f=this.resx-h;e=this.resy-g}if(typeof(this.wp0)!="number"){this.wp0=this.wp1=this.w;this.wq0=this.wq1=0;this.hq0=this.hq1=this.h;this.hp0=this.hp1=0;this.p0=this.p1=this.x;this.q0=this.q1=this.y}if(!this.dotexmove){this.dotexmove=true;this.s1=this.s0;this.ws1=this.ws0;this.t1=this.t0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0}var i=this.ht1*this.ws1-this.hs1*this.wt1;this.clipRTo(((h-this.p1)*this.ht1+(this.q1-g)*this.hs1)/i,-((h-this.p1)*this.wt1+(this.q1-g)*this.ws1)/i,(c*this.ht1-b*this.hs1)/i,-(c*this.wt1-b*this.ws1)/i,(f*this.ht1-e*this.hs1)/i,-(f*this.wt1-e*this.ws1)/i);return this};this.cvCssTex=function(q,o,b){if(!b){b=0}var u=1-b,d,c;var n,k,w,r,p,v;if(this.dotexmove){n=this.ws0*u+this.ws1*b,k=this.wt0*u+this.wt1*b,r=this.hs0*u+this.hs1*b,p=this.ht0*u+this.ht1*b,w=this.s0*u+this.s1*b,v=this.t0*u+this.t1*b}else{n=this.ws0;k=this.wt0;r=this.hs0;p=this.ht0;w=this.s0*u+this.s1*b,v=this.t0*u+this.t1*b}if(typeof(this.wp0)!="number"){var f=(q-this.x)/this.w,e=(o-this.y)/this.h;d=n*f+r*f+w;c=n*e+r*e+v}else{var g=[this.wp0,this.wq0,this.p0,this.hp0,this.hq0,this.q0,0,0,1];var j=taccgl.m33Inverse(g);var h=taccgl.mi33MulV(j,[q,o,1]);d=n*h[0]+r*h[0]+w;c=n*h[1]+r*h[1]+v}return[d,c]};this.cvTexCss=function(b,c){};this.clipA=function(c,e,b,d){this.dotexmove=true;this.s1=this.s0;this.ws1=this.ws0;this.t1=this.t0;this.ht1=this.ht0;if(c){this.wx0=c}else{this.wx0=0}if(e){this.hy0=e}else{this.hy0=0}if(b||b==0){this.wx1=b}if(d||d==0){this.hy1=d}this.ws0=this.wx0;this.wt0=this.hs0=this.wt1=this.hs1=0;this.ht0=this.hy0;this.ws1=this.wx1;this.ht1=this.hy1;return this};this.growA=function(c,e,b,d){if(c||c==0){this.wx0=c}else{this.wx0=0}if(e||e==0){this.hy0=e}else{this.hy0=0}if(b||b==0){this.wx1=b}if(d||d==0){this.hy1=d}return this};this.resize=function(d,g,c,f){if(typeof(g)=="number"){var j=Math.sqrt(this.hx0*this.hx0+this.hy0*this.hy0+this.hz0*this.hz0);if(j<0.000001){this.hy0=g;this.hx0=0;this.hz0=0}else{this.hx0*=g/j;this.hy0*=g/j;this.hz0*=g/j}if(typeof(f)!="number"){f=g}}if(typeof(f)=="number"){var i=Math.sqrt(this.hx1*this.hx1+this.hy1*this.hy1+this.hz1*this.hz1);if(i<0.000001){this.hy1=g;this.hx1=0;this.hz1=0}else{this.hx1*=f/i;this.hy1*=f/i;this.hz1*=f/i}}if(typeof(d)=="number"){var e=Math.sqrt(this.wx0*this.wx0+this.wy0*this.wy0+this.wz0*this.wz0);if(typeof(c)!="number"){c=d}if(e<0.000001){this.wx0=d;this.wy0=0;this.wz0=0}else{this.wx0*=d/e;this.wy0*=d/e;this.wz0*=d/e}}if(typeof(c)=="number"){var b=Math.sqrt(this.wx1*this.wx1+this.wy1*this.wy1+this.wz1*this.wz1);if(b<0.000001){this.wx1=d;this.wy1=0;this.wz1=0}else{this.wx1*=c/b;this.wy1*=c/b;this.wz1*=c/b}}return this};this.resizeZ=function(d,c,f,b){if(!taccgl.dddmode){return this}if(!d&&d!=0){d=this.z0}if(!c&&c!=0){c=d}if(!f){f=0}if(!b){b=0}if(d=="out"){c=d=this.z1}else{if(d=="both"){d=this.z0;c=this.z1}}var e=(-taccgl.stdEye.eyeZ+d)/(-taccgl.stdEye.eyeZ+f);this.hx0*=e;this.hy0*=e;this.hz0*=e;this.wx0*=e;this.wy0*=e;this.wz0*=e;this.dx0*=e;this.dy0*=e;this.dz0*=e;e=(-taccgl.stdEye.eyeZ+c)/(-taccgl.stdEye.eyeZ+b);this.hx1*=e;this.hy1*=e;this.hz1*=e;this.wx1*=e;this.wy1*=e;this.wz1*=e;this.dx1*=e;this.dy1*=e;this.dz1*=e;return this};this.posZ=function(i,f,n,m,k,c,b,s){if(!f&&f!=0){f=i}else{if(typeof(f)=="object"){s=b;b=c;c=k;k=m;m=n;n=f;f=i}}var h=this.veye?this.veye:taccgl.stdEye;var j=0,g=0,e=0;if(n&&typeof(n)=="object"){if(n.eyeX||n.eyeX==0){h=n;n=m;m=k;k=c;c=b;b=s}else{var d=null,r=null;if(n.eye){h=n.eye}if(n.l||n.l==0){d=n.l}if(n.t||n.t==0){r=n.t}if(n.r||n.r==0){d=n.r+this.wx0}if(n.b||n.b==0){r=n.b+this.hy0}if(n.l0||n.l0==0){d=n.l0+this.x0}if(n.t0||n.t0==0){r=n.t0+this.y0}if(n.r0||n.r0==0){d=n.r0+this.x0+this.wx0}if(n.b0||n.b0==0){r=n.b0+this.y0+this.hy0}if(n.l1||n.l1==0){d=n.l1+this.x1}if(n.t1||n.t1==0){r=n.t1+this.y1}if(n.r1||n.r1==0){d=n.r1+this.x1+this.wx1}if(n.b1||n.b1==0){r=n.b1+this.y1+this.hy1}if(n.ox||n.ox==0){k=n.ox}if(n.oy||n.oy==0){m=n.oy}if(d||d==0||r||r==0){if(!d){d=0}if(!r){r=0}var o=h.calcPos(d,r);n=o[0];m=o[1];k=o[2]}else{if(n.ez||n.ez==0){k=n.ez}if(n.ey||n.ey==0){m=n.ex}if(n.ex||n.ex==0){n=n.ex}}}}if(!n&&n!=0){n=h.eyeX+j}if(!m&&m!=0){m=h.eyeY+g}if(!k&&k!=0){k=h.eyeZ+e}if(!c&&c!=0){c=h.ox}if(!b&&b!=0){b=h.oy}if(taccgl.dddmode){if(typeof(i)=="number"){this.x0=-((-k+i)/(-k+this.z0)*(-k*this.x0+this.z0*n)-i*n)/k;this.y0=-((-k+i)/(-k+this.z0)*(-k*this.y0+this.z0*m)-i*m)/k;this.z0=i}if(typeof(f)=="number"){this.x1=-((-k+f)/(-k+this.z1)*(-k*this.x1+this.z1*n)-f*n)/k;this.y1=-((-k+f)/(-k+this.z1)*(-k*this.y1+this.z1*m)-f*m)/k;this.z1=f}}else{var q=(n-c)/k,p=(m-b)/k;if(typeof(i)=="number"){this.x0+=q*(i-this.z0);this.y0+=p*(i-this.z0);this.z0=i}if(typeof(f)=="number"){this.x1+=q*(f-this.z1);this.y1+=p*(f-this.z1);this.z1=f}}return this};this.texmove=function(c,b,e,d){this.dotexmove=true;this.s1=e;this.ws1=this.ws0;this.t1=d;this.ht1=this.ht0;this.hs1=this.hs0;this.wt1=this.wt0;this.s0=c;this.t0=b;return this};this.flyIn=this.from=function(b,c,d){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx;c=this.resy;d=this.resz}if(typeof(d)!="number"){d=0}this.x0=b;this.y0=c;this.z0=d;return this};this.flyOut=this.to=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx;d=this.resy;c=this.resz}if(typeof(c)!="number"){c=0}this.x1=b;this.y1=d;this.z1=c;return this};this.position=this.pos=function(b,d,c){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx;d=this.resy;c=this.resz}if(!typeof(c)=="number"){c=0}this.x1=b;this.y1=d;this.z1=c;this.x0=b;this.y0=d;this.z0=c;return this};this.controllerRotationCenter=function(b,f,d,e){if(typeof(b)=="object"){e=f;this.resolvePosition(b);b=this.resx;f=this.resy;d=this.resz}if(!e){e=taccgl.controller}e.rotationCenter(b,f,d);return this};this.resolvePosition=function(B){var u=this,m,l,k,F,D,C,K,I,G,q,p,n;var f=B.el;if(B.t){u=B.t}if(f){taccgl.autoDetectScroll();if(typeof(f)=="string"){f=document.getElementById(f)}var g=f.getBoundingClientRect();m=g.left+taccgl.scrollLeft;l=g.top+taccgl.scrollTop;k=0;if(B.ex){m+=B.ex*g.width}if(B.ey){l+=B.ey*g.height}}else{if(B.pt){var b=B.pt,A=1-b;m=u.x0*A+u.x1*b;l=u.y0*A+u.y1*b;k=u.z0*A+u.z1*b}else{m=u.x0;l=u.y0;k=u.z0}}if(B.rt){var e=B.rt,w=1-e;F=u.hx0*w+u.hx1*e;D=u.hy0*w+u.hy1*e;C=u.hz0*w+u.hz1*e;K=u.wx0*w+u.wx1*e;I=u.wy0*w+u.wy1*e;G=u.wz0*w+u.wz1*e;q=u.dx0*w+u.dx1*e;p=u.dy0*w+u.dy1*e;n=u.dz0*w+u.dz1*e}else{F=u.hx0;D=u.hy0;C=u.hz0;K=u.wx0;I=u.wy0;G=u.wz0;q=u.dx0;p=u.dy0;n=u.dz0}if(typeof(B.hx)=="number"){m=u.x+u.w*B.hx}if(typeof(B.hy)=="number"){l=u.y+u.h*B.hy}if(typeof(B.Tx)=="number"||typeof(B.Ty)=="number"){if(typeof(B.Tx)!="number"){B.Tx=0}if(typeof(B.Ty)!="number"){B.Ty=0}var J,H,d,c;if(B.pt){var b=B.pt,A=1-b;m=u.s0*A+u.s1*b;l=u.t0*A+u.t1*b}else{m=u.s0;l=u.t0}if(B.rt&&u.dotexmove){var e=B.rt,w=1-e;J=u.hs0*w+u.hs1*e;H=u.ht0*w+u.ht1*e;d=u.ws0*w+u.ws1*e;c=u.wt0*w+u.wt1*e}else{J=u.hs0;H=u.ht0;d=u.ws0;c=u.wt0}m=m+B.Tx*d+B.Ty*J;l=l+B.Tx*c+B.Ty*H}if(B.M){var v=B.mx,s=B.my,r=B.mz,E,i=B.M;if(!v){v=0}if(!s){s=0}if(!r){r=0}if(typeof(B.Mx)=="number"){v=i.obj_xmin*(1-B.Mx)+i.obj_xmax*B.Mx}if(typeof(B.My)=="number"){s=i.obj_ymin*(1-B.My)+i.obj_ymax*B.My}if(typeof(B.Mz)=="number"){r=i.obj_zmin*(1-B.Mz)+i.obj_zmax*B.Mz}if(i.objt0){E=i.objt0}else{E=taccgl.mi44Mul([i.wx0,i.hx0,i.dx0,i.x0,i.wy0,i.hy0,i.dy0,i.y0,i.wz0,i.hz0,i.dz0,i.z0,0,0,0,1],i.objt)}m=v*E[0]+s*E[1]+r*E[2]+E[3];l=v*E[4]+s*E[5]+r*E[6]+E[7];k=v*E[8]+s*E[9]+r*E[10]+E[11]}if(typeof(B.x)=="number"){m=B.x}if(typeof(B.y)=="number"){l=B.y}if(typeof(B.z)=="number"){k=B.z}if(B.rx){m+=B.rx*K;l+=B.rx*I;k+=B.rx*G}if(B.ry){m+=B.ry*F;l+=B.ry*D;k+=B.ry*C}if(B.rz){m+=B.rz*q;l+=B.rz*p;k+=B.rz*n}if(B.rel){var h=B.rel;taccgl.autoDetectScroll();if(typeof(h)=="string"){h=document.getElementById(h)}var g=h.getBoundingClientRect();m+=g.left+taccgl.scrollLeft;l+=g.top+taccgl.scrollTop;if(B.rex){m+=B.rex*g.width}if(B.rey){l+=B.rey*g.height}}if(B.mel){var j=B.mel;taccgl.autoDetectScroll();if(typeof(j)=="string"){j=document.getElementById(j)}var g=j.getBoundingClientRect();m-=g.left+taccgl.scrollLeft;l-=g.top+taccgl.scrollTop;if(B.mex){m-=B.mex*g.width}if(B.mey){l-=B.mey*g.height}}if(B.ox){m+=B.ox}if(B.oy){l+=B.oy}if(B.oz){k+=B.oz}this.resx=m;this.resy=l;this.resz=k};this.reverseLMotion=function(){var b=this.x0,d=this.y0,c=this.z0;this.x0=this.x1;this.y0=this.y1;this.z0=this.z1;this.x1=b;this.y1=d;this.z1=c;return this};this.textureDraw=function(b){var c=this.el;if(this.mappedEl){c=this.mappedEl}taccgl.prePaintElement(c,true,b);return this};this.setCanvas=function(c){var d=this.curface;if(d.defTexCan!=c){if(!d.docolor){d.mix1=d.mix0=1;d.mixs0=d.mixs1=0}var b,f;if(d.defTexCan==1){b=d.mix0;f=d.mix1}else{b=d.mixs0;f=d.mixs1}if(c==1){this.blend(b,0,f,0)}else{this.blend(0,b,0,f)}}d.defTexCan=c};this.alloc=function(l,i){var e=this.curface;var m=l,g=1,n=1,k=1,c=1,b=true,f=e.el;if(e.mappedEl){f=e.mappedEl;var j=f.getBoundingClientRect(),l=j.width,i=j.height}if(typeof(l)=="object"){l=e.w;i=e.h;if(m.el){f=m.el;var j=f.getBoundingClientRect(),l=j.width,i=j.height}else{if(e.mappedEl){f=e.mappedEl;var j=f.getBoundingClientRect(),l=j.width,i=j.height}}if(m.w){l=m.w}if(m.h){i=m.h}if(m.scale){l*=m.scale;i*=m.scale}if(m.scalew){l*=m.scalew}if(m.scaleh){i*=m.scaleh}if(m.padleft){g=m.padleft}if(m.padright){c=m.padright}if(m.padtop){n=m.padtop}if(m.padbottom){k=m.padbottom}if(m.cache==false||m.cache){b=m.cache}}else{if(e.mappedEl){f=e.mappedEl;var j=f.getBoundingClientRect(),l=j.width,i=j.height}if(!l){l=e.w}if(!i){i=e.h}}var d=null;if(b){if(f.taccgl){if((d=f.taccgl.cachedAtlasBlock)&&(d.delno==taccgl.texAtlas.delno)){if(d.el==f&&d.w==l&&d.h==i&&d.pr==c&&d.pl==g&&d.pt==n&&d.pb==k){}else{d=null}}else{d=null}}}if(!d){d=taccgl.texAtlas.alloc(this,l+c+g,i+n+k)}e.atBl=d;if(d==null){console.log("Out of texture space for element "+f.id+" needed "+(l+c+g)+"x"+(i+n+k));return this}e.ws0=l;e.wt0=0;e.hs0=0;e.ht0=i;e.s0=e.s1=d.x+g;e.t0=e.t1=d.y+n;this.setCanvas(d.t);if(b){taccgl.taccglAttach(f);f.taccgl.cachedAtlasBlock=d;d.el=f;d.w=l;d.h=i,d.pr=c,d.pl=g,d.pt=n,d.pb=k}return this};this.texClear=function(b){var c=this.curface;b=c.defTexCan;if(b==1&&c.s0==1&&c.t0==1&&c.ws0==1&&c.wt0==0&&c.ht0==1&&c.hs0==0){return this}taccgl.texTo(b);if(!taccgl.texc){return this}taccgl.markCanvasChanged();if(c.s0!=c.x||c.t0!=c.y||c.ws0!=c.w||c.ht0!=c.h){var e=c.ws0/c.w;var d=c.ht0/c.h;taccgl.texTransform(e,0,0,d,(c.s0-c.x*e),(c.t0-c.y*d));taccgl.texc.clearRect(c.x,c.y,c.w,c.h);taccgl.texTransform(1,0,0,1,0,0)}else{taccgl.texc.clearRect(c.x,c.y,c.w,c.h)}return this};this.mActor=function(b,c){if(!c){c=1}this.hideAtBegin();this.defTexCan=c;this.paint();if(b!=null){this.visatend(b)}else{taccgl.taccglAttach(this.el);if(!this.el.taccgl.preVisibility&&this.el.taccgl.preVisibility!=""){this.el.taccgl.preVisibility=this.el.style.visibility}this.visatend(this.el.taccgl.preVisibility)}if(c==2){this.blend(0,1)}return this};this.paintJob=function(c){if(taccgl.prevPaintJob){var b=taccgl.newJob(c);b.waitFor(taccgl.prevPaintJob);taccgl.prevPaintJob=b;return}else{c()}};this.paint=function(g,q){var c=this.curface,d=c.el,n=c.w,e=c.h,m=c.x,k=c.y;if(c.mappedEl){d=c.mappedEl;taccgl.autoDetectScroll();var j=d.getBoundingClientRect();n=j.width;e=j.height;m=j.left+taccgl.scrollLeft,k=j.top+taccgl.scrollTop}if(!c.atBl){this.alloc()}if(typeof(g)=="object"){var b=g;g=c.defTexCan;q=(b.ignorehide!=false);if(b.el){d=b.el;taccgl.autoDetectScroll();var j=d.getBoundingClientRect();n=j.width;e=j.height;m=j.left+taccgl.scrollLeft,k=j.top+taccgl.scrollTop}}else{if(q!=false){q=true}if(!g){g=this.defTexCan}else{throw"paint: parameter error"}}if(g==1&&c.s0==1&&c.t0==1&&c.ws0==1&&c.wt0==0&&c.ht0==1&&c.hs0==0){return this}if(!(taccgl.ddmode||taccgl.dddmode)){return this}if(c.s0!=this.x||c.t0!=this.y||c.ws0!=this.w||c.ht0!=this.h||this.hs0!=0||this.wt0!=0){var l=c.ws0/n;var i=c.ht0/e,o=c.s0,f=c.t0;taccgl.prePaintElement(d,q,g,function(){taccgl.texTransform(l,0,0,i,(o-m*l),(f-k*i))},function(){taccgl.texTransform(1,0,0,1,0,0)})}else{taccgl.prePaintElement(d,q,g)}return this};this.texTransform=function(){var b=this.curface,j=b.w,c=b.h,g=b.x,f=b.y;taccgl.texTo(b.defTexCan);var i=b.ws0/j;var e=b.ht0/c,k=b.s0,d=b.t0;taccgl.texTransform(i,0,0,e,(k-g*i),(d-f*e))};this.hide=function(){taccgl.taccglAttach(this.el);if(!this.el.taccgl.preVisibility&&this.el.taccgl.preVisibility!=""){this.el.taccgl.preVisibility=this.el.style.visibility}this.el.style.visibility="hidden";var b;if(b=this.el.taccgl.asShadow){b.showafter(false);b.starttime(-1);b.dur(0.001);b.start()}return this};this.opacity=function(c){if(!c){c=0}taccgl.taccglAttach(this.el);if(!this.el.taccgl.preOpacity&&this.el.taccgl.preOpacity!=0){this.el.taccgl.preOpacity=this.el.style.opacity}this.el.style.opacity=c;var b;if(c==0&&(b=this.el.taccgl.asShadow)){b.showafter(false);b.starttime(-1);b.dur(0.001);b.start()}return this};this.visatend=this.visAtEnd=function(b){taccgl.taccglAttach(this.el);if(b!=null){this.postVisibility=b}else{if(this.el.taccgl.preVisibility!=null){this.postVisibility=this.el.taccgl.preVisibility}else{this.postVisibility=this.el.style.visibility}}this.elshowatend=this.el;this.special=true;return this};this.opacityatend=this.opacityAtEnd=function(b){taccgl.taccglAttach(this.el);if(b!=null){this.postOpacity=b}else{if(this.el.taccgl.preOpacity!=null){this.postOpacity=this.el.taccgl.preOpacity}else{this.postOpacity=this.el.style.opacity}}this.elshowatend=this.el;this.special=true;return this};this.hideAtBegin=function(){this.elhideatbegin=this.el;this.special=true;return this};this.opacityAtBegin=function(c){if(!c){c=0}this.elhideatbegin=this.el;this.opaqueLevelBegin=c;this.special=true;var b;if(this.el.taccgl&&(b=this.el.taccgl.asShadow)){b.showafter(false);b.dur(this.basetime-b.basetime);b.start()}return this};this.visFinal=function(b){taccgl.taccglAttach(this.el);if(b){this.el.taccgl.postVisibility=b}else{if(this.el.taccgl.preVisibility!=null){this.el.taccgl.postVisibility=this.el.taccgl.preVisibility}else{this.el.taccgl.postVisibility=this.el.style.visibility}}taccgl.showAfterAnimation.push(this);return this};this.opacityFinal=function(b){taccgl.taccglAttach(this.el);if(b){this.el.taccgl.postOpacity=b}else{if(this.el.taccgl.preOpacity!=null){this.el.taccgl.postOpacity=this.el.taccgl.preOpacity}else{this.el.taccgl.postOpacity=this.el.style.opacity}}taccgl.showAfterAnimation.push(this);return this};this.absStartScroll=function(b){if(!b){b=0}this.basetime=b;this.flags&=65535;this.flags|=1<<16;return this};this.startScroll=function(b){if(!b){b=0}this.basetime=this.y+b;this.flags&=65535;this.flags|=1<<16;return this};this.distance=this.dist=function(b){this.vduration=b;return this};this.eye=function(b){this.veye=b;return this};this.starttime=this.startTime=function(b){if(!b){b=0}this.basetime=b+taccgl.currenttime;this.flags&=65535;return this};this.absStartTime=function(b){this.basetime=b;this.flags&=65535;return this};this.duration=this.dur=function(b){this.vduration=b*taccgl.timeScale;return this};this.permanent=this.perm=function(){this.vduration=100000000;return this};this.until=function(b){this.dur(b+taccgl.currenttime-this.basetime);return this};this.untilEo=function(b){this.until(b.basetime+b.vduration);return this};this.untilBo=function(b){this.until(b.basetime);return this};this.untilaLEo=function(b){if(b.basetime+b.vduration>this.basetime+this.vduration){this.until(b.basetime+b.vduration)}return this};this.untilaLBo=function(b){if(b.basetime>this.basetime+this.vduration){this.until(b.basetime)}return this};this.untilaMEo=function(b){if(b.basetime+b.vduration<this.basetime+this.vduration){this.until(b.basetime+b.vduration)}return this};this.untilaMBo=function(b){if(b.basetime<this.basetime+this.vduration){this.until(b.basetime)}return this};this.showbefore=this.showBefore=function(c){if(c==false){this.flags&=~1}else{this.flags|=1}return this};this.showafter=this.showAfter=function(c){if(c==false){this.flags&=~2}else{this.flags|=2}return this};this.texCan=function(b){this.defTexCan=b;return this};this.alpha=function(b,c){if(this.defTexCan==1){this.blend(b,0,c,0)}else{this.blend(0,b,0,c)}return this};this.blend=this.blendInt=function(e,d,b,c){if(!this.docolor){this.col0s=this.col0t=this.col1s=this.col1t=-128*256}this.docolor=true;this.flags|=16;this.mix0=e;this.mix1=e;if(!d){d=0}this.mixs0=d;this.mixs1=d;if(typeof(b)=="number"){this.mix1=b}if(typeof(c)=="number"){this.mixs1=c}return this};this.blendA=function(c,b,e,d){if(!this.docolor){this.col0s=this.col0t=this.col1s=this.col1t=-128*256}this.docolor=true;this.flags|=16;this.mix0=c;this.mix1=b;if(!e){e=0}if(!d){d=0}this.mixs0=e;this.mixs1=d;return this};this.color=function(d,b){this.bgColor(d,b);this.mix1=this.mix0=0;this.mixs0=this.mixs1=0;return this};this.bgColor=function(k,f){var j,i,h,d,e;if(!this.docolor){this.mix1=this.mix0=1;this.mixs0=this.mixs1=0}this.docolor=true;this.flags|=16;this.flags&=~32;this.flags&=~64;this.ddcolor0=this.ddcolor1=k;if(f){this.ddcolor1=f}if(k&&taccgl.scratchc){taccgl.scratchc.fillStyle=k;taccgl.scratchc.clearRect(0,0,1,1);taccgl.scratchc.fillRect(0,0,1,1);j=taccgl.scratchc.getImageData(0,0,1,1),i=j.data[0],h=j.data[1],d=j.data[2],e=j.data[3];this.col0s=this.col1s=i+256*(h-128);this.col0t=this.col1t=e+256*(d-128)}if(f&&taccgl.scratchc){taccgl.scratchc.fillStyle=f;taccgl.scratchc.clearRect(0,0,1,1);taccgl.scratchc.fillRect(0,0,1,1);j=taccgl.scratchc.getImageData(0,0,1,1),i=j.data[0],h=j.data[1],d=j.data[2],e=j.data[3];this.col1s=i+256*(h-128);this.col1t=e+256*(d-128)}return this};this.colorInt=function(k,j,c,e,h,f,i,d){if(!this.docolor){this.mix1=this.mix0=1;this.mixs0=this.mixs1=0}this.docolor=true;this.flags|=16;this.flags&=~32;this.flags&=~64;this.col0s=k+256*(j-128);this.col0t=e+256*(c-128);this.col1s=h+256*(f-128);this.col1t=d+256*(i-128);return this};this.discardThreshold=function(b){this.colorInt(b*255,0,0,0,b*255,0,0,0);return this};this.colorA=function(k,f){var j,i,h,d,e;if(!this.docolor){this.mix1=this.mix0=1;this.mixs0=this.mixs1=0}this.docolor=true;this.flags|=16;this.flags&=~32;this.flags&=~64;this.ddcolor0=k;this.ddcolor1=f;if(k&&taccgl.scratchc){taccgl.scratchc.fillStyle=k;taccgl.scratchc.clearRect(0,0,1,1);taccgl.scratchc.fillRect(0,0,1,1);j=taccgl.scratchc.getImageData(0,0,1,1),i=j.data[0],h=j.data[1],d=j.data[2],e=j.data[3];this.col0s=i+256*(h-128);this.col0t=e+256*(d-128)}if(f&&taccgl.scratchc){taccgl.scratchc.fillStyle=f;taccgl.scratchc.clearRect(0,0,1,1);taccgl.scratchc.fillRect(0,0,1,1);j=taccgl.scratchc.getImageData(0,0,1,1),i=j.data[0],h=j.data[1],d=j.data[2],e=j.data[3];this.col1s=i+256*(h-128);this.col1t=e+256*(d-128)}return this};this.lightAmbDiff=function(e,b,d,c){this.bgColor(e,b);this.ddcolor0="rgba(255,255,255,"+d+")";this.ddcolor1=this.ddcolor0="rgba(255,255,255,"+c+")";if(!d&&d!=0){d=0}if(!c&&c!=0){c=0}if(d>1){d=1}if(c>1){c=1}if(d<0){d=0}if(c<0){c=0}this.col0t=Math.floor(this.col0t/256)*256+d*255;this.col1t=Math.floor(this.col1t/256)*256+c*255;this.flags|=32;this.flags&=~64;return this};this.lightBgAmbDiff=function(j,m,l,f,e){if(!this.docolor){this.mix1=this.mix0=1;this.mixs0=this.mixs1=0}this.docolor=true;this.flags|=16+32+64;this.ddcolor0=j;this.ddcolor1=j;if(!f&&f!=0){f=1}if(!e&&e!=0){e=1}if(f>1){f=1}if(e>1){e=1}if(f<0){f=0}if(e<0){e=0}if(j&&taccgl.scratchc){taccgl.scratchc.fillStyle=j;taccgl.scratchc.clearRect(0,0,1,1);taccgl.scratchc.fillRect(0,0,1,1);var h=taccgl.scratchc.getImageData(0,0,1,1),d=h.data[0],i=h.data[1],k=h.data[2];this.col0s=d+256*(i-128);this.col0t=Math.floor(f*255)+256*(k-128);this.ddcolor0="rgba("+d+","+i+","+k+","+f+")";this.ddcolor1="rgba("+d+","+i+","+k+","+e+")"}if(m>1){m=1}if(l>1){l=1}if(m<0){m=0}if(l<0){l=0}m=Math.floor(m*255);l=Math.floor(l*255);this.col1s=m+256*(l-128);this.col1t=Math.floor(e*255);return this};this.material=function(b){b.applyToAnim(this);return this};this.applyToAnim=function(b){b.lightSpecular=this.lightSpecular;b.lightShininess=Math.round(this.lightShininess);if(this.docolor){b.docolor=this.docolor;b.flags|=this.flags;b.col0s=this.col0s;b.col0t=this.col0t;b.col1s=this.col1s;b.col1t=this.col1t;b.ddcolor0=this.ddcolor0;b.ddcolor1=this.ddcolor1;b.mix0=this.mix0;b.mix1=this.mix1;b.mixs0=this.mixs0;b.mixs1=this.mixs1;b.defTexCan=this.defTexCan}b.s0=this.s0;b.t0=this.t0;b.ws0=this.ws0;b.ht0=this.ht0;b.wt0=this.wt0;b.hs0=this.hs0;if(this.dotexmove){b.dotexmove=this.texmove;b.s1=this.s1;b.t1=this.t1;b.ws1=this.ws1;b.ht1=this.ht1;b.wt1=this.wt1;b.hs1=this.hs1}};this.map=function(e,c,b,d){if(typeof(e)=="object"){this.resolvePosition(e);d=b;b=c;e=this.resx;c=this.resy}if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-e;d=this.resy-c}this.dotexmove=false;if(e||e==0){this.s0=e}if(c||c==0){this.t0=c}if(b||d){this.wt0=this.hs0=0}if(b&&d){this.ws0=b;this.ht0=d}else{if(b){this.ht0*=b/this.ws0;this.ws0=b}else{if(d){this.ws0*=d/this.ht0;this.ht0=d}}}return this};this.mapScale=function(b){this.ws0*=b;this.ht0*=b;this.wt0*=b;this.hs0*=b;return this};this.map1=this.mapTo=function(e,c,b,d){if(typeof(e)=="object"){this.resolvePosition(e);d=b;b=c;e=this.resx;c=this.resy}if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-e;d=this.resy-c}this.dotexmove=true;if(e||e==0){this.s1=e}if(c||c==0){this.t1=c}if(b||d){this.wt1=this.hs1=0}if(b&&d){this.ws1=b;this.ht1=d}else{if(b){this.ht1*=b/this.ws1;this.ws1=b}else{if(d){this.ws1*=d/this.ht1;this.ht1=d}}}return this};this.mapFrom=function(e,c,b,d){if(!this.dotexmove){this.dotexmove=true;this.s1=this.s0;this.ws1=this.ws0;this.t1=this.t0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0}if(typeof(e)=="object"){this.resolvePosition(e);d=b;b=c;e=this.resx;c=this.resy}if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx-e;d=this.resy-c}if(e||e==0){this.s0=e}if(c||c==0){this.t0=c}if(b||d){this.wt0=this.hs0=0}if(b&&d){this.ws0=b;this.ht0=d}else{if(b){this.ht0*=b/this.ws0;this.ws0=b}else{if(d){this.ws0*=d/this.ht0;this.ht0=d}}}return this};this.mapT=function(g,f,c,b,e,d){if(typeof(g)=="object"){this.resolvePosition(g);d=e;e=b;b=c;c=f;g=this.resx;f=this.resy}if(typeof(c)=="object"){this.resolvePosition(c);d=e;e=b;c=this.resx-g;b=this.resy-f}if(typeof(e)=="object"){this.resolvePosition(e);e=this.resx-g;d=this.resy-f}if(this.doftetexmove){this.mapRFrom(g,f,c,b,e,d);this.mapRTo(g,f,c,b,e,d)}else{this.s0=g;this.t0=f;this.ws0=c;this.wt0=b;this.hs0=e;this.ht0=d}return this};this.mapTFrom=function(g,f,c,b,e,d){if(!this.dotexmove){this.dotexmove=true;this.s1=this.s0;this.ws1=this.ws0;this.t1=this.t0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0}if(typeof(g)=="object"){this.resolvePosition(g);d=e;e=b;b=c;c=f;g=this.resx;f=this.resy}if(typeof(c)=="object"){this.resolvePosition(c);d=e;e=b;c=this.resx-g;b=this.resy-f}if(typeof(e)=="object"){this.resolvePosition(e);e=this.resx-g;d=this.resy-f}this.s0=g;this.t0=f;this.ws0=c;this.wt0=b;this.hs0=e;this.ht0=d;return this};this.mapTTo=function(g,f,c,b,e,d){if(typeof(g)=="object"){this.resolvePosition(g);d=e;e=b;b=c;c=f;g=this.resx;f=this.resy}if(typeof(c)=="object"){this.resolvePosition(c);d=e;e=b;c=this.resx-g;b=this.resy-f}if(typeof(e)=="object"){this.resolvePosition(e);e=this.resx-g;d=this.resy-f}this.dotexmove=true;this.s1=g;this.t1=f;this.ws1=c;this.wt1=b;this.hs1=e;this.ht1=d;return this};this.mapAnim=function(){this.dotexmove=true;this.s1=this.s0;this.t1=this.t0;this.ws1=this.ws0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0;return this};this.mapReverse=function(){if(this.dotexmove){var d=this.s1,f=this.t1,b=this.ws1,g=this.ht1,c=this.wt1,e=this.hs1;this.s1=this.s0;this.t1=this.t0;this.ws1=this.ws0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0;this.s0=d;this.t0=f;this.ws0=b;this.ht0=g;this.wt0=c;this.hs0=e;return this}};this.mapElement=function(d){if(typeof(d)=="string"){d=document.getElementById(d)}taccgl.autoDetectScroll();var e=d.getBoundingClientRect(),c=e.left+taccgl.scrollLeft,b=e.top+taccgl.scrollTop;this.map(c,b,d.offsetWidth,d.offsetHeight);return this};this.mapA=function(b){if(typeof(b)=="string"){b=document.getElementById(b)}var d=this.curface;d.mappedEl=b;taccgl.autoDetectScroll();var c=b.getBoundingClientRect();d.wp0=d.wp1=c.width;d.wq0=d.wq1=0;d.hq0=d.hq1=c.height;d.hp0=d.hp1=0;d.p0=d.p1=c.left+taccgl.scrollLeft;d.q0=d.q1=c.top+taccgl.scrollTop};this.mapActor=function(b,c){if(typeof(b)=="string"){b=document.getElementById(b)}this.mapA(b);if(typeof(c)=="object"){c.el=b}else{c={el:b}}this.alloc(c);this.paint({});return this};this.mapMirrorY=function(){this.s0+=this.ws0;this.t0+=this.wt0;this.ws0=-this.ws0;this.wt0=-this.wt0;return this};this.mapMirrorX=function(){this.t0+=this.ht0;this.s0+=this.hs0;this.ht0=-this.ht0;this.hs0=-this.hs0;return this};this.mapTurn=function(){this.s0=this.s0+this.ws0+this.hs0;this.t0=this.t0+this.ht0+this.wt0;this.ht0=-this.ht0;this.hs0=-this.hs0;this.ws0=-this.ws0;this.wt0=-this.wt0;return this};this.mapRelative=function(e,c,b,d){if(!b&&b!=0){b=this.ws0}if(!d&&d!=0){d=this.ht0}this.s0+=e;this.t0+=c;this.ws0=b;this.ht0=d;this.wt0=0;this.hs0=0;return this};this.mapClip=function(b,c,e,d){if(d!="b"&&d!="br"){if(c>this.ht0){c=this.ht0}}if(d!="r"&&d!="br"){if(b>this.ws0){b=this.ws0}}if(e=="tl"){}else{if(e=="t"){b=this.ws0}else{if(e=="tr"){this.s0+=this.ws0-b}else{if(e=="l"){c=this.ht0}else{if(e=="r"){this.s0+=this.ws0-b;c=this.ht0}else{if(e=="bl"){this.t0+=this.ht0-c}else{if(e=="b"){this.t0+=this.ht0-c;b=this.ws0}else{if(e=="br"){this.t0+=this.ht0-c;this.s0+=this.ws0-b}}}}}}}}this.ws0=b;this.ht0=c;return this};this.mapClipToElement=function(e,d){var c=Math.sqrt(this.hx0*this.hx0+this.hy0*this.hy0+this.hz0*this.hz0),b=Math.sqrt(this.wx0*this.wx0+this.wy0*this.wy0+this.wz0*this.wz0);this.mapClip(b,c,e,d);return this};this.initNormals=function(){this.donormal=true;this.ntlx=this.nblx=this.ntrx=this.nbrx=this.hy0*this.wz0-this.hz0*this.wy0;this.ntly=this.nbly=this.ntry=this.nbry=this.hz0*this.wx0-this.hx0*this.wz0;this.ntlz=this.nblz=this.ntrz=this.nbrz=this.hx0*this.wy0-this.hy0*this.wx0};this.copyTiming=function(b){this.absStartTime(b.basetime);this.dur(b.vduration);return this};this.copyMotion=function(b){this.rotate(b.rotpx,b.rotpy,b.rotpz,b.rotax,b.rotay,b.rotaz);this.rotatePart(b.rotfrom,b.rotto);return this};this.hbStarted=function(){if(!this.astepdelno){return false}return this.astepdelno==taccgl.delno};this.inTime=function(b){if(!b&&b!=0){b=taccgl.currenttime}if(b<this.basetime&&((this.flags&1)==0)){return false}if(b>this.basetime+this.vduration&&((this.flags&2)==0)){return false}return true};this.calcBounds0=function(){var c=taccgl.projectX(this.x0,this.y0,this.z0);var f=c;var d=c;var c=taccgl.projectX(this.x0+this.hx0,this.y0+this.hy0,this.z0+this.hz0);if(c<f){f=c}if(c>d){d=c}var c=taccgl.projectX(this.x0+this.wx0,this.y0+this.wy0,this.z0+this.wz0);if(c<f){f=c}if(c>d){d=c}var c=taccgl.projectX(this.x0+this.dx0,this.y0+this.dy0,this.z0+this.dz0);if(c<f){f=c}if(c>d){d=c}var c=taccgl.projectX(this.x0+this.hx0+this.wx0,this.y0+this.hy0+this.wy0,this.z0+this.hz0+this.wz0);if(c<f){f=c}if(c>d){d=c}var c=taccgl.projectX(this.x0+this.hx0+this.dx0,this.y0+this.hy0+this.dy0,this.z0+this.hz0+this.dz0);if(c<f){f=c}if(c>d){d=c}var c=taccgl.projectX(this.x0+this.dx0+this.wx0,this.y0+this.dy0+this.wy0,this.z0+this.dz0+this.wz0);if(c<f){f=c}if(c>d){d=c}var c=taccgl.projectX(this.x0+this.hx0+this.wx0+this.dx0,this.y0+this.hy0+this.wy0+this.dy0,this.z0+this.hz0+this.wz0+this.dz0);if(c<f){f=c}if(c>d){d=c}this.pxmin=f;this.pxmax=d;var g=taccgl.projectY(this.x0,this.y0,this.z0);var e=g;var b=g;var g=taccgl.projectY(this.x0+this.hx0,this.y0+this.hy0,this.z0+this.hz0);if(g<e){e=g}if(g>b){b=g}var g=taccgl.projectY(this.x0+this.wx0,this.y0+this.wy0,this.z0+this.wz0);if(g<e){e=g}if(g>b){b=g}var g=taccgl.projectY(this.x0+this.dx0,this.y0+this.dy0,this.z0+this.dz0);if(g<e){e=g}if(g>b){b=g}var g=taccgl.projectY(this.x0+this.hx0+this.wx0,this.y0+this.hy0+this.wy0,this.z0+this.hz0+this.wz0);if(g<e){e=g}if(g>b){b=g}var g=taccgl.projectY(this.x0+this.hx0+this.dx0,this.y0+this.hy0+this.dy0,this.z0+this.hz0+this.dz0);if(g<e){e=g}if(g>b){b=g}var g=taccgl.projectY(this.x0+this.dx0+this.wx0,this.y0+this.dy0+this.wy0,this.z0+this.dz0+this.wz0);if(g<e){e=g}if(g>b){b=g}var g=taccgl.projectY(this.x0+this.hx0+this.wx0+this.dx0,this.y0+this.hy0+this.wy0+this.dy0,this.z0+this.hz0+this.wz0+this.dz0);if(g<e){e=g}if(g>b){b=g}this.pymin=e;this.pymax=b;return this};this.evalObjt=function(){this.objt0=[this.wx0,this.hx0,this.dx0,this.x0,this.wy0,this.hy0,this.dy0,this.y0,this.wz0,this.hz0,this.dz0,this.z0,0,0,0,1];this.objt1=[this.wx1,this.hx1,this.dx1,this.x1,this.wy1,this.hy1,this.dy1,this.y1,this.wz1,this.hz1,this.dz1,this.z1,0,0,0,1];this.objt0inv=taccgl.mi33T(taccgl.m33Inverse(taccgl.m33FromM44(this.objt0)));this.objt1inv=taccgl.mi33T(taccgl.m33Inverse(taccgl.m33FromM44(this.objt1)))};this.ddstart=function(){var b=taccgl,g=this.vduration+this.basetime;if(this.special){this.startSpecialDD()}if(!taccgl.ddmode){return}if(b.duration<g&&((this.flags&1<<16)==0)){b.setDuration(g)}if(!this.doacceleration){this.ax=this.ay=this.az=0}if(!this.dotexmove){this.s1=this.s0;this.ws1=this.ws0;this.t1=this.t0;this.ht1=this.ht0}if(this.face){var c;for(c=0;c<this.face.length;c++){var d=this.face[c];if(!d.dotexmove){d.s1=d.s0}d.ws1=d.ws0;d.t1=d.t0;d.ht1=d.ht0}}if(this.astepdelno!=b.delno){b.AA.push(this);this.ddindex=b.AA.length-1}this.astepdelno=b.delno;return this};this.startSpecialDD=function(){if(((this.flags&1<<16)==0)&&(this.isforeground||this.todoAtBegin||this.todoAtEnd||this.elshowatend||this.elhideatbegin)){this.registerBeginEnd()}};this.startSpecial=function(){if(this.p!=taccgl.stdsc){taccgl.setShader(this.p)}if(this.isforeground||this.todoAtBegin||this.todoAtEnd||this.elshowatend||this.elhideatbegin){this.registerBeginEnd()}var b;if(this.elhideatbegin&&this.el.taccgl&&(b=this.el.taccgl.asShadow)){if(this.basetime-b.basetime>0){b.showafter(false);b.dur(this.basetime-b.basetime);b.start()}}};this.start=function(){var d=taccgl;if(!d.dddmode){this.ddstart();return this}var f=null;if(this.astepdelno==d.delno){f=d.vertI;d.vertI=this.vertindex}else{this.vertindex=d.vertI;this.astepdelno=d.delno}if(this.special){this.startSpecial()}var b=-this.hy0*this.wz0+this.hz0*this.wy0,g=-this.hz0*this.wx0+this.hx0*this.wz0,e=-this.hx0*this.wy0+this.hy0*this.wx0;var c=this.lightSpecular+this.lightShininess;d.nvertMove(this.x0,this.y0,this.z0,this.x1,this.y1,this.z1,b,g,e,c,this.s0,this.t0,this.flags,this.basetime,this.vduration);d.nvertMove(this.x0+this.hx0,this.y0+this.hy0,this.z0+this.hz0,this.x1+this.hx1,this.y1+this.hy1,this.z1+this.hz1,b,g,e,c,this.s0+this.hs0,this.t0+this.ht0,this.flags,this.basetime,this.vduration);d.nvertMove(this.x0+this.wx0,this.y0+this.wy0,this.z0+this.wz0,this.x1+this.wx1,this.y1+this.wy1,this.z1+this.wz1,b,g,e,c,this.s0+this.ws0,this.t0+this.wt0,this.flags,this.basetime,this.vduration);d.nvertMove(this.x0+this.wx0+this.hx0,this.y0+this.wy0+this.hy0,this.z0+this.wz0+this.hz0,this.x1+this.wx1+this.hx1,this.y1+this.hy1+this.wy1,this.z1+this.wz1+this.hz1,b,g,e,c,this.s0+this.ws0+this.hs0,this.t0+this.ht0+this.wt0,this.flags,this.basetime,this.vduration);d.nvertMove(this.x0+this.wx0,this.y0+this.wy0,this.z0+this.wz0,this.x1+this.wx1,this.y1+this.wy1,this.z1+this.wz1,b,g,e,c,this.s0+this.ws0,this.t0+this.wt0,this.flags,this.basetime,this.vduration);d.nvertMove(this.x0+this.hx0,this.y0+this.hy0,this.z0+this.hz0,this.x1+this.hx1,this.y1+this.hy1,this.z1+this.hz1,b,g,e,c,this.s0+this.hs0,this.t0+this.ht0,this.flags,this.basetime,this.vduration);this.startRest();if(this.p!=d.stdsc){d.setShader(d.stdsc)}this.vertEndIndex=d.vertI;if(f){d.vertI=f}return this};this.startRest=function(){var b=taccgl,c,d=this.vduration+this.basetime;if(b.duration<d&&((this.flags&1<<16)==0)){b.setDuration(d)}if(this.rotation){for(c=1;c<=6;c++){b.nvertRot(this.rotpx,this.rotpy,this.rotpz,this.rotax,this.rotay,this.rotaz,this.rotfrom,this.rotto,this.rotacc);b.nvertOffset(-1)}b.nvertOffset(6)}if(this.doacceleration){for(c=1;c<=6;c++){b.nvertAcceleration(this.ax,this.ay,this.az);b.nvertOffset(-1)}b.nvertOffset(6)}if(this.dotexmove){b.nvertOffset(-5);b.nvertTexMove(this.s1,this.t1);b.nvertOffset(1);b.nvertTexMove(this.s1+this.hs1,this.t1+this.ht1);b.nvertOffset(1);b.nvertTexMove(this.s1+this.ws1,this.t1+this.wt1);b.nvertOffset(1);b.nvertTexMove(this.s1+this.ws1+this.hs1,this.t1+this.wt1+this.ht1);b.nvertOffset(1);b.nvertTexMove(this.s1+this.ws1,this.t1+this.wt1);b.nvertOffset(1);b.nvertTexMove(this.s1+this.hs1,this.t1+this.ht1)}if(this.docolor){b.nvertColor6(this.col0s,this.col0t,this.col1s,this.col1t,this.mix0,this.mix1,this.mixs0,this.mixs1)}if(this.donormal){b.nvertOffset(-5);b.nvertNormal3(this.ntlx,this.ntly,this.ntlz);b.nvertOffset(1);b.nvertNormal3(this.nblx,this.nbly,this.nblz);b.nvertOffset(1);b.nvertNormal3(this.ntrx,this.ntry,this.ntrz);b.nvertOffset(1);b.nvertNormal3(this.nbrx,this.nbry,this.nbrz);b.nvertOffset(1);b.nvertNormal3(this.ntrx,this.ntry,this.ntrz);b.nvertOffset(1);b.nvertNormal3(this.nblx,this.nbly,this.nblz)}};this.startRestTriangle=function(){var b=taccgl,c,d=this.vduration+this.basetime;if(b.duration<d&&((this.flags&1<<16)==0)){b.setDuration(d)}if(this.rotation){for(c=1;c<=3;c++){b.nvertRot(this.rotpx,this.rotpy,this.rotpz,this.rotax,this.rotay,this.rotaz,this.rotfrom,this.rotto,this.rotacc);b.nvertOffset(-1)}b.nvertOffset(3)}if(this.doacceleration){for(c=1;c<=3;c++){b.nvertAcceleration(this.ax,this.ay,this.az);b.nvertOffset(-1)}b.nvertOffset(3)}if(this.dotexmove){b.nvertOffset(-2);b.nvertTexMove(this.s1,this.t1);b.nvertOffset(1);b.nvertTexMove(this.s1+this.hs1,this.t1+this.ht1);b.nvertOffset(1);b.nvertTexMove(this.s1+this.ws1,this.t1+this.wt1)}if(this.docolor){b.nvertColor3(this.col0s,this.col0t,this.col1s,this.col1t,this.mix0,this.mix1,this.mixs0,this.mixs1)}};this.startFixNormal0=function(){var e=taccgl;var m=this.lightSpecular+this.lightShininess;e.nvertOffset(-3);var l=e.vertOrigin[4*e.vertI+4]-e.vertOrigin[4*e.vertI],g=e.vertOrigin[4*e.vertI+5]-e.vertOrigin[4*e.vertI+1],c=e.vertOrigin[4*e.vertI+6]-e.vertOrigin[4*e.vertI+2],b=e.vertOrigin[4*e.vertI+8]-e.vertOrigin[4*e.vertI],k=e.vertOrigin[4*e.vertI+9]-e.vertOrigin[4*e.vertI+1],d=e.vertOrigin[4*e.vertI+10]-e.vertOrigin[4*e.vertI+2],i=-g*d+c*k,h=-c*b+l*d,f=-l*k+g*b;e.nvertOffset(1);e.nvertNormal(i,h,f,m);e.nvertOffset(1);e.nvertNormal(i,h,f,m);e.nvertOffset(1);e.nvertNormal(i,h,f,m)};this.startFixNormal=function(){var C=taccgl;var m=this.lightSpecular+this.lightShininess;C.nvertOffset(-3);var D=4*C.vertI;var l=C.vertOrigin[D+4]-C.vertOrigin[D],A=C.vertOrigin[D+5]-C.vertOrigin[D+1],e=C.vertOrigin[D+6]-C.vertOrigin[D+2],x=C.vertOrigin[D+8]-C.vertOrigin[D],G=C.vertOrigin[D+9]-C.vertOrigin[D+1],h=C.vertOrigin[D+10]-C.vertOrigin[D+2],y=-A*h+e*G,d=-e*x+l*h,k=-l*G+A*x,i=C.vertPos[D+4]-C.vertPos[D],z=C.vertPos[D+5]-C.vertPos[D+1],c=C.vertPos[D+6]-C.vertPos[D+2],u=C.vertPos[D+8]-C.vertPos[D],E=C.vertPos[D+9]-C.vertPos[D+1],f=C.vertPos[D+10]-C.vertPos[D+2],v=-z*f+c*E,F=-c*u+i*f,g=-i*E+z*u,q=-d*g+k*F,o=-k*v+y*g,n=-y*F+d*v,B=Math.sqrt(q*q+o*o+n*n),t=Math.sqrt(y*y+d*d+k*k),s=Math.sqrt(v*v+F*F+g*g);if(t<0.001){y=d=0;k=1;t=1}if(s<0.001){v=F=0;g=1;s=1}var p=Math.PI*2-Math.acos((y*v+d*F+k*g)/t/s),r=Math.PI*2;if(Math.abs(p-r)<0.001){p=r=0}q/=B;o/=B;n/=B;C.nvertOffset(1);C.nvertNormal(y,d,k,m);if(B>0.001){C.nvertRot(C.vertPos[D],C.vertPos[D+1],C.vertPos[D+2],q,o,n,r,p)}C.nvertOffset(1);C.nvertNormal(y,d,k,m);if(B>0.001){C.nvertRot(C.vertPos[D+4],C.vertPos[D+5],C.vertPos[D+6],q,o,n,r,p)}C.nvertOffset(1);C.nvertNormal(y,d,k,m);if(B>0.001){C.nvertRot(C.vertPos[D+8],C.vertPos[D+9],C.vertPos[D+10],q,o,n,r,p)}};this.startFixNormal1=function(){var g=taccgl;g.nvertOffset(-3);var l=4*g.vertI,m=g.vertPos[l+4]-g.vertPos[l],h=g.vertPos[l+5]-g.vertPos[l+1],d=g.vertPos[l+6]-g.vertPos[l+2],n=g.vertPos[l+8]-g.vertPos[l],i=g.vertPos[l+9]-g.vertPos[l+1],e=g.vertPos[l+10]-g.vertPos[l+2],c=-h*e+d*i,k=-d*n+m*e,f=-m*i+h*n;g.nvertOffset(1);g.nvertN1(c,k,f);g.nvertOffset(1);g.nvertN1(c,k,f);g.nvertOffset(1);g.nvertN1(c,k,f)};this.a=function(c,b){var d=taccgl.a(c,b);d.absStartTime(this.basetime+this.vduration);return(d)};this.actor=function(d,c,b,f){var e=taccgl.actor(d,c,b,f);e.absStartTime(this.basetime+this.vduration);return(e)};this.vecsize=function(b,d,c){return Math.sqrt(b*b+d*d+c*c)};this.contIntern=function(c,b){if(this.flags&65536){c.absStartScroll(this.basetime+this.vduration)}else{c.absStartTime(this.basetime+this.vduration)}if(this.mappedEl){c.mappedEl=this.mappedEl}if(!b){c.defTexCan=this.defTexCan;this.calcRotEndPoints();c.flyIn(this.roex,this.roey,this.roez);c.hvec(this.rohx,this.rohy,this.rohz);c.wvec(this.rowx,this.rowy,this.rowz);c.dvec(this.rodx,this.rody,this.rodz);c.flyOut(this.roex,this.roey,this.roez);c.eye(this.veye);if(this.docolor){c.blendInt(this.mix1,this.mixs1);if(this.flags&32){c.col0s=this.col0s;c.col1s=this.col1s;c.col0t=this.col0t;c.col1t=this.col1t;c.col0t=Math.floor(this.col0t/256)*256+(this.col1t&255)}else{c.col0s=this.col1s;c.col1s=this.col1s;c.col0t=this.col1t;c.col1t=this.col1t}c.flags|=this.flags&(16+32+64)}if(typeof(this.wp0)=="number"){c.wp0=this.wp1;c.wq0=this.wq1;c.hp0=this.hp1;c.hq0=this.hq1;c.p0=this.p1;c.q0=this.q1;c.wp1=this.wp1;c.wq1=this.wq1;c.hp1=this.hp1;c.hq1=this.hq1;c.p1=this.p1;c.q1=this.q1}c.flags|=this.flags&256;c.s0=this.s0;c.t0=this.t0;c.ws0=this.ws0;c.wt0=this.wt0;c.ht0=this.ht0;c.hs0=this.hs0;c.p=this.p}return(c)};this.contShiftAtEndAction=function(b){if(this.elshowatend){b.elshowatend=this.elshowatend;this.elshowatend=null;b.special=true;if(this.postVisibility||this.postVisibility==""){b.postVisibility=this.postVisibility}if(this.postOpacity||this.postOpacity==0||this.postOpacity==""){b.postOpacity=this.postOpacity}}};this.cont=function(){var c=this.el,b=new taccgl.taccglAnim(c);if(this.elshowatend){this.contShiftAtEndAction(b)}return(this.contIntern(b,null))};this.baseCont=function(){var c=this.el,b=new taccgl.taccglAnim(c);return(this.contIntern(b,null))};this.calcRotation=function(g,b,i,f){var h=Math.cos(-g),e=(1-h),d=-Math.sin(-g);b-=this.rotpx;i-=this.rotpy;f-=this.rotpz;this.resx=(h+this.rotax*this.rotax*e)*b+(this.rotax*this.rotay*e-this.rotaz*d)*i+(this.rotax*this.rotaz*e+this.rotay*d)*f;this.resy=(this.rotax*this.rotay*e+this.rotaz*d)*b+(h+this.rotay*this.rotay*e)*i+(this.rotay*this.rotaz*e-this.rotax*d)*f;this.resz=(this.rotaz*this.rotax*e-this.rotay*d)*b+(this.rotaz*this.rotay*e+this.rotax*d)*i+(h+this.rotaz*this.rotaz*e)*f;this.resx+=this.rotpx;this.resy+=this.rotpy;this.resz+=this.rotpz};this.calcRotEndPoints=function(){if(this.rotation){this.calcRotation(this.rotto,this.x1,this.y1,this.z1);this.roex=this.resx;this.roey=this.resy;this.roez=this.resz;this.calcRotation(this.rotto,this.x1+this.hx1,this.y1+this.hy1,this.z1+this.hz1);this.rohx=this.resx-this.roex;this.rohy=this.resy-this.roey;this.rohz=this.resz-this.roez;this.calcRotation(this.rotto,this.x1+this.wx1,this.y1+this.wy1,this.z1+this.wz1);this.rowx=this.resx-this.roex;this.rowy=this.resy-this.roey;this.rowz=this.resz-this.roez;this.calcRotation(this.rotto,this.x1+this.dx1,this.y1+this.dy1,this.z1+this.dz1);this.rodx=this.resx-this.roex;this.rody=this.resy-this.roey;this.rodz=this.resz-this.roez}else{this.roex=this.x1;this.roey=this.y1;this.roez=this.z1;this.rohx=this.hx1;this.rohy=this.hy1;this.rohz=this.hz1;this.rowx=this.wx1;this.rowy=this.wy1;this.rowz=this.wz1;this.rodx=this.dx1;this.rody=this.dy1;this.rodz=this.dz1}};this.freeze=function(b){if(b&&b!=1){alert("nyi")}this.calcRotEndPoints();this.x0=this.x1=this.roex;this.y0=this.y1=this.roey;this.z0=this.z1=this.roez;this.hx0=this.hx1=this.rohx;this.hy0=this.hy1=this.rohy;this.hz0=this.hz1=this.rohz;this.wx0=this.wx1=this.rowx;this.wy0=this.wy1=this.rowy;this.wz0=this.wz1=this.rowz;this.dx0=this.dx1=this.rodx;this.dy0=this.dy1=this.rody;this.dz0=this.dz1=this.rodz;if(this.docolor){this.blend(this.mix1,this.mixs1);if(this.flags&96){}else{this.col0s=this.col1s;this.col1s=this.col1s;this.col0t=this.col1t;this.col1t=this.col1t}}if(this.dotexmix){this.s0=this.s1;this.t0=this.t1;this.ws0=this.ws1;this.wt0=this.wt1;this.ht0=this.ht1;this.hs0=this.hs1;this.dotexmix=false}return this};this.calcPos=function(b){if(this.dorotation){alert("nyi")}else{var c=1-b;this.resx=this.x0*c+this.x1*b;this.resy=this.y0*c+this.y1*b;this.resz=this.z0*c+this.z1*b}};this.intProject=function(b,e,d){if(taccgl.dddmode){var c=-d*(1/taccgl.stdEye.eyeZ)+1;this.respx=(b-d*(taccgl.stdEye.eyeX/taccgl.stdEye.eyeZ))/c;this.respy=(e-d*(taccgl.stdEye.eyeY/taccgl.stdEye.eyeZ))/c}else{this.respx=b+d*taccgl.stdEye.ddfx;this.respy=e+d*taccgl.stdEye.ddfy}};this.cssRelPos=function(b){if(!b){b=0}this.calcPos(b);this.intProject(this.resx,this.resy,this.resz);this.el.style.left=this.respx-this.x+"px";this.el.style.top=this.respy-this.y+"px";this.el.style.position="relative";this.cssAdjustFun=function(){this.cssRelPos(b)};return this};this.cssIgnoreRelPos=function(){var c=parseFloat(this.el.style.left);var b=parseFloat(this.el.style.top);if(c){this.x=this.s0=this.x0=this.x1=this.x-c}if(b){this.y=this.t0=this.y0=this.y1=this.y-b}return this};this.cssParallax=function(){taccgl.doParallax.push(this);return this};this.vEnd_x=function(){return((this.ax*0.5+this.x1-this.x0)/this.vduration)};this.vEnd_y=function(){return((this.ay*0.5+this.y1-this.y0)/this.vduration)};this.vEnd_z=function(){return((this.az*0.5+this.z1-this.z0)/this.vduration)};this.contAccel=function(b,g,f,e){if(typeof(b)=="object"){this.resolvePosition(b);b=this.resx;e=g;g=this.resy;f=this.resz}var c=new taccgl.taccglAnim(this.el);c.defTexCan=this.defTexCan;c.absStartTime(this.basetime+this.vduration);c.flyIn(this.x1,this.y1,this.z1).duration(e).flyOut(b,g,f);c.vBegin(this.vEnd_x(),this.vEnd_y(),this.vEnd_z());c.hvec(this.hx1,this.hy1,this.hz1);c.wvec(this.wx1,this.wy1,this.wz1);c.dvec(this.dx1,this.dy1,this.hd1);if(this.docolor){c.blendInt(this.mix1,this.mixs1);if(this.flags&96){c.col0s=this.col0s;c.col1s=this.col1s;c.col0t=this.col0t;c.col1t=this.col1t}else{c.col0s=this.col1s;c.col1s=this.col1s;c.col0t=this.col1t;c.col1t=this.col1t}c.flags|=this.flags&(16+32+64)}if(this.mappedEl){c.mappedEl=this.mappedEl}if(typeof(this.wp0)=="number"){c.wp0=this.wp1;c.wq0=this.wq1;c.hp0=this.hp1;c.hq0=this.hq1;c.p0=this.p1;c.q0=this.q1;c.wp1=this.wp1;c.wq1=this.wq1;c.hp1=this.hp1;c.hq1=this.hq1;c.p1=this.p1;c.q1=this.q1}c.flags|=this.flags&256;c.s0=this.s0;c.t0=this.t0;c.ws0=this.ws0;c.wt0=this.wt0;c.ht0=this.ht0;c.hs0=this.hs0;c.p=this.p;if(this.elshowatend){c.elshowatend=this.elshowatend;this.elshowatend=null;c.special=true;if(this.postVisibility||this.postVisibility==""){c.postVisibility=this.postVisibility}if(this.postOpacity||this.postOpacity==0||this.postOpacity==""){c.postOpacity=this.postOpacity}}return(c)};this.clone=function(){return new this.taccglAnimClone(this)};this.taccglAnimClone=function(b){this.el=b.el;this.x=b.x;this.y=b.y;this.w=b.w;this.h=b.h;if(b.mappedEl){this.mappedEl=b.mappedEl}this.curface=this;this.x0=b.x0;this.y0=b.y0;this.z0=b.z0;this.s0=b.s0;this.t0=b.t0;this.wx0=b.wx0;this.wy0=b.wy0;this.wz0=b.wz0;this.hx0=b.hx0;this.hy0=b.hy0;this.hz0=b.hz0;this.dx0=b.dx0;this.dy0=b.dy0;this.dz0=b.dz0;this.ws0=b.ws0;this.ht0=b.ht0;this.wt0=b.wt0;this.hs0=b.hs0;this.x1=b.x1;this.y1=b.y1;this.z1=b.z1;this.s1=b.s1;this.t1=b.t1;this.wx1=b.wx1;this.wy1=b.wy1;this.wz1=b.wz1;this.hx1=b.hx1;this.hy1=b.hy1;this.hz1=b.hz1;this.dx1=b.dx1;this.dy1=b.dy1;this.dz1=b.dz1;this.ws1=b.ws1;this.ht1=b.ht1;this.wt1=b.wt1;this.hs1=b.hs1;this.rotation=b.rotation;this.flags=b.flags;this.basetime=b.basetime;this.vduration=b.vduration;this.isforeground=b.isforeground;this.elshowatend=b.elshowatend;this.doacceleration=b.doacceleration;this.dotexmove=b.dotexmove;this.docolor=b.docolor;this.p=b.p;this.lightSpecular=b.lightSpecular;this.lightShininess=b.lightShininess;this.defTexCan=b.defTexCan;this.veye=b.veye;if(this.doacceleration){this.ax=b.ax;this.ay=b.ay;this.az=b.az}if(this.rotation){this.rotpx=b.rotpx;this.rotpy=b.rotpy;this.rotpz=b.rotpz;this.rotax=b.rotax;this.rotay=b.rotay;this.rotaz=b.rotaz;this.rotfrom=b.rotfrom;this.rotto=b.rotto}if(this.docolor){this.mix1=b.mix1;this.mix0=b.mix0;this.mixs0=b.mixs0;this.mixs1=b.mixs1;this.col0s=b.col0s;this.col0t=b.col0t;this.col1s=b.col1s;this.col1t=b.col1t}if(typeof(b.wp0)=="number"){this.wp0=b.wp0;this.wq0=b.wq0;this.hp0=b.hp0;this.hq0=b.hq0;this.p0=b.p0;this.q0=b.q0;this.wp1=b.wp1;this.wq1=b.wq1;this.hp1=b.hp1;this.hq1=b.hq1;this.p1=b.p1;this.q1=b.q1}if(b.attime||b.attime==0){this.attime=b.attime;taccgl.newDoat(this)}}}function taccglFlexiBorderPrototype(a){this.initSuper=taccgl.taccglAnim.prototype.init;this.init=function(b){this.initSuper(b);this.vnparts=100;this.vtest2=false;this.dx0=this.dx1=0;this.dy0=this.dy1=0;this.dz0=this.dz1=this.hy0};this.initSecond=function(){};this.nparts=function(b){this.vnparts=b;return this};this.startH=function(){var q=taccgl,p=this.vnparts,s,t,k,c,u,l,d,r,b,h,f,o,w,v,e,m;var g=this.lightSpecular+this.lightShininess;for(s=0;s<=p;s++){if(this.vtest2&&s%2==1){continue}if(s<p){this.resnx=this.resny=this.resnz=0;this.borderFun1(this.x1+this.wx1/p*s,this.y1+this.wy1/p*s,this.z1+this.wz1/p*s,s/p,0);t=this.resx;c=this.resy;k=this.resz;r=this.resnx;b=this.resny;h=this.resnz;this.resnx=this.resny=this.resnz=0;this.borderFun0(this.x0+this.wx0/p*s,this.y0+this.wy0/p*s,this.z0+this.wz0/p*s,s/p,0);u=this.resx;d=this.resy;l=this.resz;q.nvertMove(u,d,l,t,c,k,this.resnx,this.resny,this.resnz,g,this.s0+this.ws0/p*s,this.t0+this.wt0/p*s,this.flags,this.basetime,this.vduration);this.resnx=this.resny=this.resnz=0;this.borderFun1(this.x1+this.wx1/p*s+this.hx1,this.y1+this.wy1/p*s+this.hy1,this.z1+this.wz1/p*s+this.hz1,s/p,1);t=this.resx;c=this.resy;k=this.resz;f=this.resnx;o=this.resny;w=this.resnz;this.resnx=this.resny=this.resnz=0;this.borderFun0(this.x0+this.wx0/p*s+this.hx0,this.y0+this.wy0/p*s+this.hy0,this.z0+this.wz0/p*s+this.hz0,s/p,1);u=this.resx;d=this.resy;l=this.resz;q.nvertMove(u,d,l,t,c,k,this.resnx,this.resny,this.resnz,g,this.s0+this.ws0/p*s+this.hs0,this.t0+this.wt0/p*s+this.ht0,this.flags,this.basetime,this.vduration);this.resnx=this.resny=this.resnz=0;s++;this.borderFun1(this.x1+this.wx1/p*s,this.y1+this.wy1/p*s,this.z1+this.wz1/p*s,s/p,0);t=this.resx;c=this.resy;k=this.resz;v=this.resnx;e=this.resny;m=this.resnz;this.resnx=this.resny=this.resnz=0;this.borderFun0(this.x0+this.wx0/p*s,this.y0+this.wy0/p*s,this.z0+this.wz0/p*s,s/p,0);u=this.resx;d=this.resy;l=this.resz;q.nvertMove(u,d,l,t,c,k,this.resnx,this.resny,this.resnz,g,this.s0+this.ws0/p*s,this.t0+this.wt0/p*s,this.flags,this.basetime,this.vduration);s--;if(this.resnx==0&&this.resny==0&&this.resnz==0){if(v==0&&e==0&&m==0){this.startFixNormal()}else{this.startFixNormal0();q.nvertOffset(-2);q.nvertN1(r,b,h);q.nvertOffset(1);q.nvertN1(f,o,w);q.nvertOffset(1);q.nvertN1(v,e,m)}}else{if(v==0&&e==0&&m==0){this.startFixNormal1()}else{q.nvertOffset(-2);q.nvertN1(r,b,h);q.nvertOffset(1);q.nvertN1(f,o,w);q.nvertOffset(1);q.nvertN1(v,e,m)}}this.resnx=this.resny=this.resnz=0;this.borderFun1(this.x1+this.wx1/p*s+this.hx1,this.y1+this.wy1/p*s+this.hy1,this.z1+this.wz1/p*s+this.hz1,s/p,1);t=this.resx;c=this.resy;k=this.resz;r=this.resnx;b=this.resny;h=this.resnz;this.resnx=this.resny=this.resnz=0;this.borderFun0(this.x0+this.wx0/p*s+this.hx0,this.y0+this.wy0/p*s+this.hy0,this.z0+this.wz0/p*s+this.hz0,s/p,1);u=this.resx;d=this.resy;l=this.resz;q.nvertMove(u,d,l,t,c,k,this.resnx,this.resny,this.resnz,g,this.s0+this.ws0/p*s+this.hs0,this.t0+this.wt0/p*s+this.ht0,this.flags,this.basetime,this.vduration);s++;this.borderFun1(this.x1+this.wx1/p*s+this.hx1,this.y1+this.wy1/p*s+this.hy1,this.z1+this.wz1/p*s+this.hz1,s/p,1);t=this.resx;c=this.resy;k=this.resz;f=this.resnx;o=this.resny;w=this.resnz;this.borderFun0(this.x0+this.wx0/p*s+this.hx0,this.y0+this.wy0/p*s+this.hy0,this.z0+this.wz0/p*s+this.hz0,s/p,1);u=this.resx;d=this.resy;l=this.resz;q.nvertMove(u,d,l,t,c,k,this.resnx,this.resny,this.resnz,g,this.s0+this.ws0/p*s+this.hs0,this.t0+this.wt0/p*s+this.ht0,this.flags,this.basetime,this.vduration);s--;this.resnx=this.resny=this.resnz=0;s++;this.borderFun1(this.x1+this.wx1/p*s,this.y1+this.wy1/p*s,this.z1+this.wz1/p*s,s/p,0);t=this.resx;c=this.resy;k=this.resz;v=this.resnx;e=this.resny;m=this.resnz;this.resnx=this.resny=this.resnz=0;this.borderFun0(this.x0+this.wx0/p*s,this.y0+this.wy0/p*s,this.z0+this.wz0/p*s,s/p,0);u=this.resx;d=this.resy;l=this.resz;q.nvertMove(u,d,l,t,c,k,this.resnx,this.resny,this.resnz,g,this.s0+this.ws0/p*s,this.t0+this.wt0/p*s,this.flags,this.basetime,this.vduration);s--;if(this.resnx==0&&this.resny==0&&this.resnz==0){if(v==0&&e==0&&m==0){this.startFixNormal()}else{this.startFixNormal0();q.nvertOffset(-2);q.nvertN1(r,b,h);q.nvertOffset(1);q.nvertN1(f,o,w);q.nvertOffset(1);q.nvertN1(v,e,m)}}else{if(v==0&&e==0&&m==0){this.startFixNormal1()}else{q.nvertOffset(-2);q.nvertN1(r,b,h);q.nvertOffset(1);q.nvertN1(f,o,w);q.nvertOffset(1);q.nvertN1(v,e,m)}}this.startRest()}}};this.startC=function(){var E=taccgl,B=this.vnparts,h=this.x0+this.wx0/2,q=this.y0+this.hy0/2,I=this.z0,g=this.x1+this.wx1/2,m=this.y1+this.hy1/2,H=this.z1,A=this.s0+this.ws0*0.5,x=this.t0+this.ht0*0.5,F,v,u,r,G,f,o,N,M,J,l,z,P,C,y,b,O;for(F=0;F<=B;F++){var D=Math.PI*2*F/B,t=Math.sin(D),L=Math.cos(D),p=1,e,d;G=g+(L*p*this.wx1);f=m+(t*p*this.hy1);o=this.z1;e=L;d=t;if(t<=-0.5){f=m-this.hy1*0.5;G=g-0.5*this.wx1*L/t;d=0;e=0.5-0.5*L/t}if(t>=0.5){f=m+this.hy1*0.5;G=g+0.5*this.wx1*L/t;d=1;e=0.5+0.5*L/t}if(G>g+this.wx1/2){G=g+this.wx1/2;f=m+0.5*this.hy1*t/L;e=1;d=0.5+0.5*t/L}if(G<g-this.wx1/2){G=g-this.wx1/2;f=m-0.5*this.hy1*t/L;e=0;d=0.5-0.5*t/L}this.borderFun1(G,f,o,e,d);G=this.resx;f=this.resy;o=this.resz;var K=h+L*this.wx0,k;e=L;d=t;if(t<=-0.5){k=q-this.hy0*0.5;K=h-0.5*this.wx0*L/t;d=0;e=0.5-0.5*L/t}if(t>=0.5){k=q+this.hy0*0.5;K=h+0.5*this.wx0*L/t;d=1;e=0.5+0.5*L/t}if(K<h-this.wx0*0.5){K=h-this.wx0*0.5;k=q-0.5*this.hy0*t/L;e=1;d=0.5+0.5*t/L}if(K>h+this.wx0*0.5){K=h+this.wx0*0.5;k=q+0.5*this.hy0*t/L;e=0;d=0.5-0.5*t/L}v=K;u=k;r=this.z0;this.borderFun0(v,u,r,e,d);v=this.resx;u=this.resy;r=this.resz;C=A+L*this.ws0;if(t<=-0.5){y=x-this.ht0*0.5;C=A-0.5*this.ws0*L/t}if(t>=0.5){y=x+this.ht0*0.5;C=A+0.5*this.ws0*L/t}if(C<A-this.ws0*0.5){C=A-this.ws0*0.5;y=x-0.5*this.ht0*t/L}if(C>A+this.ws0*0.5){C=A+this.ws0*0.5;y=x+0.5*this.ht0*t/L}if(F>0&&(!this.vtest2||(F%2!=1))){E.nvertMove(N,M,J,l,z,P,0,0,0,0,b,O,this.flags,this.basetime,this.vduration);E.nvertMove(v,u,r,G,f,o,0,0,0,0,C,y,this.flags,this.basetime,this.vduration);E.nvertMove(h,q,I,g,m,H,0,0,0,0,this.s0+this.ws0/2,this.t0+this.ht0/2,this.flags,this.basetime,this.vduration);this.startFixNormal();this.startRestTriangle()}N=v;M=u;J=r;l=G;z=f;P=o;b=C;O=y}return this};this.renderFun=this.startH;this.start=function(){if(taccgl.dddmode){if(this.special){this.startSpecial()}var c=null,b=taccgl;if(this.astepdelno==b.delno){c=b.vertI;b.vertI=this.vertindex}else{this.vertindex=b.vertI;this.astepdelno=b.delno}this.evalObjt();this.renderFun();this.vertEndIndex=b.vertI;if(c){b.vertI=c}if(this.p!=b.stdsc){b.setShader(b.stdsc)}}else{this.ddstart()}return this};this.horizontal=function(){this.renderFun=this.startH;return this};this.vertical=function(){this.renderFun=this.startV;return this};this.circular=function(){this.renderFun=this.startC;return this};this.test2=function(){this.vtest2=true;return this};this.borderRect=function(b,d,c){this.resx=b;this.resy=d;this.resz=c};this.borderRelRect0=function(b,f,e,d,c){this.resx=this.x0+this.wx0*d+this.hx0*c;this.resy=this.y0+this.wy0*d+this.hy0*c;this.resz=this.z0+this.wz0*d+this.hz0*c};this.borderRelRect1=function(b,f,e,d,c){this.resx=this.x1+this.wx1*d+this.hx1*c;this.resy=this.y1+this.wy1*d+this.hy1*c;this.resz=this.z1+this.wz1*d+this.hz1*c};this.borderCircle1=function(j,i,h){var l=this.x1+this.wx1*0.5,k=this.y1+this.hy1*0.5,g=j-l,f=i-k,c=g,b=Math.sqrt(this.hy1*this.hy1*0.25-this.hy1*this.hy1/this.wx1/this.wx1*g*g);if(f<0){b=-b}if(isNaN(b)){b=0}this.resx=l+c;this.resy=k+b;this.resz=this.z1};this.borderCircle0=function(j,i,h){var l=this.x0+this.wx0*0.5,k=this.y0+this.hy0*0.5,g=j-l,f=i-k,c=g,b=Math.sqrt(this.hy0*this.hy0*0.25-this.hy0*this.hy0/this.wx0/this.wx0*g*g);if(isNaN(b)){b=0}if(f<0){b=-b}this.resx=l+c;this.resy=k+b;this.resz=this.z0};this.borderResize=function(j,i,h){var l=this.x1+this.wx1*0.5,k=this.y1+this.hy1*0.5,g=j-l,f=i-k,c=g+0.01*f*f,b=f+0.001*g*g;this.resx=l+c;this.resy=k+b;this.resz=this.z1};this.borderWave0=function(l,k,j){var n=this.x0+this.wx0*0.5,m=this.y0+this.hy0*0.5,i=l-n,h=k-m,b=(l-this.x0)/this.wx0,g=this.wavefv0*(1-b)+this.wavetv0*b,c,f;if(h>0){c=h+Math.sin(g)*this.ampb0}else{c=h+Math.sin(g)*this.ampt0}b=(k-this.y0)/this.hy0,g=this.wavefh0*(1-b)+this.waveth0*b;if(i>0){f=i+Math.sin(g)*this.ampl0}else{f=i+Math.sin(g)*this.ampr0}this.resx=n+f;this.resy=m+c;this.resz=j};this.borderWave1=function(l,k,j){var n=this.x1+this.wx1*0.5,m=this.y1+this.hy1*0.5,i=l-n,h=k-m,b=(l-this.x1)/this.wx1,g=this.wavefv1*(1-b)+this.wavetv1*b,c,f;if(h>0){c=h+Math.sin(g)*this.ampb1}else{c=h+Math.sin(g)*this.ampt1}b=(k-this.y1)/this.hy1,g=this.wavefh1*(1-b)+this.waveth1*b;if(i>0){f=i+Math.sin(g)*this.ampl1}else{f=i+Math.sin(g)*this.ampr1}this.resx=n+f;this.resy=m+c;this.resz=j};this.borderZWave0=function(k,j,i,d,c){var g,b,h=this.wavefv0*(1-d)+this.wavetv0*d;if(c>0.5){b=Math.sin(h)*this.ampb0;g=Math.cos(h)*this.ampb0*(this.wavetv0-this.wavefv0)}else{b=Math.sin(h)*this.ampt0;g=Math.cos(h)*this.ampt0*(this.wavetv0-this.wavefv0)}h=this.wavefh0*(1-c)+this.waveth0*c;if(d<0.5){b+=Math.sin(h)*this.ampl0}else{b+=Math.sin(h)*this.ampr0}this.resx=k+b*this.dx0;this.resy=j+b*this.dy0;this.resz=i+b*this.dz0;var e=1,f=0;var l=this.objt0inv;this.resnx=g*l[0]+f*l[1]+e*l[2];this.resny=g*l[3]+f*l[4]+e*l[5];this.resnz=g*l[6]+f*l[7]+e*l[8]};this.borderZWave1=function(k,j,i,d,c){var g,b,h=this.wavefv1*(1-d)+this.wavetv1*d;if(c>0.5){b=Math.sin(h)*this.ampb1;g=Math.cos(h)*this.ampb1*(this.wavetv1-this.wavefv1)}else{b=Math.sin(h)*this.ampt1;g=Math.cos(h)*this.ampt1*(this.wavetv1-this.wavefv1)}h=this.wavefh1*(1-c)+this.waveth1*c;if(d>0.5){b+=Math.sin(h)*this.ampl1}else{b+=Math.sin(h)*this.ampr1}this.resx=k+b*this.dx1;this.resy=j+b*this.dy1;this.resz=i+b*this.dz1;var e=1,f=0;var l=this.objt1inv;this.resnx=g*l[0]+f*l[1]+e*l[2];this.resny=g*l[3]+f*l[4]+e*l[5];this.resnz=g*l[6]+f*l[7]+e*l[8]};this.borderFlip1x=function(b,h,g){var d;if(h<this.y1+0.5*this.hy1){d=this.flipt1}else{d=this.flipb1}var c=this.x1+this.wx1*d;if(b<c){this.resx=b;this.resy=h;this.resz=g;return}var e=(b-c)/(this.wx1*(1-d));b=c+Math.cos(Math.PI*(1-e)*0.5)*((1-d)*this.wx1)/Math.PI*2;g+=(-1+Math.sin(Math.PI*(1-e)*0.5))*((1-d)*1000)/Math.PI*2;this.resx=b;this.resy=h;this.resz=g};this.borderFlip1=function(o,n,m,k,i){var E,A,w,H,G,F,l;if(i<0.5){E=this.flipt1;l=this.flipGammat1}else{E=this.flipb1;l=this.flipGammab1}var d=this.x1+this.wx1*E,c=this.y1+this.wy1*E,b=this.z1+this.wz1*E;if(i>0.5){d+=this.hx1;c+=this.hy1;b+=this.hz1}w=k;if(w<E){H=0;G=0;F=1}else{var j=-(w-E)*(2*l+Math.PI)/(1-E)*0.5+Math.PI*0.5;var e=Math.sqrt(this.wx1*this.wx1+this.wy1*this.wy1+this.wz1*this.wz1),B=Math.sqrt(this.dx1*this.dx1+this.dy1*this.dy1+this.dz1*this.dz1),r=e*(1-E);var v=-(8*r-8*E)/((4*Math.sqrt(B*r)-6*r-6*B)*l+2*Math.PI*Math.sqrt(B*r)-3*Math.PI*r-3*B*Math.PI);var D=v*(1-E)*(Math.cos(j)),C=v*(Math.sin(j))-v;o=d+D*this.wx1-C*this.dx1;n=c+D*this.wy1-C*this.dy1;m=b+D*this.wz1-C*this.dz1;H=v*(2*l+Math.PI)*Math.cos(j)/(E-1)*0.5;G=0;F=v*(2*l+Math.PI)*Math.sin(j)*0.5}var u=this.objt1inv;this.resnx=H*u[0]+G*u[1]+F*u[2];this.resny=H*u[3]+G*u[4]+F*u[5];this.resnz=H*u[6]+G*u[7]+F*u[8];this.resx=o;this.resy=n;this.resz=m};this.borderFlip0=function(o,n,m,k,i){var E,A,w,H,G,F,l;if(i<0.5){E=this.flipt0;l=this.flipGammat0}else{E=this.flipb0;l=this.flipGammab0}var d=this.x0+this.wx0*E,c=this.y0+this.wy0*E,b=this.z0+this.wz0*E;if(i>0.5){d+=this.hx0;c+=this.hy0;b+=this.hz0}w=k;if(w<E){H=0;G=0;F=1}else{var j=-(w-E)*(2*l+Math.PI)/(1-E)*0.5+Math.PI*0.5;var e=Math.sqrt(this.wx0*this.wx0+this.wy0*this.wy0+this.wz0*this.wz0),B=Math.sqrt(this.dx0*this.dx0+this.dy0*this.dy0+this.dz0*this.dz0),r=e*(1-E);var v=-(8*r-8*E)/((4*Math.sqrt(B*r)-6*r-6*B)*l+2*Math.PI*Math.sqrt(B*r)-3*Math.PI*r-3*B*Math.PI);var D=v*(1-E)*(Math.cos(j)),C=v*(Math.sin(j))-v;o=d+D*this.wx0-C*this.dx0;n=c+D*this.wy0-C*this.dy0;m=b+D*this.wz0-C*this.dz0;H=v*(2*l+Math.PI)*Math.cos(j)/(E-1)*0.5;G=0;F=v*(2*l+Math.PI)*Math.sin(j)*0.5}var u=this.objt0inv;this.resnx=H*u[0]+G*u[1]+F*u[2];this.resny=H*u[3]+G*u[4]+F*u[5];this.resnz=H*u[6]+G*u[7]+F*u[8];this.resx=o;this.resy=n;this.resz=m};this.Flip=function(e,c,b,d){if(!b){b=0}if(!d){d=0}this.flipGammat1=b;this.flipGammab1=d;this.flipGammat0=b;this.flipGammab0=d;this.flipt1=e;this.flipb1=c;this.flipt0=e;this.flipb0=c;this.borderFun1=this.borderFlip1;this.borderFun0=this.borderFlip0;return this};this.Flip1=function(e,c,b,d){if(!b){b=0}if(!d){d=0}this.flipGammat1=b;this.flipGammab1=d;this.flipt1=e;this.flipb1=c;this.borderFun1=this.borderFlip1;return this};this.borderFun1=this.borderRect;this.borderFun0=this.borderRect;this.Circle=function(){this.borderFun0=this.borderCircle0;this.borderFun1=this.borderCircle1;return this};this.Circle1=function(){this.borderFun1=this.borderCircle1;return this};this.Rect=function(){this.borderFun0=this.borderRect;this.borderFun1=this.borderRect;return this};this.Rect1=function(){this.borderFun1=this.borderRect;return this};this.RelRect=function(){this.borderFun0=this.borderRelRect0;this.borderFun1=this.borderRelRect1;return this};this.RelRect1=function(){this.borderFun1=this.borderRelRect1;return this};this.Wave=function(g,d,h,c,e,i,b,f){this.Wave1(g,d,h,c,e,i,b,f);if(g+""=="undefined"){g=this.ht1/2}if(d+""=="undefined"){d=this.ht1/2}if(e+""=="undefined"){e=0}if(i+""=="undefined"){i=0}if(c+""=="undefined"){c=Math.PI*2}if(!h){h=0}if(f+""=="undefined"){f=Math.PI*2}if(!b){b=0}this.ampt0=g;this.ampb0=d;this.ampl0=e;this.ampr0=i;this.wavefh0=b;this.waveth0=f;this.wavefv0=h;this.wavetv0=c;this.borderFun0=this.borderWave0;return this};this.Wave1=function(g,d,h,c,e,i,b,f){if(g+""=="undefined"){g=this.ht1/2}if(d+""=="undefined"){d=this.ht1/2}if(e+""=="undefined"){e=0}if(i+""=="undefined"){i=0}if(c+""=="undefined"){c=Math.PI*2}if(!h){h=0}if(f+""=="undefined"){f=Math.PI*2}if(!b){b=0}this.ampt1=g;this.ampb1=d;this.ampl1=e;this.ampr1=i;this.wavefh1=b;this.waveth1=f;this.wavefv1=h;this.wavetv1=c;this.borderFun1=this.borderWave1;return this};this.ZWave=function(g,d,h,c,e,i,b,f){this.ZWave1(g,d,h,c,e,i,b,f);if(g+""=="undefined"){g=this.ht1/2}if(d+""=="undefined"){d=this.ht1/2}if(e+""=="undefined"){e=0}if(i+""=="undefined"){i=0}if(c+""=="undefined"){c=Math.PI*2}if(!h){h=0}if(f+""=="undefined"){f=Math.PI*2}if(!b){b=0}this.ampt0=g;this.ampb0=d;this.ampl0=e;this.ampr0=i;this.wavefh0=b;this.waveth0=f;this.wavefv0=h;this.wavetv0=c;this.borderFun0=this.borderZWave0;return this};this.ZWave1=function(g,d,h,c,e,i,b,f){if(g+""=="undefined"){g=this.ht1/2}if(d+""=="undefined"){d=this.ht1/2}if(e+""=="undefined"){e=0}if(i+""=="undefined"){i=0}if(c+""=="undefined"){c=Math.PI*2}if(!h){h=0}if(f+""=="undefined"){f=Math.PI*2}if(!b){b=0}this.ampt1=g;this.ampb1=d;this.ampl1=e;this.ampr1=i;this.wavefh1=b;this.waveth1=f;this.wavefv1=h;this.wavetv1=c;this.borderFun1=this.borderZWave1;return this};this.cont=function(b){var d=b;if(!b){d=this.el}var c=new taccgl.flexiBorder(d);if(this.elshowatend){this.contShiftAtEndAction(c)}this.contIntern(c,b);c.nparts(this.vnparts);c.renderFun=this.renderFun;c.vtest2=this.vtest2;if(this.borderFun1==this.borderCircle1){c.Circle()}else{if(this.borderFun1==this.borderWave1){c.Wave(this.ampt1,this.ampb1,this.wavefv1,this.wavetv1,this.ampl1,this.ampr1,this.wavefh1,this.waveth1)}else{if(this.borderFun1==this.borderZWave1){c.ZWave(this.ampt1,this.ampb1,this.wavefv1,this.wavetv1,this.ampl1,this.ampr1,this.wavefh1,this.waveth1)}else{if(this.borderFun1==this.borderFlip1){c.Flip(this.flipt1,this.flipb1,this.flipGammat1,this.flipGammab1)}}}}return(c)};this.clone=function(b){return new this.taccglFlexiBorderClone(this)};this.taccglFlexiBorderClone=function(b){this.taccglAnimClone(b);this.vnparts=b.vnparts;this.vtest2=b.vtest2;this.renderFun=b.renderFun;this.borderFun1=b.borderFun1;this.borderFun0=b.borderFun0;if(this.borderFun1==this.borderWave1||this.borderFun1==this.borderZWave1){this.ampt1=b.ampt1;this.ampb1=b.ampb1;this.wavefv1=b.wavefv1;this.wavetv1=b.wavetv1;this.ampl1=b.ampl1;this.ampr1=b.ampr1;this.wavefh1=b.wavefh1;this.waveth1=b.waveth1}else{if(this.borderFun1==this.borderFlip1){this.flipt1=b.flipt1;this.flipb1=b.flipb1}}if(this.borderFun0==this.borderWave0||this.borderFun0==this.borderZWave0){this.ampt0=b.ampt0;this.ampb0=b.ampb0;this.wavefv0=b.wavefv0;this.wavetv0=b.wavetv0;this.ampl0=b.ampl0;this.ampr0=b.ampr0;this.wavefh0=b.wavefh0;this.waveth0=b.waveth0}else{if(this.borderFun0==this.borderFlip0){this.flipt0=b.flipt0;this.flipb0=b.flipb0}}}}taccglFlexiBorderPrototype.prototype=taccgl.taccglAnim.prototype;taccgl.flexiBorder.prototype=new taccglFlexiBorderPrototype();taccgl.flexiBorder.prototype.taccglFlexiBorderClone.prototype=taccgl.flexiBorder.prototype;function taccglTrianglePrototype(a){this.initSuper=taccgl.taccglAnim.prototype.init;this.init=function(b){this.initSuper(b)};this.cont=function(){var c=this.el,b=new taccgl.triangle(c);if(this.elshowatend){this.contShiftAtEndAction(b)}return(this.contIntern(b,null))};this.clone=function(b){return new this.taccglTriangleClone(this)};this.taccglTriangleClone=function(b){this.taccglAnimClone(b)};this.start=function(){var d=taccgl;if(!d.dddmode){return this}var f=null;if(this.astepdelno==d.delno){f=d.vertI;d.vertI=this.vertindex}else{this.vertindex=d.vertI;this.astepdelno=d.delno}if(this.special){this.startSpecial()}var b=-this.hy0*this.wz0+this.hz0*this.wy0,g=-this.hz0*this.wx0+this.hx0*this.wz0,e=-this.hx0*this.wy0+this.hy0*this.wx0;var c=this.lightSpecular+this.lightShininess;d.nvertMove(this.x0,this.y0,this.z0,this.x1,this.y1,this.z1,b,g,e,c,this.s0,this.t0,this.flags,this.basetime,this.vduration);d.nvertMove(this.x0+this.hx0,this.y0+this.hy0,this.z0+this.hz0,this.x1+this.hx1,this.y1+this.hy1,this.z1+this.hz1,b,g,e,c,this.s0+this.hs0,this.t0+this.ht0,this.flags,this.basetime,this.vduration);d.nvertMove(this.x0+this.wx0,this.y0+this.wy0,this.z0+this.wz0,this.x1+this.wx1,this.y1+this.wy1,this.z1+this.wz1,b,g,e,c,this.s0+this.ws0,this.t0+this.wt0,this.flags,this.basetime,this.vduration);this.startRestTriangle();if(this.p!=d.stdsc){d.setShader(d.stdsc)}this.vertEndIndex=d.vertI;if(f){d.vertI=f}return this}}taccglTrianglePrototype.prototype=taccgl.taccglAnim.prototype;taccgl.triangle.prototype=new taccglTrianglePrototype();taccgl.triangle.prototype.taccglTriangleClone.prototype=taccgl.triangle.prototype;function taccglMultiFacePrototype(a){this.initSuper=taccgl.taccglAnim.prototype.init;this.init=function(b){this.face=Array(0);this.initSuper(b)};this.initSecond=function(){};this.createFace=function(c,f,i,l,m,d,g,j,k,b,e,h){this.xtl=c;this.ytl=f;this.ztl=i;this.xtr=l;this.ytr=m;this.ztr=d;this.xbl=g;this.ybl=j;this.zbl=k;this.xbr=b;this.ybr=e;this.zbr=h};this.newFace=function(c,g,j,n,o,d,h,k,m,b,e,i){var l=new this.createFace(c,g,j,n,o,d,h,k,m,b,e,i);if(!this.dotexmove){this.s1=this.s0;this.ws1=this.ws0;this.t1=this.t0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0}l.flags=this.flags;l.defTexCan=1;l.s0=this.s0;l.t0=this.t0;l.ws0=this.ws0;l.ht0=this.ht0;l.wt0=this.wt0;l.hs0=this.hs0;l.s1=this.s1;l.t1=this.t1;l.ws1=this.ws1;l.ht1=this.ht1;l.w=this.w;l.h=this.h;l.x=this.x;l.y=this.y;l.docolor=this.docolor;if(this.docolor){l.ddcolor0=this.ddcolor0;l.ddcolor1=this.ddcolor1;l.mix0=this.mix0;l.mix1=this.mix1;l.mixs0=this.mixs0;l.mixs1=this.mixs1;l.col0s=this.col0s;l.col0t=this.col0t;l.col1s=this.col1s;l.col1t=this.col1t}if(this.atBl){l.atBl=this.atBl}l.lightSpecular=taccgl.lightSpecular;l.lightShininess=taccgl.lightShininess;l.el=this.el;l.defTexCan=this.defTexCan;this.face.push(l);this.selFace(this.face.length-1);return l};this.cloneFaces=function(c){var e,b,d;for(b=0;b<this.face.length;b++){e=this.face[b],d=c.newFace(e.xtl,e.ytl,e.ztl,e.xtr,e.ytr,e.ztr,e.xbl,e.ybl,e.zbl,e.xbr,e.ybr,e.zbr);d.s0=e.s0;d.t0=e.t0;d.ws0=e.ws0;d.ht0=e.ht0;d.wt0=e.wt0;d.hs0=e.hs0;d.s1=e.s1;d.t1=e.t1;d.ws1=e.ws1;d.ht1=e.ht1;d.flags=e.flags;d.docolor=e.docolor;d.w=e.w;d.h=e.h;d.x=e.x;d.y=e.y;if(e.docolor){d.ddcolor0=e.ddcolor0;d.ddcolor1=e.ddcolor1;d.mix0=e.mix0;d.mix1=e.mix1;d.mixs0=e.mixs0;d.mixs1=e.mixs1;d.col0s=e.col0s;d.col0t=e.col0t;d.col1s=e.col1s;d.col1t=e.col1t}if(e.atBl){d.atBl=e.atBl}}};this.selFace=function(b){this.curface=this.face[b];this.curfacei=b;return this};this.blend=function(e,d,b,c){if(!this.curface.docolor){this.curface.col0s=this.curface.col0t=this.curface.col1s=this.curface.col1t=-128*256}this.curface.docolor=true;this.curface.flags|=16;this.curface.mix0=e;this.curface.mix1=e;if(!d){d=0}this.curface.mixs0=d;this.curface.mixs1=d;if(typeof(b)=="number"){this.curface.mix1=b}if(typeof(c)=="number"){this.curface.mixs1=c}return this};this.color=function(d,b){this.bgColor(d,b);this.curface.mix1=this.curface.mix0=0;this.curface.mixs0=this.curface.mixs1=0;return this};this.bgColor=function(k,f){var j,i,h,d,e;if(!this.curface.docolor){this.curface.mix1=this.curface.mix0=1;this.curface.mixs0=this.curface.mixs1=0}this.curface.docolor=true;this.curface.flags|=16;this.flags&=~32;this.flags&=~64;this.curface.ddcolor0=k;this.curface.ddcolor1=k;if(f){this.curface.ddcolor1=f}if(k&&taccgl.scratchc){taccgl.scratchc.fillStyle=k;taccgl.scratchc.clearRect(0,0,1,1);taccgl.scratchc.fillRect(0,0,1,1);j=taccgl.scratchc.getImageData(0,0,1,1),i=j.data[0],h=j.data[1],d=j.data[2],e=j.data[3];this.curface.col1s=this.curface.col0s=i+256*(h-128);this.curface.col1t=this.curface.col0t=e+256*(d-128)}if(f&&taccgl.scratchc){taccgl.scratchc.fillStyle=f;taccgl.scratchc.clearRect(0,0,1,1);taccgl.scratchc.fillRect(0,0,1,1);j=taccgl.scratchc.getImageData(0,0,1,1),i=j.data[0],h=j.data[1],d=j.data[2],e=j.data[3];this.curface.col1s=i+256*(h-128);this.curface.col1t=e+256*(d-128)}return this};this.specLight=function(b,c){this.curface.lightSpecular=b%1;this.curface.lightShininess=Math.floor(c);return this};this.lightAmbDiff=function(e,b,d,c){this.bgColor(e,b);this.curface.ddcolor0=b;this.curface.ddcolor1=b;if(!d&&d!=0){d=0}if(!c&&c!=0){c=0}if(d>1){d=1}if(c>1){c=1}if(d<0){d=0}if(c<0){c=0}this.curface.col0t=Math.floor(this.curface.col0t/256)*256+d*255;this.curface.col1t=Math.floor(this.curface.col1t/256)*256+c*255;this.curface.flags|=32;this.curface.flags&=~64;return this};this.lightBgAmbDiff=function(j,m,l,f,e){if(!this.curface.docolor){this.curface.mix1=this.curface.mix0=1;this.curface.mixs0=this.curface.mixs1=0}this.curface.docolor=true;this.curface.flags|=16+32+64;this.curface.ddcolor0=j;this.curface.ddcolor1=j;if(!f&&f!=0){f=1}if(!e&&e!=0){e=1}if(f>1){f=1}if(e>1){e=1}if(f<0){f=0}if(e<0){e=0}if(j&&taccgl.scratchc){taccgl.scratchc.fillStyle=j;taccgl.scratchc.clearRect(0,0,1,1);taccgl.scratchc.fillRect(0,0,1,1);var h=taccgl.scratchc.getImageData(0,0,1,1),d=h.data[0],i=h.data[1],k=h.data[2];this.curface.col0s=d+256*(i-128);this.curface.col0t=Math.floor(f*255)+256*(k-128)}if(m>1){m=1}if(l>1){l=1}if(m<0){m=0}if(l<0){l=0}m=Math.floor(m*255);l=Math.floor(l*255);this.curface.col1s=m+256*(l-128);this.curface.col1t=Math.floor(e*255);return this};this.map=function(e,c,b,d){if(e||e==0){this.curface.s0=e}if(c||c==0){this.curface.t0=c}if(b||d){this.curface.wt0=this.curface.hs0=0}if(b&&d){this.curface.ws0=b;this.curface.ht0=d}else{if(b){this.curface.ws0=b;this.curface.ht0*=b/this.curface.ws0}else{if(d){this.curface.ws0*=d/this.curface.ht0;this.curface.ht0=d}}}return this};this.map1=this.mapTo=function(e,c,b,d){this.curface.dotexmove=true;this.curface.s1=e;this.curface.t1=c;this.curface.ws1=b;this.curface.ht1=d;this.curface.wt1=this.curfact.hs1=0;return this};this.mapAnim=function(){this.curface.dotexmove=true;this.curface.s1=this.curface.s0;this.curface.t1=this.curface.t0;this.curface.ws1=this.curface.ws0;this.curface.ht1=this.curface.ht0;this.curface.wt1=this.curface.wt0;this.curface.hs1=this.curface.hs0;return this};this.mapMirrorY=function(){this.curface.s0+=this.curface.ws0;this.curface.t0+=this.curface.wt0;this.curface.ws0=-this.curface.ws0;this.curface.wt0=-this.curface.wt0;return this};this.mapMirrorX=function(){this.curface.t0+=this.curface.ht0;this.curface.s0+=this.curface.hs0;this.curface.ht0=-this.curface.ht0;this.curface.hs0=-this.curface.hs0;return this};this.mapRelative=function(e,c,b,d){this.curface.s0+=e;this.curface.t0+=c;this.curface.ws0=b;this.curface.ht0=d;this.curface.wt0=0;this.curface.hs0=0;return this};this.mapClip=function(b,c,e,d){if(d!="b"&&d!="br"){if(c>this.curface.ht0){c=this.curface.ht0}}if(d!="r"&&d!="br"){if(b>this.curface.ws0){b=this.curface.ws0}}if(e=="tl"){}else{if(e=="t"){b=this.curface.ws0}else{if(e=="tr"){this.curface.s0+=this.curface.ws0-b}else{if(e=="l"){c=this.curface.ht0}else{if(e=="r"){this.s0+=this.curface.ws0-b;c=this.curface.ht0}else{if(e=="bl"){this.curface.t0+=this.curface.ht0-c}else{if(e=="b"){this.t0+=this.curface.ht0-c;b=this.curface.ws0}else{if(e=="br"){this.curface.t0+=this.curface.ht0-c;this.curface.s0+=this.curface.ws0-b}}}}}}}}this.curface.ws0=b;this.curface.ht0=c;this.curface.ws0=b;this.curface.ht0=c;return this};this.initNormals=function(){var b=this.curface;b.donormal=true;b.ntlx=b.nblx=b.ntrx=b.nbrx=this.hy0*this.wz0-this.hz0*this.wy0;b.ntly=b.nbly=b.ntry=b.nbry=this.hz0*this.wx0-this.hx0*this.wz0;b.ntlz=b.nblz=b.ntrz=b.nbrz=this.hx0*this.wy0-this.hy0*this.wx0};this.restrict=this.clip=function(b,f,c,e){this.x0=this.x1=b;this.y0=this.y1=f;this.wx0=this.wx1=c;this.hy0=this.hy1=e;this.s0=this.x0;this.t0=this.y0;this.ws0=this.wx0;this.wt0=0;this.ht0=this.hy0;this.hs0=0;var d;for(d=0;d<this.face.length;d++){this.selFace(d);this.map(b,f,c,e)}return this};this.cont=function(b){var d=b;if(!b){d=this.el}var c=new taccgl.multiFace(d);if(this.elshowatend){this.contShiftAtEndAction(c)}this.contIntern(c,b);this.cloneFaces(c);return(c)};this.startFace=function(o){var g=taccgl,k,p=this.vduration+this.basetime;if(g.duration<p&&((this.flags&1<<16)==0)){g.setDuration(p)}var r=this.wx0*o.xbl+this.hx0*o.ybl+this.dx0*o.zbl-this.wx0*o.xtl-this.hx0*o.ytl-this.dx0*o.ztl,l=this.wy0*o.xbl+this.hy0*o.ybl+this.dy0*o.zbl-this.wy0*o.xtl-this.hy0*o.ytl-this.dy0*o.ztl,c=this.wz0*o.xbl+this.hz0*o.ybl+this.dz0*o.zbl-this.wz0*o.xtl-this.hz0*o.ytl-this.dz0*o.ztl,b=this.wx0*o.xtr+this.hx0*o.ytr+this.dx0*o.ztr-this.wx0*o.xtl-this.hx0*o.ytl-this.dx0*o.ztl,q=this.wy0*o.xtr+this.hy0*o.ytr+this.dy0*o.ztr-this.wy0*o.xtl-this.hy0*o.ytl-this.dy0*o.ztl,d=this.wz0*o.xtr+this.hz0*o.ytr+this.dz0*o.ztr-this.wz0*o.xtl-this.hz0*o.ytl-this.dz0*o.ztl,n=-l*d+c*q,m=-c*b+r*d,h=-r*q+l*b,s=this.lightSpecular+this.lightShininess;g.nvertMove(this.x0+this.wx0*o.xtl+this.hx0*o.ytl+this.dx0*o.ztl,this.y0+this.wy0*o.xtl+this.hy0*o.ytl+this.dy0*o.ztl,this.z0+this.wz0*o.xtl+this.hz0*o.ytl+this.dz0*o.ztl,this.x1+this.wx1*o.xtl+this.hx1*o.ytl+this.dx1*o.ztl,this.y1+this.wy1*o.xtl+this.hy1*o.ytl+this.dy1*o.ztl,this.z1+this.wz1*o.xtl+this.hz1*o.ytl+this.dz1*o.ztl,n,m,h,s,o.s0,o.t0,o.flags|this.flags,this.basetime,this.vduration);g.nvertMove(this.x0+this.wx0*o.xbl+this.hx0*o.ybl+this.dx0*o.zbl,this.y0+this.wy0*o.xbl+this.hy0*o.ybl+this.dy0*o.zbl,this.z0+this.wz0*o.xbl+this.hz0*o.ybl+this.dz0*o.zbl,this.x1+this.wx1*o.xbl+this.hx1*o.ybl+this.dx1*o.zbl,this.y1+this.wy1*o.xbl+this.hy1*o.ybl+this.dy1*o.zbl,this.z1+this.wz1*o.xbl+this.hz1*o.ybl+this.dz1*o.zbl,n,m,h,s,o.s0+o.hs0,o.t0+o.ht0,o.flags|this.flags,this.basetime,this.vduration);g.nvertMove(this.x0+this.wx0*o.xtr+this.hx0*o.ytr+this.dx0*o.ztr,this.y0+this.wy0*o.xtr+this.hy0*o.ytr+this.dy0*o.ztr,this.z0+this.wz0*o.xtr+this.hz0*o.ytr+this.dz0*o.ztr,this.x1+this.wx1*o.xtr+this.hx1*o.ytr+this.dx1*o.ztr,this.y1+this.wy1*o.xtr+this.hy1*o.ytr+this.dy1*o.ztr,this.z1+this.wz1*o.xtr+this.hz1*o.ytr+this.dz1*o.ztr,n,m,h,s,o.s0+o.ws0,o.t0+o.wt0,o.flags|this.flags,this.basetime,this.vduration);g.nvertMove(this.x0+this.wx0*o.xbr+this.hx0*o.ybr+this.dx0*o.zbr,this.y0+this.wy0*o.xbr+this.hy0*o.ybr+this.dy0*o.zbr,this.z0+this.wz0*o.xbr+this.hz0*o.ybr+this.dz0*o.zbr,this.x1+this.wx1*o.xbr+this.hx1*o.ybr+this.dx1*o.zbr,this.y1+this.wy1*o.xbr+this.hy1*o.ybr+this.dy1*o.zbr,this.z1+this.wz1*o.xbr+this.hz1*o.ybr+this.dz1*o.zbr,n,m,h,s,o.s0+o.ws0+o.hs0,o.t0+o.ht0+o.wt0,o.flags|this.flags,this.basetime,this.vduration);g.nvertMove(this.x0+this.wx0*o.xtr+this.hx0*o.ytr+this.dx0*o.ztr,this.y0+this.wy0*o.xtr+this.hy0*o.ytr+this.dy0*o.ztr,this.z0+this.wz0*o.xtr+this.hz0*o.ytr+this.dz0*o.ztr,this.x1+this.wx1*o.xtr+this.hx1*o.ytr+this.dx1*o.ztr,this.y1+this.wy1*o.xtr+this.hy1*o.ytr+this.dy1*o.ztr,this.z1+this.wz1*o.xtr+this.hz1*o.ytr+this.dz1*o.ztr,n,m,h,s,o.s0+o.ws0,o.t0+o.wt0,o.flags|this.flags,this.basetime,this.vduration);g.nvertMove(this.x0+this.wx0*o.xbl+this.hx0*o.ybl+this.dx0*o.zbl,this.y0+this.wy0*o.xbl+this.hy0*o.ybl+this.dy0*o.zbl,this.z0+this.wz0*o.xbl+this.hz0*o.ybl+this.dz0*o.zbl,this.x1+this.wx1*o.xbl+this.hx1*o.ybl+this.dx1*o.zbl,this.y1+this.wy1*o.xbl+this.hy1*o.ybl+this.dy1*o.zbl,this.z1+this.wz1*o.xbl+this.hz1*o.ybl+this.dz1*o.zbl,n,m,h,s,o.s0+o.hs0,o.t0+o.ht0,o.flags|this.flags,this.basetime,this.vduration);if(this.rotation){for(k=1;k<=6;k++){g.nvertRot(this.rotpx,this.rotpy,this.rotpz,this.rotax,this.rotay,this.rotaz,this.rotfrom,this.rotto,this.rotacc);g.nvertOffset(-1)}g.nvertOffset(6)}if(this.doacceleration){for(k=1;k<=6;k++){g.nvertAcceleration(this.ax,this.ay,this.az);g.nvertOffset(-1)}g.nvertOffset(6)}if(o.dotexmove){g.nvertOffset(-5);g.nvertTexMove(o.s1,o.t1);g.nvertOffset(1);g.nvertTexMove(o.s1+o.ws1,o.t1+o.wt1);g.nvertOffset(1);g.nvertTexMove(o.s1+o.hs1,o.t1+o.ht1);g.nvertOffset(1);g.nvertTexMove(o.s1+o.ws1+o.hs1,o.t1+o.ht1+o.wt1);g.nvertOffset(1);g.nvertTexMove(o.s1+o.hs1,o.t1+o.ht1);g.nvertOffset(1);g.nvertTexMove(o.s1+o.ws1,o.t1+o.wt1)}if(o.docolor){g.nvertColor6(o.col0s,o.col0t,o.col1s,o.col1t,o.mix0,o.mix1,o.mixs0,o.mixs1)}if(o.donormal){g.nvertOffset(-5);g.nvertNormal3(o.ntlx,o.ntly,o.ntlz);g.nvertOffset(1);g.nvertNormal3(o.nblx,o.nbly,o.nblz);g.nvertOffset(1);g.nvertNormal3(o.ntrx,o.ntry,o.ntrz);g.nvertOffset(1);g.nvertNormal3(o.nbrx,o.nbry,o.nbrz);g.nvertOffset(1);g.nvertNormal3(o.ntrx,o.ntry,o.ntrz);g.nvertOffset(1);g.nvertNormal3(o.nblx,o.nbly,o.nblz)}return this};this.start=function(){var b,d,c;if(!taccgl.dddmode){this.ddstart();return this}var e=null;b=taccgl;if(this.astepdelno==b.delno){e=b.vertI;b.vertI=this.vertindex}else{this.vertindex=b.vertI;this.astepdelno=b.delno}if(this.special){this.startSpecial()}for(c=0;c<this.face.length;c++){d=this.face[c];this.startFace(d)}this.vertEndIndex=b.vertI;if(e){b.vertI=e}if(this.p!=b.stdsc){b.setShader(b.stdsc)}return this};this.clone=function(b){return new this.taccglMultiFaceClone(this)};this.taccglMultiFaceClone=function(b){this.taccglAnimClone(b);this.face=Array(0);b.cloneFaces(this)}}taccglMultiFacePrototype.prototype=taccgl.taccglAnim.prototype;taccgl.multiFace.prototype=new taccglMultiFacePrototype();taccgl.multiFace.prototype.taccglMultiFaceClone.prototype=taccgl.multiFace.prototype;function taccglDddBoxPrototype(a){this.initSuper2=taccgl.multiFace.prototype.init;this.startSuper=taccgl.multiFace.prototype.start;this.init=function(b){this.initSuper2(b)};this.initSecond=function(b){this.newFace(0,0,1,1,0,1,0,1,1,1,1,1);this.newFace(1,0,1,1,0,0,1,1,1,1,1,0);this.newFace(1,0,0,0,0,0,1,1,0,0,1,0);this.newFace(0,0,0,0,0,1,0,1,0,0,1,1);this.newFace(0,0,0,1,0,0,0,0,1,1,0,1);this.newFace(0,1,1,1,1,1,0,1,0,1,1,0);this.dx0=this.dx1=0;this.dy0=this.dy1=0;this.dz0=this.dz1=this.hy0};this.selFront=function(){return this.selFace(0)};this.selRight=function(){return this.selFace(1)};this.selBack=function(){return this.selFace(2)};this.selLeft=function(){return this.selFace(3)};this.selTop=function(){return this.selFace(4)};this.selBottom=function(){return this.selFace(5)};this.cont=function(b){var d=b;if(!b){d=this.el}var c=new taccglDddBoxSuper2(d);if(this.elshowatend){this.contShiftAtEndAction(c)}this.contIntern(c,b);this.cloneFaces(c);return(c)};this.clone=function(b){return new this.taccglDddBoxClone(this)};this.taccglDddBoxClone=function(b){this.taccglMultiFaceClone(b)}}taccglDddBoxPrototype.prototype=taccgl.multiFace.prototype;taccgl.dddBox.prototype=new taccglDddBoxPrototype();var taccglDddBoxSuper2=function(a){this.initSuper2(a)};taccglDddBoxSuper2.prototype=taccgl.dddBox.prototype;taccgl.dddBox.prototype.taccglDddBoxClone.prototype=taccgl.dddBox.prototype;function taccglShaderConfigPrototype(){var x=this;if(x){}x.dummy="\n";x.stdUniformsBg=function(){return"\nuniform   sampler2D uTexture;\nuniform   sampler2D uTexture2;\n"};x.stdUniformsEnd=function(){return"\n"+this.ins(this.genUniforms)+"\n"+this.ins(this.genConsts)+"\n"};x.stdVertexUniforms=function(){return"\n"+this.ins(this.stdUniformsBg)+"\nuniform   highp vec4 uTime;\n"+((!this.inShadow)?(" \nuniform   vec4   cvp;\n"):"")+"\n"+((this.inShadow)?(" \nuniform   highp vec4   shcvp;\n"):"")+"\n"+((this.sp.useTM)?("\n"):"")+"\n"+this.ins(this.stdUniformsEnd)+" \n"};x.stdFragmentUniforms=function(){return"\n"+this.ins(this.stdUniformsBg)+"\n"+((this.inShadow||this.sp.showShadow)?(" \nuniform   mediump vec4  fshcvp;\n"):"")+"\n"+((this.sp.showShadow)?("\nuniform   sampler2D uShadowMap;\n"):"")+"\n"+this.ins(this.stdUniformsEnd)+" \n"};x.stdAttributes=function(){return"\nattribute vec4 pos;\nattribute vec4 origin;\nattribute vec4 texpos;\nattribute vec4 rotP;\nattribute vec4 accel;\nattribute vec4 rotA;\nattribute vec4 color;\nattribute vec4 texmix;\nattribute vec4 normal;\n"};x.stdVarying=function(){return"\nvarying   "+this.ins(this.FSMAXP)+" vec4 vtexpos;\nvarying   "+this.ins(this.LOWP)+"  vec4 vAmbColor;\n"+this.ins(this.iVarying)+"\n"+((this.sp.lightingPerVertex)?("\nvarying   "+this.ins(this.FSMAXP)+" vec4 vLight;\n"):"")+"\n"+((this.sp.lightingPerFragment)?("\nvarying "+this.ins(this.LOWP)+" vec4 vDiffColor;\nvarying "+this.ins(this.FSMAXP)+" vec3 vnormal;\nvarying "+this.ins(this.FSMAXP)+" vec4 vLightingPar;\n"):"")+"\n"+((this.sp.lightingPerFragment||this.sp.showShadow)?("\nvarying "+this.ins(this.FSMAXP)+" vec3 v3Dpos;\n"):"")+"\n"};x.DoRotation=function(){return"\nvec3 tnormal;\nvec4 \nDoRotation (vec4 p, float t)\n{\n   float from = rotP.w;\n   float to   = rotA.w; \n   float b    = mix (from,to,t) + 0.5*t*(t-1.0)*rotA.z; \n   float z = sqrt(abs(1.0-rotA.x*rotA.x-rotA.y*rotA.y));\n   vec3  q = vec3(p) - vec3(rotP);\n   float c = cos(b); float mc= (1.0-c);\n   float s = -sin(b);\n   mat3 Mrot = mat3 (c+rotA.x*rotA.x*mc,            rotA.x*rotA.y*mc-z*s,    rotA.x*z*mc+rotA.y*s,\n                     rotA.x*rotA.y*mc+z*s,     c+rotA.y*rotA.y*mc,           rotA.y*z*mc-rotA.x*s,\n                     z*rotA.x*mc-rotA.y*s,     z*rotA.y*mc+rotA.x*s,    c+z*z*mc);\n   q = Mrot * q;\n   tnormal = Mrot * tnormal;\n   q=q+vec3(rotP);    return vec4( q.x, q.y, q.z, p.w);\n}\n"};x.stdVertexHead=function(){return"\nvoid main()\n{\n    vec4 a = vec4 (vec3(pos),1.0);  \n    flags = int(pos.w);\n    float basetime = origin.w;\n    float duration = accel.w;\n    mat4 pm;\n    float rt =  (uTime[int(fract(pos.w)*4.0)]-basetime)/duration;\n    tnormal = normal.xyz;\n"+((!this.isTrident)?("\n    float t  =  clamp(rt,0.0,1.0);\n"):"")+"\n"+((this.isTrident)?("\n    float t  =  rt; \n    if (t>1.0) t=1.0;\n    if (t<0.0) t=0.0;\n"):"")+"\n    "+this.ins(this.iTimes)+"\n"};x.stdVertexCondition=function(){return"\n  if (  (((flags/2)*2 == flags) && (rt<0.0)) || (((flags/4)*4 == (flags/2)*2)) && (rt>1.0)  ) {\n        gl_Position = vec4(0.0,0.0,0.0,1.0); \n  } else {\n"};x.stdVertexMotionAnimation=function(){return"\n    if (rotA.w!=0.0 || rotP.w!=0.0) {\n       vec4 ra = DoRotation (a,t);\n       a = vec4 ((mix (vec3(origin),vec3(a),t)+0.5*t*(t-1.0)*vec3(accel)-vec3(a)+vec3(ra)),1.0);\n    } else {\n       a = vec4 (mix (vec3(origin),vec3(a),t)+0.5*t*(t-1.0)*vec3(accel),1.0);       }\n"+((this.sp.useTM)?("\n    if ((flags/16)*16 != (flags/8)*8) {\n      a= a*uTMT ;\n      tnormal = uTM_1T * tnormal;\n    }\n"):"")+"\n"};x.stdVertex3DmappingEye=function(){return"\n"+((this.sp.useuEye)?("\n    float ex=uEye.x; float ey=uEye.y; float ez=uEye.z;\n    vec3 eyePoint = uEye;\n"):"")+"\n"+((!this.sp.useuEye)?("\n    const float ex="+this.ins(this.EYEX)+";     const float ey="+this.ins(this.EYEY)+";     const float ez="+this.ins(this.EYEZ)+";\n    vec3 eyePoint = vec3("+this.ins(this.EYEX)+","+this.ins(this.EYEY)+","+this.ins(this.EYEZ)+");\n"):"")+"\n"};x.stdVertex3DmappingBase=function(){return"\n    pm = mat4   (    cvp.p,                            0.0,                            0.0,    0.0,  \n                             0.0,                       -  cvp.q,                            0.0,    0.0,\n                        (1.0+cvp.p*(cvp.s-ex))/ez,   (-1.0+cvp.q*(ey-cvp.t))/ez,          0.0,   -1.0/ez,\n                         -cvp.p*cvp.s-1.0,              cvp.q*cvp.t+1.0,              -ez/65536.0,    1.0);\n                     \n    vec4 pos; \n    pos = pm*a;\n    gl_Position = pos;\n"};x.stdVertexTexmix=function(){return"\n    vtexpos.st=mix (texpos.st,texpos.pq,t);\n"};x.stdVertexLighting=function(){return"\n"+((this.sp.lightingPerVertex)?("\n    vec3 diffColor, ambColor;\n    vec3 lightDir = normalize(uLightPos.xyz - a.xyz);\n"):"")+"\n    if ((flags/32)*2 != (flags/16) ) {\n       vec4 c0 = vec4( mod(color.s,256.0)/255.0 , (floor(color.s*(1.0/256.0))+128.0)*(1.0/255.0), \n                 (floor(color.t*(1.0/256.0))+128.0)*(1.0/255.0), mod(color.t,256.0) *(1.0/255.0));\n       vec4 c1 = vec4( mod(color.p,256.0)/255.0 , (floor(color.p*(1.0/256.0))+128.0)*(1.0/255.0), \n                 (floor(color.q*(1.0/256.0))+128.0)*(1.0/255.0), mod(color.q,256.0) *(1.0/255.0));\n       vec4 m = texmix;\n       if ((flags/64)*2 != (flags/32)) {\n"+((this.sp.lightingPerFragment)?("\n          if ((flags/128)*2 != (flags/64)) {\n             vDiffColor = vec4(c1.r,c1.g,0.0,0.0);\n               vAmbColor  = vec4(c0.rgb, 1.0) * mix(c0.w,c1.w,t);\n          } else {\n             vDiffColor = vec4(c1.rgb,1.0);\n             vAmbColor  = vec4(c0.rgb, mix(c0.w,c1.w,t));\n          }\n"):"")+"\n"+((this.sp.lightingPerVertex)?("\n          if ((flags/128)*2 != (flags/64)) {\n             diffColor = vec3 (c1.g,c1.g,c1.g);\n             ambColor = vec3 (c1.r,c1.r,c1.r);\n             vAmbColor  = vec4(c0.rgb, 1.0) * mix(c0.w,c1.w,t);\n          } else {\n             diffColor = c1.rgb;\n             ambColor  = c0.rgb;                vAmbColor  = vec4(1.0,1.0,1.0, 1.0) * mix(c0.w,c1.w,t);\n          }  \n"):"")+"\n"+(((!this.sp.lightingPerFragment)&&(!this.sp.lightingPerVertex))?("\n          if ((flags/128)*2 != (flags/64)) {\n              vAmbColor  = vec4(c0.rgb, 1.0) * (c1.g+c1.r) * mix(c0.w,c1.w,t);\n          } else {\n              vAmbColor  = vec4(c0.rgb+c1.rgb,1.0) * mix(c0.w,c1.w,t);\n          }  \n"):"")+"\n       } else {\n"+((this.sp.lightingPerFragment)?("\n          vDiffColor = vec4 (uLightingPar.x, uLightingPar.y, 0.0, 0.0);\n"):"")+"\n"+((this.sp.lightingPerVertex)?("\n          ambColor = vec3 (uLightingPar.x,uLightingPar.x,uLightingPar.x);\n          diffColor = vec3 (uLightingPar.y,uLightingPar.y,uLightingPar.y);\n"):"")+"\n          vAmbColor  = mix (c0,c1,t);\n       }\n       vtexpos.pq  = clamp (mix (m.st,m.pq,t), 0.0, 1.0);\n    } else {\n       vAmbColor = vec4(0.0,0.0,0.0,0.0);\n"+((this.sp.lightingPerFragment)?("\n       vDiffColor = vec4(uLightingPar.x, uLightingPar.y,0.0,0.0);\n"):"")+"\n"+((this.sp.lightingPerVertex)?("\n          ambColor = vec3 (uLightingPar.x,uLightingPar.x,uLightingPar.x);\n          diffColor = vec3 (uLightingPar.y,uLightingPar.y,uLightingPar.y);\n"):"")+"\n       vtexpos.pq  = vec2(1.0,0.0);\n    }\n"+((this.sp.lightingPerFragment||this.sp.showShadow)?("\n   v3Dpos=a.xyz; "+this.ins(this.calcv3Dpos)+"\n"):"")+"\n"+((this.sp.lightingPerFragment)?("\n   vnormal=normalize(tnormal.xyz);\n   vLightingPar = vec4((((flags/256)*2 != (flags/128)) ? 1.0 : 0.0 ), 0.0, fract(normal.w), floor(normal.w));\n"):"")+"\n"+((this.sp.lightingPerVertex)?("\n          if (dot( (eyePoint-a.xyz), tnormal) <0.0 ) tnormal=-tnormal;  \n   \n   vLight.rgb = diffColor * ( clamp(   (dot(normalize(tnormal.xyz), lightDir )), 0.0, 1.0));\n   if ((flags/256)*2 != (flags/128)) { vLight.a =-1.0; }\n   else { vLight.a=0.0;vLight.rgb+=ambColor;}\n"):"")+"\n"};x.stdVertexConditionEnd=function(){return"\n  }\n"};x.stdVertexFoot=function(){return"\n}\n"};x.stdVertex3Dmapping=function(){return"\n   "+this.ins(this.stdVertex3DmappingEye)+"\n   "+this.ins(this.stdVertex3DmappingBase)+"\n"};x.SHCVP=function(){return"\n"+((this.inFragment)?("fshcvp"):"")+""+((this.inVertex)?("shcvp"):"")+"\n"};x.stdShadow3Dmapping=function(){return"\n      mat4 shadowPM = \n          mat4 (      "+this.ins(this.SHCVP)+".p,                                                             0.0,                                  0.0,    0.0,  \n                          0.0,                                                            -  "+this.ins(this.SHCVP)+".q,                            0.0,    0.0,\n               (1.0+"+this.ins(this.SHCVP)+".p*("+this.ins(this.SHCVP)+".s-uLightPos.x))/uLightPos.z, (-1.0+"+this.ins(this.SHCVP)+".q*(uLightPos.y-"+this.ins(this.SHCVP)+".t))/uLightPos.z,      0.0,   -shF/uLightPos.z,\n               -"+this.ins(this.SHCVP)+".p*"+this.ins(this.SHCVP)+".s-1.0,                                       "+this.ins(this.SHCVP)+".q*"+this.ins(this.SHCVP)+".t+1.0,                  -uLightPos.z/65536.0,    shF);\n"};x.vertexShaderCode=function(){return"\n"+this.ins(this.stdVertexUniforms)+"\n"+this.ins(this.stdAttributes)+"\n"+this.ins(this.stdVarying)+"\nint flags;\n"+this.ins(this.vertexVar)+"\n"+this.ins(this.DoRotation)+"\n"+this.ins(this.stdVertexHead)+" \n   "+this.ins(this.stdVertexCondition)+"\n   "+this.ins(this.pos)+"\n   "+this.ins(this.stdVertexMotionAnimation)+"\n   "+this.ins(this.stdVertex3Dmapping)+"\n   "+this.ins(this.stdVertexTexmix)+" \n   "+this.ins(this.stdVertexLighting)+"\n"+this.ins(this.stdVertexConditionEnd)+"\n"+this.ins(this.stdVertexFoot)+"\n"};x.shadowVertexShaderCode=function(){return"\n"+this.ins(this.stdVertexUniforms)+"\n"+this.ins(this.stdAttributes)+"\n"+this.ins(this.stdVarying)+"\nint flags;\n"+this.ins(this.vertexVar)+"\n"+this.ins(this.DoRotation)+"\n"+this.ins(this.stdVertexHead)+" \n"+this.ins(this.stdVertexCondition)+"\n   "+this.ins(this.pos)+"\n    if ((flags/512)*2 != (flags/256)) {\n        gl_Position = vec4(0.0,0.0,0.0,1.0);\n    } else {\n   "+this.ins(this.stdVertexMotionAnimation)+"\n   const float shF=1.0;\n   "+this.ins(this.stdShadow3Dmapping)+"\n   \n   v3Dpos=a.xyz; \n   gl_Position=shadowPM*a;\n"+((this.sp.lightingPerFragment)?("\n   vnormal=normalize(tnormal.xyz);\n"):"")+"\n   "+this.ins(this.stdVertexTexmix)+" \n    if ((flags/32)*2 != (flags/16)) {\n       vec4 m = texmix;\n       vtexpos.pq   = clamp (mix (m.st,m.pq,t), 0.0, 1.0);\n       float c0a =  mod(color.t,256.0) *(1.0/255.0);\n       float c1a =  mod(color.q,256.0) *(1.0/255.0);\n       vAmbColor = vec4( mod(color.s,256.0)/255.0 ,0.0 ,0.0 ,mix(c0a,c1a,t));\n					\n    } else {\n       vAmbColor = vec4(0.0,0.0,0.0,0.0);\n       vtexpos.pq   = vec2(1.0,0.0);\n    }\n"+this.ins(this.stdVertexConditionEnd)+"\n    }\n"+this.ins(this.stdVertexFoot)+"\n"};x.fragmentDefs=function(){return"\n#define TS(S) ((S)*(1.0/"+this.ins(this.TEXTURECANVASWIDTH)+"))\n#define TT(T) ((T)*(1.0/"+this.ins(this.TEXTURECANVASHEIGHT)+"))\n"};x.fragmentShaderCode=function(){return"\nprecision "+this.ins(this.FSMAXP)+" float;\n"+this.ins(this.stdFragmentUniforms)+"\n"+this.ins(this.fragmentDefs)+"\n"+this.ins(this.ifragDef)+"\n"+this.ins(this.fragDef)+"\n"+this.ins(this.stdVarying)+"\nvoid main()\n{\n   mediump vec4 c, d, e;\n   \n   "+this.ins(this.dyntexvar)+"\n   "+this.ins(this.ifragVar)+"\n   "+this.ins(this.fragVar)+"\n   "+this.ins(this.fragPos)+"\n  "+((this.sp.useTex)?("\n   c  = texture2D(uTexture,  "+this.ins(this.vtexpos_st)+");\n  "):"")+"\n  "+((this.sp.showShadow)?("\n      const float shF=2.0;\n      "+this.ins(this.stdShadow3Dmapping)+"\n      vec4 sp4=shadowPM * vec4(v3Dpos,1.0);\n      vec3 sp=(sp4.xyz/sp4.w) + vec3(0.5,0.5,0.5); \n   vec4 sm  = texture2D(uShadowMap,  sp.xy);\n   const float shadowDiff = 0.0005;\n   float hasShadow = (sp.z - shadowDiff > dot (sm,vec4(255.0/256.0,255.0/256.0/256.0,255.0/65536.0/256.0,255.0/65536.0/65536.0))) ? 0.2 :0.0;\n   sm = texture2D(uShadowMap,  sp.xy + vec2(4.0/2048.0,4.0/2048.0));\n   hasShadow += (sp.z - shadowDiff > dot (sm,vec4(255.0/256.0,255.0/256.0/256.0,255.0/65536.0/256.0,255.0/65536.0/65536.0))) ? 0.2 :0.0;\n   sm = texture2D(uShadowMap,  sp.xy + vec2(-4.0/2048.0,-4.0/2048.0));\n   hasShadow += (sp.z - shadowDiff > dot (sm,vec4(255.0/256.0,255.0/256.0/256.0,255.0/65536.0/256.0,255.0/65536.0/65536.0))) ? 0.2 :0.0;\n   sm = texture2D(uShadowMap,  sp.xy + vec2(1.0/2048.0,1.0/2048.0));\n   hasShadow += (sp.z - shadowDiff > dot (sm,vec4(255.0/256.0,255.0/256.0/256.0,255.0/65536.0/256.0,255.0/65536.0/65536.0))) ? 0.2 :0.0;\n   sm = texture2D(uShadowMap,  sp.xy + vec2(-1.0/2048.0,-1.0/2048.0));\n   hasShadow += (sp.z - shadowDiff > dot (sm,vec4(255.0/256.0,255.0/256.0/256.0,255.0/65536.0/256.0,255.0/65536.0/65536.0))) ? 0.2 :0.0;\n   hasShadow *= uShadowFactor;\n   "+this.ins(this.endShadowCalc)+"\n  "):"")+"\n  "+((this.sp.lightingPerFragment)?("\n     bool  colormode= vDiffColor.w!=0.0; \n   vec4  bgcolor  = colormode ? vec4(1.0,1.0,1.0,1.0)*vAmbColor.w : vAmbColor;\n  "):"")+"\n  "+((!this.sp.lightingPerFragment)?("\n   vec4  bgcolor  = vAmbColor;\n  "):"")+"\n  "+((this.sp.useTex)?("\n  "+((!this.sp.singleTex)?("				\n   d = texture2D(uTexture2, "+this.ins(this.vtexpos_st2)+");\n   float da = vtexpos.q; float ca = vtexpos.p;\n   "+this.ins(this.mixAlpha)+"\n   "+this.ins(this.mix)+"\n   "+((this.qmix)?("\n   e = c*ca+d*da;\n   "):"")+"\n   "+((!this.qmix)?("\n   float dam=d.a*da; float cam=c.a*ca;\n   e = vec4 (c.rgb * ca * (1.0-dam) + d.rgb*da, 1.0-(1.0-dam)*(1.0-cam)); \n   "):"")+"\n  "):"")+"\n  "+((this.sp.singleTex)?("\n   float ca = vtexpos.p;\n   "+this.ins(this.mixAlpha)+"\n   "+this.ins(this.mix)+"\n   float cam=c.a*ca; float dam=0.0;\n   e = vec4 (c.rgb * ca,  cam);\n  "):"")+"\n   float a =  1.0  -(1.0-bgcolor.a)*(1.0-e.a);\n   mediump vec3 col = e.rgb + bgcolor.rgb * (1.0-e.a);  \n  "):"")+"    "+((!this.sp.useTex)?("\n   vec3 col=bgcolor.rgb; float a=bgcolor.a;\n  "):"")+"\n   "+this.ins(this.alpha)+"\n   "+this.ins(this.color)+"\n  "+((this.sp.useDiscard&&!this.sp.discardThreshold)?("\n   if (a<0.01) discard;\n  "):"")+"\n  "+((this.sp.discardThreshold)?("\n   if (a<bgcolor.r) discard;\n  "):"")+"\n  "+((this.sp.lightingPerFragment)?("\n   "+this.ins(this.FSMAXP)+" vec3 lightDir = normalize( (uLightPos.xyz - v3Dpos)  "+((!this.fsHighp)?("*(1.0/8192.0)"):"")+" );\n   "+this.ins(this.FSMAXP)+" vec3 normal;\n  "+((this.sp.frontfacing)?("\n   if (gl_FrontFacing) normal=vnormal; else normal=-vnormal;\n  "):"")+"\n  "+((!this.sp.frontfacing)?("\n   normal=vnormal;					\n  "):"")+"\n   "+this.ins(this.normal)+"\n  normal=normalize(normal);\n   \n  mediump vec3 Light =  (colormode ? vDiffColor.rgb : uLightingColor * vDiffColor.y ) *\n  	          ( clamp( ( "+((!this.sp.frontfacing)?("abs"):"")+"(dot(normal, lightDir ))), 0.0, 1.0));\n"+((this.sp.useuEye)?("\n  vec3 eye = vec3 (uEye);\n"):"")+"\n"+((!this.sp.useuEye)?("\n  vec3 eye = vec3 ("+this.ins(this.EYEX)+", "+this.ins(this.EYEY)+", "+this.ins(this.EYEZ)+");\n"):"")+"\n"+((this.sp.specLight)?("\n    Light += "+((this.sp.showShadow)?(" (uShadowFactor-hasShadow)* "):"")+" uLightingColor * vLightingPar.z * pow ( clamp ( dot ( reflect (-lightDir, normal), normalize((eye - v3Dpos) "+((!this.fsHighp)?("*(1.0/8192.0)"):"")+" ) ), 0.0, 1.0),  0.000001+vLightingPar.w) ; \n"):"")+"\n    col *= ( Light   "+((this.sp.showShadow)?(" * (1.0-hasShadow) "):"")+" + (colormode ? vAmbColor.rgb : uLightingAmbientColor * vDiffColor.x));\n  "):"")+"\n  "+((this.sp.lightingPerVertex)?("  \n    col *= vLight.rgb;  \n  "):"")+"\n  "+((this.sp.shadowOnly!=false&&this.sp.shadowOnly!=true)?("\n  "+((this.sp.lightingPerFragment)?("\n   if (vLightingPar.x>0.0) {\n      col=vec3(0.0,0.0,0.0);\n      a =  "+((this.sp.showShadow)?("hasShadow*(Light.r+Light.g+Light.b)/3.0+"):"")+"0.0;\n   }\n  "):"")+"\n  "+((this.sp.lightingPerVertex)?("\n   if (vLight.a<=-1.0) {\n      col=vec3(0.0,0.0,0.0);\n      a =  "+((this.sp.showShadow)?("hasShadow*(vLight.r+vLight.g+vLight.b)/3.0+"):"")+"0.0;\n   }\n  "):"")+"\n  "):"")+"\n  "+((this.sp.shadowOnly)?("\n      col=vec3(0.0,0.0,0.0);\n      "+((this.sp.lightingPerFragment)?("\n      a =  "+((this.sp.showShadow)?("hasShadow*(Light.r+Light.g+Light.b)/3.0+"):"")+"0.0;\n      "):"")+"\n      "+((this.sp.lightingPerVertex)?("\n         a =  "+((this.sp.showShadow)?("hasShadow*(vLight.r+vLight.g+vLight.b)/3.0+"):"")+"0.0;\n      "):"")+"\n      "+((!this.sp.lighting)?("\n         a =  "+((this.sp.showShadow)?("hasShadow+"):"")+"0.0;\n      "):"")+"\n  "):"")+" \n   "+this.ins(this.finalcolor)+"\n  "+((this.sp.showShadow)?("\n  "):"")+"  \n      gl_FragColor = vec4(col,a);\n}\n"};x.endShadowCalc=function(){return"\n"};x.calcv3Dpos=function(){return"\n"};x.shadowFragmentShaderCode=function(){return"\nprecision mediump float;\n"+this.ins(this.stdUniformsBg)+" "+this.ins(this.stdUniformsEnd)+"\n"+this.ins(this.fragmentDefs)+"\n"+this.ins(this.ifragDef)+"\n"+this.ins(this.fragDef)+"\n"+this.ins(this.stdVarying)+"\nvoid main()\n{\n   vec4 c, d, e;\n   "+this.ins(this.dyntexvar)+"\n   "+this.ins(this.ifragVar)+"\n   "+this.ins(this.fragVar)+"\n   "+this.ins(this.fragPos)+"\n   float bgcolora = vAmbColor.a; \n  "+((this.sp.useTex)?("\n   c  = texture2D(uTexture,  "+this.ins(this.vtexpos_st)+");\n  "+((!this.sp.singleTex)?("				\n   d = texture2D(uTexture2,  "+this.ins(this.vtexpos_st2)+");\n   float da = vtexpos.q; float ca = vtexpos.p;\n   "+this.ins(this.mixAlpha)+"\n   float dam=d.a*da; float cam=c.a*ca;\n   float ea = 1.0-(1.0-dam)*(1.0-cam); \n  "):"")+"\n  "+((this.sp.singleTex)?("\n   float ca = vtexpos.p;\n   "+this.ins(this.mixAlpha)+"\n   float cam=c.a*ca; float dam=0.0;\n   float ea = cam;\n  "):"")+"\n   float a =  1.0  -(1.0-bgcolora)*(1.0-ea);\n  "):"")+"\n  "+((!this.sp.useTex)?("\n   float a=bgcolora;\n  "):"")+"\n   "+this.ins(this.alpha)+"\n  "+((this.sp.useDiscard&&!this.sp.discardThreshold)?("\n   if (a<0.01) discard;\n  "):"")+"\n  "+((this.sp.discardThreshold)?("\n   if (a<vAmbColor.r) discard;\n  "):"")+"\n   gl_FragColor = floor ( fract( gl_FragCoord.z*vec4(1.0,256.0,65536.0,256.0*65536.0) ) * 256.0 ) * (1.0/255.0);\n}\n"};this.init=function(){this.p=null;this.ifragDef="";this.ifragVar="";this.iTimes="";this.iVarying="";this.dyntexvar="";this.vtexpos_st=this.vtexpos_st2="vtexpos.st";this.lighting=true;this.lightingPerFragment=!taccgl_perVertex;this.lightingPerVertex=taccgl_perVertex;this.frontfacing=taccgl_frontfacing;this.useTex=true;this.shadowOnly=null;this.useDiscard=true;this.discardThreshold=false;if(window.taccgl_TM||window.taccgl_TM==false){this.useTM=window.taccgl_TM}else{this.useTM=true}if(window.taccgl_parallax||window.taccgl_parallax==false){this.useuEye=window.taccgl_parallax}else{this.useuEye=true}if(window.taccgl_noSpecular||window.taccgl_noSpecular==false){this.specLight=!taccgl_noSpecular}else{this.specLight=true}if(window.taccgl_mediump||window.taccgl_mediump==false){this.force_mediump=taccgl_mediump}else{this.force_mediump=false}if(window.taccgl_qmix||window.taccgl_qmix==false){this.qmix=taccgl_qmix}else{this.qmix=true}if(window.taccgl_singleTex||window.taccgl_singleTex==false){this.singleTex=taccgl_singleTex}else{this.singleTex=false}this.consts=new this.empty();this.uniforms=new this.empty();this.showShadow=true;this.castShadow=true;var ua=navigator.userAgent;this.isTrident=ua.match(/Trident|Edge/);if(this.lightingPerVertex){this.showShadow=this.castShadow=false}if(this.dddmode){this.evalPrecisionFormat()}this.reuseSc={}};this.empty=function(){};this.setLighting=function(ena,perVertex){if(ena){this.lighting=true;if(perVertex){this.lightingPerFragment=false;this.lightingPerVertex=true}else{this.lightingPerFragment=true;this.lightingPerVertex=false}}else{this.lighting=false;this.lightingPerFragment=false;this.lightingPerVertex=false;this.showShadow=false}return this};this.initShader=function(){if(!taccgl.dddmode){return}var x=this;if(x){}var s=this.prepShader("taccgl_Shaders",this.getShader("taccgl_Shaders"));eval(s)};this.extendShader=function(n){if(!taccgl.dddmode){return}if(n=="taccgl_Shaders"){return}var x=this;if(x){}eval(this.prepShader(n,this.getShader(n)))};this.fpn=function(f){var s=f+"";return(s.replace(/^([0-9]*)$/,"$1.0"))};this.el=function(pre,el,t,ti){if(!taccgl.dddmode){return this}if(typeof(el)=="string"){el=document.getElementById(el)}taccgl.autoDetectScroll();var rect=el.getBoundingClientRect(),x=rect.left+taccgl.scrollLeft,y=rect.top+taccgl.scrollTop;if(t){var v=t.cvCssTex(x,y,ti);x=v[0];y=v[1]}this.ifragDef+="#define "+pre+"S TS("+this.fpn(x)+")\n#define "+pre+"T TT("+this.fpn(y)+")\n#define "+pre+"W TS("+el.offsetWidth+".0)\n#define "+pre+"H TT("+el.offsetHeight+".0)\n#define "+pre+"MS TS("+this.fpn(x)+"+"+el.offsetWidth+".0/2.0)\n#define "+pre+"MT TT("+this.fpn(y)+"+"+el.offsetHeight+".0/2.0)\n";return this};this.transtex=function(pre,tr,ti){if(!taccgl.dddmode){return this}if(!ti){ti=0}var tm=1-ti;var ws,wt,s,hs,ht,t;if(tr.dotexmove){ws=tr.ws0*tm+tr.ws1*ti,wt=tr.wt0*tm+tr.wt1*ti,hs=tr.hs0*tm+tr.hs1*ti,ht=tr.ht0*tm+tr.ht1*ti,s=tr.s0*tm+tr.s1*ti,t=tr.t0*tm+tr.t1*ti}else{ws=tr.ws0;wt=tr.wt0;hs=tr.hs0;ht=tr.ht0;s=tr.s0*tm+tr.s1*ti,t=tr.t0*tm+tr.t1*ti}this.ifragDef+="#define "+pre+"S TS("+this.fpn(s)+")\n#define "+pre+"T TT("+this.fpn(t)+")\n#define "+pre+"WS TS("+this.fpn(ws)+")\n#define "+pre+"WT TT("+this.fpn(wt)+")\n#define "+pre+"HS TS("+this.fpn(hs)+")\n#define "+pre+"HT TT("+this.fpn(ht)+")\n"};this.times=function(){if(!taccgl.dddmode){return this}this.ifragVar+="float basetime = times.s; float duration = times.t; float rt = times.p; float ct = times.q;\nfloat mct= 1.0-ct;\n";this.iTimes+="times.s=basetime;  times.t= duration; times.p=rt; times.q=t;\n";this.iVarying+="varying   "+this.FSMAXP()+" vec4 times;     //: passing on timing information for user shaders \n";return this};this.fragCoord=function(){if(!taccgl.dddmode){return this}this.ifragVar+="float fx=gl_FragCoord.x; float fy=gl_FragCoord.y; float fz=gl_FragCoord.z; float fw=gl_FragCoord.w;\n";return this};this.evalPrecisionFormat=function(){this.pfFsHighP=taccgl.g.getShaderPrecisionFormat(taccgl.g.FRAGMENT_SHADER,taccgl.g.HIGH_FLOAT);this.pfFsMediumP=taccgl.g.getShaderPrecisionFormat(taccgl.g.FRAGMENT_SHADER,taccgl.g.MEDIUM_FLOAT);this.pfFsLowP=taccgl.g.getShaderPrecisionFormat(taccgl.g.FRAGMENT_SHADER,taccgl.g.LOW_FLOAT);this.fsHighp=(this.pfFsHighP.rangeMin!=0&&this.pfFsHighP.rangeMax!=0)};this.dynTex=function(){this.dyntexvar=function(){if(!this.singleTex){return"float s=vtexpos.s; float t=vtexpos.t; float s2=vtexpos.s; float t2=vtexpos.t;\n"}else{return"float s=vtexpos.s; float t=vtexpos.t;\n"}};this.vtexpos_st="vec2(s,t)";this.vtexpos_st2="vec2(s2,t2)";return this};this.ins=function(h,a,b,c,d,e,f,g){if(typeof(h)=="function"){this.h=h;var r=this.h(a,b,c,d,e,f,g);this.h=null;return r}else{if(typeof(h)=="string"){return h}else{if(typeof(h)=="number"){var s=""+h;if(s.match(/\./)){return s}return s+".0"}else{if(h&&typeof(h)=="object"){if(h.length){var x="",i;for(i=0;i<h.length;i++){x+=this.ins(h[i],a,b,c,d,e,f,g)}return x}else{return h.gen(a,b,c,d,e,f,g)}}}}}};this.prepShader=function(n,s){var t;t="{x.dummy='"+s;t=t.replace(/\n:([A-Za-z0-9]+)/g,"//-----\n';}; x.$1=function(){return '//+++++ $1 ");t=t.replace(/\n/g,"\\n'+\n'");t=t.replace(/\$\$([A-Za-z0-9_]+)/g,"'+this.ins(this.$1)+'");t=t.replace(/\$\$\[/g,"'+");t=t.replace(/\$\$\]/g,"+'");t=t.replace(/\$\$\?([A-Za-z0-9_!|.()&=<>]+)\{/g,"'+(($1)?('");t=t.replace(/\$\$\?\}/g,"'):'')+'");t+="';}";s='/*\n<script id="taccgl_Shaders" type="x-gsgl/x-vertex">'+s+"<\/script>\n*/\n";if(taccgl_showShader){document.body.insertAdjacentHTML("afterbegin",'<H1 style="z-index:1000000; position:relative; color:red; background-color:white; margin-top:20px;">Cut and Paste Shader '+n+'</h1><div style="z-index:100000; position:relative"><textarea cols="80" rows="5">'+s+t+"</textarea></div>")}return(t)};this.getShader=function(n){var el=document.getElementById(n),t=" ";if(el){t=el.innerHTML;if(!t){t=el.text}}return(t)};this.TEXTURECANVASWIDTH=function(){return taccgl_texCanWidth+".0"};this.TEXTURECANVASHEIGHT=function(){return taccgl_texCanHeight+".0"};this.EYEX=function(){return Math.floor(taccgl.stdEye.eyeX)+".0"};this.EYEY=function(){return Math.floor(taccgl.stdEye.eyeY)+".0"};this.EYEZ=function(){return Math.floor(taccgl.stdEye.eyeZ)+".0"};this.fragDef="/* fragDef */";this.fragVar="/* fragVar */";this.fragPos="/* fragPos */";this.mix="/* mix */";this.color="/* color */";this.finalcolor="/* finalcolor */";this.vertexVar="/* vertexVar */";this.pos="/* pos */";this.alpha="/* alpha */";this.mixAlpha="/* mixAlpha */";this.normal="/* normal */";this.LOWP=function(){if(this.force_mediump){return"mediump"}else{return"lowp"}};this.FSMAXP=function(){if(this.fsHighp){return"highp"}else{return"mediump"}};this.genUniforms=function(){var s="",n;for(n in this.uniforms){var u=this.uniforms[n];s+="uniform ";if(u.d==1){s+=" float "}else{if(u.d<=4){s+=" "+this.FSMAXP()+" vec"+u.d}else{s+=" "+this.FSMAXP()+" mat"+(u.d-100)}}s+=" "+u.name+";\n"}return s};this.genConsts=function(){var s="",n;for(n in this.consts){var u=this.consts[n];s+="const  ";if(u.d==1){s+=" float "}else{s+=" vec"+u.d}s+=" "+u.name+" = ";if(u.d==1){s+=u.jcx}else{s+=" vec"+u.d+"(";s+=u.jcx;if(u.jcy){s+=","+u.jcy}if(u.jcz){s+=","+u.jcz}if(u.jcw){s+=","+u.jcw}s+=")"}s+=";\n"}return s};this.shaderPar=function(sc){this.lighting=sc.lighting;this.lightingPerFragment=sc.lightingPerFragment;this.lightingPerVertex=sc.lightingPerVertex;this.singleTex=sc.singleTex;this.frontfacing=sc.frontfacing;this.useTM=sc.useTM;this.useuEye=sc.useuEye;this.specLight=sc.specLight;this.useTex=sc.useTex;this.shadowOnly=sc.shadowOnly;this.useDiscard=sc.useDiscard;this.discardThreshold=sc.discardThreshold;this.showShadow=sc.showShadow;this.castShadow=sc.castShadow};this.newUniform=function(name,d,jcx,jcy,jcz,jcw){this.name=name;this.jcx=jcx;this.jcy=jcy;this.jcz=jcz;this.jcw=jcw;this.d=d};this.newConst=function(name,d,jcx,jcy,jcz,jcw){this.name=name;this.jcx=jcx;this.jcy=jcy;this.jcz=jcz;this.jcw=jcw;this.d=d};this.createUniform=function(name,jcx,jcy,jcz,jcw){var d=1;if(jcy){d=2}if(jcz){d=3}if(jcw){d=4}this.uniforms[name]=new this.newUniform(name,d,jcx,jcy,jcz,jcw)};this.createUniformMatrix=function(name,d,transpose,m){this.uniforms[name]=new this.newUniform(name,100+d,transpose,m)};this.createConst=function(name,jcx,jcy,jcz,jcw){var d=1;if(jcy){d=2}if(jcz){d=3}if(jcw){d=4}this.consts[name]=new this.newConst(name,d,jcx,jcy,jcz,jcw)};this.setupGen=function(){if(this.sp.lighting){this.createUniform("uLightingPar","taccgl.lightAmbient","taccgl.lightDiffuse","taccgl.lightSpecular","taccgl.lightShininess");this.createUniform("uLightPos","taccgl.stdLight.x","taccgl.stdLight.y","taccgl.stdLight.z","taccgl.stdLight.focus");if(!this.uniforms.uLightingAmbientColor){this.createConst("uLightingAmbientColor","1.0","1.0","1.0")}if(!this.uniforms.uLightingColor){this.createConst("uLightingColor","1.0","1.0","1.0")}if(!window.taccgl_shadowFactor){taccgl_shadowFactor=0.8}if(!this.uniforms.uShadowFactor){this.createConst("uShadowFactor",taccgl_shadowFactor.toFixed(5))}}if(this.sp.useTM){this.createUniformMatrix("uTMT",4,"false","taccgl.TM");this.createUniformMatrix("uTM_1T",3,"false","taccgl.TM_1")}if(this.sp.useuEye){this.createUniform("uEye","taccgl.stdEye.eyeX","taccgl.stdEye.eyeY","taccgl.stdEye.eyeZ")}};this.reuseVertexShader=function(sc){this.reuseSc=sc};this.trycompile=function(par,reuse){taccgl.webglerror=false;this.sp=par;this.setupGen();this.inShadow=false;if(reuse&&par.lightingPerVertex!=reuse.lightingPerVertex){reuse=this.reuseSc.perVpar}if(reuse&&reuse.vertexShader){par.vertexShader=reuse.vertexShader}else{this.inFragment=false;this.inVertex=true;par.vstext=this.vertexShaderCode();this.inVertex=false}this.inFragment=true;this.inVertex=false;par.fstext=this.fragmentShaderCode();this.inFragment=false;this.inShadow=null;if(taccgl_showShader){document.body.insertAdjacentHTML("afterbegin",'<textarea cols="80" rows="2" style="z-index:100000; position:relative">'+par.fstext+"</textarea>");document.body.insertAdjacentHTML("afterbegin",'<textarea cols="80" rows="2" style="z-index:100000; position:relative">'+par.vstext+"</textarea>")}if(!par.vertexShader){par.vertexShader=taccgl.createVertexShader(taccgl.replaceShaderVariables(par.vstext));if(par.vertexShader==null||taccgl.webglerror){return null}}par.fragmentShader=taccgl.createFragmentShader(taccgl.replaceShaderVariables(par.fstext));if(par.fragmentShader==null||taccgl.webglerror){return null}return par.p=taccgl.createShaderProgram(par.vertexShader,par.fragmentShader)};this.compileShadowShader=function(){this.shadowP=null;taccgl.webglerror=false;this.inShadow=true;if(this.reuseSc&&this.reuseSc.shadowMapVertexShader){this.shadowMapVertexShader=this.reuseSc.shadowMapVertexShader}else{this.inFragment=false;this.inVertex=true;var vstext=this.shadowVertexShaderCode();this.inVertex=false}this.inFragment=true;this.inVertex=false;var fstext=this.shadowFragmentShaderCode();this.inFragment=false;this.inShadow=null;var vs;if(!this.shadowMapVertexShader){vs=this.shadowMapVertexShader=taccgl.createVertexShader(taccgl.replaceShaderVariables(vstext));if(vs==null||taccgl.webglerror){return}}var fs=taccgl.createFragmentShader(taccgl.replaceShaderVariables(fstext));if(fs==null||taccgl.webglerror){return}this.shadowP=taccgl.createShaderProgram(this.shadowMapVertexShader,fs)};this.newLocs=function(p,shadowmap,genshadowmap){var g=taccgl.g;this.uTime=g.getUniformLocation(p,"uTime");if(genshadowmap){this.shcvp=g.getUniformLocation(p,"shcvp")}else{this.cvp=g.getUniformLocation(p,"cvp")}this.uTexture=g.getUniformLocation(p,"uTexture");this.uTexture2=g.getUniformLocation(p,"uTexture2");if(shadowmap){this.uShadowMap=g.getUniformLocation(p,"uShadowMap");this.shcvp=g.getUniformLocation(p,"shcvp");this.fshcvp=g.getUniformLocation(p,"fshcvp")}};this.compileUniforms=function(){this.fastLoc=new this.newLocs(this.fastProg,this.fastPar.showShadow,false);this.perVLoc=new this.newLocs(this.perVProg,false,false);if(this.advProg){this.advLoc=new this.newLocs(this.advProg,this.advPar.showShadow,false)}if(this.shadowP){this.shadowLoc=new this.newLocs(this.shadowP,false,true)}var s="x.passUniforms=function (loc) {var g=taccgl.g;\n",n,u;for(n in this.uniforms){u=this.uniforms[n];if(u.d>100){s+="g.uniformMatrix"+(u.d-100)+"fv(loc."+u.name+","+u.jcx+","+u.jcy+");\n"}else{s+="g.uniform"+u.d+"f(loc."+u.name+","+u.jcx;if(u.jcy){s+=","+u.jcy}if(u.jcz){s+=","+u.jcz}if(u.jcw){s+=","+u.jcw}s+=");\n"}this.fastLoc[u.name]=taccgl.g.getUniformLocation(this.fastProg,u.name);this.perVLoc[u.name]=taccgl.g.getUniformLocation(this.perVProg,u.name);if(this.advProg){this.advLoc[u.name]=taccgl.g.getUniformLocation(this.advProg,u.name)}}s+="};\n";if(this.shadowP){s+="x.shadowPassUniforms=function () {var g=taccgl.g;\n";for(n in this.uniforms){u=this.uniforms[n];if(u.d>100){s+="g.uniformMatrix"+(u.d-100)+"fv(this.shadowLoc."+u.name+","+u.jcx+","+u.jcy+");\n"}else{s+="g.uniform"+u.d+"f(this.shadowLoc."+u.name+","+u.jcx;if(u.jcy){s+=","+u.jcy}if(u.jcz){s+=","+u.jcz}if(u.jcw){s+=","+u.jcw}s+=");\n"}this.shadowLoc[u.name]=taccgl.g.getUniformLocation(this.shadowP,u.name)}s+="}"}var x=this;eval(s);if(x){}};this.compile=function(){if(!taccgl.dddmode){return this}var fastCompileStart=taccgl.perfnow();this.fastPar=new this.shaderPar(this);this.fastPar.showShadow=false;this.fastProg=this.trycompile(this.fastPar,this.reuseSc.fastPar);if(!this.fastProg){this.fastPar.frontfacing=false;this.fastProg=this.trycompile(this.fastPar,this.reuseSc.fastPar)}if(!this.fastProg&&this.fastPar.lighting){this.fastPar.lighting=false;this.fastPar.lightingPerFragment=false;this.fastPar.lightingPerVertex=false;this.fastProg=this.trycompile(this.fastPar,this.reuseSc.fastPar)}if(!this.fastProg||taccgl.webglerror){return}var fastCompileTime=taccgl.perfnow()-fastCompileStart;var n=navigator.appVersion;var aT;if(n.match(/Chrome/)){aT=taccgl_advCompileTimeChrome}else{aT=taccgl_advCompileTime}if(this.showShadow&&this.fastPar.lighting&&(fastCompileTime<aT||taccgl.shadowEna==true)&&taccgl.shadowEna!=false){this.advPar=new this.shaderPar(this);this.advPar.frontfacing=this.fastPar.frontfacing;this.advProg=this.trycompile(this.advPar,this.reuseSc.advPar);if(!this.advProg){taccgl.webglerror=false}else{}}else{this.advProg=null}if(this.castShadow&&this.advProg){this.sp=this.advPar;this.compileShadowShader();if(taccgl.webglerror){taccgl.shadowEna=false;taccgl.webglerror=false}else{}}if(this.fastPar.lightingPerVertex||!this.fastPar.lighting){this.perVPar=this.fastPar;this.perVProg=this.fastProg;this.perVLoc=this.fastLoc}else{this.perVPar=new this.shaderPar(this);this.perVPar.showShadow=false;this.perVPar.lightingPerFragment=false;this.perVPar.lightingPerVertex=true;this.perVProg=this.trycompile(this.perVPar,this.reuseSc.perVPar);if(!this.perVProg||taccgl.webglerror){taccgl.tlog("Compilation of perVProg failed with  "+this.perVPar.toString()+"\n");this.perVPar=this.fastPar;this.perVProg=this.fastProg;this.perVLoc=this.fastLoc;taccgl.tlog("Using fastProg as perVProg  with  "+this.perVPar.toString()+"\n")}else{}}this.compileUniforms();if(this.advProg!=null){this.p=this.advProg;this.loc=this.advLoc}else{this.p=this.fastProg;this.loc=this.fastLoc}this.qp=new Array(6);this.qLoc=new Array(6);this.qp[1]=this.perVProg;this.qLoc[1]=this.perVLoc;this.qp[2]=this.perVProg;this.qLoc[2]=this.perVLoc;this.qp[3]=this.perVProg;this.qLoc[3]=this.perVLoc;this.qp[4]=this.fastProg;this.qLoc[4]=this.fastLoc;this.qp[5]=this.fastProg;this.qLoc[5]=this.fastLoc;if(this.advProg!=null){this.qp[5]=this.advProg;this.qLoc[5]=this.advLoc}};this.freeCompiled=function(){if(!taccgl.dddmode){return this}taccgl.g.useProgram(null);taccgl.g.deleteProgram(this.p)}}function taccglShaderConfigEmpty(){this.init()}function taccglMultiPrototype(){this.start=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.start(h,g,p,n,l,k)}return this};this.mActor=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.mActor(h,g,p,n,l,k)}return this};this.stop=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.stop(h,g,p,n,l,k)}return this};this.hide=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.hide(h,g,p,n,l,k)}return this};this.hideAtBegin=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.hideAtBegin(h,g,p,n,l,k)}return this};this.cposClientRects=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.cposClientRects(h,g,p,n,l,k)}return this};this.cposTransform=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.cposTransform(h,g,p,n,l,k)}return this};this.opacity=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.opacity(h,g,p,n,l,k)}return this};this.alpha=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.alpha(h,g,p,n,l,k)}return this};this.textureDraw=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.textureDraw(h,g,p,n,l,k)}return this};this.paint=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.paint(h,g,p,n,l,k)}return this};this.alloc=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.alloc(h,g,p,n,l,k)}return this};this.ap=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.ap(h,g,p,n,l,k)}return this};this.texClear=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.texClear(h,g,p,n,l,k)}return this};this.rotate=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.rotate(h,g,p,n,l,k)}return this};this.rotateMiddle=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.rotateMiddle(h,g,p,n,l,k)}return this};this.rotVBegin=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.rotVBegin(h,g,p,n,l,k)}return this};this.rotVEnd=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.rotVEnd(h,g,p,n,l,k)}return this};this.rotatePart=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.rotatePart(h,g,p,n,l,k)}return this};this.foreground=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.foreground(h,g,p,n,l,k)}return this};this.visatend=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.visatend(h,g,p,n,l,k)}return this};this.visAtEnd=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.visAtEnd(h,g,p,n,l,k)}return this};this.opacityatend=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.opacityatend(h,g,p,n,l,k)}return this};this.opacityAtEnd=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.opacityAtEnd(h,g,p,n,l,k)}return this};this.showafter=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.showafter(h,g,p,n,l,k)}return this};this.showbefore=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.showbefore(h,g,p,n,l,k)}return this};this.showAfter=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.showAfter(h,g,p,n,l,k)}return this};this.showBefore=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.showBefore(h,g,p,n,l,k)}return this};this.visFinal=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.visFinal(h,g,p,n,l,k)}return this};this.opacityFinal=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.opacityFinal(h,g,p,n,l,k)}return this};this.posZ=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.posZ(h,g,p,n,l,k)}return this};this.resizeZ=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.resizeZ(h,g,p,n,l,k)}return this};this.flyIn=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.flyIn(h,g,p,n,l,k)}return this};this.flyOut=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.flyOut(h,g,p,n,l,k)}return this};this.from=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.from(h,g,p,n,l,k)}return this};this.to=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.to(h,g,p,n,l,k)}return this};this.position=this.pos=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.position(h,g,p,n,l,k)}return this};this.restrict=this.clip=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clip(h,g,p,n,l,k)}return this};this.clipFrom=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clipFrom(h,g,p,n,l,k)}return this};this.clipTo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clipTo(h,g,p,n,l,k)}return this};this.clipT=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clipT(h,g,p,n,l,k)}return this};this.clipTFrom=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clipTFrom(h,g,p,n,l,k)}return this};this.clipTTo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clipTTo(h,g,p,n,l,k)}return this};this.clipR=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clipR(h,g,p,n,l,k)}return this};this.clipRFrom=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clipRFrom(h,g,p,n,l,k)}return this};this.clipRTo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.clipRTo(h,g,p,n,l,k)}return this};this.mapR=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.mapR(h,g,p,n,l,k)}return this};this.mapRFrom=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.mapRFrom(h,g,p,n,l,k)}return this};this.mapRTo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.mapRTo(h,g,p,n,l,k)}return this};this.depth=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.depth(h,g,p,n,l,k)}return this};this.resize=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.resize(h,g,p,n,l,k)}return this};this.starttime=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.starttime(h,g,p,n,l,k)}return this};this.startTime=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.startTime(h,g,p,n,l,k)}return this};this.duration=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.duration(h,g,p,n,l,k)}return this};this.dur=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.dur(h,g,p,n,l,k)}return this};this.flyHome=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.flyHome(h,g,p,n,l,k)}return this};this.color=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.color(h,g,p,n,l,k)}return this};this.bgColor=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.bgColor(h,g,p,n,l,k)}return this};this.shadowOnly=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.shadowOnly(h,g,p,n,l,k)}return this};this.castShadow=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.castShadow(h,g,p,n,l,k)}return this};this.lightAmbDiff=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.lightAmbDiff(h,g,p,n,l,k)}return this};this.lightBgAmbDiff=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.lightBgAmbDiff(h,g,p,n,l,k)}return this};this.specLight=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.specLight(h,g,p,n,l,k)}return this};this.material=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.material(h,g,p,n,l,k)}return this};this.blend=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.blend(h,g,p,n,l,k)}return this};this.acceleration=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.acceleration(h,g,p,n,l,k)}return this};this.vEnd=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.vEnd(h,g,p,n,l,k)}return this};this.vBegin=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.vBegin(h,g,p,n,l,k)}return this};this.scalarAcceleration=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.scalarAcceleration(h,g,p,n,l,k)}return this};this.until=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.until(h,g,p,n,l,k)}return this};this.untilEo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.untilEo(h,g,p,n,l,k)}return this};this.untilBo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.untilBo(h,g,p,n,l,k)}return this};this.untilaLEo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.untilaLEo(h,g,p,n,l,k)}return this};this.untilaMEo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.untilaMEo(h,g,p,n,l,k)}return this};this.untilaLBo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.untilalBo(h,g,p,n,l,k)}return this};this.untilaMBo=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.untilaMBo(h,g,p,n,l,k)}return this};this.LQCanvas=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.LQCanvas(h,g,p,n,l,k)}return this};this.NQCanvas=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.NQCanvas(h,g,p,n,l,k)}return this};this.map=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.map(h,g,p,n,l,k)}return this};this.mapScale=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.mapScale(h,g,p,n,l,k)}return this};this.mapRelative=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.mapRelative(h,g,p,n,l,k)}return this};this.copyTiming=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.copyTiming(h,g,p,n,l,k)}return this};this.copyMotion=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.copyMotion(h,g,p,n,l,k)}return this};this.copyMotion=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);m.copyMotion(h,g,p,n,l,k)}return this};this.opacity3D=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);if(m.opacity3D){m.opacity3D(h,g,p,n,l,k)}}return this};this.appendBuffer=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);if(m.appendBuffer){m.appendBuffer(h,g,p,n,l,k)}}return this};this.startScroll=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);if(m.startScroll){m.startScroll(h,g,p,n,l,k)}}return this};this.absStartScroll=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);if(m.absStartScroll){m.absStartScroll(h,g,p,n,l,k)}}return this};this.freeze=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);if(m.distance){m.freeze(h,g,p,n,l,k)}}return this};this.distance=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);if(m.distance){m.distance(h,g,p,n,l,k)}}return this};this.eye=function(h,g,p,n,l,k){var j;for(j=0;j<this.ar.length;j++){var m=(this.ar[j]);if(m.distance){m.eye(h,g,p,n,l,k)}}return this};this.selVisible=function(){var c=Array(0);var a;for(a=0;a<this.ar.length;a++){var b=getComputedStyle(this.ar[a].el);if(b.visibility=="visible"){c.push(this.ar[a])}}return new taccglMultiIntClone(c)};this.getI=function(a){if(a<0||a>=this.ar.length){return null}return this.ar[a]};this.length=function(){return this.ar.length};this.mp=function(e,g){var c;for(c=0;c<this.ar.length;c++){var b=this.ar[c];e(b,c,g,this)}return this};this.select=function(g,h){var e=Array(0);var c;for(c=0;c<this.ar.length;c++){var b=this.ar[c];if(g(b,c,h,this)){e.push(b)}}return new taccglMultiIntClone(e)};this.selModulo=function(b,h,e){var g=Array(0);var d;if(!h){h=0}if(!e){e=h}for(d=0;d<this.ar.length;d++){var c=this.ar[d];if(h<=d%b&&d%b<=e){g.push(c)}}return new taccglMultiIntClone(g)};this.cont=function(){var d=Array(0);var c;for(c=0;c<this.ar.length;c++){var b=this.ar[c];d.push(b.cont())}return new taccglMultiIntClone(d)};this.clone=function(){var d=Array(0);var c;for(c=0;c<this.ar.length;c++){var b=this.ar[c];d.push(b.clone())}return new taccglMultiIntClone(d)};this.pclone=function(){var d=Array(0);var c;for(c=0;c<this.ar.length;c++){var b=this.ar[c];d.push(b.pclone())}return new taccglMultiIntClone(d)};this.pnclone=function(){var d=Array(0);var c;for(c=0;c<this.ar.length;c++){var b=this.ar[c];d.push(b.pnclone())}return new taccglMultiIntClone(d)};this.a=this.ma=function(d,c){if(!c){c=taccgl.taccglAnim}var b;if(typeof(c)=="object"){c.actorInit(d);b=c}else{b=new c(d)}this.ar.push(b);return this};this.mac=function(b,a){if(typeof(b)=="string"){var c=document.getElementById(b);if(!c){return this}}return this.ma(b,a)};this.add=this.mSingle=function(b){this.ar.push(b);return this};this.mClass=function(a,b){this.union(taccgl.mClass(a,b));return this};this.mName=function(a,b){this.union(taccgl.mName(a.k));return this};this.mTagName=function(a,b){this.union(taccgl.mTagName(a.k));return this};this.union=function(a){this.ar=this.ar.concat(a.ar);return this};this.sequence=function(j,f){if(!f){f=0}var k=this.ar.length,e;var h=(j-(k-1)*f)/k,c=this.ar[0].basetime;for(e=0;e<this.ar.length;e++){var b=this.ar[e];b.dur(h);b.absStartTime(c+e*(h+f))}return this};this.sliceV=function(e,l,u,m){if(!l){l=0}if(!u){u=0}if(!m){m=1}var c=Array(0);var k,h;for(k=0;k<this.ar.length;k++){var q=this.ar[k],p,o;if(typeof(q.wp0)!="number"){q.wp0=q.wp1=q.w;q.wq0=q.wq1=0;q.hq0=q.hq1=q.h;q.hp0=q.hp1=0;q.p0=q.p1=q.x;q.q0=q.q1=q.y}if(m==1){o=e}else{o=(1-Math.pow(m,e))/(1-m)}var t=(q.wp0-l*(e-1))/o-e*u/2+u/2;for(h=0;h<e;h++){if(h!=e-1){p=q.clone()}else{p=q}if(m==1){p.clip(q.p0+h*(t+l)+h*(h-1)/2*u,q.q0,t+u*h,q.hq0)}else{p.clip(q.p0+t*(1-Math.pow(m,h))/(1-m)+h*l+h*(h-1)/2*u,q.q0,Math.pow(m,h)*t+u*h,q.hq0)}c.push(p)}}this.ar=c;return this};this.sliceH=function(e,l,u,m){if(!l){l=0}if(!u){u=0}if(!m){m=1}var c=Array(0),k,h;for(k=0;k<this.ar.length;k++){var q=this.ar[k],p,o;if(typeof(q.wp0)!="number"){q.wp0=q.wp1=q.w;q.wq0=q.wq1=0;q.hq0=q.hq1=q.h;q.hp0=q.hp1=0;q.p0=q.p1=q.x;q.q0=q.q1=q.y}if(m==1){o=e}else{o=(1-Math.pow(m,e))/(1-m)}var t=(q.hq0-l*(e-1))/o-e*u/2+u/2;for(h=0;h<e;h++){if(h!=e-1){p=q.clone()}else{p=q}if(m==1){p.clip(q.p0,q.q0+h*(t+l)+h*(h-1)/2*u,q.wp0,t+u*h)}else{p.clip(q.p0,q.q0+t*(1-Math.pow(m,h))/(1-m)+h*l+h*(h-1)/2*u,q.wp0,Math.pow(m,h)*t+u*h)}c.push(p)}}this.ar=c;return this};this.mult=function(l){var h=Array(0),g,f;for(g=0;g<this.ar.length;g++){var e=this.ar[g],c,k;for(f=0;f<l;f++){if(f!=l-1){c=e.clone()}else{c=e}h.push(c)}}this.ar=h;return this};return this}function taccglMultiEmpty(){this.ar=Array(0);return this}function taccglMultiElement(a){this.ar=Array(1);this.ar[0]=a;return this}function taccglMultiSet(c,a){var b;this.ar=Array(c.length);if(!taccgl.cv){taccgl.begin()}if(!a){a=taccgl.taccglAnim}for(b=0;b<c.length;b++){this.ar[b]=new a(c[b])}return this}function taccglMultiIntClone(a){this.ar=a;return this}taccglMultiEmpty.prototype=taccglMultiElement.prototype=taccglMultiSet.prototype=taccglMultiIntClone.prototype=new taccglMultiPrototype();function taccglMaterialPrototype(){var a=taccgl.taccglAnim.prototype;this.applyToAnim=a.applyToAnim;this.blend=a.blend;this.color=a.color;this.bgColor=a.bgColor;this.lightAmbDiff=a.lightAmbDiff;this.lightBgAmbDiff=a.lightBgAmbDiff;this.specLight=a.specLight;this.mapElement=a.mapElement;this.map=a.map;this.mapScale=a.mapScale;this.map1=a.map1;this.mapA=a.mapA;this.mapTo=a.mapTo;this.mapFrom=a.mapFrom;this.mapT=a.mapT;this.mapTTo=a.mapTTo;this.mapTFrom=a.mapTFrom;this.mapActor=a.mapActor;this.mapMirrorY=a.mapMirrorY;this.mapMirrorX=a.mapMirrorX;this.mapTurn=a.mapTurn;this.mapClip=a.mapClip;this.mapClip=a.mapRelative;this.setCanvas=a.setCanvas;this.alloc=a.alloc;this.paint=a.paint}function taccglMaterial(){this.curface=this;this.flags=0;this.lightSpecular=taccgl.lightSpecular;this.lightShininess=taccgl.lightShininess;this.col0s=this.col0t=this.col1s=this.col1t=-128*256;this.mix1=this.mix0=1;this.mixs0=this.mixs1=0;this.docolor=true;this.flags|=16;this.defTexCan=1;this.colkind=null;this.doSpecLight=false;return this}taccglMaterial.prototype=new taccglMaterialPrototype();taccgl.material=function(){return new taccglMaterial()};function taccglLightSourcePrototype(){this.setPos=function(a,c,b){this.x=a;this.y=c;this.z=b;taccgl.adjustShcvp()};this.setPosI=function(a,c,b){this.x=a;this.y=c;this.z=b};this.setShadowZRange=function(b,a){this.zBack=a;this.zFront=b;this.adjustShcvp()};this.setFocus=function(a){this.focus=a};this.parallaxPos=function(c,b,a,e,d){if(a==null){a=this.x}if(e==null){e=this.y}if(d==null){d=this.z}this.plxfx=c;this.plxfy=b;this.plxx=a;this.plxy=e;this.plxz=d;taccgl.parallaxAdjust()}}function taccglLightSource(){this.x=-200;this.y=-200;this.z=5000;this.focus=1;return this}taccglLightSource.prototype=new taccglLightSourcePrototype();taccgl.lightSource=function(){return new taccglLightSource()};function taccglEyePrototype(){this.setDefault=function(a,c,b){this.ox=0;this.oy=500;this.setPos(0,0,5000)};this.intSetPos=function(a,c,b){this.eyeX=a;this.eyeY=c;this.eyeZ=b;if(taccgl.stdEye==this&&taccgl.stdsc&&taccgl.stdsc.sp&&taccgl.stdsc.sp.useuEye==false){taccgl.createShaders();taccgl.adjustQuality()}this.ddfx=-(a-this.ox)/b;this.ddfy=-(c-this.oy)/b;return this};this.setPos=function(a,c,b){this.plxx=this.plxy=this.plxz=this.plxfx=this.plxfy=null;this.intSetPos(a,c,b);return this};this.parallaxAdjust=function(){if(this.plxfx||this.plxfy){this.intSetPos(this.plxx+this.plxfx*taccgl.o_sl,this.plxy+taccgl.o_st*this.plxfy,this.plxz)}return this};this.calcPos=function(b,a){return[this.plxx+this.plxfx*b,this.plxy+a*this.plxfy,this.plxz]};this.setOrigin=function(a,b){this.ox=a;this.oy=b;if(taccgl.ddmode){this.ddfx=-(this.eyeX-this.ox)/this.eyeZ;this.ddfy=-(this.eyeY-this.oy)/this.eyeZ}return this};this.parallax=function(c,b,a,e,d){if(!taccgl.initialized){taccgl.begin()}if(a==null){if(this.plxx||this.plxx==0){a=this.plxx}else{a=this.eyeX}}if(e==null){if(this.plxy||this.plxy==0){e=this.plxy}else{e=this.eyeY}}if(d==null){if(this.plxz||this.plxz==0){d=this.plxz}else{d=this.eyeZ}}this.plxfx=c;this.plxfy=b;this.plxx=a;this.plxy=e;this.plxz=d;taccgl.parallaxAdjust();return this};this.clone=function(){return new taccglEye(this)}}function taccglEye(a){if(a){this.eyeX=a.eyeX;this.eyeY=a.eyeY;this.eyeZ=a.eyeZ;this.ox=a.ox;this.oy=a.oy;this.oz=a.oy;if(a.plxz){this.plxfx=a.plxfx;this.plxfy=a.plxfy;this.plxx=a.plxx;this.plxy=a.plxy;this.plxz=a.plxz}taccgl.eyePositions.push(this)}else{this.setDefault();taccgl.eyePositions.push(this)}return this}function taccglTextureAtlasPrototype(){this.init=function(){this.bins=Array(0);this.delno=1};this.addBin=function(c,a,b){this.bins.push({id:c,w:a,h:b,blocks:Array(0),points:[{x:0,y:0}]})};this.clear=function(){var a;for(a=0;a<this.bins.length;a++){this.bins[a].blocks=Array(0);this.bins[a].points=[{x:0,y:0}]}this.delno++};this.allocInBin=function(d,n,g,o){var l=this.bins[o];var f=0;var k=null;while(f<l.points.length){var c=l.points[f];if(c.x+n<=l.w&&c.y+g<=l.h){var e=0;while(e<l.blocks.length){var m=l.blocks[e];if(c.x+n>m.x&&c.x<m.x+m.w&&c.y+g>m.y&&c.y<m.y+m.h){break}e++}if(e>=l.blocks.length){k={x:c.x,y:c.y,w:n,h:g,id:d,t:l.id,delno:this.delno};l.blocks.push(k);l.points.push({x:c.x,y:c.y+g});c.x+=n;break}}f++}return k};this.alloc=function(f,c,e){var d=0;while(d<this.bins.length){var b=this.allocInBin(f,c,e,d);if(b){return b}d++}return null}}function taccglTextureAtlas(){this.init();return this}taccglTextureAtlas.prototype=new taccglTextureAtlasPrototype();taccgl.textureAtlas=function(){return new taccglTextureAtlas()};function taccgl_opaqueShadow(j){var e=taccgl.g;var d=taccgl,a=d.pr;e.bindFramebuffer(e.FRAMEBUFFER,d.shadowfb);e.viewport(0,0,2048,2048);e.disable(e.BLEND);e.clearColor(1,1,1,1);e.clear(e.COLOR_BUFFER_BIT|e.DEPTH_BUFFER_BIT);var i;for(i=0;i<d.draw_shprognumber;i++){var h=d.shprogfromRun[i],c;if(i<d.draw_shprognumber-1){c=d.shprogfromRun[i+1]-h}else{c=d.draw_vertexnumber-h}var f=d.shprogRun[i],b=f.shadowP;if(b){e.useProgram(b);e.uniform4f(f.shadowLoc.uTime,j,taccgl.o_st,0,0);if(taccgl_looperrcheck){if((taccgl.glerr=e.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on uniform1f ")}}e.uniform4f(f.shadowLoc.shcvp,d.shcvpx,d.shcvpy,2/d.shcvpw,2/d.shcvph);if(taccgl_looperrcheck){if((taccgl.glerr=e.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on uniform4f ")}}e.uniform1i(f.shadowLoc.uTexture,0);if(taccgl_looperrcheck){if((taccgl.glerr=e.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on unifomli")}}e.uniform1i(f.shadowLoc.uTexture2,1);if(taccgl_looperrcheck){if((taccgl.glerr=e.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on unifomli")}}if(f.shadowPassUniforms){f.shadowPassUniforms()}e.drawArrays(e.TRIANGLES,h,c);if(taccgl_looperrcheck){if((taccgl.glerr=e.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on drawArrays in opaqueShadow")}}}}e.enable(e.BLEND);e.bindFramebuffer(e.FRAMEBUFFER,null);var a=d.pr;e.viewport(0,0,e.drawingBufferWidth,e.drawingBufferHeight)}var taccgl_breakframe=-100000;function taccgl_draw3d(q){var v=null;var i=1;var h=taccgl,u=h.g,z;if(taccgl.drawConsoleTime){console.time("PreDraw3d")}if(h.pendingResizeBody){h.resizeBody();h.pendingResizeBody=false}if(window.devicePixelRatio&&h.prevDpr!=window.devicePixelRatio){if(taccgl.onDprChange()){return}}if(taccgl_drawerrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on start of draw3d ");h.drawImmediateTerm(25);return}}if(window.performance&&window.performance.now){v=window.performance.now()}else{v=new Date().getTime()}var n=(v-h.draw_startTime)/h.draw_duration;h.currenttime=n;var D=false;while(n>h.doat[h.doatI].attime){D=h.doat[h.doatI].doPreDraw(h.doatI)||D;if(h.doatI>=h.doat.length){break}}if(D){h.drawTerminated();h.doHook(h.onTerm);return}h.draw_frames++;if(h.draw_meaIgnore-->0&&h.draw_meaFrames>=0){h.draw_meaAdjust+=v-h.meaA[h.draw_meaFrames%h.meaAS]-17}h.draw_meaFrames++;h.meaA[h.draw_meaFrames%h.meaAS]=v;h.meaAA[h.draw_meaFrames%h.meaAS]=v-h.draw_meaAdjust;var E=taccgl.extTimer,p=null,x=10000000000;if(!taccgl.evaluateGPUTimer()){E=null}if(taccgl_use_disjoint_timer_query){p=h.etGPUTime;x=h.etGPUTimeLag}var B,C,j,l=taccgl_tfr[h.quality],d=60/l;if(h.draw_meaFrames<=0){h.draw_meaTime=v;j=30;B=0}else{B=(v-h.draw_meaTime-h.draw_meaAdjust)/h.draw_duration;var y=240;if(h.draw_meaFrames<=y){j=h.draw_meaFrames/B}else{j=(y*1000/(h.meaA[(h.draw_meaFrames)%h.meaAS]-h.meaA[(h.draw_meaFrames-y)%h.meaAS]))}}C=j*d;if(h.draw_frames==2){if((h.slowStartupFrames<4||h.loadTest===false&&(!(h.quality==h.hardFailQ-1&&n<0.02))||(h.loadTest>0)&&(C>50||h.draw_meaFrames<=2))&&h.slowStartupTime<1000&&x>h.slowStartupFrames-4){if(h.loadTest==false){if(h.slowStartupFrames>2&&n<0.02&&x>10000){if(h.quality<4){h.quality++;h.adjustQuality();h.draw_meaFrames=-2;h.draw_meaAdjust=0;h.draw_meaIgnore=0}else{i=4;h.loadTest=6}}}else{i=4;h.loadTest--}h.slowStartupTime+=v-h.draw_startTime;h.slowStartupFrames+=1;h.draw_startTime=v;n=0;h.draw_frames=1;h.currenttime=0}else{if(x<=h.slowStartupFrames-4){var o=p,c;if(h.quality==1){o*=12}else{if(h.quality==2){o*=8}else{if(h.quality==3){o*=4}else{if(h.quality==4){o*=2}}}}if(o<10000){c=5}else{if(o<20000){c=4}else{if(o<40000){c=3}else{if(o<80000){c=2}else{c=1}}}}h.quality=c;h.adjustQuality();h.draw_meaFrames=-3;h.draw_meaAdjust=0;h.draw_meaIgnore=0;taccgl.resetGPUTimers()}else{if(h.quality==h.hardFailQ-1&&n<0.02){}else{if(h.loadTest===false&&C<30){h.quality=1;h.adjustQuality();h.draw_meaFrames=-3;h.draw_meaAdjust=0;h.draw_meaIgnore=0;taccgl.resetGPUTimers();h.loadTest=0}else{h.loadTest=false;if(C>54){h.quality=5;h.adjustQuality();h.draw_meaFrames=-3;h.draw_meaAdjust=0;h.draw_meaIgnore=0;taccgl.resetGPUTimers()}else{}}}}}}else{if((h.draw_frames>=2)&&((n>0.2*d&&(h.draw_meaFrames>10||B>1))||n<0.02*d)){if(C<taccgl_immediateStop&&h.quality==1){h.webglerror=true;h.drawImmediateTerm(26);return}if(C<25&&h.quality>1&&(x>h.draw_meaFrames||p>12000)){if(h.loadTestl>=0){h.draw_meaFrames=-3;h.draw_meaAdjust=0;h.draw_meaIgnore=0;taccgl.resetGPUTimers();h.loadTestl=-1}else{if((h.draw_meaFrames<5||5*d/(v-h.meaAA[(h.draw_meaFrames-5)%h.meaAS]-h.draw_meaAdjust)<0.025)&&(h.draw_meaFrames<2||2*d/(v-h.meaAA[(h.draw_meaFrames-2)%h.meaAS]-h.draw_meaAdjust)<0.025)){h.reduceQuality()}}}if(C>54&&h.quality<h.hardFailQ-1&&(h.epack||v-h.draw_lastSwitchTime>2000)&&(x>h.draw_meaFrames||p<7000)){if(x<=h.draw_meaFrames){h.quality++;h.adjustQuality();h.draw_lastSwitchTime=v;h.draw_meaFrames=-3;h.draw_meaAdjust=0;h.draw_meaIgnore=0;h.loadTestl=0;taccgl.resetGPUTimers()}else{if(h.loadTestl<-60){h.loadTestl=15}else{if(h.loadTestl>0&&h.loadTestl<2){if((h.draw_meaFrames<5||5*d/(v-h.meaA[(h.draw_meaFrames-5)%h.meaAS])>0.054)&&(h.draw_meaFrames<2||2*d/(v-h.meaA[(h.draw_meaFrames-2)%h.meaAS])>0.054)){h.quality++;h.adjustQuality();h.draw_lastSwitchTime=v;h.draw_meaFrames=-3;h.draw_meaAdjust=0;h.draw_meaIgnore=0;h.loadTestl=0;taccgl.resetGPUTimers()}}}}}if(C<51&&h.quality>2&&h.epack&&h.draw_meaFrames>20&&(x>h.draw_meaFrames||p>12000)){if(h.loadTestl>=0){h.draw_meaFrames=-3;h.draw_meaAdjust=0;h.draw_meaIgnore=0;h.loadTestl=-1;taccgl.resetGPUTimers()}else{if((h.draw_meaFrames<5||5/(v-h.meaAA[(h.draw_meaFrames-5)%h.meaAS]-h.draw_meaAdjust)<0.05*d)&&(h.draw_meaFrames<2||2/(v-h.meaAA[(h.draw_meaFrames-2)%h.meaAS]-h.draw_meaAdjust)<0.05*d)&&(h.draw_meaFrames<4||2/(h.meaAA[(h.draw_meaFrames-2)%h.meaAS]-h.meaAA[(h.draw_meaFrames-4)%h.meaAS])<0.05*d)&&(h.draw_meaFrames<6||2/(h.meaAA[(h.draw_meaFrames-4)%h.meaAS]-h.meaAA[(h.draw_meaFrames-6)%h.meaAS])<0.05*d)){h.reduceQuality()}}}if(h.loadTestl-->0){if(C>52){i=3}else{h.loadTestl=-1}}}}h.rAFdeviation+=n*60-Math.round(n*60);h.rAFcnt++;if(taccgl.drawConsoleTime){console.timeEnd("PreDraw3d")}if(taccgl.drawConsoleTimeStamp){console.timeStamp("Stamp "+h.quality+" "+i)}if(taccgl.drawConsoleTime){console.time("Draw "+h.quality+" "+i)}if(E){E.beginQueryEXT(E.TIME_ELAPSED_EXT,taccgl.eTimerAll);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on beginQueryEXT")}}}var w;if(h.shadowEna&&(h.quality>4||((i>1)&&(h.quality==4)))){for(w=0;w<i;w++){taccgl_opaqueShadow(n)}}if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on vertexAttribPointer draw3D before bindFramebuffer ")}}u.bindFramebuffer(u.FRAMEBUFFER,null);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on vertexAttribPointer draw3D bindFramebuffer ")}}u.clearColor(0,0,0,0);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on vertexAttribPointer draw3D clear ")}}h.doHook(taccgl.onBeforeDraw3D,n);var m;for(w=0;w<i*1;w++){if(w>0){u.clear(u.COLOR_BUFFER_BIT|u.DEPTH_BUFFER_BIT)}for(m=0;m<h.draw_shprognumber;m++){var A=h.shprogfromRun[m],s;if(m<h.draw_shprognumber-1){s=h.shprogfromRun[m+1]-A}else{s=h.draw_vertexnumber-A}var a=h.shprog[m],r=a.qp[h.quality];u.useProgram(r);var k=a.qLoc[h.quality];u.uniform4f(k.uTime,n,taccgl.o_st,0,0);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on uniform1f ")}}u.uniform4f(k.cvp,h.cvpx,h.cvpy,2/h.cvpw,2/h.cvph);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on uniform4f ")}}u.uniform1i(k.uTexture,0);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on unifomli")}}u.uniform1i(k.uTexture2,1);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on unifomli")}}if(a.passUniforms){a.passUniforms(k)}if(h.shadowEna){u.uniform1i(k.uShadowMap,2);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on unifomli")}}u.uniform4f(k.fshcvp,h.shcvpx,h.shcvpy,2/h.shcvpw,2/h.shcvph);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on unifoml4f fshcvp")}}}u.drawArrays(u.TRIANGLES,A,s)}if(i>1){if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){h.webglerror=true;h.drawImmediateTerm(27)}}}}if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){if(taccgl.glerr!=1285){taccgl.glError("Error "+taccgl.glerr+" on drawArrays")}}}if(E){E.endQueryEXT(E.TIME_ELAPSED_EXT,taccgl.eTimerAll);if(taccgl_looperrcheck){if((taccgl.glerr=u.getError())!=0){taccgl.glError("Error "+taccgl.glerr+" on endQueryEXT")}}}if(h.onAfterDraw){h.doHook(h.onAfterDraw)}if(E){taccgl.extTimerRunning=true;taccgl.loadFactor=i;taccgl.extTimerQuality=taccgl.quality}if(taccgl.drawConsoleTime){console.timeEnd("Draw "+h.quality+" "+i)}if(taccgl.drawConsoleTime){console.time("Draw glError")}if(taccgl.drawConsoleTime){console.timeEnd("Draw glError")}if(window.taccgl_requestAnimationFrame){h.reqAnimFrameId=taccgl_requestAnimationFrame(taccgl_draw3d)}}function taccgl_draw2d(O){var e=taccgl,aj=e.g,c=1,s=e.pr,aa=e.tpr;if(!e.draw_running){return}var L=null;if(window.performance&&window.performance.now){L=window.performance.now()}else{L=new Date().getTime()}var K=(L-e.draw_startTime)/e.draw_duration;if(e.quality<=2){s*=0.5}e.currenttime=K;var am=false,ag,an,V,H,R,Q,P;var w=document.getElementById("taccgl_textureCanvas");var r=document.getElementById("taccgl_textureCanvas2");while(K>e.doat[e.doatI].attime){am=e.doat[e.doatI].doPreDraw(e.doatI)||am;if(e.doatI>=e.doat.length){break}}if(am){e.drawTerminatedDD();e.doHook(e.onTerm);return}e.draw_frames++;if(e.draw_meaIgnore-->0&&e.draw_meaFrames>=0){e.draw_meaAdjust+=L-e.meaA[e.draw_meaFrames%e.meaAS]}e.draw_meaFrames++;e.meaA[e.draw_meaFrames%e.meaAS]=L;e.meaAA[e.draw_meaFrames%e.meaAS]=L-e.draw_meaAdjust;var d,S;if(e.draw_meaFrames<=0){e.draw_meaTime=L;S=30;d=0}else{d=(L-e.draw_meaTime-e.draw_meaAdjust)/e.draw_duration;S=e.draw_meaFrames/d}if(e.draw_frames==2){if((e.loadTest===false&&(!(e.quality==5&&K<0.02))||e.slowStartupFrames<4||(e.loadTest>0&&K>0.02))&&e.slowStartupTime<3000){if(e.loadTest==false){if(e.slowStartupFrames>2&&K<0.02){c=8;e.loadTest=6}}else{c=8;e.loadTest--}e.slowStartupTime+=L-e.draw_startTime;e.slowStartupFrames+=1;e.draw_startTime=e.draw_meaTime=L;K=0;e.draw_frames=1;e.draw_meaFrames=0;e.draw_meaAdjust=0;e.draw_meaIgnore=0}else{if(e.quality==5&&K<0.02){}else{if(e.loadTest===false){e.quality=1;e.adjustQuality();e.draw_meaFrames=-3;e.draw_meaAdjust=0;e.draw_meaIgnore=0;e.loadTest=0}else{e.loadTest=false;if(K<0.02){e.quality++;e.adjustQuality();e.draw_meaFrames=-3;e.draw_meaAdjust=0;e.draw_meaIgnore=0}else{}}}}}else{if((e.draw_frames>=2)&&((K>0.2&&(e.draw_meaFrames>10||d>1))||K<0.02||e.draw_frames==2)){if(S<taccgl_immediateStop&&e.quality==1){e.webglerror=true;e.drawImmediateTermDD(29);return}if(S<20&&e.quality>1){if((e.draw_meaFrames<5||5/(L-e.meaAA[(e.draw_meaFrames-5)%e.meaAS]-e.draw_meaAdjust)<0.02)&&(e.draw_meaFrames<2||2/(L-e.meaAA[(e.draw_meaFrames-2)%e.meaAS]-e.draw_meaAdjust)<0.02)){if(e.draw_meaFrames<60){if(e.quality<e.softFailQ){e.softFailQ=e.quality;e.softFailCnt=0}e.softFailCnt++;if(e.softFailCnt>1){e.hardFailQ=e.softFailQ}}e.quality--;e.draw_lastSwitchTime=L;e.adjustQuality();e.draw_meaFrames=-3;e.draw_meaAdjust=0;e.draw_meaIgnore=0}}if(S>50&&e.quality<e.hardFailQ-1&&(e.epack||L-e.draw_lastSwitchTime>2000)){if(e.loadTestl<-60){e.loadTestl=6}else{if(e.loadTestl>=0&&e.loadTestl<2){if((e.draw_meaFrames<5||5/(L-e.meaA[(e.draw_meaFrames-5)%e.meaAS])>0.05)&&(e.draw_meaFrames<2||2/(L-e.meaA[(e.draw_meaFrames-2)%e.meaAS])>0.05)){e.quality++;e.adjustQuality();e.draw_meaFrames=-3;e.draw_meaAdjust=0;e.draw_meaIgnore=0;e.loadTestl=0}}}}if(e.loadTestl-->0){c=8}if(S<30&&e.quality>2&&(e.epack||L-e.draw_lastSwitchTime>2000)&&e.draw_meaFrames>60){if((e.draw_meaFrames<5||5/(L-e.meaAA[(e.draw_meaFrames-5)%e.meaAS]-e.draw_meaAdjust)<0.03)&&(e.draw_meaFrames<2||2/(L-e.meaAA[(e.draw_meaFrames-2)%e.meaAS]-e.draw_meaAdjust)<0.03)){if(e.draw_meaFrames<60){if(e.quality<e.softFailQ){e.softFailQ=e.quality;e.softFailCnt=0}e.softFailCnt++;if(e.softFailCnt>1){e.hardFailQ=e.softFailQ}}e.quality--;e.draw_lastSwitchTime=L;e.adjustQuality();e.draw_meaFrames=-3;e.draw_meaAdjust=0;e.draw_meaIgnore=0}}}}for(var u=0;u<c;u++){aj.clearRect(0,0,e.cv.width,e.cv.height);ag=0;while(ag<e.AAstartedLength){an=e.AA[ag];var A=an.flags;var D=K;if(an.flags>65535){D=taccgl.o_st}V=H=(D-an.basetime)/an.vduration;if(V<0){V=0;if((A&1)==0){ag++;continue}}if(V>1){V=1;if((A&2)==0){ag++;continue}}var al=1-V;var U=an.veye?an.veye:e.stdEye;if((!an.rotation)&&!an.face&&an.wy0==0&&an.wz0==0&&an.hx0==0&&an.hz0==0&&an.wy1==0&&an.wz1==0&&an.hx1==0&&an.hz1==0){var q=an.wx0*al+an.wx1*V,h=an.hy0*al+an.hy1*V;R=an.x0*al+an.x1*V-0.5*V*al*an.ax;Q=an.y0*al+an.y1*V-0.5*V*al*an.ay;P=an.z0*al+an.z1*V-0.5*V*al*an.az;R=R+U.ddfx*P;Q=Q+U.ddfy*P;if(q>0&&h>0){if(A&128){aj.globalAlpha=1;aj.clearRect((R-e.canvasX)*s,(Q-e.canvasY)*s,q*s,h*s)}else{if(an.docolor){if((al>0)&&an.ddcolor0){aj.fillStyle=an.ddcolor0;aj.globalAlpha=1;aj.fillRect((R-e.canvasX)*s,(Q-e.canvasY)*s,q*s,h*s)}if((V>0)&&an.ddcolor1){aj.fillStyle=an.ddcolor1;aj.globalAlpha=V;aj.fillRect((R-e.canvasX)*s,(Q-e.canvasY)*s,q*s,h*s)}var M=(1-V)*an.mix0+V*an.mix1;if(M>0){aj.globalAlpha=M;aj.drawImage(w,(an.s0*al+an.s1*V)*aa,(an.t0*al+an.t1*V)*aa,(an.ws0*al+an.ws1*V)*aa,(an.ht0*al+an.ht1*V)*aa,(R-e.canvasX)*s,(Q-e.canvasY)*s,q*s,h*s)}var N=(1-V)*an.mixs0+V*an.mixs1;if(N>0){aj.globalAlpha=N;aj.drawImage(r,(an.s0*al+an.s1*V)*aa,(an.t0*al+an.t1*V)*aa,(an.ws0*al+an.ws1*V)*aa,(an.ht0*al+an.ht1*V)*aa,(R-e.canvasX)*s,(Q-e.canvasY)*s,q*s,h*s)}}else{aj.globalAlpha=1;aj.drawImage(w,(an.s0*al+an.s1*V)*aa,(an.t0*al+an.t1*V)*aa,(an.ws0*al+an.ws1*V)*aa,(an.ht0*al+an.ht1*V)*aa,(R-e.canvasX)*s,(Q-e.canvasY)*s,q*s,h*s)}}}}else{aj.save();var Y=an.hx0*al+an.hx1*V,X=an.hy0*al+an.hy1*V,W=an.hz0*al+an.hz1*V,ai=an.wx0*al+an.wx1*V,ah=an.wy0*al+an.wy1*V,af=an.wz0*al+an.wz1*V,n=an.dx0*al+an.dx1*V,l=an.dy0*al+an.dy1*V,k=an.dz0*al+an.dz1*V;if(an.rotation){var ac=an.rotfrom*al+an.rotto*V;var G,F,E,ad,ab,Z;an.calcRotation(ac,an.x1,an.y1,an.z1);G=an.resx;F=an.resy;E=an.resz;ad=an.x0*al+an.x1*V-0.5*V*al*an.ax-an.x1+G;ab=an.y0*al+an.y1*V-0.5*V*al*an.ay-an.y1+F;Z=an.z0*al+an.z1*V-0.5*V*al*an.az-an.z1+E;an.calcRotation(ac,an.x1+an.hx1,an.y1+an.hy1,an.z1+an.hz1);G=an.resx;F=an.resy;E=an.resz;Y=an.x0*al+an.x1*V-0.5*V*al*an.ax-an.x1+G-ad;X=an.y0*al+an.y1*V-0.5*V*al*an.ay-an.y1+F-ab;W=an.z0*al+an.z1*V-0.5*V*al*an.az-an.z1+E-Z;an.calcRotation(ac,an.x1+an.wx1,an.y1+an.wy1,an.z1+an.wz1);G=an.resx;F=an.resy;E=an.resz;ai=an.x0*al+an.x1*V-0.5*V*al*an.ax-an.x1+G-ad;ah=an.y0*al+an.y1*V-0.5*V*al*an.ay-an.y1+F-ab;af=an.z0*al+an.z1*V-0.5*V*al*an.az-an.z1+E-Z;an.calcRotation(ac,an.x1+an.dx1,an.y1+an.dy1,an.z1+an.dz1);G=an.resx;F=an.resy;E=an.resz;n=an.x0*al+an.x1*V-0.5*V*al*an.ax-an.x1+G-ad;l=an.y0*al+an.y1*V-0.5*V*al*an.ay-an.y1+F-ab;k=an.z0*al+an.z1*V-0.5*V*al*an.az-an.z1+E-Z;R=ad;Q=ab;P=Z}else{R=an.x0*al+an.x1*V-0.5*V*al*an.ax;Q=an.y0*al+an.y1*V-0.5*V*al*an.ay;P=an.z0*al+an.z1*V-0.5*V*al*an.az}R=R+U.ddfx*P;Q=Q+U.ddfy*P;Y=Y+U.ddfx*W;X=X+U.ddfy*W;ai=ai+U.ddfx*af;ah=ah+U.ddfy*af;n=n+U.ddfx*k;l=l+U.ddfy*k;aj.setTransform(ai/4096*s,ah/4096*s,Y/4096*s,X/4096*s,(R-e.canvasX)*s,(Q-e.canvasY)*s);if(!an.face){if(an.docolor){if((al>0)&&an.ddcolor0){aj.fillStyle=an.ddcolor0;aj.globalAlpha=1;aj.fillRect(0,0,4096,4096)}if((V>0)&&an.ddcolor1){aj.fillStyle=an.ddcolor1;aj.globalAlpha=V;aj.fillRect(0,0,4096,4096)}M=(1-V)*an.mix0+V*an.mix1;if(M>0){aj.globalAlpha=M;aj.drawImage(w,(an.s0*al+an.s1*V)*aa,(an.t0*al+an.t1*V)*aa,(an.ws0*al+an.ws1*V)*aa,(an.ht0*al+an.ht1*V)*aa,0,0,4096,4096)}N=(1-V)*an.mixs0+V*an.mixs1;if(N>0){aj.globalAlpha=N;aj.drawImage(r,(an.s0*al+an.s1*V)*aa,(an.t0*al+an.t1*V)*aa,(an.ws0*al+an.ws1*V)*aa,(an.ht0*al+an.ht1*V)*aa,0,0,4096,4096)}}else{aj.globalAlpha=1;aj.drawImage(w,(an.s0*al+an.s1*V)*aa,(an.t0*al+an.t1*V)*aa,(an.ws0*al+an.ws1*V)*aa,(an.ht0*al+an.ht1*V)*aa,0,0,4096,4096)}}else{var ae,ak,v=Array(an.face.length),C=Array(an.face.length);for(ae=0;ae<an.face.length;ae++){ak=an.face[ae];var T=P,B=P+af*ak.xtr+W*ak.ytr+k*ak.ztr,m=P+af*ak.xbl+W*ak.ybl+k*ak.zbl,J=(T+B+m)/3;v[ae]=-J;C[ae]=ak}var p=false;while(!p){p=true;for(ae=1;ae<C.length;ae++){if(v[ae-1]<v[ae]){var I;I=v[ae];v[ae]=v[ae-1];v[ae-1]=I;I=C[ae];C[ae]=C[ae-1];C[ae-1]=I;p=false}}}for(ae=0;ae<an.face.length;ae++){ak=C[ae];aj.setTransform((ai/4096*(ak.xtr-ak.xtl)+Y/4096*(ak.ytr-ak.ytl)+n/4096*(ak.ztr-ak.ztl))*s,(ah/4096*(ak.xtr-ak.xtl)+X/4096*(ak.ytr-ak.ytl)+l/4096*(ak.ztr-ak.ztl))*s,(ai/4096*(ak.xbl-ak.xtl)+Y/4096*(ak.ybl-ak.ytl)+n/4096*(ak.zbl-ak.ztl))*s,(ah/4096*(ak.xbl-ak.xtl)+X/4096*(ak.ybl-ak.ytl)+l/4096*(ak.zbl-ak.ztl))*s,(R+ai*ak.xtl+Y*ak.ytl+n*ak.ztl-e.canvasX)*s,(Q+ah*ak.xtl+X*ak.ytl+l*ak.ztl-e.canvasY)*s);if(ak.docolor){if((al>0)&&ak.ddcolor0){aj.fillStyle=ak.ddcolor0;aj.globalAlpha=1;aj.fillRect(0,0,4096,4096)}if((V>0)&&ak.ddcolor1){aj.fillStyle=ak.ddcolor1;aj.globalAlpha=V;aj.fillRect(0,0,4096,4096)}M=(1-V)*ak.mix0+V*ak.mix1;if(M>0){aj.globalAlpha=M;aj.drawImage(w,aa*(ak.s0*al+ak.s1*V),aa*(ak.t0*al+ak.t1*V),aa*(ak.ws0*al+ak.ws1*V),aa*(ak.ht0*al+ak.ht1*V),0,0,4096,4096)}N=(1-V)*ak.mixs0+V*ak.mixs1;if(N>0){aj.globalAlpha=N;aj.drawImage(r,aa*(ak.s0*al+ak.s1*V),aa*(ak.t0*al+ak.t1*V),aa*(ak.ws0*al+ak.ws1*V),aa*(ak.ht0*al+ak.ht1*V),0,0,4096,4096)}}else{aj.globalAlpha=1;aj.drawImage(w,aa*(ak.s0*al+ak.s1*V),aa*(ak.t0*al+ak.t1*V),aa*(ak.ws0*al+ak.ws1*V),aa*(ak.ht0*al+ak.ht1*V),0,0,4096,4096)}}}aj.restore()}ag++}}if(window.taccgl_requestAnimationFrame){e.reqAnimFrameId=taccgl_requestAnimationFrame(taccgl_draw2d)}}function taccglObjFile(){this.onload=this.onreadystatechange=null;this.vready="init";this.verror=false;this.loadmtl=true;this.read=function(a,c,f){if(f){this.onload=f}this.faces=Array(0);if(!taccgl.dddmode){this.vready=this.verror="ddmode";this.mtl=new taccglMtlFile();this.mtl.vready=this.mtl.verror="ddmode";var b=this;setTimeout(function(){taccgl.doHook(b.onload,b)},1);return this}if(!c){c=false}if(window.taccgl_nocache){var d=new Date().getTime();a+="?t="+d}this.url=a;this.req=null;if(window.taccgl_activeX!=false&&!a.match(/^http:/)){if("ActiveXObject" in window){this.req=new ActiveXObject("MSXML2.XMLHTTP.6.0")}}if(!this.req){this.req=new XMLHttpRequest()}this.req.open("GET",a,c);this.vready="loading";if(c){var e=this;this.req.onreadystatechange=function(){e.readyStateChange()}}this.req.send();if(!c){this.processRequest(this.req);if(this.vready=="ready"&&this.loadmtl){this.mtl=new taccglMtlFile();this.mtl.read(this.mtlurl(),c)}}return this};this.ready=function(){return this.vready};this.error=function(){return this.verror};this.mtlurl=function(){if(/\//.test(this.url)){return(this.url.replace(/^(.*)\/([^\/]+)$/,"$1/"+this.mtllib))}else{return this.mtllib}};this.readyStateChange=function(){taccgl.doHook(this.onreadystatechange,this);if(this.req.readyState==4){this.processRequest(this.req);if(this.vready=="ready"&&this.loadmtl){this.mtl=new taccglMtlFile();this.mtl.obj=this;this.mtl.read(this.mtlurl(),true);this.vready="loading"}else{taccgl.doHook(this.onload,this)}}};this.initvb=function(a){this.vb=new ArrayBuffer(a);this.vf=new Float32Array(this.vb);this.vbsize=a};this.resizevb=function(){var a=this.vf,d=this.vbsize;this.initvb(2*d);var c,b=d/4;for(c=0;c<b;c++){this.vf[c]=a[c]}};this.initfb=function(a){this.fb=new ArrayBuffer(a);this.fi=new Int32Array(this.fb);this.fbsize=a};this.resizefb=function(){var d=this.fi,c=this.fbsize;this.initfb(2*c);var b,a=c/4;for(b=0;b<a;b++){this.fi[b]=d[b]}};this.initData=function(){var a=100;this.initvb(a);this.initfb(a);this.facesMaterial=Array(0);this.objects=new this.createObjects();this.currentObject=null};this.createObject=function(){};this.createObjects=function(){};this.processRequest=function(b){if(b.status!=200&&b.status!=0){this.vready="error";this.verror=b.statusText;return}this.initData();var c=0,w=0,u=0,m=0,l;var k=/(\#.*)|(mtllib .*)|(o .*)|(vt?n?) ([0-9.-]+) ([0-9.-]+)( ([0-9.-]*))?$|([0-9.-]+)|(usemtl .*)|(f .*)|(s .*)/gm;var o=/(\n)|([0-9-]+)(\/([0-9-]*)(\/([0-9-]+))?)?/g;var v,t;var j=b.responseText;while((v=k.exec(j))!=null){if(v[4]){var g=parseFloat(v[5]);var f=parseFloat(v[6]);var e=parseFloat(v[7]);if(v[4]=="v"){l=c*9;c++;f=-f}if(v[4]=="vt"){l=3+w*9;w++}if(v[4]=="vn"){l=6+u*9;u++;f=-f}if(4*l+12>=this.vbsize){this.resizevb()}this.vf[l]=g;this.vf[l+1]=f;this.vf[l+2]=e}if(v[11]){this.faces.push(m);this.facesMaterial.push(i);while((t=o.exec(v[11]))!=null&&t[1]==null){var d=parseInt(t[2]);var s=parseInt(t[4]);if(isNaN(s)){s=0}var h=parseInt(t[6]);if(isNaN(h)){h=0}if(12*m+12>=this.fbsize){this.resizefb()}this.fi[3*m]=d;if(d<0){alert("Cannot handle negative vertex index")}this.fi[3*m+1]=s;this.fi[3*m+2]=h;m++}}else{if(v[3]){var q=v[3].replace(/o /,"");if(this.currentObject){this.currentObject.endFace=this.faces.length-1;this.currentObject.endf=m;this.currentObject.endv=w;this.currentObject.endvn=u;this.currentObject.endvt=w}this.objects[q]=this.currentObject=new this.createObject();this.currentObject.startFace=this.faces.length;this.currentObject.bgf=m;this.currentObject.bgv=w;this.currentObject.bgvn=u;this.currentObject.bgvt=w}else{if(v[10]){var i=v[10].replace(/usemtl /,"")}else{if(v[2]){this.mtllib=v[2].replace(/mtllib /,"")}}}}if(k.lastIndex==0){return}}if(this.currentObject){this.currentObject.endFace=this.faces.length-1;this.currentObject.endf=m;this.currentObject.endv=w;this.currentObject.endvn=u;this.currentObject.endvt=w}this.faceNumber=m;this.vready="ready"};this.scene=function(){var b=new taccgl.DDDObject(this,true);return b};this.objs=function(c){var b=new taccgl.DDDObject(this,c);return b}}taccgl.objFile=function(){if(!this.initialized){this.begin()}var a=new taccglObjFile();return(a)};function taccglMtlFile(){this.onload=this.onreadystatechange=null;this.vready="init";this.verror=false;this.ready=function(){return this.vready};this.error=function(){return this.verror};this.read=function(a,b){if(!b){b=false}if(window.taccgl_nocache){var c=new Date().getTime();a+="?t="+c}this.req=null;if(window.taccgl_activeX!=false&&!a.match(/^http:/)){if("ActiveXObject" in window){this.req=new ActiveXObject("MSXML2.XMLHTTP.6.0")}}if(!this.req){this.req=new XMLHttpRequest()}this.req.open("GET",a,b);if(b){var d=this;this.req.onreadystatechange=function(){d.readyStateChange()}}this.req.send();if(!b){this.processRequest(this.req)}};this.readyStateChange=function(){taccgl.doHook(this.onreadystatechange,this);if(this.req.readyState==4){this.processRequest(this.req);var a=this.obj;if(a){a.vready=this.vready;taccgl.doHook(a.onload,a)}else{taccgl.doHook(this.onload,this)}}};this.initData=function(){this.materials=new this.createMaterials()};this.createMaterial=function(){};this.createMaterials=function(){};this.processRequest=function(j){if(j.status!=200&&j.status!=0){this.vready="error";this.verror=j.statusText;return}this.initData();var b=/(\#.*)|(newmtl .*)|(Ns .*)|(Ni .*)|(Ka?d?s?) ([0-9.-]+) ([0-9.-]+) ([0-9.-]+)|(d .*)|(illum .*)/g;var k,d,l;var h=false,g;while((k=b.exec(j.responseText))!=null){if(k[5]){var i=parseFloat(k[6]);var c=parseFloat(k[7]);var f=parseFloat(k[8]);if(k[5]=="Ka"){d.ambR=i;d.ambG=c;d.ambB=f;if(i>0||c>0||f>0){h=false}if((i<0.8||c<0.8||f<0.8)&&(i>0||c>0||f>0)){g=false}}if(k[5]=="Kd"){d.diffR=i;d.diffG=c;d.diffB=f}if(k[5]=="Ks"){d.specR=i;d.specG=c;d.specB=f}}else{if(k[3]){l=k[3].replace(/Ns /,"");d.Ns=parseFloat(l)}else{if(k[4]){l=k[4].replace(/Ni /,"");d.Ni=parseFloat(l)}else{if(k[2]){var e=k[2].replace(/newmtl /,"");d=new this.createMaterial();this.materials[e]=d}else{if(k[10]){l=k[10].replace(/illum /,"");d.illum=parseInt(l)}else{if(k[9]){l=k[9].replace(/d /,"");l=l.replace(/Tr /,"");d.transp=parseFloat(l)}else{if(k[1]){if(k[1].match(/Blender/)){h=g=true}}}}}}}}}this.vready="ready";if(h){this.ambientAdjust(0.6,0.6)}else{if(g){this.ambientAdjust(0.6,0.6,0)}}};this.defaultSpec=function(e,c,b){var d,a;if(!b){b=0}for(d in this.materials){a=this.materials[d];if(a.Ns<=b){a.Ns=c;a.specR=a.specB=a.specG=e}}};this.ambientAdjust=function(g,i,c,e){if(!i&&i!=0){i=1}if(!e&&e!=0){e=1}if(!c&&c!=0){c=1}var h,b;for(h in this.materials){b=this.materials[h];b.ambDiffc=g;b.diffc=i;b.specc=e;b.ambc=c}}}taccgl.mtlFile=function(a,b){var c=new taccglMtlFile();c.read(a,b);return(c)};function taccgl3DObjectPrototype(){this.initSuper=taccgl.taccglAnim.prototype.init;this.init=function(a){this.initSuper(a);this.objt=null;this.dz0=this.dz1=this.hy0;this.flags=16;this.docolor=true;this.col0s=-32768;this.col0t=-32768;this.col1s=-32768;this.col1t=-32768;this.mix0=1;this.mix1=1;this.mixs0=0;this.mixs1=0;this.dddo0=this.dddo1=1;this.materials=new this.createMaterials()};this.actorInit=function(a){this.init(a)};this.contInit=function(a){this.init(a)};this.createMaterials=function(){};this.getModMat=function(){if(!this.objt){this.objt=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]}return this.objt};this.setModMat=function(a){this.objt=a;return this};this.axisSet=function(e,g){var d=0,f=1;if(g=="x"){d=0}else{if(g=="y"){d=1}else{if(g=="z"){d=2}else{f=-1;if(g=="X"){d=0}else{if(g=="Y"){d=1}else{if(g=="Z"){d=2}}}}}}this.objt[4*e+d]=f};this.axis=function(a,b){if(!b){b=false}this.negNormal=b;this.objt=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1];this.axisSet(0,a[0]);this.axisSet(1,a[1]);this.axisSet(2,a[2]);return this};this.dMMVertex=function(d){var c=(d-1)*9;var a=this.ofi.vf[c];var e=this.ofi.vf[c+1];var b=this.ofi.vf[c+2];var i=this.objt;var h=a*i[0]+e*i[1]+b*i[2]+i[3];var g=a*i[4]+e*i[5]+b*i[6]+i[7];var f=a*i[8]+e*i[9]+b*i[10]+i[11];if(h<this.obj_xmin){this.obj_xmin=h}if(g<this.obj_ymin){this.obj_ymin=g}if(f<this.obj_zmin){this.obj_zmin=f}if(h>this.obj_xmax){this.obj_xmax=h}if(g>this.obj_ymax){this.obj_ymax=g}if(f>this.obj_zmax){this.obj_zmax=f}};this.dMMFace=function(c,b){var a;for(a=c;a<b;a++){this.dMMVertex(this.ofi.fi[3*a])}};this.dMMFaces=function(c,b){var a;for(a=c;a<=b;a++){var d;if(a<this.ofi.faces.length-1){d=this.ofi.faces[a+1]}else{d=this.ofi.faceNumber}this.dMMFace(this.ofi.faces[a],d)}};this.determineMinMax=function(a){this.obj_xmax=-1e+39;this.obj_ymax=-1e+39;this.obj_zmax=-1e+39;this.obj_xmin=1e+39;this.obj_ymin=1e+39;this.obj_zmin=1e+39;if(!a){a=this.selObjects}if(a==true){this.dMMFaces(0,this.ofi.faces.length-1)}else{var d=new RegExp(a);var c;for(c in this.ofi.objects){if(d.test(c)){var b=this.ofi.objects[c];this.dMMFaces(b.startFace,b.endFace)}}}};this.material=function(b,a){if(typeof(b)=="object"){b.applyToAnim(this)}else{this.materials[b]=a}return this};this.modAlign=function(a){this.objt=a.objt.slice(0);return this};this.makeFit=function(b,c,a){this.modFit(c,b,a);return this};this.modFit=function(e,c,a){if(!this.objt){this.objt=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]}if(!taccgl.dddmode){return this}if(!c){c="xyz"}this.determineMinMax(a);if(!e){this.objt=taccgl.mi44Mul([1/(this.obj_xmax-this.obj_xmin),0,0,-this.obj_xmin/(this.obj_xmax-this.obj_xmin),0,1/(this.obj_ymax-this.obj_ymin),0,-this.obj_ymin/(this.obj_ymax-this.obj_ymin),0,0,1/(this.obj_zmax-this.obj_zmin),-this.obj_zmin/(this.obj_zmax-this.obj_zmin),0,0,0,1],this.objt)}else{if(c.match(/x|X|y|Y|z|Z/)){var i=1e+39;var b;var d=Math.sqrt(this.hx0*this.hx0+this.hy0*this.hy0+this.hz0*this.hz0);var g=Math.sqrt(this.wx0*this.wx0+this.wy0*this.wy0+this.wz0*this.wz0);var f=Math.sqrt(this.dx0*this.dx0+this.dy0*this.dy0+this.dz0*this.dz0);if(c.match(/x|X/)){b=g/(this.obj_xmax-this.obj_xmin);if(b<i){i=b}}if(c.match(/y|Y/)){b=d/(this.obj_ymax-this.obj_ymin);if(b<i){i=b}}if(c.match(/z|Z/)){b=f/(this.obj_zmax-this.obj_zmin);if(b<i){i=b}}var h=[i/g,0,0,-this.obj_xmin*i/g,0,i/d,0,-this.obj_ymin*i/d,0,0,i/f,-this.obj_zmin*i/f,0,0,0,1];if(e.length<3){e+="   "}if(e[0].match(/r|b/)){b=(this.obj_xmax-this.obj_xmin)*i/g;h[3]+=1-b}else{if(e[0].match(/L|T/)){b=(this.obj_xmax-this.obj_xmin)*i/g;h[3]+=-b}else{if(e[0].match(/c/)){b=(this.obj_xmax-this.obj_xmin)*i/g;h[3]+=-b/2}else{if(e[0].match(/R|B/)){b=(this.obj_xmax-this.obj_xmin)*i/g;h[3]+=1}else{if(e[0].match(/m|M/)){b=(this.obj_xmax-this.obj_xmin)*i*0.5/g;h[3]+=0.5-b}else{if(e[0].match(/C/)){b=(this.obj_xmax-this.obj_xmin)*i*0.5/g;h[3]+=1-b}else{if(e[0].match(/s/)){h[3]=-this.obj_xmin/(this.obj_xmax-this.obj_xmin);h[0]=1/(this.obj_xmax-this.obj_xmin)}else{if(e[0].match(/S/)){h[3]=-this.obj_xmin/(this.obj_xmax-this.obj_xmin)-1;h[0]=1/(this.obj_xmax-this.obj_xmin)}}}}}}}}if(e[1].match(/r|b/)){b=(this.obj_ymax-this.obj_ymin)*i/d;h[7]+=1-b}else{if(e[1].match(/L|T/)){b=(this.obj_ymax-this.obj_ymin)*i/d;h[7]+=-b}else{if(e[1].match(/c/)){b=(this.obj_ymax-this.obj_ymin)*i/d;h[7]+=-b/2}else{if(e[1].match(/B/)){b=(this.obj_ymax-this.obj_ymin)*i*0.5/d;h[7]+=1}else{if(e[1].match(/m|M/)){b=(this.obj_ymax-this.obj_ymin)*i*0.5/d;h[7]+=0.5-b}else{if(e[1].match(/C/)){b=(this.obj_ymax-this.obj_ymin)*i*0.5/d;h[7]+=1-b}else{if(e[1].match(/s/)){h[7]=-this.obj_ymin/(this.obj_ymax-this.obj_ymin);h[5]=1/(this.obj_ymax-this.obj_ymin)}else{if(e[1].match(/S/)){h[7]=-this.obj_ymin/(this.obj_ymax-this.obj_ymin)-1;h[5]=1/(this.obj_xmax-this.obj_xmin)}}}}}}}}if(e[2].match(/b/)){b=(this.obj_zmax-this.obj_zmin)*i/f;h[11]+=0}else{if(e[2].match(/c/)){b=(this.obj_zmax-this.obj_zmin)*i/f;h[11]+=1-b/2}else{if(e[2].match(/F/)){b=(this.obj_zmax-this.obj_zmin)*i/f;h[11]+=1}else{if(e[2].match(/f/)){b=(this.obj_zmax-this.obj_zmin)*i/f;h[11]+=1-b}else{if(e[2].match(/m/)){b=(this.obj_zmax-this.obj_zmin)*i*0.5/f;h[11]+=0.5-b}else{if(e[2].match(/C/)){b=(this.obj_zmax-this.obj_zmin)*i*0.5/f;h[11]+=-b}else{if(e[2].match(/B/)){b=(this.obj_zmax-this.obj_zmin)*i/f;h[11]+=-b}else{if(e[2].match(/s/)){h[11]=-this.obj_zmin/(this.obj_zmax-this.obj_zmin);h[10]=1/(this.obj_zmax-this.obj_zmin)}else{if(e[2].match(/S/)){h[11]=-this.obj_zmin/(this.obj_zmax-this.obj_zmin)-1;h[10]=1/(this.obj_zmax-this.obj_zmin)}}}}}}}}}this.objt=taccgl.mi44Mul(h,this.objt)}}return this};this.opacity3D=function(b,a){if(typeof(b)=="number"){this.dddo0=b;this.dddo1=b}if(typeof(a)=="number"){this.dddo1=a}};this.cont=function(){var b=new taccgl.DDDObject(this.ofi,this.selObjects);b.contInit(this.el);b.objt=this.objt.slice(0);var a;for(a in this.materials){b.materials[a]=this.materials[a]}if(this.elshowatend){this.contShiftAtEndAction(b)}this.contIntern(b);return(b)};this.getVertexCoord=function(d){var b=(d-1)*9;var e=this.ofi.vf[b];var f=this.ofi.vf[b+1];var a=this.ofi.vf[b+2];var c=this.objt0;this.ox=e*c[0]+f*c[1]+a*c[2]+c[3];this.oy=e*c[4]+f*c[5]+a*c[6]+c[7];this.oz=e*c[8]+f*c[9]+a*c[10]+c[11]};this.startVertex=function(d,q,i){var p=(d-1)*9;var c=this.ofi.vf[p];var o=this.ofi.vf[p+1];var w=this.ofi.vf[p+2];var n=this.objt0;var h=c*n[0]+o*n[1]+w*n[2]+n[3];var g=c*n[4]+o*n[5]+w*n[6]+n[7];var f=c*n[8]+o*n[9]+w*n[10]+n[11];n=this.objt1;var r=c*n[0]+o*n[1]+w*n[2]+n[3];var b=c*n[4]+o*n[5]+w*n[6]+n[7];var m=c*n[8]+o*n[9]+w*n[10]+n[11];var v=0,u=0,s=0,e=this.flightSpecular+this.flightShininess;if(i){p=(i-1)*9;c=this.ofi.vf[p+6];o=this.ofi.vf[p+6+1];w=this.ofi.vf[p+6+2];n=this.objt0inv;v=c*n[0]+o*n[1]+w*n[2];u=c*n[3]+o*n[4]+w*n[5];s=c*n[6]+o*n[7]+w*n[8]}else{v=this.nx;u=this.ny;s=this.nz}var a=this.fs0,k=this.ft0;var l=this.mix0;if(q){p=(q-1)*9;a+=this.ofi.vf[p+3]*this.fws0+(1-this.ofi.vf[p+4])*this.fhs0;k+=this.ofi.vf[p+3]*this.fwt0+(1-this.ofi.vf[p+4])*this.fht0;l=1}taccgl.nvertMove(h,g,f,r,b,m,v,u,s,e,a,k,this.fflags,this.basetime,this.vduration);if(this.rotation){taccgl.nvertRot(this.rotpx,this.rotpy,this.rotpz,this.rotax,this.rotay,this.rotaz,this.rotfrom,this.rotto,this.rotacc)}if(this.doacceleration){taccgl.nvertAcceleration(this.ax,this.ay,this.az)}};this.startTriangle=function(u,m,n,t,s,d,r,h,i){if(n==0||d==0||i==0){this.getVertexCoord(u);var l=this.ox;var k=this.oy;var j=this.oz;this.getVertexCoord(t);var q=this.ox;var p=this.oy;var o=this.oz;this.getVertexCoord(r);var g=this.ox;var f=this.oy;var e=this.oz;this.nx=-(p-k)*(e-j)+(o-j)*(f-k);this.ny=-(o-j)*(g-l)+(q-l)*(e-j);this.nz=-(q-l)*(f-k)+(p-k)*(g-l)}this.startVertex(u,m,n);this.startVertex(t,s,d);this.startVertex(r,h,i);taccgl.nvertColor3(this.fcol0s,this.fcol0t,this.fcol1s,this.fcol1t,this.fmix0,this.fmix1,this.fmixs0,this.fmixs1)};this.startMapElement=function(){var a=taccgl;if(!this.dotexmove){this.s1=this.s0;this.t1=this.t0;this.ws1=this.ws0;this.ht1=this.ht0;this.wt1=this.wt0;this.hs1=this.hs0}a.nvertOffset(-5);a.nvertTexMove4(this.s0+this.hs0,this.t0+this.ht0,this.s1+this.hs1,this.t1+this.ht1);a.nvertOffset(1);a.nvertTexMove4(this.s0+this.ws0+this.hs0,this.t0+this.wt0+this.ht0,this.s1+this.ws1+this.hs1,this.t1+this.wt1+this.ht1);a.nvertOffset(1);a.nvertTexMove4(this.s0+this.ws0,this.t0+this.wt0,this.s1+this.ws1,this.t1+this.wt1);a.nvertOffset(1);a.nvertTexMove4(this.s0+this.hs0,this.t0+this.ht0,this.s1+this.hs1,this.t1+this.ht1);a.nvertOffset(1);a.nvertTexMove4(this.s0+this.ws0,this.t0+this.wt0,this.s1+this.ws1,this.t1+this.wt1);a.nvertOffset(1);a.nvertTexMove4(this.s0,this.t0,this.s1,this.t1)};this.startMapMaterial=function(a){var e=taccgl,d,g,b,h,c,f;if(!a.dotexmove){d=a.s0;g=a.t0;b=a.ws0;h=a.ht0;c=a.wt0;f=a.hs0}else{d=a.s1;g=a.t1;b=a.ws1;h=a.ht1}e.nvertOffset(-5);e.nvertTexMove4(a.s0+a.hs0,a.t0+a.ht0,d+f,g+h);e.nvertOffset(1);e.nvertTexMove4(a.s0+a.ws0,a.t0+a.ht0,d+b,g+h);e.nvertOffset(1);e.nvertTexMove4(a.s0+a.ws0,a.t0+a.wt0,d+b,g+c);e.nvertOffset(1);e.nvertTexMove4(a.s0+a.hs0,a.t0+a.ht0,d+f,g+h);e.nvertOffset(1);e.nvertTexMove4(a.s0+a.ws0,a.t0+a.wt0,d+b,g+c);e.nvertOffset(1);e.nvertTexMove4(a.s0,a.t0,d,g)};this.startFace=function(l,g,e){var f;var a=this.ofi.mtl.materials;var c=null,p=this.materials[e];if(a){c=a[e]}if(p&&p.docolor){this.fflags=p.flags|this.flags;this.fcol0s=p.col0s;this.fcol0t=p.col0t;this.fcol1s=p.col1s;this.fcol1t=p.col1t;this.flightSpecular=p.lightSpecular;this.flightShininess=Math.round(p.lightShininess);this.fmix0=p.mix0;this.fmix1=p.mix1;this.fmixs0=p.mixs0;this.fmixs1=p.mixs1;if(typeof(p.s0)!="number"){this.fmix0=0;this.fmix1=0;this.fmixs0=0;this.fmixs1=0}this.fs0=p.s0;this.ft0=p.t0;this.fhs0=p.hs0;this.fht0=p.ht0;this.fws0=p.ws0;this.fwt0=p.wt0}else{if(e=="HTML"){if(g-l==4||this.ofi.fi[3*l+1]!=0){c=null}}this.fs0=this.s0;this.ft0=this.t0;this.fhs0=this.hs0;this.fht0=this.ht0;this.fws0=this.ws0;this.fwt0=this.wt0;if(c){var n,r,d,q;if(!c.ambDiffc){n=0}else{n=c.ambDiffc}if(!c.diffc&&c.diffc!=0){d=1}else{d=c.diffc}if(!c.ambc&&c.ambc!=0){r=1}else{r=c.ambc}if(!c.specc&&c.specc!=0){q=1}else{q=c.specc}if(p){q=p.lightSpecular+p.lightShininess}var h=c.ambR*r+c.diffR*n;var o=c.ambG*r+c.diffG*n;var b=c.ambB*r+n*c.diffB;if(h>1){h=1}if(o>1){o=1}if(b>1){b=1}this.fflags=(this.flags|48)&~64;this.fcol0s=Math.floor(h*255)+256*(Math.floor(o*255)-128);this.fcol0t=this.dddo0*255+256*(Math.floor(255*b)-128);this.fcol1s=Math.floor(d*c.diffR*255)+256*(Math.floor(d*c.diffG*255)-128);this.fcol1t=this.dddo1*255+256*(Math.floor(d*255*c.diffB)-128);this.flightSpecular=Math.min((c.specR+c.specG+c.specB)/3,0.999)*q;this.flightShininess=Math.round(c.Ns);this.fmix0=0;this.fmix1=0;this.fmixs0=0;this.fmixs1=0}else{this.fflags=this.flags;this.fcol0s=this.col0s;this.fcol0t=this.col0t;this.fcol1s=this.col1s;this.fcol1t=this.col1t;this.flightSpecular=this.lightSpecular;this.flightShininess=Math.round(this.lightShininess);this.fmix0=this.mix0;this.fmix1=this.mix1;this.fmixs0=this.mixs0;this.fmixs1=this.mixs1}}for(f=l+2;f<g;f++){this.startTriangle(this.ofi.fi[3*l],this.ofi.fi[3*l+1],this.ofi.fi[3*l+2],this.ofi.fi[3*(f-1)],this.ofi.fi[3*(f-1)+1],this.ofi.fi[3*(f-1)+2],this.ofi.fi[3*f],this.ofi.fi[3*f+1],this.ofi.fi[3*f+2])}if(g-l==4&&p&&typeof(p.s0)=="number"&&this.ofi.fi[3*l+1]==0){this.startMapMaterial(p)}if(g-l==4&&e=="HTML"&&this.ofi.fi[3*l+1]==0){this.startMapElement()}};this.startFaces=function(c,b){var a;for(a=c;a<=b;a++){var d;if(a<this.ofi.faces.length-1){d=this.ofi.faces[a+1]}else{d=this.ofi.faceNumber}this.startFace(this.ofi.faces[a],d,this.ofi.facesMaterial[a])}};this.start=function(){if(!taccgl.dddmode){return this}var d=null,a=taccgl;if(this.astepdelno==a.delno){d=a.vertI;a.vertI=this.vertindex}else{this.vertindex=a.vertI;this.astepdelno=a.delno}var b=this.vduration+this.basetime;if(taccgl.duration<b&&((this.flags&1<<16)==0)){taccgl.setDuration(b)}if(this.special){this.startSpecial()}if(!this.objt){this.objt=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]}this.objt0=taccgl.mi44Mul([this.wx0,this.hx0,this.dx0,this.x0,this.wy0,this.hy0,this.dy0,this.y0,this.wz0,this.hz0,this.dz0,this.z0,0,0,0,1],this.objt);this.objt1=taccgl.mi44Mul([this.wx1,this.hx1,this.dx1,this.x1,this.wy1,this.hy1,this.dy1,this.y1,this.wz1,this.hz1,this.dz1,this.z1,0,0,0,1],this.objt);this.objt0inv=taccgl.mi33T(taccgl.m33Inverse(taccgl.m33FromM44(this.objt0)));if(this.negNormal){taccgl.mi33Negate(this.objt0inv)}if(this.selObjects==true){this.startFaces(0,this.ofi.faces.length-1)}else{var g=new RegExp(this.selObjects);var f;for(f in this.ofi.objects){if(g.test(f)){var c=this.ofi.objects[f];this.startFaces(c.startFace,c.endFace)}}}this.vertEndIndex=a.vertI;if(d){a.vertI=d}if(this.p!=a.stdsc){a.setShader(a.stdsc)}return this};this.clone=function(b){return new this.taccglDDDObjectClone(this)};this.taccglDDDObjectClone=function(b){this.taccglAnimClone(b);this.objt=b.objt.slice(0);this.dddo0=b.dddo0;this.dddo1=b.dddo1;this.obj_xmin=b.obj_xmin;this.obj_ymin=b.obj_ymin;this.obj_zmin=b.obj_zmin;this.obj_xmax=b.obj_xmax;this.obj_ymax=b.obj_ymax;this.obj_zmax=b.obj_zmax;this.ofi=b.ofi;this.selObjects=b.selObjects;this.materials=b.materials}}taccgl.DDDObject=function(b,a){this.ofi=b;this.selObjects=a};taccgl3DObjectPrototype.prototype=taccgl.taccglAnim.prototype;taccgl.DDDObject.prototype=new taccgl3DObjectPrototype();taccgl.DDDObject.prototype.taccglDDDObjectClone.prototype=taccgl.DDDObject.prototype;function taccglControllerPrototype(){this.baseinit=function(){this.can=document.getElementById("taccgl_canvas3d");if(!taccgl.overs){taccgl.overs=new Array(0)}this.automaticMouseMoveOut=true};this.init=function(){this.baseinit()};this.attachEventForwarding=function(){};this.detachEventForwarding=function(){};this.attach=function(){this.baseAttach()};this.baseAttach=function(){this.can=document.getElementById("taccgl_canvas3d");this.attachEventForwarding()};this.detach=function(){this.baseDetach()};this.baseDetach=function(){this.detachEventForwarding()};this.instMouseOverFilterClass=function(g,f,a,b){if(!document.getElementsByClassName){return}var e=document.getElementsByClassName(g);for(var d=0;d<e.length;d++){this.instMouseOverFilter(e[d],f,a,b)}};this.elstr=function(a){if(!a){return a+""}var b="";if(a.tagName){b+=a.tagName}b+="#";if(a.id&&a.id+""!="undefined"){b+=a.id}b+=" ";return b};this.instMouseOverFilter=function(g,f,b,d){if(typeof(g)=="string"){g=document.getElementById(g)}var e=g.onmouseover;var c=g.onmouseout;var a=this;if(!d){d=0}if(e&&!e.istaccglfilter){g.onmouseover=function(j){if(!j){j=window.event}a.prevFound=j.target;if(!j.fromElement||j.fromElement.id!="taccgl_canvas3d"){var h=0;while(h<taccgl.overs.length&&taccgl.overs[h]!=g){h++}if(h<taccgl.overs.length){if(f){return}}else{taccgl.overs.push(g)}if(d==0){e(j)}else{if(g.outTimer){clearTimeout(g.outTimer);g.outTimer=null}else{g.overTimer=setTimeout(function(){g.overTimer=null;e(j)},d)}}}};g.onmouseover.istaccglfilter=true}if(c&&!c.istaccglfilter){g.onmouseout=function(j){if(!j){j=window.event}if(!j.toElement||j.toElement.id!="taccgl_canvas3d"){if(a.prevFound==g){a.prevFound=null}var h=0;while(h<taccgl.overs.length&&taccgl.overs[h]!=g){h++}if(h>=taccgl.overs.length){if(b){return}}else{taccgl.overs.splice(h,1)}if(d==0){c(j)}else{if(g.overTimer){clearTimeout(g.overTimer);g.overTimer=null}else{g.outTimer=setTimeout(function(){g.outTimer=null;c(j)},d)}}}};g.onmouseout.istaccglfilter=true}};this.bodyOnMouseMove=function(h){if(!h){h=window.event}if(!this.automaticMouseMoveOut){return}if(!document.createEvent){return}var g=h.target;if(!g){h=h.srcElement}if(g&&g.id&&g.id=="taccgl_canvas3d"){return}var d=new Array(0);while(g){d.push(g);g=g.parentElement}var c=0;while(c<taccgl.overs.length){var a=0;while(a<d.length&&d[a]!=taccgl.overs[c]){a++}if(a>=d.length){var b=taccgl.overs[c];if(document.createEvent){var f=document.createEvent("MouseEvents");f.initMouseEvent("mouseout",h.cancelBubble,h.cancelable,h.view,h.detail,h.screenX,h.screenY,h.clientX,h.clientY,h.ctrlKey,h.altKey,h.shiftKey,h.metaKey,h.button,h.target);taccgl.overs[c].dispatchEvent(f);f=document.createEvent("MouseEvents");f.initMouseEvent("mouseleave",h.cancelBubble,h.cancelable,h.view,h.detail,h.screenX,h.screenY,h.clientX,h.clientY,h.ctrlKey,h.altKey,h.shiftKey,h.metaKey,h.button,h.target);b.dispatchEvent(f)}if(taccgl.overs[c]==b){taccgl.overs.splice(c,1)}}else{c++}}}}function taccglForwardingControllerPrototype(){this.init=function(){this.baseinit()};this.invisibleCanvas=function(){};this.attachEventForwarding=function(){var a=this;if(this.can){this.can.onclick=function(b){a.fwonclick(b,"click")};this.can.ondblclick=function(b){a.fwonclick(b,"dblclick")};this.can.onmouseup=function(b){a.fwonclick(b,"mouseup")};this.can.onmousedown=function(b){a.fwonclick(b,"mousedown")};this.can.onmousemove=function(b){a.fwonmousemove(b)};this.can.style.pointerEvents="none"}};this.detachEventForwarding=function(){if(this.can){this.can.onclick=this.can.ondblclick=this.can.onmouseup=this.can.onmousedown=this.can.onmousemove=null;this.can.style.pointerEvents="all"}};this.findElement=function(a,h,d,g,f,e,b,c){this.can.style.visibility="hidden";this.foundEl=document.elementFromPoint(a,h);this.can.style.visibility="visible"};this.fwonclick=function(c,a){this.foundEl=null;this.findElement(c.clientX,c.clientY);var b=document.createEvent("MouseEvents");b.initMouseEvent(a,c.cancelBubble,c.cancelable,c.view,c.detail,c.screenX,c.screenY,c.clientX,c.clientY,c.ctrlKey,c.altKey,c.shiftKey,c.metaKey,c.button,c.relatedTarget);b.toElement=this.foundEl;if(this.foundEl){this.foundEl.dispatchEvent(b)}};this.fwonmouseout=function(c,a){var b=document.createEvent("MouseEvents");b.initMouseEvent("mouseout",c.cancelBubble,c.cancelable,c.view,c.detail,c.screenX,c.screenY,c.clientX,c.clientY,c.ctrlKey,c.altKey,c.shiftKey,c.metaKey,c.button,this.foundEl);a.dispatchEvent(b);b=document.createEvent("MouseEvents");b.initMouseEvent("mouseleave",c.cancelBubble,c.cancelable,c.view,c.detail,c.screenX,c.screenY,c.clientX,c.clientY,c.ctrlKey,c.altKey,c.shiftKey,c.metaKey,c.button,this.foundEl);a.dispatchEvent(b)};this.fwonmouseover=function(c,a){var b=document.createEvent("MouseEvents");b.initMouseEvent("mouseover",c.cancelBubble,c.cancelable,c.view,c.detail,c.screenX,c.screenY,c.clientX,c.clientY,c.ctrlKey,c.altKey,c.shiftKey,c.metaKey,c.button,this.prevFound);a.dispatchEvent(b);b=document.createEvent("MouseEvents");b.initMouseEvent("mouseenter",c.cancelBubble,c.cancelable,c.view,c.detail,c.screenX,c.screenY,c.clientX,c.clientY,c.ctrlKey,c.altKey,c.shiftKey,c.metaKey,c.button,this.prevFound);a.dispatchEvent(b)};this.fwonmousemove=function(b){this.foundEl=null;this.findElement(b.clientX,b.clientY);this.doHoverChain(b,this.prevFound,this.foundEl);if(this.foundEl){var a=document.createEvent("MouseEvents");a.initMouseEvent("move",b.cancelBubble,b.cancelable,b.view,b.detail,b.screenX,b.screenY,b.clientX,b.clientY,b.ctrlKey,b.altKey,b.shiftKey,b.metaKey,b.button,b.relatedTarget);a.toElement=this.foundEl;this.foundEl.dispatchEvent(a)}this.prevFound=this.foundEl};this.matchesOnElement=function(p,d){var b=/(,?([A-Za-z0-9][-_A-Za-z0-9]*))|(\.([A-Za-z0-9][-_A-Za-z0-9]*))|(#([A-Za-z0-9][-_A-Za-z0-9]*))|(:([A-Za-z0-9][-_A-Za-z0-9]*))/g;var n=d.tagName.toLowerCase(),c=d.id,h=false,f=false,m=false,i=false,g=false,o=false,k,j=d.className.toLowerCase();while((k=b.exec(p))!=null){if(k[1]){i=true;if(k[2].toLowerCase()==n){h=true}}else{if(k[3]){g=true;var e=k[4].toLowerCase();if(e==j||j.indexOf(" "+e)!=-1||j.indexOf(e+" ")!=-1){o=true}}else{if(k[5]){f=true;if(k[6]==c){m=true}}}}}return((f&&m)||(!f&&((((i&&h)||!i)&&(!g||o)))))};this.styleText=function(d){var c=d.cssText;var e=/{([^}]*)}/g;var b=e.exec(c);if(!b){return""}if(!b[1]){return""}return b[1]};this.doHoverChain=function(h,a,d){var i=new Array(0),f=new Array(0),b=a,j=d;while(b){i.push(b);b=b.parentElement}while(j){f.push(j);j=j.parentElement}var c=f.length,g=i.length;while(c>0&&g>0&&i[g]===f[c]){c--;g--}while(g>0){g--;this.unHover(h,i[g])}while(c>0){c--;this.doHover(h,f[c])}};this.doHover=function(h,b){this.fwonmouseover(h,b);var g,l=document.styleSheets;if(b.tagName.toLowerCase()=="a"){this.can.style.cursor="pointer"}for(g=0;g<l.length;g++){var m=l[g],f;var d=m.cssRules;for(f=0;f<d.length;f++){var a=d[f],k=a.selectorText;if(a.type==a.STYLE_RULE&&k.match(/:hover/)){if(this.matchesOnElement(k,b)){if(!b.taccglNoHoverStyle){b.taccglNoHoverStyle=b.style.cssText}var c=this.styleText(a);if(b.tagName.toLowerCase()=="a"){this.can.style.cursor="pointer";c="cursor:pointer;"+c}b.style.cssText=b.taccglNoHoverStyle+";"+c}}}}};this.unHover=function(b,a){if(!a){return}this.fwonmouseout(b,a);if(a.taccglNoHoverStyle||a.taccglNoHoverStyle==""){a.style.cssText=a.taccglNoHoverStyle}a.taccglNoHoverStyle=null;this.can.style.cursor=""}}taccgl.createController=function(){this.init()};taccgl.createController.prototype=new taccglControllerPrototype();taccglForwardingControllerPrototype.prototype=new taccglControllerPrototype();taccgl.createForwardingController=function(){this.init()};taccgl.createForwardingController.prototype=new taccglForwardingControllerPrototype();taccgl.blockingController=function(){return new this.createController()};taccgl.forwardingController=function(){return new this.createForwardingController()};function taccgl3DCanvasPrototype(){this.init=function(){}}taccgl.createDDDCanvas=function(){this.init()};taccgl.createDDDCanvas.prototype=new taccgl3DCanvasPrototype();taccgl.useController=function(a){if(!this.initialized){this.begin()}this.controller.detach();this.previousController=this.controller;this.controller=a;this.controller.attach()};function taccglTransformControllerPrototype(){this.init=function(){this.baseinit();this.rcx=500;this.rcy=500;this.rcz=0;this.vexitOnMouseout=false;this.moveStep=2;this.minPitch=-10;this.maxPitch=10;this.minRoll=-10;this.maxRoll=10;this.minYaw=-10;this.maxYaw=10;this.isactive=true};this.pitch=function(a,b){this.minPitch=a;this.maxPitch=b};this.roll=function(a,b){this.minRoll=a;this.maxRoll=b};this.yaw=function(a,b){this.minYaw=a;this.maxYaw=b};this.active=function(b){this.isactive=b};this.attachEventForwarding=function(){var c=this;var b=document.getElementById("taccgl_mouseTrap");if(!b){if(document.body.insertAdjacentHTML){document.body.insertAdjacentHTML("afterbegin",'<div id=\'taccgl_mouseTrap\' tabindex="0" style="cursor:crosshair;xbackground-color:rgba(100,0,0,0.5); height:100%; width:100%; position:fixed;z-index:9999; display:none"></div>')}}b=document.getElementById("taccgl_mouseTrap");if(!b){return}b.onmousedown=function(d){c.tronmousedown(d)};b.onmouseup=function(d){c.tronmouseup(d)};b.onmousemove=function(d){c.tronmousemove(d)};b.onclick=function(d){c.tronclick(d)};b.onkeypress=function(d){return c.tronkeypress(d)};b.onkeydown=function(d){return c.tronkeydown(d)};b.onkeyup=function(d){return c.tronkeyup(d)};b.oncontextmenu=function(){return false};b.style.display="";var a=b.clientWidth;b.style.opacity=1;b.focus()};this.detachEventForwarding=function(){var a=document.getElementById("taccgl_mouseTrap");if(a){a.style.display="none";a.style.opacity=0}};this.rotationCenter=function(a,c,b){this.rcx=a;this.rcy=c;this.rcz=b};this.mouseBox=function(a,c,b,d){this.mbxmin=a;this.mbxmax=c;this.mbymin=b;this.mbymax=d};this.extendMouseBox=function(a,c,b,d){this.mbxmin=Math.min(a,this.mbxmin);this.mbxmax=Math.max(c,this.mbxmax);this.mbymin=Math.min(b,this.mbymin);this.mbymax=Math.max(d,this.mbymax)};this.exitOnMouseout=function(a){if(a!=false){a=true}this.vexitOnMouseout=a};this.tronmousedown=function(a){if(!a){a=event}this.vexitOnMouseout=false;this.cX=a.clientX;this.cY=a.clientY;this.button=a.which;this.IM=taccgl.TM.slice();a.cancelBubble=true;if(a.stopPropagation){a.stopPropagation()}return false};this.tronmousemove=function(t){if(this.vexitOnMouseout){var m=t.pageX;var l=t.pageY;if(m>this.mbxmax||m<this.mbxmin||l>this.mbymax||l<this.mbymin){this.doexit()}}if(this.button==1||this.button==3){var d=t.clientX-this.cX,a=t.clientY-this.cY;if(t.shiftKey){d/=10;a/=10}if(this.button==1&&!t.ctrlKey){var n=taccgl.m33Rotation(-d/300*Math.PI,[0,1,0]);var p=taccgl.mi33MulV(n,[1,0,0]);n=taccgl.m33Rotation(d/300*Math.PI,[0,1,0]);n=taccgl.mi33Mul(n,taccgl.m33Rotation(-a/300*Math.PI,p));var g=this.rcx+this.IM[3],f=this.rcy+this.IM[7],b=this.rcz+this.IM[11];this.TM=taccgl.m44FromM33C(n,[this.rcx,this.rcy,this.rcz,1])}else{if(this.button==1&&t.ctrlKey){var n=taccgl.m33Rotation(d/300*Math.PI,[0,1,0]);n=taccgl.mi33Mul(n,taccgl.m33Rotation(a/300*Math.PI,[0,0,1]));var g=this.rcx+this.IM[3],f=this.rcy+this.IM[7],b=this.rcz+this.IM[11];var i=taccgl.mi44MulV(this.IM,[this.rcx,this.rcy,this.rcz,1]);this.TM=taccgl.m44FromM33C(n,i)}else{if(this.button==3&&!t.ctrlKey){this.TM=taccgl.m44Translation(d,a,0)}else{if(this.button==3&&t.ctrlKey){this.TM=taccgl.m44Translation(d,0,-a*10)}}}}var w=taccgl.mi44Mul(this.TM,this.IM);var r;if(this.isactive){var r=taccgl.m33FromM44(w)}else{var r=taccgl.mi33T(taccgl.m33FromM44(w))}var j=taccgl.m33ToEulerAngles(r);if((this.minPitch<=j.pitch&&j.pitch<=this.maxPitch)&&(this.minRoll<=j.roll&&j.roll<=this.maxRoll)&&(this.minYaw<=j.yaw&&j.yaw<=this.maxYaw)){taccgl.setTM(w)}else{j.pitch=taccgl.clamp(j.pitch,this.minPitch,this.maxPitch);j.roll=taccgl.clamp(j.roll,this.minRoll,this.maxRoll);j.yaw=taccgl.clamp(j.yaw,this.minYaw,this.maxYaw);var h=taccgl.m33FromEulerAngles(j);if(!this.isactive){h=taccgl.mi33T(h)}var v=[this.rcx,this.rcy,this.rcz,1];var k=taccgl.mAffInverse(this.IM);var o=taccgl.mi44MulV(k,v);var q=v.slice();taccgl.viSub(q,taccgl.mi33MulV(h,o));taccgl.setTM(taccgl.m44FromM33(h,q))}}t.cancelBubble=true;if(t.stopPropagation){t.stopPropagation()}return false};this.tronmouseup=function(a){this.button=0;a.cancelBubble=true;if(a.stopPropagation){a.stopPropagation()}return false};this.tronclick=function(c){var b=c.clientX-this.cX,a=c.clientY-this.cY;if(b==0&&a==0){this.doexit()}c.cancelBubble=true;if(c.stopPropagation){c.stopPropagation()}return false};this.applyTM=function(a){taccgl.tlog("taccgl.TM before =\n"+taccgl.m44ToString(taccgl.TM));taccgl.applyTM(a);taccgl.tlog("taccgl.TM after \n"+taccgl.m44ToString(taccgl.TM))};this.tronkeypress=function(d){var f=event.charCode;var b=String.fromCharCode(f);taccgl.tlog("Transformcontroller onkeypress "+f+" "+b);if(b=="w"){this.applyTM(taccgl.m44Translation(0,0,-200))}else{if(b=="s"){this.applyTM(taccgl.m44Translation(0,0,200))}else{if(b=="a"){this.applyTM(taccgl.m44Translation(-2,0,0))}else{if(b=="d"){this.applyTM(taccgl.m44Translation(2,0,0))}else{if(b=="q"){this.applyTM(taccgl.m44Translation(0,-2,0))}else{if(b=="e"){this.applyTM(taccgl.m44Translation(0,2,0))}else{if(b=="i"){this.applyTM(taccgl.m44Translation(0,0,-2))}else{if(b=="k"){this.applyTM(taccgl.m44Translation(0,0,2))}else{if(b=="j"){this.applyTM(taccgl.m44Translation(-2,0,0))}else{if(b=="l"){this.applyTM(taccgl.m44Translation(2,0,0))}else{if(b=="r"){var d=taccgl.stdEye;d.setPos(d.eyeX,d.eyeY,d.eyeZ+2)}else{if(b=="f"){var d=taccgl.stdEye;d.setPos(d.eyeX,d.eyeY,d.eyeZ-2)}else{if(b=="R"){taccgl.TM=taccgl.m44IConst.slice()}else{if(b=="+"){this.applyTM(taccgl.m44FromM33C(taccgl.miMulS(taccgl.m33I(),1.1),[this.rcx,this.rcy,this.rcz]))}else{if(b=="-"){this.applyTM(taccgl.m44FromM33C(taccgl.miMulS(taccgl.m33I(),1/1.1),[this.rcx,this.rcy,this.rcz]))}else{if(b=="I"){taccgl.tlog("taccgl.TM=\n"+taccgl.m44ToString(taccgl.TM));var a=taccgl.mi44MulV(taccgl.TM,[0,0,-1,0]);taccgl.tlog("viewDirection="+taccgl.vToString(a))}else{return true}}}}}}}}}}}}}}}}if(d.preventDefault){d.preventDefault()}if(d.stopImmediatePropagation){d.stopImmediatePropagation()}d.cancelBubble=true;return false};this.tronkeydown=function(b){var d=event.charCode;var a=String.fromCharCode(d);taccgl.tlog("Transformcontroller onkeydown "+d+" "+a);if(a=="w"){}};this.tronkeyup=function(b){var d=event.charCode;var a=String.fromCharCode(d);taccgl.tlog("Transformcontroller onkeyup "+d+" "+a);if(a=="w"){}};this.doexit=function(){this.nextController=taccgl.previousController;taccgl.doHook(this.onTerm);if(this.nextController){taccgl.useController(this.nextController)}};this.onTerm=null}taccglTransformControllerPrototype.prototype=taccglForwardingControllerPrototype.prototype;taccgl.createTransformController=function(){this.init()};taccgl.createTransformController.prototype=new taccglTransformControllerPrototype();taccgl.transformController=function(){return new this.createTransformController()};function taccglJobPrototype(){this.init=function(b,d,c,a){this.waitcnt=0;this.f=b;this.p1=d;this.p2=c;this.p3=a};this.doJob=function(){var a;this.f(this.p1,this.p2,this.p3);if(this.succ){for(a=0;a<this.succ.length;a++){this.succ[a].decWait()}}};this.waitFor=function(a){if(!a.succ){a.succ=Array(0)}a.succ.push(this);this.incWait()};this.incWait=function(){this.waitcnt++};this.decWait=function(){this.waitcnt--;if(this.waitcnt==0){taccgl.jobsReady.push(this)}}}taccgl.createJob=function(b,d,c,a){this.init(b,d,c,a)};taccgl.createJob.prototype=new taccglJobPrototype();taccgl.newJob=function(b,d,c,a){return new this.createJob(b,d,c,a)};taccgl.jobsReady=Array(0);taccgl.jobSchedule=function(){if(taccgl.jobsReady.length>0){var a=taccgl.jobsReady[0];taccgl.jobsReady=taccgl.jobsReady.slice(1);a.doJob()}};taccgl.jobScheduleAll=function(){while(taccgl.jobsReady.length>0){taccgl.jobSchedule()}};